WOW Extensions Designer

About WOW Extensions

Introduction

Getting Started

Developing with WOW Extensions

Working with ActiveX Controls

Manipulating Properties and Events

Debugging

Using WOW Extensions Thin Client

Using WOW Extensions with RM/Panels

Reference Information


About WOW Extensions

Thank you for purchasing WOW Extensions, Liant Software's programming tool that allows you to design and develop event-driven Windows applications completely in COBOL. It allows you, the developer, to implement a full-featured graphical user interface to your RM/COBOL application, while retaining the COBOL business logic and data access.

About This Document

The documentation for WOW Extensions is available in two HTML Help files:

· WOW Designer Help (cblwow.chm). This is the primary help file, providing you with online documentation for the WOW Extensions Designer, including reference information about the key elements of the Designer window, descriptions of the commands on the menus, dialog boxes, tools in the Toolbox, buttons on the toolbar, and how to work with WOW Extensions projects. It also provides an alphabetic reference for each of the intrinsic (standard) Windows and the ActiveX controls used in the WOW Extensions development environment. Properties and events are defined for each control, along with a discussion of the properties and events used by forms. For quick reference, this help file contains a checklist summarizing whether the properties for a specific control or form can be manipulated with the WOW Designer at design time, retrieved or set at runtime, or both.

· WOW Functions and Messages Help (cblwowfm.chm). This help file contains comprehensive information about Windows messages, Windows API functions, and WOW functions (including those that support ActiveX, RPC, and Thin Client implementations). It also includes lists of the functions and messages, arranged alphabetically, with links to the complete descriptions.

For more information, see Using WOW Extensions Help.

Technical Support

Liant Software offers various support options. For a complete list and a description of each, visit the Product Support section at the Liant web site: http://www.liant.com.

For other ways to contact Liant Software, click here.

Copyright 1995-2008. Liant Software Corporation. All rights reserved.


Introduction

What's New in WOW Extensions

Enhancements in Previous Versions of WOW Extensions

WOW Extensions Components

WOW Extensions Development Process

Windows GUI Elements


What's New in WOW Extensions

See Also

Version 12 of WOW Extensions, which requires RM/COBOL version 12 or later, contains both enhancements and problem corrections to previous releases.

Enhancements to WOW Extensions version 12 include the following:

· Two new options have been added to the New Project Options area of the Code Preferences page for new projects:

Generate Untruncated Paragraph Names. This option, which is enabled by default, allows the WOW Designer to generate paragraph names that are no longer abbreviated (or truncated) in order to avoid duplicate paragraph names caused by the previous truncation scheme. When enabled, this option prevents projects created with earlier version of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Generate (72 column) Short Lines. The option allows the WOW Designer to generate COBOL source records beginning at column 72 (for backward compatibility). If this option is not selected, source records with longer line lengths (now allowed by an RM/COBOL compiler directive) are generated.

Note that existing projects createdwith earlier versions of WOW Extensions also generate truncated paragraph names programs . For more information, see the discussion of these options in the Project Options dialog box.

· Improved compatibility with Windows Vista and Windows Server 2008 systems.

· This release also corrected numerous minor problems.


Enhancements in Previous Versions of WOW Extensions

To see a list of the enhancements contained in previous versions of WOW Extensions, click one of the following topics:

· Version 11

· Version 10

· Version 9

· Version 4

· Version 3.10

· Version 3


Version 11 Enhancements

Version 11 of WOW Extensions, which requires RM/COBOL version 11 or later, contains both enhancements and problem corrections to previous releases.

Enhancements to WOW Extensions version 11 include the following:

· A more flexible, feature-rich source code editing capability has been added. The code editor supports markers, line numbers, vertical alignment lines, syntax coloring, brace matching, and regular expression capabilities for find and replace operations. The new code editor is based on the Scintilla Windows control, which is a free source code editing component, and it replaces the standard Windows RichEdit control used in previous versions of WOW Extensions. For more information, see the Code Edit Windows Preferences page and the Event-Handling Code dialog box.

· The status bar, tab, and toolbar controls have been enhanced to allow interactive behavior such that when a desired status bar pane, tab, or toolbar is clicked, it automatically changes the current pane, tab, or button.

· Double-clicking on a menu item in the Menu Control list box of the Menu Editor dialog box now opens the Event-Handling Code dialog box with the code for that item displayed in the Code Entry area. This feature is particularly helpful when a menu contains several items. Formerly, it was necessary to click on the menu bar, and then search for the desired event.

With the addition of the Name Locking option, the Menu Editor dialog box also now allows you to control which portion, if any, of a menu name should change when a menu is moved.

· It is now possible to select all controls of one type within a container control (a tab or a group box control) at the same time. For more information, see Tab Control, Group Box Control, or how to select one or more control(s).

· A new option on the General Preferences page, Build Before Executing, allows you to combine the actions of compiling and running.

· Bookmarks are now supported in the WOW Designer. For more information, see the Edit Bookmarks dialog box.

· Two new Windows System functions, SETLOCALEMONETARY and SETLOCALENUMERIC, have been added in version 11. These functions allow you to change locality (country and language) settings at runtime. (For complete details, see the Functions and Messages online Help file.)


Version 10 Enhancements

Version 10 of WOW Extensions, which requires RM/COBOL version 10 or later, contains both enhancements and problem corrections to previous releases.

Enhancements to WOW Extensions version 10 include the following:

· A new Tab Order Editor dialog box displays a list of controls on the active form and allows you to change their tab order easily.

Similarly, a new Z-Order Editor dialog box displays a list of controls on the active form and allows you to change their control stacking order (or z-order) easily (that is, the order in which controls are created).

· Up to 16 user-defined custom colors are now saved in the WOW Designer's configuration file (cblwow.ini). This means that the custom colors are available to subsequent executions of the Designer.

· A [VERSION COMPATIBILITY] section was added to the WOW runtime initialization file (wowrt.ini) in order to provide the capability to restore pre-version 9 runtime behavior. Note that it is also possible to define these settings within the WOW Designer by using the Runtime Preferences page.

· The [WOWRT] section of the wowrt.ini file contains several new entries:

-  ToolTipTimeOutSeconds, which allows you to set the length of time, in seconds, that tool tips are visible at runtime .

-  LocaleMonetary, which allows you to override regional settings when handling monetary data entry. Note that these this entry is contained in the [INTERNATIONALIZATION] section, which may be added to the wowrt.ini file.

-  LocaleNumeric, which allows you to override regional settings when handling numeric or monetary data entry. Note that these this entry is contained in the [INTERNATIONALIZATION] section, which may be added to the wowrt.ini file.

· It is now possible to prevent ActiveX event code from being executed while another event is being processed by setting the AllowMultipleEvents property to False for each ActiveX control, and by either using the Enable ActiveX Multiple Event Blocking option on the Runtime Preferences page or setting the EnableActiveXMultipleEventBlocking option in the [WOWRT] section of the wowrt.ini file.

· Support has been added for simple ActiveX containers. The ActiveX control must support this feature, as is the case for some ActiveX group boxes, for example.

· The location of the WOW Extensions runtime system, wowrt.dll, can now be specified on the Tools Preferences page.

· The External Edit Comparison dialog box contains a new command button, Run Diff, which causes the WOW Designer to write the information in the Original Code and Externally Edited Code areas to a file and invokes a file comparison tool to report the results of the comparison. If you wish to use a file comparison tool other than the default, Microsoft Windows windiff, the location of that tool can be specified on the Tools Preferences page.

· A new option, Generate Old-Style Working Storage Guard Names, has been added to the Code Preferences page that causes the WOW Designer to generate Working-Storage guard names that are limited to 30 characters in length, which was the case in versions prior to 10.01. The version 10.01 Designer will generate names up to 240 characters long. Checking this option prevents pre-10.01 projects from having compilation errors due to references to old 30-character names.

· The View menu now includes a Lock Icons command that shows or hides the lock icons associated with locked controls.

· The Form menu now includes a Test command. The location of the form test program, wowtestform.exe, can be specified on the Tools Preferences page. This test form program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

· Default font settings (font name, style, special effects, if any, and size) for controls can now be established at design time using the Control Font option on the Fonts & Colors Preferences page.

· The Enable Mouse Move Events option was added to the Runtime Preferences page to allow developers to control whether the WOW runtime will recognize mouse move events. Mouse move events consume an inordinate amount of CPU resources even when no event code is attached. The ability to de-select this option is useful in preventing such resource consumption unless the developer deems it necessary.

· MouseDown, MouseMove, and MouseUp events were added to many controls as well as to forms.

· The date time picker and month calendar controls feature new events. Support is now available for GotFocus, KeyDown, KeyPress, KeyUp, and LostFocus events.

· The WOW Designer online help file now documents whether properties can be manipulated at design time, retrieved or set at runtime, or both. Click here for more information.

· Support for the bitmap control is now available for panels.

· A new form property, KeyPreview, has been added that indicates whether the form will receive key events before the event is passed to the control that has focus.

Additionally, the WSDefinition property, which enables definition data to be written to a file having a .wfd (WOW form definition) extension, is now available for forms.

· A runtime-only property, Version, has been added to forms.

· In addition to setting tool tips at design time, it is now possible to set them at runtime using the ToolTipText property.

· The font properties (FontBold, FontItalic, FontName, FontSize, FontStrikethru, and FontUnderline) of a status bar control can now be set at design time as well as at runtime.

· Several new ActiveX properties have been added, including the following:

-  AllowMultipleEvents

-  EnableKeyPressforTabMode

-  Group

-  NewDoMethodArgumentPassing

· Two new properties have been added to the edit box control. SelectAllOnGotFocus is a design-time-only property that determines whether the text in an edit box control will be selected when the control has focus. The WantPopupMenu property determines whether a standard Windows popup menu will display when the user right-clicks while in an edit box.

· Many controls in a panel now have the following new properties available: ClientEdge, ModalFrame, RightAlignedText, RightToLeftReading, StaticEdge, and Transparent.

· The tab control now has Accelerator and TabEnabled properties that can be set for individual tabs on the control.

· The toolbar control now has Accelerator|tag=Accelerator Property,BtnToolTipEnabled and BtnToolTipText properties, which can be set for individual buttons on the toolbar.

· A track bar has been added to the Event-Handling Code dialog box so that the Working Storage and Code Entry areas can be resized, as necessary.

· Several new WOW functions have been added in version 10. (For complete details, see the Functions and Messages online Help file.) These include the following:

-  WOWGETINDEXPROP and WOWSETINDEXPROP get and set, respectively, the value of one index property for certain intrinsic controls, including status bar, tab, and toolbar.

-  WOWFORMTOWOWVERSION retrieves a string containing the version of WOW Extension used to create the form.

-  WOWGETWINDOWTYPE function retrieves the type of a control or form.

Note These functions are not available for WOW Thin Client.


Version 9 Enhancements

Notes

· Beginning with version 9, the name of this product has changed from Cobol-WOW to WOW Extensions.

· Changes in WOW Extensions version 9 require that you make minor modifications when migrating projects that you created with earlier versions of the product.

Version 9 of WOW Extensions, which requires RM/COBOL version 9 or later, contains both enhancements and problem corrections to previous releases. Enhancements to WOW Extensions version 9 include the following:

· ActiveX event-handling code now has access to the ActiveX control event arguments. This adds a much needed capability for interfacing with ActiveX controls.

· The WOW Designer can now generate nested COBOL programs. This allows for a more structured COBOL program. It also allows each section of event handling code to have its own Working Storage area. The default for new projects is to generate non-nested programs. This option can be set on a project-by-project basis. See Code Preferences and the Project Options dialog box for more information. Note that existing projects created with earlier versions of WOW Extensions also generate non-nested programs.

· Controls within containers, such as check boxes or radio buttons, can now be aligned and spaced within that container using the alignment and spacing options on the Layout toolbar or the Control menu.

· A ToolWindow property causes a form to have a shorter title bar and prevents the form from appearing in the Windows Task Bar.

· The Code Templates tree is now a separate window within the WOW Designer window.

· A Tag property has been added to most intrinsic controls. This general-purpose property can be used by the WOW Extensions developer for storing application-related information in the control.

· A ToolTipText property and ToolTipEnabled property have been added to many intrinsic controls. These properties allow developers to add tool tips to controls.

· The value of the Name property can now be retrieved at runtime.

· Menus can be saved and reloaded in other projects using the Save and Load command buttons on the Menu Editor dialog box.

· It is now possible to customize an existing toolbar to your liking. If there are some features you use more often than others, you can add those feature buttons for faster access, or you can delete ones you never use. For more information, see the Customize Toolbar dialog box.

· Two new intrinsic controls have been added: a date time picker control and a month calendar control.

· The Project Output dialog bar in the WOW Designer window shows the results of an application code search (displayed on the Find in Code tab) or a compilation (displayed on the Compiler Output tab). When a project is compiled, the currently registered RM/COBOL compiler is used and the output that normally would be displayed by the compiler is routed to this new Project Output window in the WOW Designer.

· WOW Extensions now uses CodeBridge, Liant Software's cross-language call system, to translate data to and from the COBOL program and the various properties of the controls.

· A Tab Control Editor dialog box provides the capability to delete the current tab within a tab control, shift the controls contained within that tab to the left or right, and modify certain tab properties that require special consideration with the tab control. Changing these properties for the tab control in the Tab Control Editor is equivalent to setting their values in the Properties dialog box. To display this dialog box, select a tab control on a form and then click Tab Editor from the Control menu.

· During the design process, the Drop Down Combo Box command from the Control menu allows all of the pre-defined data entries to be visible in the drop-down list box and provides the capability to select one of the entries for display in the edit box portion of the combo box control.

· WOW Extensions now provides information about available product updates automatically. You can control the type of information you want to see by using the Project Update Check options on the General Preferences page in the Preferences dialog box.

· The WOW Extensions runtime system now has its own initialization file, wowrt.ini. An optional environment variable, WOW_RUNTIME_INI_PATH, can be used to tell the WOW Designer and runtime system where to locate the wowrt.ini file. This environment variable allows you the option of specifying the complete pathname (including the filename) of wowrt.ini from the WOW Designer, so that the correct runtime initialization file can be located by the WOW Designer during the design process.

· WOW Thin Client has its own configuration file, wowclient.cfg, where wowclient is the name of the wowclient executable file, wowclient.exe. wowclient.cfg is automatically located in the same directory as wowclient.exe. By specifying a complete pathname in the environment variable, WOW_THIN_CLIENT_CFG_FILE, the default name and location can be overridden. This configuration file allows terminal settings for Thin Client Accept/Display to be configured.

· A number of new functions and messages have been added in version 9. (For complete details on the following, see the Functions and Messages online Help file.)

-  A set of functions provides additional support for the Thin Client implementation of WOW Extensions. Another group of functions adds certain RPC (Remote Procedure Calls) capabilities to the Thin Client implementation.

-  WOWLOADICON, DESTROYICON, WM-SETICON, and WM-GETICON facilitate the use of icons in WOW Extensions.

-  New functions that assist with the manipulation of controls include WOWADDMULTIPLESTRINGS, WOWINITALLCONTROLS, WOWINITCONTROL, WOWMULTICONTROLGETPROP, WOWMULTICONTROLSETPROP, and WOWSETSTRIPTRAILING.

-  Four new profile functions that pertain to initialization file information have been added: GETPROFILESECTION, GETPRIVATEPROFILESECTION, WRITEPROFILESECTION, and WRITEPRIVATEPROFILESECTION.

-  The GETENVIRONMENTVARIABLE and SETENVIRONMENTVARIABLE functions add capabilities for using environment variables with WOW Extensions.

-  GETVERSIONEX obtains extended information about the version of the operating system that is currently running.

· A new Panel Import Preferences dialog box allows you to specify certain graphical characteristics that will determine the way that character- and GUI-based panels in an RM/Panels library will appear when the library is opened in the WOW Designer.

· It is now possible to enumerate controls on a WOW form, which allows the developer to loop through all the controls on a form. This feature could be used to resize controls when the form is resized. For more information, click here.

WOW Extensions version 9 requires RM/COBOL version 9 or higher.


Migrating to WOW Extensions Version 9

Caution To ensure a smooth migration, back up your pre-version 9 projects before migrating them to version 9.

Several modifications in WOW Extensions version 9 require that you make changes when migrating projects that you created with earlier versions of the product to WOW Extensions version 9.

Several commands, such as Open All on the Form menu and Regenerate w/Forms on the Project menu, assist the migration process. Additionally, saving modified forms will prompt with Yes to All to make this process easier. When the Designer detects old versions of a form, it continues to inform you that the form is being upgraded (as in the past), but it now allows you to suppress the message for future forms that you open.

New definitions in the windows.cpy copy file may cause compilation errors if you have added definitions to your projects yourself when working with versions prior to version 9. To avoid this problem, simply remove your definitions and use the new definitions provided with version 9. If you have added your own definitions to your projects and used names different from those in the version 9 windows.cpy copy file, Liant recommends that you modify your code to use the definitions provided with version 9.

Delete all of the WOW Extensions-generated source files (.cbl, .wws, and .wpr) before opening the project with version 9. When you save the project, the generated source files will be in the new format.

A new feature in version 9 allows your event-processing code for ActiveX controls to access the arguments associated with ActiveX events. If your pre-version 9 projects have code attached to ActiveX events and you want to process these arguments, you must re-insert your event-processing code. For more information on ActiveX event arguments, click here.


Process ActiveX Control Event Arguments

Event-processing code for ActiveX controls can access the arguments associated with ActiveX events, which is useful when migrating pre-version 9 projects to the current version.

1. With your project open in the Designer, open the Event-Handling Code dialog box.

2. In the Events/Sections list, select the desired event. The code associated with that event will be displayed in the Code Entry area.

3. Select all the code (press Ctrl+Home followed by Ctrl+Shift+End).

4. Copy and delete the selected code by pressing Ctrl+X.

5. Do one of the following:

· If the event has arguments, the WOW Designer will insert code in the Working-Storage area and the Code Entry area that automatically binds and un-binds the arguments to COBOL variables. Paste your copied code into the Code Entry area. The correct insertion location is marked by comments in the automatically inserted code, as follows:

* Add your event handling code here.
* Do not modify the code above
* except to change the names of the local
* event arguments.
*
*
* End of your event handling code.

· If the event does not have arguments, the Code Entry area will be blank and you can simply paste your copied code back in the area.

6. Repeat this process for each event.

7. Close the Event-Handling Code dialog box.


Version 4 Enhancements

Version 4 of Cobol-WOW contains both enhancements and problem corrections to the previous release. Enhancements to Cobol-WOW version 4 include the following:

· The Thin Client component of Cobol-WOW has been enhanced to allow Cobol-WOW programs executing in a client/server architecture over a LAN or the Internet to select and print to a printer on the client machine. All of the RM/COBOL runtime Windows’ P$ subprograms and Windows’ printing capabilities are available in this environment.

· It is now possible to use enhanced RM/Panels panels with the Thin Client component of Cobol-WOW. This capability is transparent to the user.

· A new capability, Cobol-WOW Thin Client Accept/Display, has been added that allows Cobol-WOW programs running in the client/server architecture over a LAN or the Internet, to use COBOL ACCEPT and DISPLAY statements. The input/output of these statements appear in the default RM/COBOL for Windows standard graphical user interface window (supported by the rmguife.dll) on the Windows' client machine.

Cobol-WOW version 4 requires RM/COBOL version 8 or higher.


Version 3.10 Enhancements

Enhancements to Cobol-WOW version 3.10 include the following:

· A new component, Cobol-WOW Thin Client, has been added that allows Cobol-WOW programs to be executed in a client/server architecture over a LAN or the Internet.

· Print support has been added to the Cobol-WOW Designer. It is now possible to print a form or print a packaging list of the application components, such as COBOL program, bitmaps, icons, animation files, ActiveX controls, and so on) that are required for distribution.

· Form and control properties can now be organized either alphabetically or by functional category.

· The static text box control can now have a transparent background.

· Version 3.10 allows you to enter a text string that you want to locate in your application code. Results are displayed in an area below the Project tree and the desktop area of the Designer window.

· Cobol-WOW now supports the Euro currency symbol (€). A new section, [INTERNATIONALIZATION], has been added to the WOW initialization file, cblwow.ini. This section supports three keywords:

-  EuroSupport=True|False. Turns off/on the ability to map the Euro currency symbol. The default is True.

-  EuroCodePointAnsi=<value> where <value> is in the range 0 through 255 (which can be specified in decimal or hex; that is, 128 or 0x80).

-  EuroCodePointOem=<value> where <value> is in the range 0 through 255 (which can be specified in decimal or hex; that is, 213 or 0xD5).

Cobol-WOW version 3.10 requires RM/COBOL version 7.00.03 or higher.


Version 3 Enhancements

Version 3 of Cobol-WOW has been significantly enhanced to provide new functionality and improved reliability. With this version, Liant Software Corporation assumes all responsibilities for the product, including future enhancement and support. Prior versions were developed and maintained by England Technical Services, Inc.

Cobol-WOW version 3, which requires RM/COBOL version 7.00.03 or higher, includes improved ActiveX support. The Cobol-WOW Designer has been rebuilt using up-to-date Microsoft technology for ActiveX controls, ensuring results that are more reliable and a broader range of application. The Designer has also been given a modern appearance and behavior, making it more intuitive and flexible to use. Many problems and defects have been corrected in order to assure the consistency and stability of the product. The documentation, including the Functions and Messages and Cobol-WOW Designer online Help files and the user's guide in PDF format, has been completely revised and new material has been developed. (Note that beginning with the v10 release, a user’s guide is no longer included as part of the WOW Extensions documentation set.)

Cobol-WOW version 3 is project-based, and the Designer includes 'tree'-structure project navigation. If you have a form-based application created with an earlier version of Cobol-WOW, you must create a project and add the form files in the existing application to it. For more information on using Cobol-WOW projects, click here.


WOW Extensions Components

See Also

The WOW Extensions development environment consists of three major components:

· a design facility

· a runtime system

· the Thin Client program


WOW Designer

See Also

The WOW Designer, cblwow.exe, is a standard Windows, multiple document interface (MDI) application that provides COBOL developers with the capability to define the visual interface elements of the application. The multiple document interface feature allows an application to manage multiple files within the single, parent (or application) window. In WOW Extensions, this means you can open and edit multiple forms at one time in the WOW Designer window. You can also copy information back and forth between forms, move and resize the forms, and so forth.

The WOW Designer also provides you with the capability to define forms, populate those forms with intrinsic controls and ActiveX controls, adjust the properties of forms and controls, and attach COBOL event-handling logic to their events.


WOW Runtime System

See Also

The WOW runtime system, wowrt.dll, is a Windows dynamic-link library (DLL) that manages Windows messages, provides runtime support for the forms and controls, and provides a COBOL interface to the Windows Application Programming Interface (API).

Note The WOW runtime system DLL (wowrt.dll) must be distributed with your WOW applications.

Windows provides hundreds of functions for application programming, collectively referred to as the Windows API. The interface to these functions is a C-language interface that does not accept COBOL data types. Sometimes the architecture of these functions prevents direct access from COBOL. wowrt.dll provides a COBOL interface to these Windows functions, providing direct access to the power and flexibility of Windows. For more information on these functions, see the Functions and Messages online Help file.

Execution of a Windows program also generates a number of messages. Again, the generation and transmission of these messages are designed for a C-language interface. wowrt.dll conveniently captures, organizes, stores, and reports these messages to the COBOL application. For more information on these messages, see the Functions and Messages online Help file.

It is possible to customize the WOW runtime initialization file, wowrt.ini, in order to define default settings for various runtime activities. This is accomplished by using the Runtime Preferences page of the Preferences dialog box in the WOW Designer, or by manually adding or modifying [WOWRT] or [VERSION COMPATIBILITY] sections in the wowrt.ini file.


WOW Thin Client

See Also

The WOW Thin Client executable program, wowclient.exe, which is installed on the Windows client workstation, begins the WOW Thin Client session by connecting to the server. It loads the required DLLs and reads the initialization file, rpcplus.ini, which tells RPC (Remote Procedure Calls) what server to connect to and which port to use. The server, upon receiving this connection request, begins execution of the application on the server. The application runs as a normal RM/COBOL program on the server until a WOW function is invoked. All WOW functions are intercepted by special logic in the WOW runtime, which routes the requests back to the client, where they are executed. This causes the user interface to be presented on the client. When the WOW function completes execution, control is returned back to the server.


WOW Extensions Development Process

See Also

You begin the WOW Extensions development process by creating a project. A project is the top-level building block in the development environment provided by WOW Extensions to facilitate the creation of the multiple forms that make up your application's user interface. A project manages not only the form creation, but also provides the ability to add file access and other code to the rest of your program. The default extension for WOW project filenames is .wpj. The .wpj project definition file is a binary file that contains project configuration information and a list of the forms included in the project.

Next, you design forms. The form files that are contained in a project are also known as members. The default extension for a form file is .wow. A full range of form types, styles, system colors and fonts is available to create highly stylized forms.

You continue using the WOW Designer to populate the form with controls selected from the Toolbox. The Toolbox provides the ability to add Windows intrinsic controls (default) and Active X controls to the form. Using the Properties dialog box, WOW Extensions enables the appearance and functionality of each control to be fully tailored to your needs.

Next, you attach event-handling code to the graphical user interface objects: the form, Windows intrinsic controls, and ActiveX controls. The WOW Designer provides a complete list of possible events for each object and includes an Event-Handling Code dialog box that can be used to easily add event-handling code using familiar COBOL statements. In addition, over 150 of the Windows API functions are available, all with parameters that use standard COBOL data types.

Once the event-handling code is complete, you can generate copy files to allow for easy integration of the form into a legacy COBOL application or into a new COBOL program -- ready to compile and execute. The compile and execute processes are available from the Project menu in the WOW Designer.

WOW Extensions also makes it easy to test your program and debug your source code.


Windows GUI Elements

See Also

This topic briefly describes the various elements of the Microsoft Windows graphical user interface environment and the fundamental steps involved that allow you to develop and build Windows-based applications with WOW Extensions. These GUI elements include the following:

· Forms

· Controls

· Properties

· Events

· Handles

· IDs

· Functions and messages


Forms

See Also

WOW Extensions uses the term “form” to describe the windows you create in the WOW Designer as you design the interface of your application. These forms, however, are true Microsoft Windows windows. A form looks like a typical window and contains a Control-menu icon (also known as the System-menu icon), a title bar, a border, a client (or workspace) area, and Minimize and Maximize buttons. The form has only default properties associated with it.

Forms are the containers within which you group controls. In traditional programming, you placed fields on the screen or in a pop-up window. With WOW Extensions, you place fields (that is, controls) in a form.

When a program creates a form, all the controls contained on the form are created. The form is the parent of the controls. If the form is moved, the controls move with it. If the form is hidden, the controls are hidden. If the form is destroyed, the controls are destroyed.

Although forms are quite versatile, most of your programming will be involved with manipulating controls, not forms.

Note The evenly spaced marks that appear on the form at design time are the grid. The grid makes it easier to align, reposition, and resize controls visually. The Show Grid and Snap to Grid options on the General Preferences page of the Preferences dialog box, which are enabled by default at design time, cause the edges of each control to align with the nearest grid points. You can disable these options by using the commands from the Form menu. To specify the units of measure for the grid points (that is, the X and Y coordinates), choose the Alignment Preferences page of the Preferences dialog box.


Controls

See Also

Controls are the primary mechanism for getting user input and displaying output information. Controls replace the fields used with the COBOL ACCEPT and DISPLAY statements. A large portion of the interface design consists of using controls to customize the forms that make up your application.

You have probably seen and used controls in other Windows-based software applications. Although they vary from one another in appearance and function, they are all windows, and, as such, can be manipulated in identical ways. They are all hidden, displayed, enabled, disabled, created, destroyed, moved, and resized in the same manner. Tool tips are also available on controls at design time. For more information on manipulating controls in a form, click here.

WOW Extensions supports two broad categories of controls:

· ActiveX controls, which exist as separate files with an .ocx filename extension. These include controls that are available with 32-bit versions of the Windows operating system, such as the animation, toolbar, or progress bar controls, as well those available from third-party vendors.

Note Although ActiveX controls may have additional features, Liant recommends that you use intrinsic controls whenever possible for greater portability.

· Intrinsic controls (or default controls), such as the command button or a check box. The intrinsic controls are the easiest controls to implement, because they are part of the Windows operating system. You do not need to install or distribute any special files to support them. They will work under any version of Windows. Intrinsic controls are always included in the Toolbox, unlike ActiveX controls, which can be removed from or added to the Toolbox.

Note If you are using WOW Extensions to modify an existing RM/Panels panel library, WOW Extensions refers to the objects called "data fields" in RM/Panels as "controls."


Manipulating Controls in a Form

See Also

After populating a form with controls, you can refine the appearance of your form by resizing the form, if necessary. You can also work with the controls in your form for a more balanced layout, and define the tab order and z-order for the controls.

Note You must select a control before you can manipulate it on a form.

For more information about arranging controls on a form, click one of the following topics:

· Selecting one or more control(s)

· Resizing a control

· Moving a control

· Aligning, centering, or spacing a control


Select one or more control(s)

There are several ways to select controls on a form:

· To select a single control, single-click the control on the form with the left mouse button.

You can also select the control from the Objects list, located at the top of the Properties dialog box.

· To select more than one control (which provides a convenient method for moving or aligning a group of controls at the same time), first hold down the Shift key. Then click the remaining controls you want to select, one at a time.

· To use "lasso" or "rubber band"-style selection for one or more controls, position the mouse pointer beside (not on) one of the controls you want to select. Then, drag through all the controls you want to select. While you drag, WOW Extensions draws a dotted rectangle around the controls. When you release the mouse button, one or more controls in the rectangle are selected, depending on settings in the Net Object Selection group on the General Preferences page in the Preferences dialog box.

· To select all controls of the same type, hold down the Alt key and click on one of the controls. For example, if you want to select all the edit boxes on a form, click on one of them while holding down the Alt key. Pressing Shift and Alt together adds the selection to the currently selected objects on a form.

· To select all the controls of one type within a container control, that is, a group box or a tab, first select the container control, then hold down the Alt key and click on one of the controls. For example, if you want to select all the command buttons on a tab, first select the tab, and then click on one of the command buttons while holding down the Alt key.

· To select all the controls in a form, click Select All from the Edit menu.

Note When more than one control is selected in the form, a single Properties dialog box displays all the properties that are shared among the selected controls. (The Objects list area in the Properties dialog box will indicate "Form - Multiple Objects Selected".) This is true even when the value for the shared property differs among the selected controls. In this case, the property value column is empty (or blank). However, when you click on the value area, the value of the first control selected is displayed. When you change any of the shared properties in the Properties dialog box, the property value changes to the new value in all the selected controls. There is one notable exception to this: when you select multiple controls in a form, their Name property no longer appears in the Properties area, even though they all have a Name property. This is because you cannot assign the same value for the Name property to more than one control in a form.


Resize a control

When a control is selected on a form, small squares called sizing handles, appear on the perimeter of the control. To resize a control, select the control on the form, then drag one of the sizing handles to the desired size:

· Drag the handles on the top and bottom to size the control vertically.

· Drag the handles on the left and right sides to size the control horizontally.

· Drag the handles in the corners to size the control both vertically and horizontally.

When you release the mouse button, the control is redrawn in the new size.

You can also size the controls on a form by using the Size command from the Control menu or by using toolbar buttons on the Sizing toolbar.


Move a control

To move a control, select it, then click the body of the control (being careful not to select the sizing handles), and then drag the control to the desired location.

If you wish to move the controls in a position not allowed by the grid, turn off the Show Grid and Snap to Grid commands on the Form menu.


Align, center, or space a control

You can align, center, and distribute controls by using the Align, Center, and Space commands from the Control menu, or by using toolbar buttons on the Aligning, Centering, and Spacing toolbars. If you wish to place your controls in a position not allowed by the grid, turn off the Show Grid and Snap to Grid commands on the Form menu. (You can also change the position of controls with certain properties in the Properties dialog box.)

Note When aligning a group of controls, the first control you select is used as a guide to which the other controls are aligned.

You may need to modify the spacing among the selected controls in even intervals. To space controls evenly:

1. On the Options menu, click Preferences.

The Preferences dialog box opens.

2. Click the Alignment tab.

3. In the Spacing area, click Space Controls and then click OK. The dialog box closes.

With this option, selected controls are distributed equally between the left and right edges of the controls and the leftmost and rightmost boundaries of the form. (The Space Centers options distribute the spacing between the center points of each control and the leftmost and rightmost boundaries of the form.)

4. Select the controls.

5. On the Control menu, click Space, and then point to either Vertical or Horizontal on the submenu.

The spacing among the selected controls is evenly distributed between the edges of the controls and the boundaries of the form.

You can continue to choose or modify alignment options as long as the controls remain selected.


Properties

See Also

Forms and controls have a number of configurable characteristics. These characteristics are called properties. Properties are the primary means by which forms and controls are manipulated. Setting properties defines how forms and controls are displayed and how they function in the running application.

The properties of forms and controls are initially defined in the WOW Designer. During design time, you use the Properties dialog box, which lists each property and its value, to set the default (initial) properties of a selected form or control. That is only half the story, however. Most of those properties can also be altered and retrieved at runtime by the code you enter in the Event-Handling Code dialog box, which means that you have almost the same level of flexibility in customizing your user interface at runtime that you do at design time.

Note While most properties can be retrieved and set either at design time or runtime, there are exceptions. For more information, click here.


Events

See Also

When developing an application with WOW Extensions, you first design the forms, populate those forms with controls, and adjust their properties. You then use WOW Extensions to write and manage the source code to support the forms and controls.

The Windows operating system sends notification messages to the WOW runtime in response to user-performed actions, such as clicking on a command button or switching focus from one control to another. WOW automatically translates these notification messages into events (such as the Click event when the user clicks the mouse, or the LostFocus event when the user changes from one control to another, and so forth). Using the Event-Handling Code dialog box, you attach COBOL event-handling logic to the specific Windows events along with the code necessary to respond to user input. Because Windows programming is event-driven, you write code to respond to user events rather than control the sequence of events.

For more information about the notification messages that trigger events for controls and forms, see the “Event-Triggering Messages” topic in the Functions and Messages online Help file.


Handles

See Also

In a Windows graphical interface, a handle is a number that can be used to uniquely identify and access an object, such as a form or control. While most handles are associated with windows, other types of objects, such as fonts and bitmaps, can also have handles. For example, when a window is created, Windows assigns it a numeric identifier that is specific to that particular window. This number is the window’s handle. The handle is then used to identify the window when Windows wants to inform you of activity for the window, or when you tell Windows to take some action on the window.

The handle is a subscript into an internal table of information maintained by Windows. Using this handle, or subscript, to identify the window gives Windows the ability to relocate its internal information without affecting your application program. (For information on IDs, another type of numerical identifier supported by Windows, click here.)

A handle is valid from the time the object is created until the time the object is destroyed. Once the object is destroyed, the handle may be reused and assigned to another object. Handles are never saved from one session to another. They must always be stored when the object is created. WOW Extensions automatically stores all the required handles when it creates objects, so you do not have to worry about this process.


IDs

See Also

An ID is a numeric identifier assigned by the developer to a form or control when it is created. While handles and IDs are both numerical identifiers of a window, there are several important distinctions between the two values. An ID is assigned by the developer; a handle is assigned by the Windows operating system. An ID may or may not be unique; a handle is always unique. An ID is known at design time; a handle is not known until runtime and must, therefore, be stored for use.

Why does Windows support both types of identifiers? The window handle is essential to the functioning of the operating system. It provides a system-wide, unique identifier so that individual windows can be manipulated. Since several applications are running at once under Windows, the identifiers they use for windows must be unique for the entire system.

The window ID is for the developer’s use in order to simplify the programming of user interaction in windows with controls. If you assign unique ID numbers to controls, application logic can be simplified. For example, an application program might create a window containing four controls: a name text box, an address text box, an OK command button, and a Cancel command button. The application program could assign ID numbers of 1, 2, 3, and 4, respectively, to these controls. The rest of the application code could use the ID numbers to identify the controls, rather than use their window handles.

Windows always uses the window handle to identify the window when it reports events that have taken place for the window. Sometimes it also provides the window ID. Some of the actions you can take on windows allow you to specify either the window handle or the ID.

WOW Extensions makes it easy to use both handles and IDs. Data items containing both values are generated in a copy file having the extension .wws so you can use the data name to specify the ID or handle in your code.


Functions and Messages

See Also

While properties are the primary method for manipulating controls in your programs, there are two other methods of handling controls: functions and messages.

When Windows was developed, functions and messages were the primary way of manipulating controls. In fact, the intrinsic controls do not actually have properties. WOW Extensions imposes a property interface on top of the controls to give you a consistent method for using intrinsic controls and ActiveX controls.

Since Windows did not implement properties for the intrinsic controls, it provided hundreds of functions and messages to use with them. This large number of functions and messages, each with its own unique set of parameters, may seem confusing at first. They do, however, provide a great deal of flexibility that you can use to supplement setting properties, which is the new approach to using these controls. When using properties, you need only remember the property name. The syntax for setting and getting all properties is the same.

Note In most cases, you will use only properties when manipulating ActiveX controls, since these were developed with an emphasis on properties. However, you may use a few functions with ActiveX controls when working with list boxes or combo boxes.

For more information, choose from the following topics:

· What are functions?

· What are messages?

· Using functions and messages

WOW Extensions provides a comprehensive Functions and Messages online Help file, which is accessible from the WOW Designer Help menu.


What are functions?

In WOW Extensions, functions are non-COBOL routines (or subprograms) contained in the WOW runtime that allow you to use the capabilities of the Windows operating system. A function is always executed with a CALL statement and can be passed COBOL parameters. The term “function” is commonly associated with C-language programming, but because most documentation on Windows refers to these subprograms as functions, that term is used in WOW Extensions as well.

Functions allow you to adjust the initial state of the forms and controls that you create in the WOW Designer. A function executes code that can be used to carry out a specific task. Most of the functions that you will use are in the Windows application programming interface (API). Other functions are specifically designed for ActiveX controls; the remaining functions are provided to address issues exclusive to COBOL.

WOW Extensions supports Windows API functions, ActiveX functions, and WOW functions. WOW Extensions has tailored the Windows API to COBOL in order to simplify its use. It has also maintained a close parallel to the C-language syntax. These approaches should allow you to use general reference information on the Windows API from other sources to expand your knowledge of the API. Where substantial differences exist from the standard API functions, the WOW Extensions documentation notes those differences.

For more information, see the Functions and Messages online Help file and Using functions and messages.


What are messages?

Messages are the means of communicating between your application program and the Windows operating environment. The Windows operating system sends messages to your program to give you an opportunity to respond to events. You send messages to Windows to tell it what you want it to do. (This second use is very similar to executing a Windows function. In fact, many Windows functions simply send messages.)

Windows reports hundreds of messages to your application. Liant recommends that you allow WOW Extensions to interpret these messages. Although you can write your own message interpretation code, this advanced task should not be attempted until you have significant experience in developing with Windows.

Since all the messages are Windows messages, they are intended by Windows for use with forms and the intrinsic controls. Messages cannot be sent directly to ActiveX controls.

For more information, see the Functions and Messages online Help file and Using functions and messages.


Using functions and messages

WOW Extensions has a feature that makes it very easy to understand and use the enormous collection of functions and messages. The Code Templates tree in the WOW Designer window lists code templates (also called shortcuts) of every function and most of the frequently used object-manipulation messages that can be used with forms and controls.

When you select and click an item from this list, WOW Extensions inserts into the Code Entry area of the Event-Handling Code dialog box a brief description of the function call or message, the COBOL syntax (calling sequence) for its use, and a description of each parameter in your event-handling code. You simply replace the parameter names and values with your own, and the function or message is ready to use. (The manner in which code is displayed in the Event-Handling Code dialog box is configured by default using the Code Preferences page of the Preferences dialog box.)

While the large number of functions and messages provide a great deal of functionality, there is a significant amount of overlap among them. For example, the SETWINDOWTEXT function and the WM-SETTEXT message both set the text of a window. When you use the SETWINDOWTEXT function, it merely sends a WM-SETTEXT message to the window.


Getting Started

Starting and Exiting WOW Extensions

Configuring WOW Extensions

Customizing the WOW Designer Initialization File

Customizing the WOW Runtime Initialization File

Setting Preferences

Using WOW Extensions Help

WOW Extensions Product Support


Starting and Exiting WOW Extensions

See Also

When you run the WOW Setup program, Setup automatically creates a new program group and new program items for WOW Extensions in Windows. For more information about starting and quitting WOW Extensions, choose one of the following tasks:

· Start WOW Extensions

· Exit WOW Extensions


Start WOW Extensions

You can start WOW Extensions the same way you start any Windows-based application. Use one of the following methods:

· Double-click the program item for cblwow.exe that was created by the installation program.

· Choose Run from the Windows Start menu and specify the path to cblwow.exe.

· Start WOW Extensions from the command line by typing cblwow.

When you first start WOW Extensions, you see the WOW Designer window. (If you have selected the Initial About Box option on the General Preferences page, the About WOW Designer dialog box temporarily appears in the window and will close automatically, or you can click OK to close it manually.)

WOW Extensions assumes that you will be working in a project, which is the top-level building block in the WOW Extensions development environment. For more information about working with projects, click here.

Note Once you start WOW Extensions, you can change the various predefined default preferences created by the WOW installation program. The Preferences dialog box provides several pages of configuration options that you can control. For more information, see Setting Preferences.


Exit WOW Extensions

There are several ways to exit WOW Extensions. Use the one that you prefer.

In the WOW Designer window, use one of the following methods to exit:

· On the File menu, click Exit. Shortcut: Alt+F4.

· Type the letter x from the File menu.

· Left-click the Control-menu icon in the upper-left corner of the title bar and then click Close.

· Click the Close button in the in the upper-right corner of the title bar.


Configuring WOW Extensions

See Also

WOW Extensions includes two initialization files:

· cblwow.ini, a text file that is used to contain initialization information for the WOW Designer. The WOW Designer cblwow.ini file must be located in the same directory as the WOW Designer executable (cblwow.exe) installation folder. The cblwow.ini initialization file is intended to be manipulated by using the Preferences dialog box, although it may be edited manually. For information about customizing the cblwow.ini file, click here.

· wowrt.ini, a text file that is used to contain initialization information for the WOW Extensions runtime system. The WOW runtime wowrt.ini file must be located in the same directory as the runtime dynamic-link libraries (DLLs), which is usually the same directory as the RM/COBOL runtime. The wowrt.ini file is processed whenever the WOW runtime is executed. It is also possible to define runtime settings within the WOW Designer by using the Runtime Preferences page of the Preferences dialog box. For information about customizing the wowrt.ini file, click here.

Note that the WOW_RUNTIME_INI_PATH environment variable can be used to tell the WOW Designer and the runtime system where to locate the wowrt.ini file. The value supplied for this environment variable is a complete pathname, including the filename. Both the filename and the pathname can be changed.

Note that in version 9, a new section, [VERSION COMPATIBILITY] was added to wowrt.ini in order to have the capability to restore pre-version 9 runtime behavior. For more information, click here.


Customizing the WOW Designer Initialization File

See Also

Although it may be edited manually, the WOW Designer initialization file, cblwow.ini, is intended to be manipulated by using the Preferences dialog box. If you do edit this file manually, editing should be restricted to those features described specifically below:

· You may add an [INTERNATIONALIZATION] section in the WOW Designer initialization file to allow support for the Euro currency symbol.

Note that if you add ActiveX controls to your Toolbox, the controls will be recorded in the WOW Designer initialization file.

Other entries in the cblwow.ini file are reserved for use by WOW Extensions.


[INTERNATIONALIZATION] Section

If support is needed for the Euro currency symbol (€) or for international numeric or currency settings, you may manually add an [INTERNATIONALIZATION] section in either or both of the following files:

· cblwow.ini, the WOW Designer initialization file

· wowrt.ini, the WOW runtime initialization file

The entries and values for this section include the following:

[INTERNATIONALIZATION]
EuroSupport=True
EuroCodePointAnsi=<value>
EuroCodePointOem=<value>
LocaleNumeric=country
name
LocaleMonetary=country name

Euro Currency Symbol Support

The [INTERNATIONALIZATION] section contains the following keywords to support the Euro currency symbol:

· EuroSupport=True|False, which turns on and off the ability to map the Euro currency symbol. The default is True.

· EuroCodePointAnsi=<value>, where <value> is in the range 0 through 255, which can be specified in decimal or hex; that is, 128 or 0x80.

· EuroCodePointOem=<value>, where <value> is in the range 0 through 255, which can be specified in decimal or hex; that is, 213 or 0xD5.

Under Windows, two important points must be considered if enabling Euro symbol support:

1. In order to use the Euro symbol, the font used must contain the Euro character symbol (€). To determine whether the font contains the Euro symbol, open the Character Map in the Windows System Tools utility. From the Character Map dialog box, you can display the maps of different fonts. The Euro symbol will usually be located in position 128. Some fonts that contain the Euro symbol are Courier New, Times New Roman, Arial, and Tahoma.

2. If the Euro symbol displays correctly but does not print correctly, it is likely that the internal printer font was used instead of the display font. The printer font may not contain the Euro symbol. Some printers offer a Font Substitutions Table from the Printer Properties dialog box that allows you to enable printing of the Euro symbol by downloading the printer font as “Outline.” Not all printers have this capability, however, and you should refer to your printer documentation for more details.

The Microsoft Knowledge Base provides information on a variety of topics related to using the Euro currency symbol with different Windows operating systems. To search the Knowledge Base, go to:

http://support.microsoft.com/search

Select your operating system (if necessary) and search for “Euro currency symbol”.

International Numeric and Currency Settings Support

The [INTERNATIONALIZATION] section contains the following keywords to support international numeric and currency settings:

· LocaleNumeric=country name

· LocaleMonetary=country name

These keywords allow you to override regional settings when handling numeric or monetary data entry. Pre-version 9 WOW Extensions runtimes allowed the DecChar and EditChar initialization (.ini) options to be used to control the characters used when handling and verifying numeric and monetary data entry. Since later versions of WOW use CodeBridge for some of these functions, and CodeBridge uses the Window's regional (locale) settings for this processing, the pre-version 9 options were removed. To allow regional settings to be overridden, these two new options were added.

The value of these options can be any language supported by the operating system (Windows or UNIX). WOW Extensions and CodeBridge use only three symbols from the regional settings: the decimal point, the thousand's separator, and the currency symbol. An example of using these options would be, when running under a regional setting of "Spanish", to use LocaleNumeric=English and LocaleMonetary=English to force CodeBridge to use the "." instead of the "," for the decimal point, the "," instead of the "." for the thousand's separator, and the "$" instead of the Euro for the currency character.


Customizing the WOW Runtime Initialization File

See Also

Although it may be edited manually, the WOW Extensions runtime initialization file, wowrt.ini, is intended to be manipulated by using the Runtime Preferences page of the Preferences dialog box. If you do edit this file manually, editing should be restricted to those features described specifically below:

· You can define default settings for various runtime activities by manually adding or modifying a [WOWRT] section in the runtime initialization file.

· You can add or modify a [VERSION COMPATIBILITY] section in the runtime initialization file so that the runtime will alter certain behavior to match the behavior of previous versions of the WOW runtime.

· You may add keywords to an [INTERNATIONALIZATION] section in the WOW runtime initialization file to allow support for:

-  the Euro currency symbol, and

-  international numeric and currency settings.

· You can add an [RMPanelsFunctionKeys] section to the WOW runtime initialization file so that the function key information can be loaded by the WOW runtime to run a WOW-enhanced RM/Panels application.


[WOWRT] Section

See Also

By manually adding or modifying a [WOWRT] section in the WOW runtime initialization file (wowrt.ini), it is possible to define the default behavior of various activities at runtime. Note, however, that it is also possible to define most of these settings within the WOW Designer by using the Runtime Preferences page of the Preferences dialog box.

Note For issues concerning backward compatibility, see Obsolete Features for a description of entries and values that may be added to the [WOWRT] section. See also the [VERSION COMPATIBILITY] section that can be added to wowrt.ini in order to restore pre-version 9 WOW runtime behavior.

[WOWRT]
DevelopmentMode=[True/False]
RightJustifyMenus=[True/False]
FilterEvents=[True/False]
EnableActiveXMultipleEventBlocking=[True/False]
EnableMouseMoveEvents=[True/False]
UseOEMConversion=[True/False]
EnableEditBoxInsertKey=[True/False]
ValidNumericChars=0123456789$,.+-
LogFile=filename
LogLevel=n
ToolTipTimeOutSeconds=<integer seconds>

These entries and values change the wowrt.ini file as follows:

· DevelopmentMode determines whether messages that aid in debugging a WOW application at runtime are enabled.

· RightJustifyMenus determines whether the MFT_RIGHTJUSTIFY style will be added at runtime to a menu when it is created.

· FilterEvents determines whether event filtering will be performed for a form and its controls at runtime. Setting FilterEvents to False overrides the default AllowEventFilter property setting (True).

· EnableActiveXMultipleEventBlocking determines whether event code for an ActiveX control will be executed at the same time that another event is being processed. Setting EnableActiveXMultipleEventBlocking to True prevents the execution of multiple events, thus overriding the default AllowMultipleEvents property setting (True).

· EnableMouseMoveEvents determines whether the WOW runtime will recognize mouse move events. Mouse move events consume an inordinate amount of CPU resources even when no event code is attached. This option is useful in preventing such resource consumption unless the developer deems it necessary.

· UseOEMConversion determines whether COBOL data will be converted from OEM to ANSI (and vice versa) when the WOWGETPROP and WOWSETPROP functions are used at runtime. This option is useful if you need to support extended characters in your WOW application. Extended characters are those having an ASCII value greater than 128, such as 'Ü', and '¢'.

· EnableEditBoxInsertKey causes the Insert key to toggle between insert and overwrite modes in edit boxes (and the edit box portion of a combo box). Since this is non-standard Windows behavior, versions of WOW Extensions prior to 9.01 did not allow it. Note that on the Runtime Preferences page, the Enable Edit Box Insert Key option is grouped with the Version Compatibility options.

· ValidNumericChars causes the WOWGETNUM function to return a value of 1 at runtime if an invalid numeric character is contained in the field. By default, valid characters are considered to be the digits 0 through 9, the dollar sign ($), the plus (+) and minus (-) characters, and the edit (comma) and decimal (period) characters. You can change this default to a character set of your choosing. All characters listed will be considered valid numeric characters. A limit of 80 characters is supported.

· LogFile allows you to enter a filename for the trace log.

· LogLevel allows you to specify the level of detail contained in the trace log, where 0 = None, 1 = Log Wow Runtime Calls, 2 = Log Wow Runtime Call Arguments, and 3 = Log Panels Runtime Calls.

· ToolTipTimeOutSeconds allows you to set the length of time, in seconds, that tool tips are visible at runtime.


Obsolete Features

Caution The following entries in the [WOWRT] section are provided for backward compatibility only. Their use can introduce non-standard Windows behavior.

Note that the EnableOldOptions=True entry is required for the any of the subsequent entries to take effect.

EnableOldOptions=True
EditFocusForeground=RRR,GGG,BBB
EditFocusBackground=RRR,GGG,BBB
ButtonFocusForeground=RRR,GGG,BBB
ButtonFocusBackground=RRR,GGG,BBB
ListBoxFocusForeground=RRR,GGG,BBB
ListBoxFocusBackground=RRR,GGG,BBB
DefaultFontName=fontname
DefaultFontSize=fontsize
DefaultFontHeight=fontheight

The RRR,GGG,BBB (Red, Green, Blue) values apply to the foreground and background colors used for edit boxes, command buttons, radio buttons, and list boxes. The DefaultFontName and DefaultFontSize entries apply to all intrinsic controls.


[VERSION COMPATIBILITY] Section

Note In version 9.0 of the WOW Extensions runtime, a [VERSION COMPATIBILITY] section was added to the WOW runtime initialization file (wowrt.ini) in order to have the capability to restore pre-version 9 runtime behavior. It is also possible to define these settings within the WOW Designer by using the Runtime Preferences page of the Preferences dialog box.

The entries and values for this section include the following:

[VERSION COMPATIBILITY]
EnableOldStyleAccelMode=[True/False]
EnableOldStyleFormSizeMode=[True/False]
EnableActiveXKeyPressForTabMode=[True/False]
EnableDoubleClickOnNonStandardListBox=[True/False]
EnableControlEventsOnTabKey=[True/False]
EnableControlEventsOnAccel=[True/False]
EnableNonChildLostFocusEvents=[True/False]
EnableAppSwitchLostFocusEvents=[True/False]
DisableRestoreFocusWhenDialogMotionIsFalse=[True/False]

These entries and values for this section change the wowrt.ini file as follows:

· EnableOldStyleAccelMode determines whether the simulation of a button being pushed will occur when an accelerator is pressed. This behavior is produced by sending a WM_LBUTTONDOWN message followed by a WM_LBUTTONUP message to the control. Versions of WOW Extensions prior to 9.01 sent a WM_COMMAND BM_CLICKED message to the control when an accelerator was pressed.

· EnableOldStyleFormSizeMode determines whether WOW will revert to the manner of changing form size that was used in versions of WOW Extensions prior to 9.01. Version 9.01 corrected inconsistencies in the handling of the WOWGETPROP and WOWSETPROP functions that existed in previous versions of WOW Extensions. In previous versions, the values set by WOWSETPROP when changing the size of a form were not the same as those returned by subsequent WOWGETPROP function calls.

· EnableActiveXKeyPressForTabMode determines whether the WOW Extensions runtime will use the KeyPress event to control Tab key motion for all ActiveX controls on a form. Note that setting this value overrides the EnableKeyPressForTabMode property setting.

If the EnableActiveXKeyPressForTabMode value is set to False, the WOW runtime behavior is controlled by the EnableKeyPressForTabMode property on a per ActiveX control basis.

Version 9 and later of the WOW runtime intercepts keyboard messages before they become ActiveX events and causes tabbing to occur at that point in time, thus causing the KeyPress event not to occur. The EnableActiveXKeyPress for Tab Mode option and the EnableKeyPressForTabMode property were added because not all ActiveX controls allow the WOW runtime to act on the Tab key in this manner, and setting this property to True allows the WOW runtime to behave as it did prior to version 9 (that is, using the KeyPress event to cause Tab key motion).

· EnableDoubleClickOnNonStandardListBox determines whether to turn on the simulation of the double-click event (DblClick) that occurred in pre-version 9 WOW Extensions runtimes for non-standard list box controls. A non-standard list box is one that has the Standard property set to a value of False. Windows does not signal a double-click event on non-standard list boxes.

· EnableControlEventsOnTabKey determines whether a control will receive key events (KeyDown, KeyPress, or KeyUp) when the Tab key is being used for dialog motion (that is, Tab key motion between fields). Version 9 of the WOW Extensions runtime did not pass key events to controls in such instances.

· EnableControlEventsOnAccel determines whether a control will receive key events (KeyDown, KeyPress, or KeyUp) when the Accelerator key is being used. Version 9 of the WOW Extensions runtime did not pass key events to controls in such instances.

· EnableNonChildLostFocusEvents determines whether the LostFocus event will be received by the WOW application when the user switches to another non-child WOW form in the same application. Version 9 of the WOW Extensions runtime suppressed LostFocus events in such instances.

· EnableAppSwitchLostFocusEvents determines whether the LostFocus event will be received by the WOW application when the user switches to another application. Version 9 of the WOW Extensions runtime suppressed LostFocus events in such instances.

· DisableRestoreFocusWhenDialogMotionIsFalse determines whether the WOW Extensions runtime will be prevented from restoring focus to the control that had focus prior to the user or application moving focus to a different form or application.


Setting Preferences

When you installed WOW Extensions, a number of configuration options were predefined. The settings of these options control various defaults, ranging from the general screen appearance to the way code is displayed to how controls are aligned and distributed, among others. You can change these default configuration options using the Preferences dialog box.

To display the Preferences dialog box, click Preferences on the Options menu.

For more information, choose one of the following topics:

· General Preferences

· Fonts & Colors Preferences

· Code Edit Windows Preferences

· Alignment Preferences

· Code Preferences

· Tools Preferences

· External-Editing Preferences

· Runtime Preferences

Note For more information on locating required tools, click here.


Locating Required Tools

See Also

The options on the Tools Preferences page of the Preferences dialog box determine where WOW Extensions locates the RM/COBOL compiler and runtime systems, the CodeWatch debugger, the form test program, the WOW Extensions runtime, and any custom toolbars that were added.

To change the default settings and customize the WOW Designer development environment to your specifications:

1. On the Options menu, click Preferences to open the Preferences dialog box.

2. In the Preferences dialog box, click the Tools tab to open the corresponding page of preferences.

3. Set the preferences to your specifications.


Preferences Dialog Box

See Also

WOW Extensions allows you to establish default settings for various preferences related to the general configuration, color, alignment, code, tools, external editing, and runtime activities. You change these settings in the Preferences dialog box.

To access the Preferences dialog box in the WOW Designer:

· On the Options menu, click Preferences.

When the Preferences dialog box is displayed, click one of the tabs to display the corresponding page of preferences:

· General

· Fonts & Colors

· Code Edit Windows

· Alignment

· Code

· Tools

· External-Editing

· Runtime

Three command buttons, OK, Cancel, and Apply, appear in the lower-right corner in the Preferences dialog box no matter which page is selected and displayed. They perform the same functions in all of the pages in the Preferences dialog box.

· The OK command button closes the Preferences dialog box and saves any changes that you have made on the specified page.

· The Cancel command button closes the Preferences dialog box without saving any changes you have made to the settings.

· The Apply command button saves all the changes you have made without closing the Preferences dialog box.


General Preferences

See Also

The General page in the Preferences dialog box contains preferences that enable you to specify settings that affect what you will see when you start WOW Extensions, and the appearance and behavior of the WOW Designer window.

On the Options menu, click Preferences, and then click the General tab. The General Preferences page contains the following options.

Option

Description

Restore Windows At Startup

If the Restore Windows At Startup check box is selected, WOW Extensions loads (or returns) the last opened windows you worked with (that is, the Toolbox, Properties dialog box, Event-Handling Code dialog box, and/or the Menu Editor dialog box) to their same positions in the WOW Designer window when you last quit WOW Extensions. This option is enabled by default.

Show Tool Tips on Controls

The Show Tool Tips on Controls check box, which is enabled by default, causes a tool tip identifying the type of control to display when the mouse hovers over the control. If you deselect the check box, the change is not effective until the form is reopened.

Initial About Box

The Initial About Box check box, when selected, displays the About WOW Designer dialog box each time you start WOW Extensions. This dialog box (which also can be accessed by using the About command on the Help menu) displays information about your copy of WOW Extensions, including the version of the program, copyright notice, the name and company name of the person the copy is licensed to, and the serial number. (The duration of this display is determined by the Initial About Box Timer option.)

Initial About Box Timer

The Initial About Box Timer option tells WOW Extensions to display the About WOW Designer dialog box for whatever interval -- in seconds -- that you specify. The default value is five seconds. If the Initial About Box check box is not selected, this option is inactive (dimmed).

Expand ActiveX Properties in Property Window

The Expand ActiveX Properties in Properties Window option, which is enabled by default, causes the property page for an ActiveX control to be displayed in the Properties dialog box. If this option is not selected, you must right-click on the ActiveX control to view its properties.

Store Project Profile Settings in Project.ini file

The Store Project Profile Settings in Project.ini file option causes the project-specific profile settings to be stored in a special initialization file rather than in the WOW Designer cblwow.ini file. By default, WOW Extensions creates a separate section in cblwow.ini for each project, which can cause the size of cblwow.ini to grow quite large in some applications. Enabling this option overrides the default behavior and helps reduce the size of cblwow.ini. The project-specific initialization file is stored in the same directory as the project file (.wpj).

Use VB Like Create, Move and Size

The Use VB Like Create, Move and Size option causes WOW Extensions to behave in the same manner as Visual Basic when creating, moving, and sizing controls on a form. When this option is enabled, the control appears as a rectangle on the form until you release the mouse.

Project Update Check

WOW Extensions automatically provides information about product updates for the WOW Designer. The option buttons in the Project Update Check group determine which messages are displayed at start up.

· When the None option button is selected, no messages are displayed.

· When the Urgent option button is selected, only those messages that Liant designates as being urgent are displayed.

· When the All option button is selected, all update messages are displayed. This option is enabled by default.

On Startup

The option buttons in the On Startup group determine what you see on the screen whenever you start WOW Extensions.

· When the New Project option button is selected, the WOW Designer window is displayed with the Save Project dialog box, which establishes the project name and the folder for the project files.

· If you select the Empty Workspace option button, the WOW Designer window opens with a blank work area.

· Choosing the Last Project option button opens the most recently used project in the last WOW session. This option is enabled by default.

Initial

The check boxes in the Initial group determine whether a grid (an evenly spaced pattern of pixels, or screen dots) will appear on a form when it is first created and whether its controls will be in perfect horizontal and/or vertical alignment to the nearest grid point. Both options are enabled by default.

· If you select the Show Grid check box, the grid will appear on the form when it is initially created. For more information, see the Show Grid command on the Form menu.

· If you select the Snap to Grid check box, the form’s controls will be snapped into perfect horizontal and/or vertical alignment to the nearest grid point. For more information, see the Snap to Grid command on the Form menu.

Window Options

The check boxes in the Window Options group determine the way in which various windows are displayed in the WOW Designer. Each of these options is enabled by default.

· Checking the Properties Window Always On Top option displays the Properties dialog box on top of the form during design time when you choose the Properties command on the View menu or click the Show Properties button on the View toolbar.

· Checking the ActiveX Methods Window Always On Top option displays the ActiveX Methods dialog box on top of the form during design time when you choose the ActiveX Methods command on the View menu or click the Show ActiveX Methods button on the View toolbar.

· Checking the Menu Editor Window Always On Top option displays the Menu Editor dialog box on top of the form during design time when you choose the Menu Editor command on the View menu or click the Show Menu Editor button on the View toolbar.

On Execute/Build

The check boxes in the On Execute/Build group determine how files are saved prior to compilation.

· When the Build Before Executing check box is selected, the files will be compiled automatically prior to execution. This option is enabled by default.

· When the Save Files Before Building check box is selected, any modifications are automatically saved prior to compiling the file(s). This option is enabled by default.

· When the Prompt Before Saving Files check box is selected, you will be asked whether or not you want to save any modifications before the files are compiled.

Net Object Selection

The option buttons in the Net Object Selection group determine how to select controls when doing "lasso" or "rubber band"-style selection. That is, when you position the mouse pointer beside (not on) one of the controls you want to select and then drag through all the controls you want to select. While you drag, WOW Extensions draws a dotted rectangle around the controls. When you release the mouse button, one or more controls in the rectangle are selected, depending on the following settings. For more information on selecting controls, click here.

· When the Intersects option button is selected, the dotted rectangle can intersect any portion of a control in order to select it. This option is enabled by default.

· When the Surrounds option button is selected, the dotted rectangle must completely surround a control before it is selected.


Fonts & Colors Preferences

See Also

The Fonts & Colors Preferences page in the Preferences dialog box lets you change some color and font settings in WOW Extensions.

On the Options menu, click Preferences, and then click the Fonts & Colors tab. The Fonts & Colors Preferences page contains the following options.

Option

Description

Control Colors

Use the Control Colors area to set the Default Foreground Color and Default Background Color for the controls at design time and runtime. The RGB (Red, Green, Blue) values for the current color selections are displayed in the text entry boxes, and samples of the colors are shown in the sample display boxes.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground and background colors for the controls. For more information on setting the Color dialog box options, see the Foreground Color and Background Color commands on the Control menu.

Form Color

Use the Form Color area to set the Default Background Color for a form at design time and runtime. The RGB (Red, Green, Blue) value for the current color selection is displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default background color for the form. For more information on the Color dialog box settings for forms, see the Background Color command on the Form menu.

Control Font

Use the Control Font area to establish the font settings (font name, style, special effects, if any, and size) for controls at design time and runtime, as well as viewing a sample of how text will appear with the specified font settings.

Use the ellipsis button (…), located next to the font sample box, to open the standard Windows Font dialog box to change the default font and sample font for the controls.

Code Edit, Find in Code, and Compiler Output Windows

Use the Code Edit, Find in Code, and Compiler Output Windows area to specify the default settings for the appearance of the application source code that is displayed in the Code Entry and Working Storage areas (collectively known as the "code edit" windows) of the Event-Handling Code dialog box, and on the Find in Code and Compiler Output tabs of the Project Output dialog bar as a result of a code search or a compilation:

· The Font and Sample option controls the appearance of the source code text in these windows. Click the ellipsis button (…) to display the standard Windows Font dialog box, which allows you to select the font settings for the text. Once you have determined these settings and closed the Font dialog box, your selections (font name, style, special effects, if any, and size) will appear in the Font and Sample text box.

· The Background Color option controls the default color used for the background of these windows displaying the application source code. Click the ellipsis button (…) to display the standard Windows Color dialog box, which allows you to change the default background color. Once you have determined this setting and closed the Color dialog box, the RGB (Red, Green, Blue) values for the color selection are displayed in the Background Color text box, and a sample of the color is shown in the sample display box.


Code Edit Windows Preferences

See Also

The Code Edit Windows Preferences page in the Preferences dialog box provides features to edit your application source code and specify how it is displayed in the "code edit" windows (this term refers to the Working Storage and Code Entry areas of the Event-Handling Code dialog box), and in the Find in Code and Compiler Output tabs of the Project Output dialog bar a result of a code search or a compilation.

The options include support for coloring syntax and vertical line columns (to set selection margins that can contain markers that help identify lines of code). The Code Edit, Find in Code, and Compiler Output Windows option on the Fonts & Colors Preferences page allows the use of proportional fonts, bold and italics, and multiple foreground and background color.

On the Options menu, click Preferences, and then click the Code Edit Windows tab. The Code Edit Windows Preferences page contains the following options.

Option

Description

Working Storage Edit Window Percentage

The Working Storage Edit Window Percentage option allows for the initial size of the Working Storage area of the Event-Handling Code dialog box to be preset. The size can range from a value of 0 to 100 percent. Once this percentage has been set, it then becomes the default size for the Working Storage area. This option is useful when more space is desired for the Code Entry area, as it allows the size of the Working Storage area to be reduced.

Tab Stops

The Tab Stops option specifies the column numbers in the COBOL source code at which tab stops will be placed. By default, the initial tab stop is defined as 8, with subsequent tab stops set at intervals of 4. Tab stops can be set to any column, must be separated by commas, and must be in increasing order.

Marker Type

You can define the type (style) of marker that is displayed in your source code by choosing one of the items listed in the Marker Type option. The available choices include: Short Arrow (the default), Circle, Round Rectangle, Arrow, Small Rectangle, Empty, Arrow Down, Minus, Plus, Arrows, Dot Dot Dot, Background, and Full Rectangle.

Auto Indent

When selected, the Auto Indent option causes the next line to be indented the same number of spaces as the current line when the Enter key is pressed. By default, the Auto Indent option is selected.

Show Line Number

When selected, the Show Line Number option indicates the edit position in the source code.

Show Markers

Markers are set on specified lines in the source code and are contained in the selection margin. Markers help you find a certain line of code quickly. By default, the Show Markers option is selected and all markers are displayed.

Vertical Lines

The Vertical Lines option defines the column position of the thin vertical lines that serve as alignment guides when placing COBOL code in the proper areas. You also can specify the color of these lines by using the Vertical Line Color option.

Vertical Line Color

The Vertical Line Color option specifies the color of the vertical lines defined in the Vertical Lines option.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default color for this option.

Line Number Foreground Color

The Line Number Foreground Color option specifies the foreground color of line numbers in the code edit windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground color for this option.

Line Number Background Color

The Line Number Background Color option specifies the background color of line numbers in the code edit windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default background color for this option.

Marker Foreground Color

The Marker Foreground Color option specifies the foreground color used for markers in the code edit windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground color for this option.

Marker Background Color

The Marker Background Color option specifies the background color used for markers in the code edit windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground color for this option.

Syntax Coloring

Use the options in the Syntax Coloring area to highlight syntax, which provides a helpful visual clue to your various code components. You are able to customize the default foreground and background colors for keywords, comment lines, bad braces, brace highlights, and operators in the source code file.

The RGB (Red, Green, Blue) values for the current color selections are displayed in the text entry boxes, and samples of the colors are shown in the sample display boxes for each of these options.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground and background colors for each of these options.


Alignment Preferences

See Also

The Alignment page in the Preferences dialog box allows you to change the alignment and distribution (spacing) settings of controls.

On the Options menu, click Preferences, and then click the Alignment tab. The Alignment Preferences page contains the following options.

Option

Description

Grid

The options in the Grid area control the vertical and horizontal spacing of the grid coordinates on the form. The default spacing is 10 x 10 pixels.

· To change the spacing in the horizontal grid, click the X Increment box and type a value.

· To change the spacing in the vertical grid, click the Y Increment box and type how many vertical grid marks you want to be visible.

Note If the Snap to Grid command on the Form menu is enabled, you can align controls to the grid. When you align controls to the grid, the bounds (or edges) of the controls are lined up as specified, snapping to the nearest grid point. The Snap to Grid option on the General Preferences page is enabled by default.

Nudge

The options in the Nudge area determine how far the selected control moves when a key is pressed. The arrow keys on your keyboard allow you to move or "nudge" controls on your form in the direction indicated by the arrow and in the increments specified.

· To nudge a control in the horizontal grid, click the X Increment box and type a value.

· To nudge a control in the vertical grid, click the Y Increment box and type a value.

If you press and hold the Ctrl key, the control moves in continuous increments. Other cursor movement keys include PageUp (PgUp), PageDown (PgDn), Home, and End keys, as well as the key combinations Ctrl+Home and Ctrl+End.

Alignment

The pair of option buttons in the Alignment area determines how the Align command on the Control menu aligns selected controls horizontally and vertically relative to each other on a form.

· The Use First Control option button aligns controls relative to the first control selected. This option is enabled by default.

· The Use Average Control option button aligns controls based on the average size and position of the selected controls.

Spacing

The pair of option buttons in the Spacing area modifies the behavior of the Space command on the Control menu.

· Selecting the Space Centers option button distributes the selected controls on a form such that the spacing between the centers of the controls is equal.

· Selecting the Space Controls option button distributes the selected controls such that the spacing between the edges of the controls is equal. This option is enabled by default.


Code Preferences

See Also

The Code page in the Preferences dialog box lets you specify the way in which the code templates are displayed in the Code Entry area of the Event-Handling Code dialog box for the selected object and event or code section. The code templates are displayed when you make a selection from the Code Templates tree. To toggle the display of the Code Templates tree:

· On the View menu, click Code Templates.

On the Options menu, click Preferences, and then click the Code tab. The Code Preferences page contains the following options.

Note The New Project Options area contains actions that pertain only to the creation of a new project.

Option

Description

Insert Code Case

The Insert Code Case group determines how the code template, generated by the function or message that you select from the Code Templates tree, is inserted in the Code Entry area of the Event-Handling Code dialog box. These options insert your code in Mixed Case (a combination of uppercase and lowercase letters, which is the default), all Uppercase letters, or all Lowercase letters, respectively. Whatever coding style you choose, the compiler can handle it properly as long as the code is syntactically correct.

Insert Code Template Comments

All the options in the Insert Code Template Comments group are enabled by default.

· Insert Descriptions inserts a description of the code at the beginning of the code template in the Code Entry area. The description is preceded by an asterisk (*).

· Insert Comments displays the remarks in the code template in the Code Entry area. These remarks will help you and other users examine and understand the code’s logic. The compiler ignores all comment lines, which are preceded by an asterisk (*).

· Insert To Do Comments displays remarks in the code template in the Code Entry area. These remarks describe coding activities that need to be done. The compiler ignores all comment lines, which are preceded by an asterisk (*).

Menu Name Generation

As with all controls, when you add a menu control to the form, WOW Extensions assigns it a default name. In the New Project Options area, the options in the Menu Name Generation group determine the naming conventions used for menu controls.

· If you select Generate Long Names and give a menu control a Title property value of File in the Menu Editor dialog box, for example, WOW Extensions automatically assigns the menu control a Name property of MENU-FILE.

Tip The Generate Long Names option causes the full name of the menu option to be used to create the internal menu name in the COBOL source code by adding hyphens (-) to it. If your menu entries are long, this can result in the name being truncated as the internal name is created. Furthermore, internal names may be duplicated inadvertently. If you are using menus, set the preference to Generate Short Names to avoid this problem.

· If you select Generate Short Names (the default), WOW Extensions sets the Name property for the control with the prefix M-; in the preceding example, the Name would be abbreviated to M-File.

· Selecting Do Not Generate Names allows you to assign a more descriptive and meaningful name to the menu control.

In all cases, the menu name appears in the Events/Code Sections list of the menu Event-Handling Code dialog box.

Note Because the Name property provides the name WOW Extensions uses to reference the menu control in the underlying code, you cannot leave the Name property blank. Be careful also to assign a unique name to the control to avoid possible name conflicts with duplicate names.

ActiveX Enum Generation

The check boxes in the ActiveX Enum Generation group of the New Project Options area allow you to control the generation of constants that can be used when writing code for ActiveX properties, methods, and events. All options are enabled by default.

· Generate Form Level causes 88-level condition-names for the ActiveX control to be generated at the form level in the Working-Storage section.

· Generate Control Level causes 78-level condition-names for the ActiveX control to be generated at the control level in the Working-Storage section.

· Generate Event Level causes 78-level condition-names for the ActiveX control to be generated at the event level in the Working-Storage section.

Generate Short Control Handles

In the New Project Options area, the Generate Short Control Handles option, which is enabled by default, removes the suffix -H from the name of the control or form in order to avoid duplicate variable names.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate -FRMH Form Handles

In the New Project Options area, the Generate -FRMH Form Handles option adds the suffix -FRMH to the name of the form. This prevents a form from having the same name as a control, which would cause duplicate variables.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate Nested Programs

In the New Project Options area, the Generate Nested Programs option causes the project to be generated in a fully block-structured form. Subprograms can be nested within the main program and with other subprograms. Each subprogram can own variables not visible to the other programs, and all calls to subprograms can pass parameters. In order to use the Generate Old-Style Paragraph Names option, the Generate Nested Programs option must not be selected.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate Working Storage Comments

In the New Project Options area, the Generate Working Storage Comments option, which is enabled by default, generates comment lines in the Working Storage copy file (.wws) for WOW forms. To make the source file smaller, deselect this option. Having a smaller source file helps ensure that the RM/COBOL compiler can accommodate the WOW program.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate Old-Style Paragraph Names

In the New Project Options area, the Generate Old-Style Paragraph Names option, when selected, allows new projects created with WOW Extensions to use old-style paragraph names; that is, paragraph names with the format, WP-DESTROY-FORMNAME. In order for old-style paragraph names to be used, the Generate Nested Programs option must not be selected.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate Old-Style Working-Storage Guard Names

In the New Project Options area, the Generate Old-Style Working-Storage Guard Names option, when selected, causes the WOW Designer to generate Working-Storage guard names that are limited to 30 characters in length, which was the case in versions prior to 10.01. Versions 10.01 and later of the WOW Designer can generate names up to 240 characters long. Selecting this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate Untruncated Paragraph Names

In the New Project Options area, the Generate Untruncated Paragraph Names option, which is enabled by default, allows the WOW Designer to generate paragraph names that are no longer abbreviated (or truncated) in order to avoid duplicate paragraph names caused by the previous truncation scheme. Selecting this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate Short
(72 column) Lines

In the New Project Options area, the Generate Short (72 column) Lines option, when selected, causes the WOW Designer to generate COBOL source records ending at column 72 (for backward compatibility). If this option is not selected, source records with longer line lengths (now allowed by an RM/COBOL compiler directive) are generated.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.

Generate Multiple Evaluate Events Paragraphs

In the New Project Options area, the Generate Multiple Evaluate Events Paragraphs option, when selected, causes the WOW Designer to generate multiple paragraphs (instead of the default, single paragraph) when evaluating events in large applications in order to avoid reaching the COBOL compiler paragraph size limit.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Tools Preferences

See Also

The options on the Tools page in the Preferences dialog box determine where WOW Extensions locates the RM/COBOL compiler and runtime systems, the CodeWatch debugger, the form test program, the WOW Extensions runtime, and any custom toolbars that were added.

On the Options menu, click Preferences, and then click the Tools tab. The Tools Preferences page contains the following options.

Option

Description

COBOL Compiler

Use the COBOL Compiler area to specify directives for the RM/COBOL compiler.

· The RMPath text box allows you to set the RMPATH synonym used by the compiler to locate copy files.

· The Command Tail text box allows you to add additional compiler command-line arguments at the end of the command line. These options will be applied each time you compile any program from the WOW Designer.

· The OEM Compiler check box tells the WOW Designer whether to use the OEM or ANSI compiler to compile the project. This information allows the Designer to properly access the Windows registry to retrieve the RMPATH synonym, which is used to locate and search copy files used in the LINKAGE section of the project COBOL code. Deselecting this check box indicates that the compiler is using the ANSI code set for character data.

COBOL Runtime

Use the COBOL Runtime area to specify the location of the RM/COBOL runtime system.

· The Directory text box allows you to specify the runtime system’s installation directory, which must exist or be accessible when running the WOW application from the WOW Designer. If you enter a value of %RM_PROGRAM_DIR%, the WOW Designer will use the value of the environment variable, RM_PROGRAM_DIR, as the location of the runtime system. RM_PROGRAM_DIR is set during the installation of the RM/COBOL development system to point to the directory where the development system is installed.

· The Command Tail text box allows you to add additional runtime command-line arguments at the end of the command line. These options will be applied each time you run any program from the WOW Designer.

COBOL Debugger

Use the COBOL Debugger area to specify the location of the CodeWatch debugger’s installation directory.

The Directory text box allows you to specify the debugger’s installation directory, which must exist or be accessible when using CodeWatch from the WOW Designer. If you enter a value of %RM_PROGRAM_DIR%, the WOW Designer will use the value of the environment variable, RM_PROGRAM_DIR, as the location of the CodeWatch debugger. RM_PROGRAM_DIR is set during the installation of the RM/COBOL development system to point to the directory where the development system is installed. For more information on debugging, click here.

Form Test Program

Use the Form Test Program area to specify the location of the form test program, wowtestform.exe. This test form program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

The Directory text box allows you to specify the form test program’s installation directory, which must exist or be accessible when testing a form with the WOW Designer.

WOW Runtime

Use the WOW Runtime area to specify the location of the WOW Extensions runtime system, wowrt.dll.

The Directory text box allows you to specify the runtime system’s installation directory, which must exist or be accessible when running the WOW application or testing a WOW panel from the WOW Designer. Note that version 9 and later of the WOW Designer uses the WOW runtime for testing panels.

File Difference Program

Use the File Difference Program area to specify the location of a file comparison tool other than the default, Microsoft Windows windiff, for comparing code differences in the External Edit Comparison dialog box.

The Path text box allows you to enter the complete pathname of the file comparison program.

Custom Toolbar Titles

Use the Custom Toolbar Titles area to specify the title of the new custom toolbar(s), Custom 1 and Custom 2, which can be created with the Customize Toolbar dialog box. Changes will be recorded in the WOW Designer initialization file, cblwow.ini. The WOW Designer must be restarted before the titles will take effect. When a custom toolbar is undocked, the title will be visible.


External-Editing Preferences

See Also

WOW Extensions enables you to view and modify the program source code, which is part of the programname.wpr copy file, with any standard text editor. (You may wish to use such an editor when developing a large program in order to take advantage of more extensive editing and search features.) The External-Editing page in the Preferences dialog box displays various options that control how WOW Extensions reacts to external edits.

Note The changes you make through external editing do not become permanent until you recompile your program.

On the Options menu, click Preferences, and then click the External-Editing tab. The External-Editing Preferences page contains the following options.

Option

Description

At Form/Project Open

The At Form/Project Open area, which contains a group of option buttons, controls how WOW Extensions behaves when a form is opened after it has been externally edited.

· The Use External Changes option unconditionally uses any external edits without notifying you (except as indicated under the Prompt When Code Has Been Externally Edited option in the At Application Activation area).

· If you select the Do Not Use External Changes option, no external edits are used and you will not be notified.

· The Ask To Use External Changes option, selected by default, displays the External Edit Comparison dialog box, prompting you to accept or ignore the external changes. The dialog box displays both the original and edited code.

At Application Activation

The At Application Activation area, which consists of a check box and three option buttons, controls how WOW Extensions behaves when you switch back to WOW Extensions after making external edits to a form that is already open in a WOW session.

· The Prompt When Code Has Been Externally Edited check box, selected by default, displays a message box informing you that external changes may have occurred (file modification times do not match the times when WOW Extensions opened the file). This message box asks if you want WOW Extensions to look for these changes. If you answer No, WOW Extensions will ignore the external changes. If you answer Yes, the remaining options in this group control how WOW Extensions will behave when it finds the changes.

Note If you have selected the Do Not Use External Changes option in the At Form/Project Open area, WOW Extensions displays the External Edit Comparison dialog box, noting that a code section has been deleted when the form is opened or WOW Extensions is activated again).

· The Use External Changes option unconditionally uses any external edits without notifying you (except as indicated under the Prompt When Code Has Been Externally Edited option).

· The Do Not Use External Changes option causes no external edits to be used and you will not be notified.

· The Ask To Use External Changes option, selected by default, displays the External Edit Comparison dialog box, prompting you to accept or ignore the external changes. The dialog box displays both the original and edited code.

Prompt When Code Has Been Externally Deleted

The Prompt When Code Has Been Externally Deleted option, enabled by default, provides an additional safety mechanism. It informs you when a section of code has been deleted, regardless of any of the external editing option settings described previously, except for the Do Not Use External Changes option in the At Form/Project Open area. The Prompt When Code Has Been Externally Deleted option displays the External Edit Comparison dialog box prompting you to accept or ignore the external changes. The dialog box displays both the original and deleted code.


Runtime Preferences

See Also

The options on the Runtime page in the Preferences dialog box allow you to define the default behavior of various activities at runtime.

Note These settings also can be modified manually in the WOW Extensions runtime initialization file, wowrt.ini.

On the Options menu, click Preferences, and then click the Runtime tab. The Runtime Preferences page contains the following options.

Option

Description

Development Mode

The Development Mode option enables messages that aid in debugging a WOW application at runtime.

Right Justify Menus

The Right Justify Menus option causes the MFT_RIGHTJUSTIFY style to be added at runtime to a menu when it is created.

Do Not Filter Events

The Do Not Filter Events option causes event filtering not to be performed for a form and its controls at runtime, overriding the default of the AllowEventFilter property setting (True).

Use OEM Conversion

The Use OEM Conversion option causes COBOL data to be converted from OEM to ANSI (and vice versa) when the WOWGETPROP and WOWSETPROP functions are used at runtime. This option is useful if you need to support extended characters in your WOW application. Extended characters are those having an ASCII value greater than 128, such as 'Ü' and '¢'.

Enable AX Multiple Event Blocking

The Enable AX Multiple Event Blocking option prevents ActiveX event code from being executed while another event is being processed. In order to prevent multiple events from occurring, this option must be selected and each ActiveX control for which the developer wishes to block multiple events must have the property AllowMultipleEvents set to False.

Enable Mouse Move Events

The Enable Mouse Move Events option, when selected, causes the WOW Extensions runtime to recognize mouse move events. Mouse move events consume an inordinate amount of CPU resources even when no event code is attached. The ability to de-select this option is useful in preventing such resource consumption unless the developer deems it necessary.

Valid Numeric Characters

The Valid Numeric Characters option causes the WOWGETNUM function to return a value of 1 at runtime if an invalid numeric character is contained in the field. By default, valid characters are considered to be the digits 0 through 9, the dollar sign ($), the plus (+) and minus (-) characters, and the edit (comma) and decimal (period) characters. You can change this default to a character set of your choosing. All characters listed will be considered valid numeric characters. A limit of 80 characters is supported.

For Logging

The For Logging area contains options for controlling the use of a tracing log.

· The File option allows you to enter a filename for the trace log.

· The Level option allows you to specify the level of detail contained in the trace log, where:

-  0 = None

-  1 = Log Wow Runtime Calls

-  2 = Log Wow Runtime Call Arguments

-  3 = Log Panels Runtime Calls

Version Compatibility

The options in the Version Compatibility area are as follows:

· The Enable Edit Box Insert Key option, when selected, causes the Insert key to toggle between insert and overwrite modes in edit boxes (and the edit box portion of a combo box). Since this is non-standard Windows behavior, versions of WOW Extensions prior to 9.01 did not allow it. Note that the location of the EnableEditBoxInsertKey configuration option is in the [WOWRT] section rather than in the [Version Compatibility] section of wowrt.ini.

· The Enable Old Style Accelerator Mode option, when selected, causes the simulation of a button being pushed when an accelerator is pressed. This behavior is produced by sending a WM_LBUTTONDOWN message followed by a WM_LBUTTONUP message to the control. Versions of WOW Extensions prior to 9.01 sent a WM_COMMAND BM_CLICKED message to the control when an accelerator was pressed.

· The Enable Old Style Form Size Mode option, when selected, reverts to the manner of changing form size that was used in versions of WOW Extensions prior to 9.01. Version 9.01 corrected inconsistencies in the handling of the WOWGETPROP and WOWSETPROP functions that existed in previous versions of WOW Extensions. In previous versions, the values set by WOWSETPROP when changing the size of a form were not the same as those returned by subsequent WOWGETPROP function calls.

· The Enable ActiveX Key Press for Tab Mode option, when selected, allows the WOW Extensions runtime to use the KeyPress event to control Tab key motion for all ActiveX controls on a form. Note that selecting this option overrides the EnableKeyPressForTabMode property.

If the Enable ActiveX Key Press for Tab Mode check box is not selected, the WOW runtime behavior is controlled by the EnableKeyPressForTabMode property on a per ActiveX control basis.

Version 9 and later of the WOW runtime intercepts keyboard messages before they become ActiveX events and causes tabbing to occur at that point in time, thus causing the KeyPress event not to occur. The Enable ActiveX Key Press for Tab Mode option and the EnableKeyPressForTabMode property were added because not all ActiveX controls allow the WOW runtime to act on the Tab key in this manner, and setting this property to True allows the WOW runtime to behave as it did prior to version 9 (that is, using the KeyPress event to cause Tab key motion).

· The Enable Double Click on Non-Standard List Box option, when selected, turns on the simulation of the double-click event (DblClick) that occurred in pre-version 9 WOW Extensions runtimes for non-standard list box controls. A non-standard list box is one that has the Standard property set to a value of False. Windows does not signal a double-click event on non-standard list boxes.

· The Enable Control Events on Tab Key option, when selected, allows a control to receive key events (KeyDown, KeyPress, or KeyUp) when the Tab key is being used for dialog motion (that is, tab key motion between fields). Version 9 of the WOW Extensions runtime did not pass key events to controls in such instances.

· The Enable Application Switch Lost Focus Events option, when selected, allows the LostFocus event to be received by the WOW application when the user switches to another application. Version 9 of the WOW Extensions runtime suppressed LostFocus events in such instances.

· The Enable Non-Child Lost Focus Events option, when selected, allows the LostFocus event to be received by the WOW application when the user switches to another non-child WOW form in the same application. Version 9 of the WOW Extensions runtime suppressed LostFocus events in such instances.

· The Enable Control Events on Accelerator option, when selected, allows a control to receive key events (KeyDown, KeyPress, or KeyUp) when the Accelerator key is being used. Version 9 of the WOW Extensions runtime did not pass key events to controls in such instances.

· The Disable Restore Focus When Dialog Motion Is False option, when selected, prevents the WOW Extensions runtime from restoring focus to the control that had focus prior to the user or application moving focus to a different form or application.


Using WOW Extensions Help

See Also

WOW Extensions comes with extensive online assistance and step-by-step instructions.

You can access Help while using WOW Extensions in a number of ways. The method you use often depends on the type of information for which you are searching.

· Help Contents. In the WOW Designer window, from the Help menu, click either Designer or Functions and Messages to open the appropriate online HTML Help system. The left side of the Help window (the navigational pane) contains the Contents, Index, Search, and Favorites tabs. The right side of the Help window (the topic pane) displays the currently selected Help topic. Across the top of the Help window is a group of buttons that help you navigate through the Help contents and perform other operations, such as printing a topic in the Help file. For more information, see Help Button Bar.

-  To browse through topics grouped by subject: Click the Contents tab. From here, you can go directly to information that is more specific and a list of all the Help topics by double-clicking any closed book icon. Then select the topic of interest from the expanded list and click the topic. The Help window for that topic appears in the topic pane.

-  To see a list of alphabetized index entries (or keywords): Click the Index tab to find specific topics listed alphabetically (the online index is arranged just like a book index). Type an entry or the first few letters of the word for which you want to search, or scroll through the list. Then select the topic and click the Display command button. The content of the Help topic opens in the Help window.

-  To search for words or phrases that may be contained in a Help topic: Click the Search tab. Follow the instructions on your screen to complete this task.

-  To create a list of preferred Help topics: Click the Favorites tab. Follow the instructions on your screen to complete this task. Note that, by default, the contents of this tab is empty until you select topics to populate it. The content of the Favorites tab is automatically saved between sessions.

· Context-sensitive Help. While working in WOW Extensions, you can easily and quickly access help for menu commands, toolbar buttons, control icons, and other screen elements.

To display Help about a particular user interface item:

-  Click the What's This? button [image] on the Help toolbar (or press Shift+F1), and then click the item you want information on. For a menu command, you must highlight the menu command first with the mouse or keyboard (press the Alt key followed by the underlined letter in the menu name, and then press the arrow keys to highlight the command). The Help file will open and display the Help topic associated with what you clicked.

-  You can also press F1 to display more extensive context-sensitive Help for a highlighted element or menu command, or a selected toolbar button.

Note You can copy or print the information in a pop-up Help window by right-clicking inside the pop-up window, and then clicking Copy or Print Topic.

-  To display help for a dialog box, choose a menu command that opens a dialog box and press F1, or choose the Help button, if one is present.

· Help button in a dialog box. If available, click the Help button in the dialog box you are using. A Help topic explaining the dialog box appears.

· Tool tips. When you pause with the pointer (without the mouse button pressed) over an item on a toolbar or a control, a small pop-up window that includes a brief description is displayed.

You can exit WOW Extensions online Help from the Help window by clicking the Close button on the title bar or double-clicking the Control menu icon at the left end of the title bar. To exit a context-sensitive Help window, if necessary, press the Esc key on the keyboard.


Help Button Bar

See Also

Several Help buttons enable you to move around the WOW Extensions Help topics easily. These Help buttons, located on the button bar along the top of the WOW Extensions Help window, provide the following actions.

Button

Action

Contents

The Contents button displays the Contents tab of either the WOW Designer or the WOW Extensions Functions & Messages Help Topics dialog box.

Hide/Show

Click the Hide button to close the navigational pane (on the left) of the Help window. Only the button bar and the topic pane are visible. To restore the navigational pane, click the Show button.

Note Be default, all three panes of the Help window are displayed initially.

Previous

Click the Previous button to display the previous topic in a series of related topics. When the first topic in the series is reached, the Previous button appears dimmed and is unavailable.

Next

Click the Next button to display the next topic in a series of related topics. When the last topic in the series is reached, the Next button appears dimmed and is unavailable.

Back

Click the Back button to display the content of the last Help topic viewed. Each time the Back button is chosen, topics are displayed one at a time moving backwards through the order in which topics were previously viewed.

Print

If you are in the topic pane, click the Print button to display the standard Windows Print dialog box, which allows you to print a copy of the current Help topic.

Shortcut: Right-click the mouse button over a Help window and click Print from the context-sensitive menu that appears.

Note If you are on the Contents tab, click this button to print pages, headings, and subtopics, or the entire table of contents. If you are on the Index or Search tab, this button opens the standard Windows Print dialog box to print the current topic.

Options

Click the down arrow on the Options button to display a menu list that includes the following:

· Hide Tabs. Closes the navigational pane.

· Back. Jumps to the previous topic.

· Forward. Jumps to the next topic in a previously-viewed sequence.

· Home. Jumps to the designated home page of the Help system.

· Stop. Stops downloading file information.

· Refresh. Updates the topic that is currently displayed in the topic pane.

· Print. If you are on the Contents tab, provides options to print pages, headings, and subtopics, or the entire table of contents. If you are on the Index or Search tab, it opens the standard Windows Print dialog box to print the current topic.

If you are in the topic pane, click this option to display the standard Windows Print dialog box, which allows you to print a copy of the current Help topic.

· Internet Options. Opens the Internet Explorer Internet Options dialog box allowing quick access to accessibility and other features.

· Search Highlight On/Off. Turns on or off highlighting for search terms.


WOW Extensions Product Support

Liant Software Corporation offers a variety of services to help you with your questions. The online Help files are designed to address the majority of users' questions. If, however, these sources do not answer your question or problem, please check the following:

· README files included with the WOW media.

· Liant web site at http://www.liant.com.

Contact Liant Software Corporation to obtain more information about Liant's technical support and training programs, as well as other products, upgrades, and services.


Contacting Liant Software Corporation

Use any of the following methods to contact Liant Software Corporation:

By | At
E-mail | info@liant.com
Web site | http://www.liant.com
Telephone | US | (1) 512-343-1010 (1) 800-762-6265 (800-RM-COBOL)
Fax | US | (1) 512-343-9487
Mail | Liant Software Corporation 5914 West Courtyard Drive, Suite 100 Austin, Texas 78730 USA Registered in England No. 2355483 Registered Office: Pellipar House, 1st Floor, 9 Cloak Lane, London, EC4R 2RU VAT Registration No. GB 503 3514 90


Developing with WOW Extensions

Using WOW Projects

Developing Event-Driven Applications

Addressing Issues in Data Entry Programs

Working with Menus

Looking Behind the Scenes


Using WOW Projects

See Also

Most of the time, your user interface will consist of multiple forms. After you have created your forms, you will want to add file access and other code to the rest of the program. To provide these capabilities in a seamless environment, WOW Extensions provides a facility called a project.

A project is the top-level building block in the WOW Extensions development environment. When you create a project, WOW Extensions lets you specify the forms that are used in the project and which of the forms are initially visible when the project starts. Not only will WOW Extensions keep track of all the forms that are part of the project, it will create a skeleton COBOL program that creates, operates, manages, and removes the forms in a project. You can also use the WOW Designer to add event-handling code and manage other sections of the COBOL program. The Event-Handling Code dialog box lists every code section of the COBOL program in the Events/Sections list box. You can copy in your file descriptions, declaratives and create additional Working Storage data items from within the WOW Designer. The default extension for WOW project filenames is .wpj. The .wpj project definition file is a binary file that contains project configuration information and a list of the forms included in the project.

WOW Extensions assumes that you will be working in a project. In the WOW Designer window, all the forms in a project are displayed in the Project tree. The Project menu provides all the commands necessary for working with the project.

Note Beginning with version 3, this product is project-based. If you have a form-based application created with a version of the product earlier than version 3, you must create a project and add the form files in the existing application to it.

For procedures on how to work with WOW projects, click one of the following:

· Create a project

· Edit an existing project


Create a project

1. On the Project menu, click New. Or, click New Project on the Project toolbar.

The Save Project dialog box (a standard Windows dialog box) opens.

Note Only one project can be opened at one time. If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created.

2. Enter a name for the project and the folder for the project files. (The default extension for a WOW project filename is .wpj.) Click Save.

The Project Properties dialog box opens.

3. In the List area, specify the members (form files) that you want to use in the project by highlighting the form filename (.wow is the default extension for a WOW form file), and then either double-click with the mouse or click the Add command button. To view more form files, open another folder in the List area or click the arrow in the Look in list box to go to another location on your computer.

The forms are added to the project and the names of the selected form files are displayed in the Members in Project area.

Note To add more than one of the listed files to the project, first hold down the Ctrl key. Then click the remaining files you want to select, one at a time. When all the desired files are selected, click Add. To add a group of files, select the first file in the group, hold down the Shift key, and then select the last file in the group. All files in the group will then be selected. Click Add to add the group of files to the project.

4. Click Close to accept the changes and close the Project Properties dialog box.


Edit an existing project

1. On the Project menu, click Open. Alternatively, click Open Project on the Project toolbar.

The Open Project dialog box (a standard Windows dialog box) opens, listing all available project (.wpj) files.

Note Only one project can be opened at one time. If you are already in an open project when you choose the Open command on the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.

2. Select the desired project file and click Open. The project name is listed in the Project tree in the WOW Designer window.

3. Double-click the project name to open the Project Properties dialog box in order to add or delete members (form files).


Developing Event-Driven Applications

See Also

Even before Windows came along, COBOL programmers were not the only ones struggling with how to code user-input logic. Everybody else was too. The developers of Windows took a new approach to user input, which is reflected in WOW Extensions. This new concept is called “event-driven” programming, as opposed to the more traditional method, sequential programming.

In sequential programming, the programmer dictates the exact sequence of events in the program. The user is directed to enter field 1, then field 2, and so forth. With this method, the programmer always knows what is going to happen. In actual use, however, users generally want to be in charge and enter things in whatever manner they wish.

Event-driven programming allows users to have that flexibility. The user is in control and makes the program respond to the user’s actions. Every time an action occurs on a field, an event is triggered. The program then responds to those events.

How does this work? First, you tell Windows that you want this field, this field, and that field on the screen. Windows creates these elements. Then Windows allows users to do whatever they want with those fields. Whenever a user does something, Windows tells the developer what is going on by communicating events to use (such as field changed, mouse clicked, and so forth). You attach your program logic (code) to these events.

To see examples comparing traditional COBOL programming and event-driven programming implemented under Windows, click here.


Comparison of Traditional COBOL Programming with Event-Driven Programming

The following two examples illustrate the differences between traditional COBOL programming and event-driven programming.

Example 1

In traditional COBOL programming, the example shown below performs three operations:

1. Accepts the customer ID.

2. Performs a lookup when the F3 key is pressed.

3. Validates the customer number before the user can proceed.

ENTER-CUST-ID
ACCEPT CUST-ID LINE 4 POSITION 10.
IF F3-KEY
PERFORM LOOK-UP-CUST.
PERFORM VALIDATE-CUSTOMER.
IF NOT VALID-CUST
PERFORM BAD-CUST
GO TO ENTER-CUST-ID.

Under Windows, you simply take the same logic and distribute it to the appropriate events. Examine these same three operations when implemented under Windows:

1. The ACCEPT statement would be eliminated because Windows handles it.

2. The lookup would probably be associated with a button or menu command, rather than the F3 key. You would attach PERFORM LOOK-UP-CUST to one or all of these events.

3. The VALIDATE-CUSTOMER validation would be attached to two events: LostFocus and Click. The first event, LostFocus, occurs when the user finishes entry into a field and moves to another field. The second event, Click, occurs when the user clicks the OK command button to signal completion of all information on the window. This validation is important because the user may never even access the CUST-ID control (unless you position him there). If the validation failed, you tell Windows to put the user back into the CUST-ID control.

In one way, this does make it less convenient, because the logic is in several places rather than one.

Example 2

ENTER-CUST-STREET-1.
ACCEPT CUST-STREET-1 LINE 7 POSITION 10 TAB UPDATE NO BEEP.
IF UP-ARROW
GO TO GET-CUST-NAME.
IF DOWN-ARROW
GO TO GET-CUST-STREET-2.

No special processing is associated with this field; the only requirements are data entry fields and logic to provide keyboard control over what field is entered next. With Windows and WOW Extensions, however, this processing is all automatic. You do not need to replace the code; you simply discard it.

Take a minute to think about your data entry screens and logic. Instead of writing all the logic to implement those screens, WOW Extensions enables you to write only the logic to implement special features, thereby substantially reducing the size of an average COBOL program.


Addressing Issues in Data Entry Programs

See Also

COBOL is often used to create data entry programs. Data entry programs have unique requirements and issues that are not ordinarily discussed in programming literature. Over the years, COBOL developers have adopted common techniques for addressing these issues in a character-based environment. This topic discusses these issues and suggests how they could be addressed under Windows with WOW Extensions.

While Windows was designed around an exceptional user interface, it was not designed for data entry. However, there are practical ways to address the different sets of issues important to data entry programs, including the following:

· Handling data

· Handling different types of data

· Managing user interaction

· Using function keys for special options


Handling Data

See Also

One set of issues important to data entry programs are those related to the manipulation of data. When data is read out of a file, how does it become displayed? How are numeric and date fields handled? How are the fields formatted? How is data moved from the user interface back to the file? This section, along with the following topics, discusses these issues:

· Handling different types of data

· Managing user interaction

· Using function keys for special options

When Windows creates a control, such as an edit box, it allocates its own storage space for the contents of that edit box control. When the user modifies the contents of the edit box control on the screen, Windows stores the new value in its own storage space and sends your program a message that the value changed. If you want the new value, you have to ask Windows for it. Windows will not automatically store the new value in your COBOL data item. The reverse is also true. Windows does not know when the value of your COBOL data item changes and will not automatically update an edit box control to display the new value. You have to send it the new value.

Two examples show how data is transferred between COBOL data items in Working Storage on record areas and a form created under Windows:

· To see an example of loading a form with COBOL data, click here.

· To see an example of retrieving information from a form and storing it in COBOL data items, click here.


Example: Loading a Form with COBOL Data

This example illustrates how to load a form with COBOL data.

In the following code section, the lines of code that contain the COBOL data are formatted in boldface type; the lines of code that move the data to the form are not formatted in this manner.

01 CUST-FIELDS
03 CUST-NAME PIC X(40).
03 CUST-CITY PIC X(20).
03 CUST-ST PIC X(2).

CALL WOWSETPROP USING WIN-RETURN CUST-NAME-H "TEXT" CUST-NAME.
CALL WOWSETPROP USING WIN-RETURN CUST-CITY-H "TEXT" CUST-CITY.
CALL WOWSETPROP USING WIN-RETURN CUST-ST-H "TEXT" CUST-ST.


Example: Retrieving Information from a Form and Storing It in COBOL Data Items

This example illustrates how to retrieve information from a form and store it in COBOL data items.

In the following code section, the lines of code that contain the COBOL data are formatted in boldface type; the lines of code that retrieve the data from the form are not formatted in this manner.

01 CUST-FIELDS
03 CUST-NAME PIC X(40).
03 CUST-CITY PIC X(20).
03 CUST-ST PIC X(2).

CALL WOWGETPROP USING WIN-RETURN CUST-NAME-H "TEXT" CUST-NAME.
CALL WOWGETPROP USING WIN-RETURN CUST-CITY-H "TEXT" CUST-CITY.
CALL WOWGETPROP USING WIN-RETURN CUST-ST-H "TEXT" CUST-ST.

Most likely, you will want to create two procedures in your program for each data entry form. Create one procedure to set the value of the controls on the form from your COBOL data. Produce the second procedure to retrieve the value of the controls on the form into your COBOL data.

Let’s say you created a form called CUSTFORM, and want to use it to update the contents of your customer file, CUSTFILE. The file and record would both contain fields such as CUST-NAME, CUST-CITY, and CUST-ST. You would create the following two procedures:

LOAD-CUST-FORM.
CALL WOWSETPROP USING WIN-RETURN CUST-NAME-H "Text" CUST-NAME.
CALL WOWSETPROP USING WIN-RETURN CUST-CITY-H "Text" CUST-CITY.
CALL WOWSETPROP USING WIN-RETURN CUST-ST-H "Text" CUST-ST.

UNLOAD-CUST-FORM.
CALL WOWGETPROP USING WIN-RETURN CUST-NAME-H "Text" CUST-NAME.
CALL WOWGETPROP USING WIN-RETURN CUST-CITY-H "Text" CUST-CITY.
CALL WOWGETPROP USING WIN-RETURN CUST-ST-H "Text" CUST-ST.

LOAD-CUST-FORM sets the Text property of each control based on the data in the file.

UNLOAD-CUST-FORM sets the value of each field in the record based on the Text property of each control.

When you want to update the data on the screen from the record, you execute PERFORM LOAD-CUST-FORM. When you want to update the data in the record from the screen, you execute PERFORM UNLOAD-CUST-FORM.

The handle fields, such as CUST-NAME-H, CUST-CITY-H, and CUST-ST-H, contain the handle of the control. The data fields, such as CUST-NAME, CUST-CITY, and CUST-ST are the COBOL data items. “Text” indicates the control property that stores the value or contents of the control. The property name to use will depend on the control.

In a typical data entry situation, the program works as follows:

1. Read a record from the file.

2. Execute PERFORM LOAD-CUST-FORM to display the values in the form.

3. Let the user modify the values (Windows handles this).

4. When the OK command button is pressed:

a. Execute PERFORM UNLOAD-CUST-FORM to put updated values in the record.

b. Write/Rewrite the record to the file.

The drawback to this approach is that you have to create two procedures that list each control handle and data field. This means you have to maintain two procedures as you add or remove controls and fields. You can, however, alter the approach and consolidate this information in one procedure.

First, declare a new data item:

01 LOAD-FUNC PIC X(5).

Then rewrite your procedures as follows:

LOAD-CUST-FORM.
MOVE WOWSETPROP TO LOAD-FUNC.
PERFORM CUST-LOAD-UNLOAD.

UNLOAD-CUST-FORM.
MOVE WOWGETPROP TO LOAD-FUNC.
PERFORM CUST-LOAD-UNLOAD.

CUST-LOAD-UNLOAD.
CALL LOAD-FUNC USING WIN-RETURN CUST-NAME-H "Text" CUST-NAME.
CALL LOAD-FUNC USING WIN-RETURN CUST-CITY-H "Text" CUST-CITY.
CALL LOAD-FUNC USING WIN-RETURN CUST-ST-H "Text" CUST-ST.

Although this may look unusual, it is actually rather straightforward. The WOWGETPROP and WOWSETPROP functions are alphanumeric fields in windows.cpy. They contain the names of subprograms in the WOW runtime system DLL, wowrt.dll. These functions are called by using a data name, not a literal name. Since they are alphanumeric data, you can MOVE them to LOAD-FUNC and CALL LOAD-FUNC instead of calling WOWGETPROP or WOWSETPROP. Because the syntax for WOWGETPROP and WOWSETPROP is identical, you can use the same statement for both. You now have the list of controls and fields in one place.


Handling Different Types of Data

See Also

Now that you have a logic structure for loading and unloading the controls in your forms, how do you deal with different types of data?

· Alphanumeric data

Not surprisingly, managing alphanumeric data is the easiest. The edit box control and many ActiveX control equivalents have a Text (or similarly named) property that contains the alphanumeric data of the control. Generally, you will use some type of edit box control for alphanumeric data entry and then set the Text property of the control.

· Numeric data

If you do not require special formatting, managing and supporting basic numeric data can be just as easy as alphanumeric data. Example

· Special formatting of numeric data

In some circumstances, you will want to carefully control the format in which the numeric data is displayed. Example

Some controls, for example scroll bars, are designed to manipulate a numeric value. Example

Other controls, such as buttons and check boxes, often represent a True or False value. Consequently, these types of controls need a different approach for handling numeric data. Example


Example: Basic Numeric Data for an Edit Box Control

The edit box control does not have any special support for numeric data. WOW Extensions, however, does provide this functionality. When you pass a numeric literal or data item while setting the Text property, WOW Extensions converts it to a string and passes the string to Windows. When you use a numeric data item while getting the Text property, WOW Extensions retrieves the text from Windows, converts it to a numeric value, and returns the numeric value. Let’s see how this works.

This function call will set the text of the control to 127 because WOW Extensions takes the numeric value and converts it to a text string.

01 COMP-FIELD PIC 9(5) COMP VALUE 127.
CALL WOWSETPROP USING WIN-RETURN EDIT-H "TEXT" COMP-FIELD.

WOW Extensions does not provide any flexibility in numeric formatting with WOWSETPROP. It will always zero suppress leading zeros and display all trailing decimal zeros. For example, this function call will set the text of the control to 127.00.

01 CUST-BAL PICS 9(7)V99 VALUE 127.
CALL WOWSETPROP USING WIN-RETURN EDIT-H "TEXT" CUST-BAL.

The numeric capabilities of WOWGETPROP are less interesting to illustrate. For example, the following function call will store the numeric value of the text of the edit box control in CUST-BAL. If the text value contains more than five integers or two decimal digits, the remaining digits are truncated.

CALL WOWGETPROP USING WIN-RETURN EDIT-H "TEXT" CUST-BAL.


Example: Formatted Numeric Data for an Edit Box Control

When special formatting of numeric data is required, you will need to perform the formatting in your COBOL program, then use the formatted value to set the control text. For example:

01 YMD-DATE PIC 99/99/99.
MOVE CUST-LAST-PURCHASE TO YMD-DATE.
CALL WOWSETPROP USING WIN-RETURN EDIT-H "TEXT" YMD-DATE.

You can still retrieve the numeric value with the CALL to WOWGETPROP.

CALL WOWGETPROP USING WIN-RETURN EDIT-H "TEXT" YMD-DATE.

Notice that the calls to WOWGETPROP and WOWSETPROP are now different, which affects the coding strategy outlined for handling basic numeric data. You now need to modify your approach as follows:

LOAD-CUST-FORM.
MOVE WOWSETPROP TO LOAD-FUNC.
PERFORM CUST-LOAD-UNLOAD.
MOVE CUST-LAST-PURCHASE TO YMD-DATE.
CALL WOWSETPROP USING WIN-RETURN EDIT-H "TEXT" YMD-DATE.

UNLOAD-CUST-FORM.
MOVE WOWGETPROP TO LOAD-FUNC.
PERFORM CUST-LOAD-UNLOAD.
CALL WOWGETPROP USING WIN-RETURN EDIT-H "TEXT" YMD-DATE.

CUST-LOAD-UNLOAD.
CALL LOAD-FUNC USING WIN-RETURN CUST-NAME-H "Text" CUST-NAME.
CALL LOAD-FUNC USING WIN-RETURN CUST-CITY-H "Text" CUST-CITY.
CALL LOAD-FUNC USING WIN-RETURN CUST-ST-H "Text" CUST-ST.


Example: Handling Numeric Data with Scroll Bar Controls

Numeric values are easy to handle with scroll bar controls. Simply use any type of numeric field with the desired property as follows:

01 NUM-VALUE PIC 9(5) COMP-6.
CALL WOWSETPROP USING WIN-RETURN SCROLLBAR-H "Value" NUM-VALUE.

or

CALL WOWGETPROP USING WIN-RETURN SCROLLBAR-H "Value" NUM-VALUE.


Example: Handling Numeric Data with Check Box Controls

Several types of controls often represent a True or False value: the value True corresponds to a numeric value of 1, and the value False corresponds to a numeric value of 0. These kinds of controls are often used to represent the value of a data item with 88-level condition names. If the data item is numeric and the conditions are 0 and 1, handling numerical data with this type of control is very straightforward.

The following example shows that you are using a check box control to indicate whether a customer is active or inactive:

01 CUST-ACTIVE PIC 9.
88 CUST-IS-ACTIVE VALUE 1.
88 CUST-IS-INACTIVE VALUE 0.

The following function call will set the check box state:

CALL WOWSETPROP USING WIN-RETURN CB-H "State" CUST-ACTIVE.

The following function call will retrieve the check box state:

CALL WOWGETPROP USING WIN-RETURN CB-H "State" CUST-ACTIVE.

If your data item and condition name are not numeric, or have values other than one and zero, you will have to use logic more like that shown in the following example:

01 CUST-WHLSLE PIC X.
88 CUST-IS-WHLSLE VALUE "Y".
88 CUST-IS-NOT-WHLSLE VALUE "N".

To set the check box state:

IF CUST-IS-WHLSLE
CALL WOWSETPROP USING WIN-RETURN CB-H "State" WIN-TRUE
ELSE
CALL WOWSETPROP USING WIN-RETURN CB-H "State" WIN-FALSE.

To retrieve the check box state:

CALL WOWGETPROP USING WIN-RETURN CB-H "State" NUM-VALUE.
IF NUM-VALUE = 1
SET CUST-IS-WHSLE TO TRUE
ELSE
SET CUST-IS-WHSLE TO FALSE.


Managing User Interaction

See Also

This topic covers a range of issues related to handling user interaction in data entry programs. Examples are provided to illustrate how to respond to these user actions in your WOW applications.

· Handling input validation

In data entry programs, it is common to validate the contents of a field after it is entered. In character-based applications, validation was performed following the ACCEPT statement. However, in Windows your WOW application would respond to an event, which represents user actions, associated with the field (control) that your application can recognize. Every field (control) has certain events to which it can respond.

Example

· Dictating entry order for controls

Character-based data entry programs generally dictate a specific entry order for fields (controls). Although Windows programs usually do not dictate such a specific order, they can easily support one by using the Tab key to move through controls in a default tab order.

Example

· Preventing data entry on a control

If you do not want a user to enter data in a particular field (control), you must disable it.

Example

· Switching to another Windows application

Your program needs to be flexible enough to accommodate moving between applications if the user wants to switch to another Windows application.

Example 1

Example 2

· Disabling and enabling a validated control

When a user completes data entry of a key field (control), such as the customer ID, and the value is validated, you do not want the user to return and change the value of the key control.

Example


Example: Handling an Invalid Value

In Windows, your first response to handle validation might be to watch for users to press the Enter key, indicating they had completed the field. However, Enter is not the key usually used for moving between fields (controls) under Windows. Such a response also overlooks that the user might have clicked on another field with the mouse, rather than with the keyboard.

In a WOW application, there are two reasonable places to perform input validation on a field (control): in the Change event or in the LostFocus event. It is preferable, however, to perform input validation in the LostFocus event rather than in the Change event. You can assume that when the user leaves the control, a value has been entered. The Change event occurs every time the user or your program changes the value of a control, for example, on every keystroke or whenever a WOWSETPROP routine is called. Unless you want to validate at all these times, the LostFocus event is the most feasible strategy.

Example

To obtain the value of the field (control) and validate it, use the LostFocus event. What if the value is invalid? Instead of going back to the ACCEPT statements (as you would in character-based programs), under Windows, you can force the user back to the invalid control with the SETFOCUS function. In this case, the LostFocus event logic is executed as follows:

CUST-TYPE-LOSTFOCUS.
CALL WOWGETPROP USING WIN-RETURN CUST-TYPE-H "TEXT" CUST-TYPE.
PERFORM VALIDATE-CUST-TYPE.
IF CUST-TYPE-IS-INVALID
PERFORM INVALID-CUST-TYPE-MSG
CALL SETFOCUS USING WIN-RETURN CUST-TYPE-H.

The user will not be allowed to leave the CUST-TYPE field until a valid value is entered.


Example: Dictating Entry Order for Controls

A developer-defined default order for moving through controls can be assigned in the WOW Designer through the TabIndex property. The TabIndex is the order in which the controls receive input focus when the user presses the Tab key. Notice that there is also a TabStop property. When the Tab key is pressed, Windows will stop only at controls that have TabStop set to True. The Enter key is not used for moving between controls; it can, however, be used to press the default button on the form when the Default property is set to True for a command button control.

In some situations, such as in the validation example, you may want to position the user on a specific control. This is performed with the SETFOCUS function. You also can disable automatic tabbing between controls by setting the DialogMotion property of the form to False.


Example: Preventing Data Entry on a Control

In character-based applications, it was easy to prevent a user from entering a value into a field. You simply did not ACCEPT it. Under Windows, any enabled control on a form can be accessed by the user. The key word here is “enabled.” If you do not want a user to Tab to or click a control, you must disable it.

For example, you have a customer maintenance form with Customer ID as the key control. You want the user to enter the customer identification number, then you will read the file, load the form, and let the user modify the rest of the fields. If you simply present the form with all the controls enabled, there is no way to prevent the user from clicking one of the other controls before completing the Customer ID control. Disabling all the other controls on the form, however, is inconvenient.

Let’s look at how you might handle this situation if you use an edit box control with the user entering the customer ID. (A more appropriate solution in this situation, however, would be to use a combo box control for the Customer ID control, since it allows the user to either enter a customer ID or select a customer from a list.)

The first issue is positioning the user in the Customer ID control. WOW Extensions automatically positions the user in the first control (set by the TabIndex property) of the form when the form is created. To avoid destroying and recreating the form every time the user wants to access a different customer, you will use the SETFOCUS function. Add the following code to your OK and Cancel command buttons, so that after every completed or canceled maintenance operation, the user will be repositioned in the Customer ID control. Be sure to place this code after the other OK or Cancel command button control logic. For example:

OK-CLICK.
*Followed by logic to save data.
.
.
.
CALL SETFOCUS USING WIN-RETURN CUST-ID-H.

CANCEL-CLICK.
*Followed by logic to cancel changes.
.
.
.
CALL SETFOCUS USING WIN-RETURN CUST-ID-H.

You also may want to add the SETFOCUS call to the Create event for your form. Then your code will not be sensitive to the TabIndex value of the CUST-ID control.


Example 1: Switching to Another Windows Application

Let’s say that the customer type control is one of many controls on the form. The user begins to enter the value, then decides to switch to another application. Your LostFocus event code is executed and you determine the customer type is invalid. You display a warning message, but do not call the SETFOCUS function back to CUST-TYPE. The user moves on to the other application, then switches back to your application by clicking a field other than CUST-TYPE. The customer type control now contains an invalid value. To protect the integrity of your data, you will need validation logic somewhere else in order to detect this response. The OK command button would appear to be an ideal place, as presumably your user will click the OK command button to save the data. Then, you could set focus back to the CUST-TYPE field if the value is invalid, as shown in the following example:

OK-CLICK.
PERFORM VALIDATE-CUST-TYPE.
IF CUST-TYPE-IS-INVALID
PERFORM INVALID-CUST-TYPE-MSG
CALL SETFOCUS USING WIN-RETURN CUST-TYPE-H.

This is, of course, a matter of personal preference. Windows applications should be as flexible as possible. From a programming viewpoint, it would be simpler to include the SETFOCUS routine in the LOSTFOCUS logic, although it would be an inconvenience for your users. Without the SETFOCUS function, the LOSTFOCUS logic looks like the following:

CUST-TYPE-LOSTFOCUS.
CALL WOWGETPROP USING WIN-RETURN CUST-TYPE-H "TEXT" CUST-TYPE.
PERFORM VALIDATE-CUST-TYPE.
IF CUST-TYPE-IS-INVALID
PERFORM INVALID-CUST-TYPE-MSG.


Example 2: Switching to Another Windows Application

Is there a simple way you can tell if the user is moving to another application? Windows provides a function called ISCHILD, which tells you whether a control is a child of a form. You can use this function to determine whether the user has clicked on another control on the form. Here is an example of the logic:

CUST-ID-LOSTFOCUS.
*Get the cust id and validate it, as described previously.
.
.
.
IF CUST-ID-INVALID
CALL GETFOCUS USING CURRENT-H
CALL ISCHILD USING WIN-RETURN DATANTRY-H CURRENT-H
IF WIN-RETURN = WIN-TRUE
CALL SETFOCUS USING WIN-RETURN CUST-ID-H.

First, use the GETFOCUS function to determine what form or control has focus. Then, use the ISCHILD function to determine whether that form or control (CURRENT-H) is a child control of the form (DATANTRY-H). If it is a child control, set focus back to the CUST-ID control. Otherwise, you can let the focus go to wherever the user places it.

That process, however, solves only half the problem. What happens when the user clicks back on the same form, but to a different control? You need to catch that event too and force the user to the CUST-ID control.

Whenever a form or control gets focus, the GetFocus event occurs. When a control on an inactive form gets focus, the GetFocus event occurs for both the form and the control. If the user switches back to the form after switching to some other application, no matter what control is clicked on, the GetFocus event will occur for the form. You can add a SETFOCUS call to the form’s GetFocus event to make sure the user goes back to the CUST-ID control.

There is one more detail. If the user has already completed the CUST-ID field, you do not want to force the user back to it. You could determine whether to force the user to the CUST-ID control by validating CUST-ID again, but that might disrupt the file position or some data value in the record. Instead, modify the LostFocus code to set a flag as shown in the following example:

CUST-ID-LOSTFOCUS.
*Get the cust id and validate it, as described previously.
.
.
.
IF CUST-ID-INVALID
CALL GETFOCUS USING CURRENT-H
CALL ISCHILD USING WIN-RETURN DATAENTRY-H CURRENT-H
IF WIN-RETURN = WIN-TRUE
CALL SETFOCUS USING WIN-RETURN CUST-ID-H
ELSE
SET FORCE-FOCUS TO TRUE
END-IF
ELSE
SET FORCE-FOCUS TO FALSE.

Now you can add this code to the GetFocus event for the form:

DATANTRY-GETFOCUS.
IF FORCE-FOCUS
CALL SETFOCUS USING WIN-RETURN CUST-ID-H.

The user will have to enter a valid customer ID before anything else can be done on the form.


Example: Disabling and Enabling a Validated Control

To prevent the user from returning and changing a value after it has been validated, you need to change the LostFocus event code:

CUST-ID-LOSTFOCUS.
*Get the cust id and validate it, as described previously.
.
.
.
IF CUST-ID-INVALID
CALL GETFOCUS USING CURRENT-H
CALL ISCHILD USING WIN-RETURN DATANTRY-H CURRENT-H
IF WIN-RETURN = WIN-TRUE
CALL SETFOCUS USING WIN-RETURN CUST-ID-H
ELSE
SET FORCE-FOCUS TO TRUE
END-IF
ELSE
CALL ENABLEWINDOW USING WIN-RETURN CUST-ID-H WIN-FALSE
SET FORCE-FOCUS TO FALSE.

The ENABLEWINDOW function, when used with the argument WIN-FALSE, disables the control. In order to enable it, return to the logic for the OK and Cancel command buttons:

OK-CLICK.
*Followed by logic to save data.
CALL ENABLEWINDOW USING WIN-RETURN CUST-ID-H WIN-TRUE.
CALL SETFOCUS USING WIN-RETURN CUST-ID-H.

CANCEL-CLICK.
*Followed by logic to cancel changes.
CALL ENABLEWINDOW USING WIN-RETURN CUST-ID-H WIN-TRUE.
CALL SETFOCUS USING WIN-RETURN CUST-ID-H.

You need to make sure you enable the control before you set focus to it. You cannot set focus to a disabled control.


Using Function Keys for Special Options

See Also

Another technique commonly used in character-based data entry programs is that of using function keys for special options. This also can be accomplished under Windows, although before we describe how it is done, let’s examine some more Windows programming principles.

Windows, a feature-rich, flexible environment, allows you to develop software that will work virtually in any capacity you wish. That being said, you need, however, to do things the Windows way. Not because it is necessarily better, or because it is an industry standard, but because it will make your coding easier. While Windows is very flexible, it was designed with a certain orientation, which was neither function-key nor data-entry-program driven.

It is important to know how to do under Windows what you could do in a character-based environment. This is the skill set and basic approach to software development you have perfected over the years. However, mirroring that approach exactly under Windows will be more difficult than transitioning to a more Windows-like approach for you and your users both.

Function keys are a good example of this point. The KeyDown and KeyUp events, provided on virtually all controls, return the value of the key pressed, thereby making function key detection possible. The Windows approach to software design, however, mandates the use of pulldown menus or command button controls for executing the type of functionality you have been used to assigning to function keys. Liant recommends that you consider implementing these approaches before implementing function keys.

For more information on implementing function keys in WOW Extensions, click here.


Implementing Function Keys in WOW Extensions

Note The following description on how to detect function keys applies only for Windows intrinsic controls.

When any key is pressed, the KeyDown event is triggered. When it is released, the KeyUp event is triggered. If the key that was pressed and released was an ASCII key, the KeyPress event is also triggered.

All of these events return a value identifying the key in WIN-WPARAM. WOW Extensions automatically moves this value to WIN-KEY, which is a numeric field that is redefined to include a one-byte, alphanumeric field, WIN-CHAR. You can, therefore, examine the key as numeric or alphanumeric data.

If the value is that of an ASCII character, WIN-CHAR will contain the alphanumeric character value. Otherwise, WIN-KEY will contain a numeric value identifying the key. This value is called a virtual key code. The value in WIN-KEY can be compared to the virtual key values defined in windows.cpy. The names of these values more or less correspond to the key names.

Now you are ready to detect function keys (remember, however, that this is not the Windows approach). If you want to use the F7 key to trigger a customer lookup in the CUST-ID field, add the following code to the KeyDown event for the CUST-ID field:

CUST-ID-KEYDOWN.
IF WIN-KEY = VK-F7
PERFORM CUSTOMER-LOOKUP.

What if you added several special key actions to the same event? In this case, you might want to switch to the EVALUATE statement, although this step is not recommended:

CUST-ID-KEYDOWN.
EVALUATE WIN-KEY
WHEN VK-F7 PERFORM CUSTOMER-LOOKUP
WHEN VK-F20 PERFORM...
WHEN VK-NUMLOCK PERFORM...
WHEN VK-ADD PERFORM...
WHEN VK-NUMPAD3 PERFORM...
WHEN VK-PRINT PERFORM...
END-EVALUATE.

This key detection will be active only for the CUST-ID field. What if you want to assign a global function key action that applies to every field on the form? The KeyPress event for the form, however, is triggered only under one of the following conditions:

· When the form is active.

· No control on the form has focus.

· A key is pressed.

When a control has focus and a key is pressed, the form KeyPress event is not triggered. You can, however, simulate it by adding the following code to the KeyPress event for each control on the form:

PERFORM FORMNAME-KEYPRESS.

Then, the EVALUATE or IF statement used for key detection could be placed in the form’s KeyPress event and would be executed when any key is pressed in any control, providing global detection. This behavior is very non-Windows-like. Windows provides accelerators for command buttons and menu commands.


Working with Menus

See Also

Menus provide a simple, consistent, and intuitive way to inform users of options (menu items) available when running a program. The WOW Designer contains a Menu Editor dialog box that makes menu creation easy.

A menu is another type of object you add to your form. A menu has two parts: the horizontal bar at the top of the form, which is always present, and the vertical menus that appear when a top-level item is selected. The line at the top of the form is called the top-level menu. The menus that “pop up” when a top-level item is selected are called pop-up menus. The top-level menu is actually constructed from the titles of the pop-up menus.

Menus are another built-in part of Windows. You do not need to distribute any special files to support menus. For more information on using menus, click here.


Using Menus

Menus are one of the simplest objects to use in your programs. They have one purpose: to indicate to the program that the user has selected an option (menu item).

A menu item can be selected from a menu in one of three ways.

· First, the user can select the menu item by clicking it.

· Second, by pressing the Alt key, the user can highlight the menu, use the arrow keys to move to a menu item, and press Enter to select it.

· Third, the user can press an accelerator key that is associated with the menu item. Accelerator keys are assigned in the Menu Editor dialog box.

When a menu item is selected, the Click event for that menu item is executed. This is the only event available for menu items. To see the event-driven code associated with the menu, double-click on the menu in the form to open the Event-Handling Code dialog box. There are no data associated with menu items. Menus are very similar to command buttons, in that they are a request for action.

Menus do not have properties like controls do, but there are some characteristics of menu items you may want to manipulate in your programs. The most common ones to use are the Checked/Unchecked and Enabled/Disabled characteristics.

For procedures on how to create a menu, click here.


Create a Menu

See Also

Note It is important to understand menu terminology in WOW Extensions. A menu consists of a menu title and one or more menu items (or options). A menu bar, which appears immediately below the title bar on the form, contains one or more menu titles. A pulldown menu, by far the most common type of menu, is represented by a menu title (for example, File, Edit, and Help) that appears on the menu bar of an application window (form). When you select a menu title either with the mouse or keyboard, a list of menu items drops down. Menu items can include commands (such as New, Open, Close, and so forth), separator bars, accelerators, and submenu titles. Each menu title and menu item the user sees corresponds to a menu control that you define in the Menu Editor dialog box.

To create a menu:

1. On the View menu, click Menu Editor. Or, click Show Menu Editor on the View toolbar.

The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box.

2. Create a top-level menu that will appear on the menu bar of your form by clicking on the Title text box in the Properties area of the Menu Editor dialog box.

3. Type the title of the menu you want to create. For example, File.

The menu is immediately visible on the form and WOW Extensions automatically assigns the menu item a Name property value. This name value is derived from the Title property value. WOW Extensions adds this menu name to the form's declaration, and the menu name appears in the Events/Sections list of the menu Event Handling Code dialog box. It is the name WOW Extensions uses to reference the menu control in the generated code.

Note You can configure the way in which the menu names are generated by changing the options on the Code Preferences page of the Preferences dialog box. To open the Preferences dialog box, choose Preferences on the Options menu.

4. Add an item (or option) to the menu created in step 3 by clicking on the second line in the Menu Control list box of the Menu Editor dialog. You can also press Enter from the first line in the Menu Control list box to advance to the second line.

a. Click on the Title text box and type the name of the first menu item that you want to appear on the menu. For example, New.

b. Indent the menu item by clicking on the Right command button at the top of the Menu Editor dialog box.

c. Optionally, add an accelerator (or shortcut) to the menu item (for example, Ctrl+N) by clicking on the Accelerator list box to display a drop-down list of key combinations that may be used to assign accelerator keys to access pulldown menu commands. In order for the accelerator to appear next to the pulldown menu item, you must type the accelerator key sequence selected from the list box following the text you entered in the Title box. It is also possible to place a tab character in the pulldown menu item to align the text that describes the accelerator key sequence. For example, if you select Ctrl+N in the Accelerator list box, you will type New\tCtrl+N in the Title box.

Note This should be done only for pulldown menu items, not for top-level titles. Only one tab character should be added to a menu item.

d. Optionally, display a check mark on the menu item at design time by clicking on the Checked check box. Check marks are commonly used to indicate an on/off condition. Choosing the menu command alternately adds and removes the check mark. If a menu command is active, a check mark will appear next to the menu item. For more information about displaying a check mark on a menu item at runtime, click here.

e. Enable the menu item at design time by clicking on the Enabled check box. When the Enabled property is checked (the default), the menu responds to user actions. If a menu control is disabled, it appears grayed or dimmed. For information about enabling a menu control at runtime, click here.

f. Optionally, insert a horizontal line, known as a separator bar, between the menu items by clicking on the Separator check box. You can use separator bars to indicate groupings within the menu item list, or simply to provide a visual break in a list.

5. Repeat step 4 to add additional menu items, as necessary.

6. Close the Menu Editor dialog box by clicking the Close button in the upper right corner of the title bar.


Check and Uncheck Menu Items

See Also

Menu options (items) can be checked and unchecked in much the same way as check boxes. Menu items let the user select whether to activate a certain feature in the application that affects program execution. The checked state of the menu item is toggled every time the item is selected (clicked). Since this is not done automatically by Windows, it must be done at runtime in your programs.

Note The Checked option in the Menu Editor dialog box allows you to toggle the display of a check mark on a menu item at design time.

A menu item is checked with the following code:

MOVE ALL 'N' TO MENU-FLAGS.
SET MF-BYCOMMAND MF-CHECKED TO TRUE.
CALL CHECKMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

MENU-FLAGS is a collection of options that affect menus. By first initializing the MENU-FLAGS parameter with the statement MOVE ALL 'N' TO MENU-FLAGS, all existing values are unset so that new values can be specified. (This parameter can have the value MF-CHECKED or MF-UNCHECKED, combined with the MF-BYCOMMAND or MF-BYPOSITION value.)

MF-BYCOMMAND supplies the identifier of the menu item to be checked.

MF-CHECKED indicates that the menu item should be checked.

WIN-RETURN specifies the previous state of the menu item (either MF-CHECKED or MF-UNCHECKED). If the menu item does not exist, the return value is -1.

MENU-H is the handle of the menu containing the item to be checked. If the item is on a pop-up menu, MENU-H should be the handle of the pop-up menu, rather than the top-level menu.

ITEM-ID is the identifier (ID number) of the menu item to be checked (selected or cleared).

The menu item is unchecked in the same manner, but MF-UNCHECKED is used in place of MF-CHECKED.


Enable and Disable Menu Items

See Also

Menu options (items) can be enabled and disabled at runtime in the same manner as controls, although this is not done with an Enabled property, but rather with the ENABLEMENUITEM function.

Note The Enabled option in the Menu Editor dialog box allows you to enable/disable a menu control at design time.

By first initializing the MENU-FLAGS parameter with the statement MOVE ALL 'N' TO MENU-FLAGS, all existing values are unset so that new values can be specified.

A menu item is disabled with the following code:

MOVE ALL 'N' TO MENU-FLAGS.
SET MF-BYCOMMAND MF-DISABLED MF-GRAYED TO TRUE.
CALL ENABLEMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

Most of the parameters for the ENABLEMENUITEM are the same as defined for the CHECKMENUITEM function. MF-DISABLED and MF-GRAYED are new options that respectively disable and gray out the option. Disabling the option does not automatically gray it out as is the case with controls. Graying must be explicitly requested with the MF-GRAYED option.

To enable the menu item, use the following code:

MOVE ALL 'N' TO MENU-FLAGS.
SET MF-BYCOMMAND MF-ENABLED TO TRUE.
CALL ENABLEMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

Notice that it is not necessary to specify “un-gray” when the option is enabled. That characteristic is enabled by default. The following code causes the option to be grayed out even when it is enabled:

MOVE ALL 'N' TO MENU-FLAGS.
SET MF-BYCOMMAND MF-ENABLED MF-GRAYED TO TRUE.
CALL ENABLEMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

This behavior would, however, be unlike the expected Windows behavior.


Pop-Up Menus

One interesting technique that can be used with menus is to have the program pop up a menu on the display without the user having selected it from the top-level menu. This type of menu is usually referred to as a context-sensitive pop-up menu. Such menus provide an efficient way to access frequently used commands without the need to navigate a menu bar. They also can include commands that logically apply to the limited context of the selected object. For example, when input focus moves to a customer number field, the program could pop up a menu listing functions related to customer number entry and place the menu next to the field. The user can select an option from the menu. By clicking outside the pop-up menu (or a specified area), the menu can be dismissed. If the user selects an option from the menu, the Click event associated with that menu option is triggered.

Use the TRACKPOPUPMENU function to accomplish this feature. A call to the TRACKPOPUPMENU function appears as follows:

MOVE ALL 'N' TO MENU-FLAGS.
SET MENU-FLAG-VALUE TO TRUE.
CALL TRACKPOPUPMENU USING WIN-RETURN MENU-H MENU-FLAGS
X Y RESERVED WND-H RECT.

WIN-RETURN returns a value of nonzero (1) if the menu was displayed (successful) or a value of zero (0) if it was not displayed (unsuccessful).

MENU-H is the handle of the pop-up menu to be displayed. This cannot be the handle of the top-level menu.

MENU-FLAGS is a collection of alignment options that affect menus. By first initializing the MENU-FLAGS parameter with the statement MOVE ALL 'N' TO MENU-FLAGS, all existing values are unset so that new values can be specified.

X and Y are the pixel coordinates at which the top left corner of the menu should be displayed. These coordinates are relative to the entire screen, not the form. You may need to use the CLIENTTOSCREEN function to help you calculate this position.

The RESERVED parameter must be zero.

WND-H is the handle of the window that owns the pop-up menu.

RECT is an optional parameter. By default, Windows erases the pop-up menu if the user clicks outside the menu. This behavior can be achieved by passing 0 for this parameter instead of RECT. However, RECT can be filled with values and passed to define a specific area of the screen the user should be allowed to click without erasing the menu. This action overrides the default behavior.


Looking Behind the Scenes

See Also

This topic defines the architecture for integrating the graphical user interface of an application for Windows with the WOW Extensions application development framework and examines the following processes:

· Initial creation of a WOW program

· Ongoing maintenance of a WOW program

· How a WOW program works

· How a WOW program works with Windows

· Using WOW programs with non-WOW COBOL programs


Initial Creation of a WOW Program

See Also

When you create a new WOW program, many files are created and processed.

WOW Extensions generates the following file types at design time.

· Project File (.wpj). The WOW Designer creates a project file to store project information, in particular, a list of the forms included in the project. This file, which has the extension .wpj, is needed only at design time. As you add or rename forms from the project, this file is automatically updated. For more information about projects, click here.

· Form File (.wow). The WOW Designer component manages the entire process of creating a form. When you first save a new form, the WOW Designer creates a file that stores the definition of the form. This type of file is known as a WOW form file and has a default extension of .wow. The .wow file is read and written to by the WOW Designer, but it is not needed during runtime. As you edit a form, the modifications are stored in the .wow file. This file is similar to a word processing file, in that just as a word processing file contains a single document, a .wow file contains the definition of a single form.

· Working Storage Copy File (.wws). The WOW Designer generates a copy file for each form that contains a binary definition of the form. This binary definition is declared as a COBOL data item. This type of copy file is known as a WOW Working Storage file and has a default extension of .wws. Any program that uses the form must contain this copy file so that it has a definition of the form. Since the form definition is in the COBOL Working-Storage Section, it is loaded into memory when the program is loaded. This allows the form to be created quickly at runtime by a single call with no disk access. For more information about this copy file, click here.

-  WOW Form Definition file (.wfd). The WOW designer will generate this binary data file if the WSDefinition property for the form is set to a value of False. The .wfd file contains the data from the form definition portion of the .wws file, which reduces the size of the COBOL application. If the form definition is written to a .wfd file, that file must be distributed with the application.

· Procedure Division Copy File (.wpr). The WOW Designer also generates a Procedure Division copy file for each form with a default extension of .wpr. This copy file contains the event-handling logic for the form and the message interpretation logic that will make the event-handling code execute. This copy file must be included in any program that uses the form. For more information about this copy file, click here.

· COBOL Skeleton Program File (.cbl). The WOW Designer generates a skeleton program, based on the project file, with enough logic to display, use, and remove the forms. This type of file is known as an RM/COBOL source file and has a default extension of .cbl. This skeleton program provides enough COBOL code to begin your program. As you enhance the program, you will probably want to add additional functionality, such as file access, to the main program. For more information about this file, click here.

· COBOL Executable Program File (.cob). The files generated by the WOW Designer combine to make a program that can be compiled and executed. This file type is known as an RM/COBOL object file and has a default extension of .cob. The WOW Designer executes the COBOL compiler on the skeleton program, which includes the two copy files. This file is created when you compile the source code with the Build command on the Project menu. Once the program is compiled, it can be run like any other COBOL program.


Ongoing Maintenance of a WOW Program

The WOW design tool, the WOW Designer, defines the user interface. The user interface logic is included in the form and the WOW Designer generates only the .wws and .wpr copy files. The WOW Designer no longer continues to regenerate the skeleton program.

In fact, the skeleton program has now become something much more. It has become the repository for the application logic. The program can be edited with any text editor.

Whenever the form is modified, the copy files must be regenerated. The program then can be recompiled.

In some circumstances, you may want to edit event-handling code outside the WOW Designer. This will work satisfactorily. The WOW Designer will detect the changes during the editing session and preserve the modifications.


How a WOW Program Works

See Also

You can understand how a WOW program works by looking at four files:

· windows.cpy

· formname.wws

· formname.cbl

· formname.wpr


windows.cpy

The windows.cpy copy file, supplied with the WOW runtime system DLL (wowrt.dll), declares the data items needed to interface to Windows. Windows was created to recognize many numerical constants. This file declares these values as COBOL data items with names that are meaningful and consistent with Windows programming constructs. This file should never be modified.

Let’s examine a few of the data items declared in windows.cpy.

Many Windows API functions require a true or false value. In Windows, True = 1 and False = 0. Because True and False have an entirely different meaning in COBOL, the windows.cpy file includes the following declaration:

01 WIN-BOOLEAN-VALUES GLOBAL.
03 WIN-TRUE PIC 9(4) BINARY(2) VALUE 1
03 WIN-FALSE PIC 9(4) BINARY(2) VALUE 0.

In writing WOW programs, you can use WIN-TRUE for True and WIN-FALSE for False. In the following code examples, the first line enables a window, while the second line disables a window.

CALL ENABLEWINDOW USING WIN-RETURN WND-H WIN-TRUE.
CALL ENABLEWINDOW USING WIN-RETURN WND-H WIN-FALSE.

The windows.cpy file also declares the data items needed to store Windows messages.

01 WIN-MSG-WS GLOBAL.
02 WIN-MSG-HANDLE PIC 9(10) BINARY(8).
02 WIN-MSG-HANDLE-A REDEFINES WIN-MSG-HANDLE PIC X(8).
02 WIN-WPARAM PIC S9(10) BINARY(8).
02 WIN-WPARAM-HL REDEFINES WIN-WPARAM.
03 FILLER PIC 9 BINARY(4).
03 WIN-WPARAM-H PIC S9(5) BINARY(2).
03 WIN-WPARAM-L PIC S9(5) BINARY(2).
03 WOW-KEY-VALUE REDEFINES WIN-WPARAM-L
PIC 9(10) BINARY(2).
02 WIN-LPARAM PIC S9(10) BINARY(8).
02 WIN-LPARAM-A REDEFINES WIN-LPARAM PIC X(8).
02 WIN-LPARAM-HL REDEFINES WIN-LPARAM.
03 FILLER PIC 9 BINARY(4).
03 WIN-LPARAM-H PIC 9(5) BINARY(2).
03 WIN-LPARAM-L PIC 9(5) BINARY(2).
02 WIN-MSG-ID PIC 9(10) BINARY(8).
02 WIN-MSG-ID-RED REDEFINES WIN-MSG-ID.
03 FILLER PIC X(6).
03 WIN-MSG-ID-A PIC XX.

Finally, this file also contains the declarations for all the Windows API functions and messages (see the Functions and Messages online Help file) that can be used with WOW Extensions.


formname.wws

The formname.wws copy file contains a binary definition of a form. It also contains special variables for use in event-handling code.

We can examine an example of this type of copy file by looking at the showme.wws file in the showme project provided in the WOW Extensions installation samples folder. This sample form has several controls, including an edit box, a command button, a check box, a list box, and a horizontal scroll bar.

The first data items in showme.wws define the ID numbers of the controls on the form. (Had the form contained pulldown menus, ID numbers for the menu controls would also be defined.) These ID numbers are required for some Windows API functions and for the event-handling code generated by the WOW Designer. For example:

01 SHOWME-IDS.
02 GROUP1-ID PIC 9(5) BINARY(4) VALUE 1.
02 EDIT1-ID PIC 9(5) BINARY(4) VALUE 2.
02 CMD1-ID PIC 9(5) BINARY(4) VALUE 3.
02 CHECK1-ID PIC 9(5) BINARY(4) VALUE 4.
02 LIST1-ID PIC 9(5) BINARY(4) VALUE 5.
02 HSCROLL1-ID PIC 9(5) BINARY(4) VALUE 6.

Following this first set of ID numbers is a second set of identifiers (NEXT-CONTROL-ID and NEXT-MENU-ID). These ID numbers define the next available identifiers for a control or a menu and can be used when adding these objects at runtime. For example:

02 NEXT-CONTROL-ID PIC 9(5) BINARY(4) VALUE 7.
02 NEXT-MENU-ID PIC 9(5) BINARY(4) VALUE 1.

You will then see the data items that contain the handles of the individual controls on the form after the form is created. The handles are required for most Windows API functions and for the event-handling code generated by the WOW Designer.

In order to facilitate tasks such as moving and resizing controls when a form is resized, a redefinition of the control handles has been added that allows the handles to be accessed as an array. The array provides not only the handles but also a field that describes the type of each control. For example:

01 SHOWME-CONTROL-HANDLES.
02 SHOWME-CTL-HS.
03 FILLER.
04 GROUP1-H PIC 9(10) BINARY(8)
VALUE 0.
04 GROUP1 PIC 9(10) BINARY(8)
REDEFINES GROUP1-H.
04 FILLER PIC XX VALUE "SC".
03 FILLER.
04 EDIT1-H PIC 9(10) BINARY(8)
VALUE 0.
04 EDIT1 PIC 9(10) BINARY(8)
REDEFINES EDIT1-H.
04 FILLER PIC XX VALUE "SC".
03 FILLER.
04 CMD1-H PIC 9(10) BINARY(8)
VALUE 0.
04 CMD1 PIC 9(10) BINARY(8)
REDEFINES CMD1-H.
04 FILLER PIC XX VALUE "SC".
03 FILLER.
04 CHECK1-H PIC 9(10) BINARY(8)
VALUE 0.
04 CHECK1 PIC 9(10) BINARY(8)
REDEFINES CHECK1-H.
04 FILLER PIC XX VALUE "SC".
03 FILLER.
04 LIST1-H PIC 9(10) BINARY(8)
VALUE 0.
04 LIST1 PIC 9(10) BINARY(8)
REDEFINES LIST1-H.
04 FILLER PIC XX VALUE "SC".
03 FILLER.
04 HSCROLL1-H PIC 9(10) BINARY(8)
VALUE 0.
04 HSCROLL1 PIC 9(10) BINARY(8)
REDEFINES HSCROLL1-H.
04 FILLER PIC XX VALUE "SC".
02 SHOWME-CONTROL-HANDLES-ARRAY OCCURS 6 TIMES
REDEFINES SHOWME-CTL-HS.
03 FILLER.
04 STANDARD-CONTROL-H PIC 9(10) BINARY(8).
04 STANDARD-CONTROL PIC 9(10) BINARY(8)
REDEFINES STANDARD-CONTROL-H.
04 ACTIVEX-CONTROL-H PIC X(8)
REDEFINES STANDARD-CONTROL-H.
04 ACTIVEX-CONTROL PIC X(8)
REDEFINES ACTIVEX-CONTROL-H.
04 CONTROL-TYPE PIC XX.
88 CONTROL-TYPE-MAIN-MENU VALUE "MM".
88 CONTROL-TYPE-SUB-MENU VALUE "SM".
88 CONTROL-TYPE-STANDARD VALUE "SC".
88 CONTROL-TYPE-ACTIVEX VALUE "AX".
88 CONTROL-TYPE-RAW-OBJECT VALUE "RO".
88 CONTROL-TYPE-NO-CONTROLS VALUE " ".

Notice that there are two definitions for control handles: one for intrinsic controls and one for ActiveX controls. Also, note that the CONTROL-TYPE field allows you to determine the type (intrinsic or ActiveX) of the control. By using the COBOL PERFORM statement along with the COUNT OF phrase, you can iterate through the control handles.

Note All handles are initialized with the value 0, while the IDs are initialized with the correct values. The handle data items will receive values when the form is created.

Finally, you will see the data item that is the binary definition of the form. It may or may not include comments describing the form contents, depending on how the form was generated. This definition begins with the following:

01 SHOWME-DEF.

Note The binary definition of a form can significantly add to the size of a COBOL application. It is possible to reduce the application’s size by copying this information to a separate file rather than to the .wws copy file. By setting the form's WSDefinition property to a value of False, form definition data will be written to a file having a .wfd (WOW form definition) extension. If the form definition is written to a .wfd file, that file must be distributed with the application.


formname.cbl

The formname.cbl file is the COBOL skeleton program file generated by the WOW Designer. This program contains the logic necessary to create, use, and destroy the form.

The Working-Storage Section of the skeleton program contains two copy files: formname.wws and windows.cpy.

The Create-Windows Section of the Procedure Division creates any form that should be created at the start of the program. The procedure, FORMNAME-CREATE-WINDOW, is declared in formname.wpr.

The statement, PERFORM PROCESS-EVENTS UNTIL WOW-QUIT, executes the PROCESS-EVENTS procedure until the condition WOW-QUIT. The event handling for the form is performed in a loop, which is terminated only when this condition is set to True by some part of the event-handling code, such as the Quit option on a File menu or a Cancel command button. The PROCESS-EVENTS procedure

PROCESS-EVENTS-PARAGRAPH.
CALL WOWGETMESSAGE USING WIN-RETURN WIN-MSG-WS WM-NOTIFY-WS.
EVALUATE WIN-MSG-HANDLE
WHEN FORMNAME-H PERFORM FORMNAME-EVALUATE-EVENTS
END-EVALUATE.

retrieves the Windows messages from the message queue and dispatches them to the appropriate form. The CALL statement retrieves the message information. The EVALUATE statement checks the message handle against the handle of each form used by the program and performs the FORMNAME-EVALUATE-EVENTS procedure for the appropriate form. Remember, there is only one form in the skeleton program. (The procedure, FORMNAME-EVALUATE-EVENTS, is declared in formname.wpr.)

The statement, PERFORM DESTROY-WINDOWS, executes the following procedure:

DESTROY-WINDOWS-PARAGRAPH.
PERFORM FORMNAME-DESTROY-WINDOW.

This procedure destroys any forms that were created at the start of the program. (The procedure, FORMNAME-DESTROY-WINDOW, is declared in formname.wpr.)

The EXIT-PROGRAM statement exits the program.


formname.wpr

The formname.wpr copy file contains the event-handling code defined for the form.

For example, let’s consider a form with the name CUSTINFO. The form has two edit box controls, and two command buttons called OK-CMD and CANCEL-CMD, with code attached to the Click event for each of the command buttons.

The first items in the custinfo.wpr copy file are the declarations of all the event-handling code defined for the form. The following procedure is responsible for connecting the event-handling code to the correct Windows message:

CUSTINFO-EVALUATE-EVENTS.
EVALUATE WIN-MSG-ID
WHEN WM-COMMAND
EVALUATE WIN-LPARAM
WHEN CANCEL-CMD-H
OF CUSTINFO-CTL-HS
EVALUATE WIN-WPARAM-H
WHEN BN-CLICKED PERFORM CUSTINFO-CANCEL-CMD-CLICK
END-EVALUATE
WHEN OK-CMD-H
OF CUSTINFO-CTL-HS
EVALUATE WIN-WPARAM-H
WHEN BN-CLICKED PERFORM CUSTINFO-OK-CMD-CLICK
END-EVALUATE
END-EVALUATE
WHEN WM-CLOSE PERFORM CUSTINFO-CLOSE
END-EVALUATE.

This procedure evaluates a Windows message and compares the parameters to those of the form and its controls. When the procedure finds a message that corresponds to an event with event-handling code, it performs that event-handling code, in this case, CUSTINFO-OK-CMD-CLICK. The size and complexity of this procedure will vary greatly depending upon the size and complexity of the form. This code is generated entirely by the WOW Designer, and since it is built on the EVALUATE statement, the execution time does not degrade as additional controls and events are added.

The next item in custinfo.wpr is the procedure that creates the form with the controls defined in the WOW Designer. This procedure also loads the handles for each of the form’s controls into CUSTINFO-CTL-HS.

CUSTINFO-CREATE-WINDOW.
MOVE ALL 'N' TO WIN-STYLE.
CALL WOWCREATEWINDOW USING CUSTINFO-H
CUSTINFO-DEF WIN-STYLE
0
CUSTINFO-CTL-HS.

Finally, you will see the procedure that destroys the form:

CUSTINFO-DESTROY-WINDOW.
CALL WOWDESTROYWINDOW USING WIN-RETURN CUSTINFO-H.


How a WOW Program Works with Windows

The WOW runtime system DLL (wowrt.dll) adds a thin layer of logic between the RM/COBOL runtime system and Windows, which makes Windows presume that it was designed to work with COBOL. This thin layer of logic processes function calls and messages to make them “feel” like COBOL on the COBOL side, and to feel like C on the Windows side.

You can see that the COBOL program does not directly communicate with Windows. When you call Windows, the call goes to the WOW runtime system DLL, then the WOW runtime system DLL calls Windows.

The Windows operating system was designed to call application code directly in order to pass messages to a program. Although Windows cannot call the interpretive COBOL code, it can call the WOW runtime system DLL and give it the messages. The WOW runtime system DLL stores the messages in a message queue and gives them to the COBOL program when the WOWGETMESSAGE function is executed.

In addition to receiving messages, this approach also provides WOW Extensions with the ability to encapsulate the event-driven architecture of Windows within the traditional structure of COBOL programs. Instead of making the programs respond to events at all times, the program can choose when to go into event-driven operation and when to sequentially process operations like traditional COBOL programs. By preserving the type of set-up and shutdown logic typically used by COBOL programs, it is easier to create report and posting programs, and to migrate legacy programs.


Using WOW Programs with Non-WOW COBOL Programs

How do WOW programs coexist with non-WOW programs? Since WOW programs are regular COBOL programs, the following issues must be considered:

Calling To and From WOW Programs

WOW programs can be called by, as well as call, legacy COBOL programs. WOW programs can be passed Linkage Section parameters, and can pass Linkage Section parameters to legacy COBOL programs.

Because WOW programs do not require any special Linkage Section parameters, they can be plugged into legacy applications and called by legacy programs as easily as any other COBOL program. Additionally, since WOW programs can call legacy programs, existing utility programs and subroutine programs can be called in the same manner as they are called by legacy programs.

Visual Considerations of WOW and Non-WOW Programs

All non-WOW programs use the standard COBOL main window to display and enter information. WOW programs create their own windows. These windows will not interfere with each other; in fact, a WOW program can also display information in the standard COBOL main window with a DISPLAY statement. The standard COBOL main window can also be hidden and displayed using the C$SHOW subprogram. For more information about the C$SHOW subprogram, see the RM/COBOL User’s Guide.


Working with ActiveX Controls

Adding ActiveX Controls to the WOW Designer

ActiveX Control Properties

ActiveX Control Events

ActiveX Control Methods

ActiveX Control Limitations

Distribution Issues


Adding ActiveX Controls to the WOW Designer

See Also

You can include ActiveX controls to design and populate the forms in your WOW application. ActiveX controls are available in all editions of Microsoft Visual Basic and from many third-party vendors. Normally, ActiveX controls have the filename extension, .ocx.

WOW Extensions determines which ActiveX controls are available by searching the Windows registry entries to find the registered ActiveX controls installed on your system. When WOW Extensions finds a control, it looks to see whether the necessary registry entries are present to allow WOW to use the control, and checks to see whether the control requires any features not provided by WOW Extensions. It then lists the ActiveX controls in the Select ActiveX Controls dialog box.

Click here for procedures on adding and removing ActiveX controls to the Toolbox. If you add ActiveX controls to your Toolbox, the controls will be recorded in the WOW initialization file, cblwow.ini. An ActiveX control is added to a form in the same manner as an intrinsic control. Simply select the control in the Toolbox, and then click and drag it on the form to establish the outline of the control.

When an ActiveX control has enumeration values in its type library, WOW Extensions will generate corresponding data-item constants in the Working-Storage Section for those values. These 78-level and 88-level condition-names can be generated at the form level, the control level, or the event level, as specified in the ActiveX Enum Generation option either on the Code Preferences page in the Preferences dialog box or in the Project Options dialog box.


Add and remove ActiveX controls on the Toolbox

To add ActiveX controls to the Toolbox:

1. On the Options menu, click Select ActiveX Controls.

The Select ActiveX Controls dialog box is displayed. This dialog box lists the ActiveX controls that are installed on your system and that appear to be compatible with WOW Extensions.

Note If an expected control does not appear in the Select the desired ActiveX controls list box, see troubleshooting tips.

2. Select the listed control(s) that you wish to add to your Toolbox and click OK.

Note WOW Extensions supports standard Windows extended selection techniques using the Ctrl and Shift keys. For example, to add a group of controls to your Toolbox, press the Shift key and move the cursor until all of the controls between the anchor (the first selected control) and the destination (the last selected control) are highlighted. Or, press Ctrl and move the cursor to add a non-continuous single control to a selected group.

The Toolbox will be reformatted to display the controls you have selected. The controls will also be recorded in the cblwow.ini file.

Note In some cases, several controls will be added to the Toolbox by selecting a single entry in the Select the desired ActiveX controls list box. This occurs because some ActiveX controls are distributed and registered as a group.

3. To cancel one or more selections, click Clear All.

4. To close the dialog box, click Cancel.

To remove ActiveX controls from the Toolbox:

· Deselect the control(s) in the Select the desired ActiveX controls list box of the Select ActiveX Controls dialog box, and click Clear All and then OK.


Troubleshoot ActiveX controls

If an expected control does not appear in the Select the desired ActiveX controls list on the Select ActiveX Controls dialog box, there are several possible explanations:

· The control has not been registered. It is not enough simply to copy the control’s implementation file (.OCX, .DLL) to the system. The control must be described through Windows registry entries. This is what allows OLE and COM to work with the control.

Check the documentation for your control to see how it should be registered. Most controls will be registered by their installation software. The RegEdit program also provides facilities for registering controls.

· The control’s Windows registry information is incomplete. The following entries are required for the control under HKEY_CLASSES_ROOT\CLSID:

CLSID
ProgID
Control
TypeLib

In addition, the TypeLib must also be registered under HKEY_CLASSES_ROOT\TypeLib.

· The control has a RequiredCategories entry in its Windows registry entry. Because WOW Extensions does not recognize this registry entry, the control cannot be displayed with WOW Extensions.


ActiveX Control Properties

See Also

ActiveX control properties are displayed and modified through the Properties dialog box in the same manner as intrinsic controls. Some properties are common to all ActiveX controls. Properties that are unique to a given ActiveX control have values that are described in the control’s documentation.

ActiveX control properties can be queried and modified at runtime using the WOWGETPROP and WOWSETPROP functions. Note that with ActiveX controls, the value of False is zero, but the value of True is -1.

While most properties can be manipulated at design time, retrieved or set at runtime, or both, there are exceptions. To see a properties manipulation checklist for an ActiveX control object, click here.

Some ActiveX control properties occur multiple times and are described as indexed.


Common ActiveX Control Properties

See Also

The following properties are common and used by all implementations of ActiveX controls.

Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Some properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box.

Note To determine the unique properties available for an ActiveX control, refer to the documentation for that control.

Properties

About | Default | Locked | Tag
Accelerator | EnableKeyPressForTabMode | Name | Top
AllowMultipleEvents | Group | NewDoMethodArgumentPassing | Visible
Cancel | Height | TabIndex | Width
Custom | Left | TabStop | Z-Order


ActiveX Indexed Properties

Some ActiveX control properties occur multiple times and are described as indexed.

Two special functions must be used to get (retrieve) and set indexed properties for ActiveX controls. These functions, AXSETINDEXPROP and AXGETINDEXPROP, are used as follows.

To retrieve an indexed property

CALL AXGETINDEXPROP USING WIN-RETURN ACTIVEXCTL-H PROPERTY-NAME
PROPERTY-VALUE INDEX….

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is always zero.
ACTIVEXCTL-H | PIC X(8) | The handle that identifies the ActiveX control.
PROPERTY-NAME | alphanumeric | Literal or data item containing the property name.
PROPERTY-VALUE | alphanumeric or numeric | Data item that will receive the property value.
INDEX… | numeric | Literals or data items that are the index(es) for the property. Multiple indices can be specified. If more than one index is specified, the most significant index should be placed first.

To set an indexed property

CALL AXSETINDEXPROP USING WIN-RETURN ACTIVEXCTL-H PROPERTY-NAME
PROPERTY-VALUE INDEX….

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is always zero.
ACTIVEXCTL-H | PIC X(8) | The handle that identifies the ActiveX control.
PROPERTY-NAME | alphanumeric | Literal or data item containing the property name.
PROPERTY-VALUE | alphanumeric or numeric | Literal or data item that contains the property value to be set.
INDEX… | numeric | Literals or data items that are the index(es) for the property. Multiple indices can be specified. If more than one index is specified, the most significant index should be placed first.


ActiveX Control Events

See Also

ActiveX control events are listed in the Events/Sections list of the Event-Handling Code dialog box. Code added to the sections identified in the Program area in the dialog box will be executed automatically when the control triggers the event.

When an event is selected in the Events/Sections list box, the code associated with that event is displayed in the Code Entry area of the Working Storage and Program area. If that event has arguments associated with it, and the Working-Storage and Program sections are empty, the WOW Designer will insert data and code into the appropriate edit boxes to handle the manipulation of those arguments. A sample of that inserted code is shown below. You may edit the inserted code to change the names of the argument names, but changing anything else will produce undesirable results.

Note The AXBINDEVENTARGUMENTS and AXUNBINDEVENTARGUMENTS functions are used to implement ActiveX arguments and are for internal WOW Extensions use only.

Working-Storage Section Sample:

* Row [in] [out] [implied out] VT_I2*
02 ROW PICTURE S9(5) BINARY(2).
* Cancel [in] [out] [implied out] VT_BOOL*
02 BRCANCEL PICTURE 9.
*
* Add your event handling working-storage here.
* Do not modify the items above
* except to change the names and types of the local
event arguments.
*

Program Section Sample:

CALL AXBINDEVENTARGUMENTS USING WIN-RETURN AXN-EVENT-HANDLE
ROW OF FORM2-AXGRIDCON-BEFORE16-WS
AXN-EVENT-ARG-OUTPUT
BRCANCEL OF FORM2-AXGRIDCON-BEFORE16-WS
AXN-EVENT-ARG-OUTPUT.
*
* Add your event handling code here.
* Do not modify the code above
* except to change the names of the local event arguments.
*

*
* End of your event handling code.
* Do not modify the code below
* except to change the names of the local event arguments.
*
CALL AXUNBINDEVENTARGUMENTS USING WIN-RETURN AXN-EVENT-HANDLE
ROW OF FORM2-AXGRIDCON-BEFORE16-WS
AXN-EVENT-ARG-OUTPUT
BRCANCEL OF FORM2-AXGRIDCON-BEFORE16-WS
AXN-EVENT-ARG-OUTPUT.


ActiveX Control Methods

See Also

Some ActiveX controls provide special capabilities that are invoked as methods. These methods can be thought of as functions or procedures built into the control. These methods can be executed using the AXDOMETHOD function as follows:

CALL AXDOMETHOD USING WIN-RETURN ACTIVEXCTL-H METHOD-NAME
PARAM… [GIVING PARAM-RESULT].

The ActiveX Methods dialog box allows you to view all the method(s) for an ActiveX control.

Note Information about methods and parameters can be found in the control’s documentation. When supplying parameters to a method, you do not need to worry about the data types being used. WOW Extensions will convert the data to the proper format based on information contained in the control. Make sure that you supply the parameters in the proper order. Parameters that are identified by the control’s documentation as being optional may be omitted.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value of the method. (See the ActiveX control's documentation for more information.)
ACTIVEXCTL-H | PIC X(8) | The handle generated for the ActiveX control by WOW Extensions.
METHOD-NAME | alphanumeric | Literal or data item containing the method name.
PARAM… | numeric | Parameters for the method. Multiple parameters may be specified.
PARAM-RESULT |  | An optional parameter to receive the value returned by the method. Note that not all methods return values. This is not the same as the WIN-RETURN parameter; PARAM-RESULT is valid only if the WIN-RETURN value is zero. This optional argument is identified by the control’s documentation and may be omitted.

Note 1 Some methods may change the content of parameters as an undocumented side-effect. Use the BY CONTENT reserved word to protect values in the calling program from such an outcome.

Example

Many controls provide an AboutBox method that will display an About Box identifying the control. This method generally requires no parameters. The AboutBox method for a control with the name MYACTIVEX would be invoked as follows:

CALL AXDOMETHOD USING WIN-RETURN MYACTIVEX-H "ABOUTBOX".

Note 2 Calling ActiveX METHODS using literals is discouraged. Liant recommends that a WORKING STORAGE variable or constant be used. For example:

WORKING-STORAGE SECTION.
78 POPConnect VALUE "Connect".
...
PROCEDURE DIVISION.
...
Call AXDoMethod Using Win-Return
POP3-H
POPConnect.


ActiveX Control Limitations

See Also

ActiveX controls have the following limitations when used with WOW Extensions:

· Some ActiveX control properties may not be available for querying or modification at runtime. This is determined by the control. If this occurs, a message box will be displayed.

· An ActiveX control handle is not a window handle. You cannot pass an ActiveX control handle to a function that expects a window handle, such as GetWindowText. An attempt to do this will result in a message box being displayed. Some ActiveX controls will expose a window handle as a property to allow you to use Windows API functions on the control. (For more information, see the Functions and Messages online Help file.)

· ActiveX controls that function as containers are not supported. You cannot place one ActiveX control inside another.

· ActiveX controls that require data binding are not supported.


Distribution Issues

If you use ActiveX controls to develop your application, these controls will have to be distributed with your application. Pay attention to the licensing issues associated with any controls you use. Some controls will require a license only for development use, while others require licenses for both development and deployment.


Manipulating Properties and Events

Setting Properties for Controls and Forms


Setting Properties for Controls and Forms

See Also

Forms and controls (both ActiveX and intrinsic) have a number of configurable characteristics. These characteristics are called properties. Properties are the primary means by which forms and controls are manipulated. Setting properties defines how forms and controls are displayed and how they function in the running application.

The properties of forms and controls are initially defined in the WOW Designer. During design time, you use the Properties dialog box, which lists each property and its value, to set the default (initial) properties of a selected form or control. Most of those properties can also be altered and retrieved at runtime by the code you enter in the Event-Handling Code dialog box. This ability provides almost the same level of flexibility in customizing a user-interface at runtime that is possible at design time. Retrieving and setting property values at runtime is accomplished primarily with the CALL statement and two WOW functions, WOWGETPROP and WOWSETPROP, which provide a consistent method of getting and setting property values for forms and all types of controls, whether intrinsic or ActiveX.

Note While most properties can be retrieved and set either at design time or runtime, there are exceptions. For more information, click here.

For more information about setting and getting property values at runtime, choose one of the following topics:

· Set a property value at runtime

· Get (retrieve) a property value at runtime

· Benefits of using WOWSETPROP and WOWGETPROP


Set a Property Value at Runtime

A property value is set at runtime by calling a special WOW function, WOWSETPROP. For example:

CALL WOWSETPROP USING WIN-RETURN WNDORACTIVEX-H
PROPERTY-NAME… PROPERTY-VALUE….

WIN-RETURN is a numeric field declared in a WOW copy file, windows.cpy. The return value is always zero.

WNDORACTIVEX-H is the handle that identifies the form or the intrinsic or ActiveX control for which to set property values

PROPERTY-NAME is the name of the property for which the value is to be set. The PROPERTY-NAME parameter can be repeated. All properties have an alphanumeric name, which is not case-sensitive. This field can be an alphanumeric literal, for example, "PropertyName", or an alphanumeric data item containing the property name.

PROPERTY-VALUE is a data item in which to store the property value. This field can be an alphanumeric or numeric literal, or a data item. The PROPERTY-VALUE parameter can be repeated.


Get (Retrieve) a Property Value at Runtime

A property value is retrieved at runtime by calling a special WOW function, WOWGETPROP. For example:

CALL WOWGETPROP USING WIN-RETURN WNDORACTIVEX-H
PROPERTY-NAME… PROPERTY-VALUE….

WIN-RETURN is a numeric field declared in a WOW copy file, windows.cpy. The return value is always zero.

WNDORACTIVEX-H is the handle that identifies the form or the intrinsic or ActiveX control that retrieves property value(s).

PROPERTY-NAME is the name of the property for which the value is to be retrieved. The PROPERTY-NAME parameter can be repeated. All properties have an alphanumeric name, which is not case-sensitive. This field can be an alphanumeric literal, for example "PropertyName", or an alphanumeric data item containing the property name.

PROPERTY-VALUE is a data item in which to store the property value. It must be a data item, not a literal. The PROPERTY-VALUE parameter can be repeated.


Benefits of Using WOWSETPROP and WOWGETPROP

You will use these two CALL statements frequently as you build your user interface. These calls are to Windows programming what the MOVE statement is to COBOL. Since these two CALL statements are used so extensively, they have three important and helpful characteristics.

1. You can retrieve and set multiple property values in a single CALL statement.

For example, to retrieve the size and location of any object with one CALL statement:

CALL WOWGETPROP USING WIN-RETURN OBJECT-H
"TOP" TOP-VALUE
"LEFT" LEFT-VALUE
"WIDTH" WIDTH-VALUE
"HEIGHT" HEIGHT-VALUE.

To set the size and location of any object with one CALL statement:

CALL WOWSETPROP USING WIN-RETURN OBJECT-H
"TOP" TOP-VALUE
"LEFT" LEFT-VALUE
"WIDTH" WIDTH-VALUE
"HEIGHT" HEIGHT-VALUE.

2. You can retrieve the numeric value of a Text property. The following example sets the text of an edit field to an alphanumeric value that represents a negative decimal number. Then it retrieves that value directly into a signed numeric field with decimal digits. By doing so, this operation prevents you from having to translate the alphanumeric value into a numeric value within your code.

01 DEC-FIELD PIC S9(5)V99.

CALL WOWSETPROP USING WIN-RETURN OBJECT-H "Text" 123.45-".
CALL WOWGETPROP USING WIN-RETURN OBJECT-H "TEXT" DEC-FIELD.

3. You can set the value of a Text property directly from a numeric field. For example:

01 DEC-FIELD PIC S9(5)V99 COMP-3.

MOVE 512.1 TO DEC-FIELD.
CALL WOWSETPROP USING WIN-RETURN OBJECT-H "Text" DEC-FIELD.

The edit field will display “512.10”.


Handling Events for Controls, Forms, and Projects

See Also

When developing an application with WOW Extensions, you create a project, design the project's forms, populate those forms with controls, and adjust their properties. You then use WOW Extensions to write and manage the source code to support the forms and controls.

The Windows operating system sends notification messages to the WOW runtime in response to user-performed actions, such as clicking on a command button or switching focus from one control to another. WOW automatically translates these notification messages into events (such as the Click event when the user clicks the mouse, or the LostFocus event when the user changes from one control to another, and so forth). Using the Event-Handling Code dialog box, you attach COBOL event-handling logic to the specific Windows events along with the code necessary to respond to user input. Because Windows programming is event-driven, you write code to respond to user events rather than control the sequence of events. To see an example of adding logic to an event that has been triggered by a notification message, click here.

Note For more information about the notification messages that trigger events for controls and forms, see the "Event-Triggering Messages" topic in the Functions and Messages online Help file.

Depending on which type of object you are working on (project, form, control, or menu), the Events/Sections list in the Event-Handling Code dialog box contains different information:

· If you are working at the project level, the list will contain the various sections of a COBOL program, such as the Identification Division or the Working-Storage Section.

· If you are working at the form level, the list will contain all the events associated with a form as well as two special sections, <<Common>> and <<EventsExtension>>:

-  The <<Common>> special section contains paragraphs that might be used from multiple places in your program. Note that if you are working with nested programs, you must add complete COBOL programs in the Code Entry area of the dialog box. (A complete COBOL program consists of all the required divisions and sections, as described in the RM/COBOL Language Reference Manual.) If you are working with non-nested programs, you must add complete paragraph(s) in the Code Entry area of the dialog box.

-  The <<EventsExtension>> special section contains code that can be called or performed in order to allow the developer to evaluate events that WOW Extensions does not automatically handle.

· If you are working with menus, the list will contain the different Click events associated with various actions.

· If you are working with controls (either ActiveX or intrinsic), the list will contain the events associated with the selected control as well as the <<Common>> special section described earlier. For more information about ActiveX events, click here.


Add Logic to an Event

The following example shows how to allow a user to change customer information in a file maintenance application. This requires adding logic to the Click event for the Change command button on a form called FIRSTAPP. When a user presses the Change button, you want to make sure that a customer has been selected. If not, you do not want a second form, called CUSTINFO, to pop up. After determining that a customer is selected, you will read the customer, set CHANGE-MODE to True, and then perform the POPUP-RTN. The POPUP-RTN procedure must be changed to load the current customer information into the CUSTINFO form after it is created.

1. In the WOW Designer, open the FIRSTAPP form.

2. Select the Change command button control and open the Event-Handling Code dialog box for the control

3. In the Events/Sections list, click the Click event.

4. In the Code Entry area, press Tab twice in order to start typing in column 12, since this is the body of a procedure.

5. Type the following code:

PERFORM CHECK-FOR-CUST-SELECTION.
IF NOT NO-CUST-SELECTED
PERFORM READ-THIS-CUST
SET CHANGE-MODE TO TRUE
PERFORM POPUP-RTN
END-IF.

6. Click Close to close the control Event-Handling Code dialog box.


Properties and Events for Intrinsic Controls

See Also

There are two basic categories of controls used in WOW Extensions. This topic introduces you to the intrinsic (default standard) Windows controls available in WOW Extensions. For more information about ActiveX controls, see Adding ActiveX Controls to the WOW Designer.

Note Intrinsic controls are always included in the Toolbox by default when you first install WOW Extensions, unlike ActiveX controls, which can be removed from or added to the Toolbox.

The following table summarizes the intrinsic controls found in the Toolbox. To see the complete description of each control, including its properties and events, click the control name.

Control | Control Name | Description
 | Animation | Displays an AVI clip. An AVI clip is a series of bitmap frames that run like a movie. Only AVI files without sound can be played using the animation control.
 | Bitmap | Displays bitmap files. The bitmap control acts like a command button when clicked.
 | Check Box | Displays a Yes/No, True/False, or On/Off option. You can check any number of check boxes on a form at one time.
 | Combo Box | Combines a text box with a list box. Allows a user to type in a selection or select an item from a drop-down list.
 | Command Button | Carries out a command or action when a user chooses it.
 | Date Time Picker | Allows the user to select a date and time, and to display that date-time in the specified format.
 | Edit Box | Provides an area to enter or display text.
 | Ellipse Shape | Draws the geometric shape of an ellipse on the form.
 | Group Box | Provides a visual and functional container for other controls. It is generally used to enclose related controls (usually check boxes or option buttons).
 | Line Shape | Draws a line on the form.
 | List Box | Displays a list of choices from which the user can select one or more items.
 | Month Calendar | Displays a monthly calendar. The calendar can display one or more months at a time.
 | Option Button | Presents mutually exclusive options in an option control. Option buttons are usually used with the group box control to form groups where only one of the listed buttons can be selected at one time.
 | Progress Bar | Displays a pattern of blocks that show the status of a long operation.
 | Rectangle Shape | Draws the geometric shape of a rectangle on the form.
 | Rounded Rectangle Shape | Draws the geometric shape of a rectangle with rounded corners on the form.
 | Scroll Bar | Allows a user to add scroll bars (horizontal and/or vertical) to controls that do not automatically provide them. (These are not the same as the built-in scroll bars that are found with many controls.)
 | Static Text | Displays text, such as titles or captions, in regular outlines or filled rectangles, that the user cannot interact with or modify.
 | Status Bar | Displays status information in a horizontal window at the bottom of an application window.
 | Tab | Acts as a container for other controls and places a series of tabs at the top of the container.
 | Timer | Provides a measured time interval that can be tied to events.
 | Toolbar | Displays a series of buttons that can be placed at the top and/or bottom of a form.
 | Trackbar | Displays a window containing a slider and optional tick marks used to select a value or a set of consecutive values in a range.
 | Updown | Consists of a pair of arrow buttons that the user can click to increment or decrement a value, such as a scroll position or a number displayed in a companion control.


Animation Control

See Also

To add an animation control to a form, click Animate from the Toolbox.

An animation control is used to display an AVI clip. An AVI clip is a series of bitmap frames that run like a movie. Only AVI files without sound can be played using the animation control.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

With one exception, properties unique to the animation control (AutoPlay, Border, Center, Play, and Transparent) can be manipulated only in the WOW Designer. The runtime functions, WOWGETPROP and WOWSETPROP, will not recognize these properties. Runtime handling of the animation control can be accomplished by using the ACM- messages listed in the control Event-Handling Code dialog box. The exception is the AnimationFile property, which can be set at runtime.

Properties

*AnimationFile | Group | NoRedraw | *Transparent
*AutoPlay | Height | *Play | Visible
*Border | Left | StaticEdge | Width
*Center | Locked | TabIndex | Z-Order
ClientEdge | ModalFrame | Tag |
Enabled | Name | Top |

Events

*Start

*Stop


Bitmap Control

See Also

To add a bitmap control to a form, click Bitmap from the Toolbox.

The Bitmap control is used to display bitmapped images. The image can be displayed in several ways, including being tiled or scaled to fit the size of the control. A bitmap defines an image or picture as a pattern of dots (or pixels) and has the file extension .bmp. Even though Windows does not implement or package a bitmap control, it does provide bitmap handling. WOW Extensions adds the bitmap control to provide a convenient way to use bitmaps on a form.

Note If you are working with the bitmap field/control in an RM/Panels panel, click here.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

BackColor | Left | StaticEdge | Visible
*Bitmap | Locked | TabIndex | Width
*BitmapMode | ModalFrame | Tag | *Xoffset
*Border | Name | ToolTipEnabled | *Yoffset
ClientEdge | NoRedraw | ToolTipText | Z-Order
Enabled | RightAlignedText | Top |
Height | RightToLeftReading | Transparent |

Events

Click

MouseDown

MouseMove

MouseUp

Note Since the bitmap control recognizes the Click event, you can use a bitmap control anywhere you would use a command button control. Grouping several bitmap controls together horizontally across the top of the screen, usually within a group box control, allows you to create a toolbar in your application. Unlike command buttons, however, bitmap controls do not appear pushed in when clicked, thereby providing no visual cue that the “button” is being pushed.


Check Box Control

See Also

To add a check box control to a form, click Check Box from the Toolbox.

Note If you are working with the check box field/control in an RM/Panels panel, click here.

The check box control displays an option that can be turned on or off. The check box control is similar to the command button, in that the primary method of operation is clicking it. The check box control, however, represents data, not a request for action.

The check box solves a programming situation that has always been challenging: one in which a user must choose between True/False, Yes/No, or On/Off options. Since check boxes work independently of each other, a user can select any number of check boxes at the same time. While these seem like trivial items, creating a character-based implementation that includes validation, good user feedback, and convenient operation are certainly not insignificant. The check box control makes these tasks effortless.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

3D | FontName | Name | ToolTipText
Accelerator | FontSize | NoRedraw | Top
*Alignment | FontStrikethru | RightAlignedText | Transparent
*AutoCheck | FontUnderline | RightToLeftReading | *Value
BackColor | ForeColor | StaticEdge | Visible
Caption | Group | TabIndex | Width
ClientEdge | Height | TabStop | Z-Orde r
Enabled | Left | Tag |
FontBold | Locked | *ThreeState |
FontItalic | ModalFrame | ToolTipEnabled |

Events

Click | KeyPress | MouseDown
GotFocus | KeyUp | MouseMove
KeyDown | LostFocus | MouseUp

Note The user can change the state of a check box in two ways: by clicking with the mouse or by pressing the Spacebar while the check box has input focus. With either method, the Click event for the check box is triggered. You may want to add event-handling code to this event to enable or disable other controls based on the new state of the check box.


Combo Box Control

See Also

To add a combo box control to a form, click Combo Box from the Toolbox.

Note If you are working with the combo box field/control in an RM/Panels panel, click here.

Many times, you may want to combine the list selection capability of a list box with the edit box’s ability to type in a value. Alternatively, to save screen space, you may wish to show only a portion of the list box’s selections. And, there may be instances when you would like to display the currently selected item in a static text box area when the entire list is not displayed. The combo box control can satisfy all these conditions since it combines the features of an edit box (also known as an edit field) and a list box. Use this control to give the user the choice of typing in the edit box area or selecting an item from the list portion of the control. Combo boxes can save space on a form.

Note During the design process, the Drop Down Combo Box command from the Control menu allows all of the pre-defined data entries to be visible in the drop-down list box and provides the capability to select one of the entries for display in the edit box portion of the combo box control. Once you select one entry or select another object or click anywhere else on the screen, which cause focus to be lost, the drop-down list box is removed.

In addition, if you know how to use an edit box and a list box, you know how to use a combo box. The properties and events available for a combo box are a composite of those present in the edit box and list box controls. The messages you use with a combo box also parallel those that you use with edit boxes and list boxes. These messages, however, begin with a CB- prefix instead of an LB- or EM- prefix.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

3D | Enabled | Locked | *Style
*AutoHScroll | FontBold | ModalFrame | TabIndex
BackColor | FontItalic | Name | TabStop
ClientEdge | FontName | NoIntegralHeight | Tag
*Count | FontSize | NoRedraw | ToolTipEnabled
CurData | FontStrikethru | *OEMConvert | ToolTipText
*CurSel | FontUnderline | RightAlignedText | Top
Data | ForeColor | RightToLeftReading | Transparent
DataCount | Group | ScrollBar | Visible
DataLoad | Height | *SelText | Width
DataSelect | Left | *Sort | Z-Order
*DisableNoScroll | LeftScrollBar | StaticEdge |

Events

Click | GotFocus | LostFocus | *NoSpace
DblClick | KeyDown | MouseDown |
*DropDown | KeyPress | MouseMove |
*EditChange | KeyUp | MouseUp |

Note The DblClick and DropDown events are not supported if the Style property is set to a value of 0 (Simple, standard combo box). The DropDown event occurs when the user double-clicks the drop-down arrow in the text portion of the drop-down combo box and in the drop-down list box.


Command Button Control

See Also

To add a command button control to a form, click Command Button from the Toolbox.

Note If you are working with the command button field/control in an RM/Panels panel, click here.

The command button (also known as push button) control causes an action to occur when the user either clicks the button or presses a key.

The command button control is simple to use for both the user and the developer. When you place a command button on a form, the user can perform one action: push. Unlike other controls, the command button does not represent any data. It represents a request for action. When a command button is pushed, an action is carried out immediately.

WOW Extensions offers a user several ways to push a command button:

· Clicking it with the mouse.

· Pressing the Spacebar when the command button has input focus.

· Pressing an accelerator key for the command button while any control on the form has input focus.

· Pressing the Enter key while any control on the form has input focus.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

Accelerator | FontItalic | Locked | ToolTipEnabled
*Bitmap | FontName | ModalFrame | ToolTipText
*Cancel | FontSize | Name | Top
Caption | FontStrikethru | NoRedraw | Visible
ClientEdge | FontUnderline | StaticEdge | Width
*Default | Group | TabIndex | Z-Order
Enabled | Height | TabStop |
FontBold | Left | Tag |

Events

Click | KeyPress | MouseDown
GotFocus | KeyUp | MouseMove
KeyDown | LostFocus | MouseUp


Date Time Picker Control

See Also

To add a date time picker control to a form, click Date Time Picker from the Toolbox.

The date time picker control allows the user to select a date and time, and to display that date-time in the specified format. An embedded month calendar control displays a monthly calendar.

The date time picker control is based on the Gregorian calendar, which was introduced in 1753. It will not calculate dates that are consistent with the Julian calendar that was in use prior to 1753.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

ClientEdge | LeftScrollBa r | Name | *Text
Enabled | Locked | NoRedraw | *Time
FontBold | *LongDateFormat | Range | *TimeFormat
FontItalic | MCColor | *RightAlign | ToolTipEnabled
FontName | MCColorIndex | RightAlignedText | ToolTipText
FontSize | *MCFontBold | RightToLeftReading | Top
FontStrikethru | *MCFontItalic | *ShortDateCenturyFormat | Transparent
FontUnderline | *MCFontName | *ShowNone | *UpDown
*Format | *MCFontSize | StaticEdge | Visible
Group | *MCFontStrikethru | TabIndex | Width
Height | *MCFontUnderline | TabStop | Z-Order
Left | ModalFrame | Tag |

Events

*Change | KeyDown | KeyUp
GotFocus | KeyPress | LostFocus


Edit Box Control

See Also

To add an edit box control to a form, click Edit Box from the Toolbox.

Note If you are working with the edit box field/control in an RM/Panels panel, click here.

The edit box control provides an area to input or display text. This control replaces the COBOL ACCEPT statement. The user can enter any type of alphanumeric data in an edit box, including numeric data. Because no formatting is provided, numbers are entered in the same manner as text.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

3D | FontUnderline | *NumericDecDigits | *TabStops
*Alignment | ForeColor | *NumericIntDigits | Tag
*AutoHScroll | Group | *NumericSign | *Text
*AutoVScroll | Height | *OEMConvert | ToolTipEnabled
BackColor | Left | *Password | ToolTipText
*Border | LeftScrollBar | *PasswordChar | Top
*Case | Locked | *ReadOnly | Transparent
ClientEdge | *MaxChars | RightAlignedText | Visible
Enabled | ModalFrame | RightToLeftReading | *WantPopUpMenu
FontBold | *MultiLine | *ScrollBars | *WantReturn
FontItalic | Name | *SelectAllOnGotFocus | Width
FontName | NoRedraw | StaticEdge | Z-Order
FontSize | *NoHideSel | TabIndex |
FontStrikethru | *Numeric | TabStop |

Events

*Change | *HScroll | LostFocus | MouseUp
Click | KeyDown | *MaxText | *NoSpace
DblClick | KeyPress | MouseDown | *VScroll
GotFocus | KeyUp | MouseMove |


Ellipse Shape

See Also

To add an ellipse shape to a form, click Ellipse from the Toolbox.

The ellipse shape is used to draw the geometric shape of an ellipse on the form. A 32-bit Windows-based application uses filled shapes in a variety of ways. Spreadsheet applications, for example, use filled shapes to construct charts and graphs.

Technically, an ellipse is a closed curve defined by two fixed points such that the sum of the distances from any point on the curve to the two fixed points is constant. When calling ellipse, an application supplies the coordinates of the upper-left and lower-right corners of the ellipse’s bounding rectangle. A bounding rectangle is the smallest rectangle completely surrounding the ellipse. When the system draws the ellipse, it excludes the right and lower sides if no world transformations are set. Therefore, for any rectangle measuring x units wide by y units high, the associated ellipse measures x-1 units wide by y-1 units high.

Note This shape is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this shape will not be displayed on the Toolbox.

All of the properties for this shape are listed in the following table. Note that none of the properties for this shape are unique. Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

BackBrushHatch | ForeColor | Name | Top
BackBrushStyle | Height | PenSize | Width
BackColor | Left | PenStyle | Z-Order
Fill | Locked | TabIndex |

Note Because the ellipse shape allows no user interaction, no events are associated with it.


Group Box Control

See Also

To add a group box control to a form, click Group Box from the Toolbox.

Note If you are working with the group box field/control in an RM/Panels panel, click here.

The group box control is a specialized container that is used to group other controls, such as check boxes and option buttons.

The group box control cannot be modified or operated on by the user. Windows implements this control in much the same way as check boxes and option buttons, and it is commonly used to group these types of controls.

It is possible to select all the controls within the group box at one time by first selecting the group box, and then holding down the Alt key and clicking on one of the controls. For example, if you want to select all the check boxes in a group box, first select the group box, and then click on one of the check boxes while holding down the Alt key.

There is no need to retrieve the text of a group box, and situations in which you would want to change its text are hard to imagine, but possible. To change the text of a group box control at runtime with the WOWSETPROP function:

CALL WOWSETPROP USING WIN-RETURN CTL-H "CAPTION" NEW-TEXT.

CTL-H is the handle of the group box. “CAPTION” is the name of the property. NEW-TEXT is the new text of the control.

All of the properties for this control are listed in the following table. Note that none of the properties for this control are unique. Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

3D | FontSize | ModalFrame | Top
BackColor | FontStrikethru | Name | Transparent
Caption | FontUnderline | NoRedraw | Visible
ClientEdge | ForeColor | RightAlignedText | Width
Enabled | Group | RightToLeftReading | Z-Order
FontBold | Height | StaticEdge |
FontItalic | Left | TabIndex |
FontName | Locked | Tag |

Note Because the group box control allows no user interaction, no events are associated with it.


Line Shape

See Also

To add a line shape to a form, click Line from the Toolbox.

The line shape is used to draw a line on the form.

Note This shape is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this shape will not be displayed on the Toolbox.

All of the properties for this shape are listed in the following table. Note that none of the properties for this shape are unique. Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

BackBrushHatch | ForeColor | Name | Top
BackBrushStyle | Height | PenSize | Width
BackColor | Left | PenStyle | Z-Order
Fill | Locked | TabIndex |

Note Because the line shape allows no user interaction, no events are associated with it.


List Box Control

See Also

To add a list box control to a form, click List Box from the Toolbox.

Note If you are working with the list box field/control in an RM/Panels panel, click here.

The list box control allows the selection of one or several items from a list of items. It is a simple, yet versatile control. You load a list box with items at runtime. When enabled, the user can select an item by clicking with the mouse or moving the selection bar with the arrow keys. You send the list box a message to find out which item in the list box is selected. The following topics will help you understand how to use list box controls more effectively:

· Special considerations when using list boxes with functions and messages.

· Basic procedures required in using a list box.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

3D | Enabled | Locked | TabIndex
BackColor | *ExtendedSel | ModalFrame | TabStop
*Border | FontBold | *MultipleSel | *TabStops
ClientEdge | FontItalic | Name | Tag
*ColumnWidth | FontName | NoIntegralHeight | ToolTipEnabled
*Count | FontSize | *NoRedraw | ToolTipText
CurData | FontStrikethru | RightAlignedText | Top
*CurSel | FontUnderline | RightToLeftReading | Transparent
Data | ForeColor | ScrollBar | *UseTabStops
DataCount | Group | *SelText | Visible
DataLoad | Height | *Sort | *WantKeyboard
DataSelect | Left | *Standard | Width
*DisableNoScroll | LeftScrollBar | StaticEdge | Z-Order

Events

Click | KeyDown | LostFocus | MouseUp
DblClick | KeyPress | MouseDown |
GotFocus | KeyUp | MouseMove |

The event to which you are most likely to respond with a list box is the Click event. This event occurs whenever a selection changes, either by a mouse click or keyboard press, or when the Standard property is set to True. However, list boxes generally do not take action on a selection change. A DblClick event occurs when a list box item is double-clicked. This event is often expected to trigger some immediate program response.


Use Functions and Messages with List Boxes

Several functions and many messages may be used with a list box. The functions that deal with adding and removing items in a list box are:

1. WOWADDITEM, which adds an item to a list box.

2. WOWREMOVEITEM, which removes an item from a list box.

3. WOWCLEAR, which removes all items from a list box.

The messages you can use with a list box are too numerous to list here, but each begins with the prefix LB-. Comprehensive information about messages can be found in the Functions and Messages online Help file. Liant recommends that you take a few minutes and browse through them to get an idea of the kinds of capabilities those messages can provide.


Use a List Box

The basic steps involved in using a list box include:

1. Loading the list box

2. Operating the list box

3. Determining the selection

4. Finding an item

5. Selecting an item

6. Retrieving the selection

7. Removing one or all items from the list box

For more information on using functions and messages with list boxes, click here.


Month Calendar Control

See Also

To add a month calendar control to a form, click Month Calendar from the Toolbox.

The month calendar control displays a monthly calendar. The calendar can display one or more months at a time. When a user clicks on the name of a month, a pop-up menu appears that lists all of the months of the year. A user can select a month by clicking its name on the menu. A user who is using the date time picker control can use the Alt+Down Arrow key combination to activate the month calendar control. A user can scroll the displayed months backward or forward, respectively, either by clicking the left arrow or the right arrow at the top of the control, or by pressing the PageUp or the PageDown key on the keyboard. When a user clicks the year that is displayed at the top of the calendar next to the month, an updown control appears. A user can use this control to change the year. A user also can use the Ctrl+PageUp or the Ctrl+PageDown key combination to scroll from one year to another. A user can press keys on the keyboard to navigate; the arrow keys scroll between days, the Home key moves to the beginning of a month, and the End key moves to the end of a month. Unless the calendar has the NoToday property set to False, a user can return to the current day by tapping the “Today” label at the bottom of the month calendar control.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

ClientEdge | Height | Name | *Today
*DayState | Left | NoRedraw | ToolTipEnabled
*Date | LeftScrollBar | *NoToday | ToolTipText
Enabled | Locked | *NoTodayCircle | Top
*FirstDayOfWeek | *MaxSelCount | Range | Transparent
FontBold | MCColor | RightAlignedText | Visible
FontItalic | MCColorIndex | RightToLeftReading | *WeekNumbers
FontName | ModalFrame | *SelRange | Width
FontSize | *MonthDelta | StaticEdge | Z-Order
FontStrikethru | *MonthRangeDayState | TabIndex |
FontUnderline | *MonthRangeVisible | TabStop |
Group | *MultiSelect | Tag |

Events

*Change | KeyDown | KeyUp
GotFocus | KeyPress | LostFocus


Option Button Control

See Also

To add an option button control to a form, click Option Button from the Toolbox.

Note If you are working with the option button field/control in an RM/Panels panel, click here.

The option button (also known as radio button) control displays an option that can be turned on or off. Option buttons are usually used in groups where turning one button on turns the others off. For more information on grouping option buttons, click here.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

3D | FontName | Name | Top
Accelerator | FontSize | NoRedraw | Transparent
*Alignment | FontStrikethru | RightAlignedText | *Value
*AutoPress | FontUnderline | RightToLeftReading | Visible
BackColor | ForeColor | StaticEdge | Width
Caption | Group | TabIndex | Z-Order
ClientEdge | Height | TabStop |
Enabled | Left | Tag |
FontBold | Locked | ToolTipEnabled |
FontItalic | ModalFrame | ToolTipText |

Events

Click | KeyDown | KeyUp
GotFocus | KeyPress | LostFocus

Note The user can change the state of an option button in two ways: by clicking with the mouse or by pressing the Spacebar while the option button has input focus. With either method, the Click event for the option button is triggered. You may want to add event-handling code to this event in order to enable/disable other controls based on the new state of the option button.


Group Option Buttons

The option button is generally used in a group with other option buttons. Together, these option buttons represent a group of mutually exclusive choices. When one option button is selected, it deselects whatever other button in the group was previously selected. Only one button in the group can be selected at any time.

At first glance, the option button control seems similar to the check box control. Because it has two states, pushed and unpushed, you might think that it would also be used for True/False type conditions. However, this is not the case.

This control also solves another tedious programming problem very easily, that of choosing one of a limited number of exclusive options. Since only one option button can be selected at a time, you do not have to validate any user input. You only need to determine which option button is selected. A group of option buttons is very similar to a list box.

When you create a group of option buttons, you must indicate to Windows that they are a group. For example, let’s say you are creating two groups of option buttons, each with three buttons in a group. Windows needs to know which buttons go together, so that it does not treat all six as one big group.

To group the option buttons, you use two properties together, the TabIndex and Group properties. The TabIndex property determines the input order of controls. Option buttons in a group must have sequential input order. If the first option button in a group has a TabIndex setting of 3, the next option button must have a TabIndex of 4, and the next one 5.

The Group property indicates that a control is the first control in a group. The first option button in a group must have the Group property set to True. The other option buttons in that group must have the Group property set to False. The first control that follows a group of controls, that is, the control whose input order (TabIndex) is subsequent to the last one in the group, should have its Group property set to True so that Windows knows where the group ends.

If you have two groups of three option buttons each, the Group and TabIndex properties should be set in the following manner:

First Group | Set Group Property to | Set TabIndex Property to
Button 1 | True | x
Button 2 | False | x + 1
Button 3 | False | x + 2

Second Group | Set Group Property to | Set TabIndex Property to
Button 4 | True | y
Button 5 | False | y + 1
Button 6 | False | y + 2


Progress Bar Control

See Also

To add a progress bar control to a form, click Progress Bar from the Toolbox.

A progress bar control consists of a patterned block that can be used to show the status of a long operation.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

All of the properties for this control are listed in the following table. Properties that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, at runtime, or both, click here.

Properties

ClientEdge | *Maximum | StaticEdge | *Value
Group | *Minimum | TabIndex | Visible
Height | ModalFrame | Tag | Width
*Increment | Name | ToolTipEnabled | Z-Order
Left | NoRedraw | ToolTipText |
Locked | RightAlignedText | Top |

Note Because the progress bar control allows no user interaction, no events are associated with it.


Rectangle Shape

See Also

To add a rectangle shape to a form, click Rectangle from the Toolbox.

The rectangle shape is used to draw the geometric shape of a rectangle on the form. Rectangles are used for the cursor clipping region, the invalid portion of the client area, an area for displaying formatted text, or the scroll area. Your applications can also use rectangles to fill, frame, or invert a portion of the client area with a given brush, and to retrieve the coordinates of a window or a window’s client area.

Note This shape is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this shape will not be displayed on the Toolbox.

All of the properties for this shape are listed in the following table. Note that none of the properties for this shape are unique. Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

BackBrushHatch | ForeColor | Name | Top
BackBrushStyle | Height | PenSize | Width
BackColor | Left | PenStyle | Z-Order
Fill | Locked | TabIndex |

Note Because the rectangle shape allows no user interaction, no events are associated with it.


Rounded Rectangle Shape

See Also

To add a rounded rectangle shape to a form, click Rounded Rectangle from the Toolbox.

The rounded rectangle shape is used to draw the geometric shape of a rectangle with rounded corners on the form. Rectangles are used for the cursor clipping region, the invalid portion of the client area, an area for displaying formatted text, or the scroll area. Your applications can also use rectangles to fill, frame, or invert a portion of the client area with a given brush, and to retrieve the coordinates of a window or a window’s client area.

Note This shape is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this shape will not be displayed on the Toolbox.

All of the properties for this shape are listed in the following table. Properties that apply only to this shape, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

BackBrushHatch | Heigh t | PenStyle | Width
BackBrushStyle | Left | *RoundnessX | Z-Order
BackColor | Locked | *RoundnessY |
Fill | Name | TabIndex |
ForeColor | PenSize | Top |

Note Because the rounded rectangle shape allows no user interaction, no events are associated with it.


Scroll Bar Controls

See Also

To add a scroll bar control to a form, click either Horizontal Scroll or Vertical Scroll from the Toolbox. A horizontal scroll bar displays a horizontal bar that can be used to scroll information. A vertical scroll bar displays a vertical bar that can be used to scroll information.

The scroll bar control is used to allow a numeric value to be manipulated as a thumb position on a bar. By specifying the minimum and maximum, the value can be viewed relative to a range of possible values. This value and the scroll bar are often used to scroll the display of other information on a form. For more information on using scroll bar controls, click here.

Note If you are working with the scroll bar field/control in an RM/Panels panel, click here.

All of the properties and events for both the horizontal and vertical scroll bar controls are listed in the following tables. Properties and events that apply only to these controls, or that require special consideration when used with them, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

Enabled | *Maximum | TabStop | Visible
Group | *Minimum | Tag | Width
Height | Name | ToolTipEnabled | Z-Order
Left | NoRedraw | ToolTipText |
*LineChange | *PageChange | Top |
Locked | TabIndex | *Value |

Events

*EndScroll | *LineRight (Horizontal) | *PageLeft (Horizontal) | *ThumbPos
*LineDn (Vertical) | *LineUp (Vertical) | *PageRight (Horizontal) | *ThumbTrk
*LineLeft (Horizontal) | *PageDn (Vertical) | *PageUp (Vertical) |

Note There are a number of events associated with the scroll bar, related to the different ways in which the thumb can be moved. No matter how the thumb is moved, the EndScroll event is always generated when the user has finished moving the thumb. Unless the contents of some part of the form are to be scrolled while the thumb is being dragged, the EndScroll event is the best place to respond to changes in thumb position.


Use Scroll Bar Controls

Let’s say a form is used for order entry and displays five lines of a possible 100 on an order. The scroll bar could be used to scroll the view to include the other lines on the order. In this case, by specifying the minimum value as 0 and the maximum value as 95, the scroll bar value could be used directly as the offset between the displayed order line and the actual order line.

Although scroll bars can be vertical or horizontal, they function in the same manner. The thumb on the scroll bar can be dragged to a desired position with the mouse. The thumb also can be moved by clicking the bar on either side of the thumb, or by clicking one of the arrows at either end of the bar.

Clicking the body of the scroll bar or on the arrows moves the thumb in different, configurable increments. Clicking the body of the scroll bar moves the thumb by the increment specified in the PageChange property. Clicking the arrows at either end of the scroll bar moves the thumb by the increment specified in the LineChange property. The PageChange increment, by convention, should be larger than the LineChange increment. Considering the order entry situation described previously, the LineChange property should be one and the PageChange property should be equal to five, which is the number of lines of the order displayed on the form at one time.


Static Text Control

See Also

To add a static text control to a form, click Static Text from the Toolbox.

Note If you are working with the static text field/control in an RM/Panels panel, click here.

The static text control is used to display text, rectangular outlines, or filled rectangles. These features could reasonably be implemented as several different types of objects, but Windows combines them since they have the same properties. You use the static text control most often to display text the user is not allowed to modify, such as labels for other controls. The static text control is also used to draw rectangles or outlines to highlight parts of a form, group controls, or even create a design.

There is rarely a need to retrieve the contents of static text controls since the user cannot change them. However, you may need to change the text of a static text control at runtime. To change the text of a static text control at runtime with the WOWSETPROP function:

CALL WOWSETPROP USING WIN-RETURN CTL-H "TEXT" NEW-TEXT.

CTL-H is the handle of the static text control. “TEXT” is the name of the property. NEW-TEXT is the new text of the control.

Note Windows displays all disabled static text controls with gray text. While you may never need to disable a static text control (since they do not have any events attached to them), if you were to do so, the text would appear as gray. If the control is displayed on a form with the default gray background, the control will not be visible.

All of the properties and events for this control are listed in the following table. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

3D | FontName | ModalFrame | Top
*Alignment | FontSize | Name | Transparent
BackColor | FontStrikethru | *NoPrefix | Visible
Caption | FontUnderline | NoRedraw | Width
ClientEdge | ForeColor | RightAlignedText | *WordWrap
*Effect | Group | RightToLeftReading | Z-Order
Enabled | Height | StaticEdge |
FontBold | Left | TabIndex |
FontItalic | Locked | Tag |

Events

Click | MouseDown | MouseUp
DblClick | MouseMove |


Status Bar Control

See Also

To add a status bar control to a form, click Status Bar from the Toolbox.

A status bar control display status information in a horizontal window at the bottom of an application window. Status bars are often divided into sections, called panes, and each pane displays different status information. It is possible to change to a different pane simply by clicking on the desired section of the status bar,

When the status bar shows only one pane, it is in “simple mode.” When the text of the window is set, the window is invalidated, but it is not redrawn until the next WM-PAINT message. Waiting for the message reduces screen flicker by minimizing the number of times the window is redrawn. A simple mode status bar is useful for displaying Help text for menu items while the user is scrolling through the menu.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

All of the properties for this control are listed in the following table. Properties that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

ClientEdge | Left | *SectionStatus | ToolTipEnabled
*CurSection | Locked | *SectionWidth | ToolTipText
FontBold | ModalFrame | *Sections | Top
FontItalic | Name | *SimpleNoBorders | Transparent
FontName | NoRedraw | *SimplePopOut | Visible
FontSize | RightAlignedText | *SimpleStatus | Width
FontStrikethru | RightToLeftReading | StaticEdge | Z-Order
FontUnderline | *SectionNoBorders | TabIndex |
Height | *SectionPopOut | Tag |

Note Because the status bar control allows no user interaction, no events are associated with it.


Tab Control

See Also

To add a tab control to a form, click Tab from the Toolbox.

A tab control is a container control, meaning it allows other controls to be placed inside it. The tab control has several tabs at the top of the control. When a control is added to the tab, it is attached to the tab that is currently selected. When another tab is selected, the controls for the other tabs are hidden and the controls for the selected tab are displayed. This is an excellent way to organize controls by category, rather than placing a large number of controls in a single window.

It is possible to select all the controls within the tab at one time by first selecting the tab, and then holding down the Alt key and clicking on one of the controls. For example, if you want to select all the command buttons in a tab, first select the tab, and then click on one of the command buttons while holding down the Alt key.

All the controls on the tab are created when the tab control is created and destroyed when the tab control is destroyed. The controls are not created and destroyed as different tabs are selected. This means that the controls can be initialized once when the tab is created, and the control values retrieved once, before the tab is destroyed. There is no need to initialize or read from the controls just because a new tab is being selected. It is possible to change to a different tab simply by clicking on the desired tab.

To delete a tab within a tab control, but retain any controls contained within the deleted tab, use the Tab Control Editor dialog box. You may also modify certain tab properties that require special consideration with the tab control in this dialog. Changing these properties for the tab control in the Tab Control Editor is equivalent to setting their values in the Properties dialog box. To display the Tab Control Editor dialog, select a tab control on a form and then click Tab Editor from the Control menu.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

At the current time, certain properties unique to the tab control (Buttons, FixedWidth, ForceLabelLeft, GetFocus, MultiLine, RightJustify, and Tabs) can be manipulated only in the WOW Designer. The runtime functions, WOWGETPROP and WOWSETPROP, will not recognize these properties.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

Accelerator | FontStrikethru | *MultiLine | TabStop
*Buttons | FontUnderline | Name | *TabText
ClientEdge | *ForceLabelLeft | NoRedraw | Tag
*CurTab | *GetFocus | RaggedRight | Top
*FixedWidth | Group | Right | Vertical
FontBold | Height | StaticEdge | Visible
FontItalic | Left | *TabEnabled | Width
FontName | Locked | TabIndex | Z-Order
FontSize | ModalFrame | *Tabs |

Events

*KeyDown

*SelChange

*SelChanging


Timer Control

See Also

To add a timer control to a form, click Timer from the Toolbox.

The timer control provides a measured time interval that can be tied to events.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

Enabled | Name | Visible
Height | NoRedraw | Width
*Interval | TabIndex | Z-Order
Left | Tag |
Locked | Top |

Event

*Timer


Toolbar Control

See Also

To add a toolbar control to a form, click Toolbar from the Toolbox.

A toolbar control consists of a series of buttons that can be placed at the top and/or bottom of a form. You can put two toolbars on a form, one at the top and one at the bottom. Event-handling code can be attached to each button in the toolbar. Each button in the toolbar can contain a bitmap and/or text. Each button in the toolbar can have its own tool tip.

It is possible to change to a different button simply by clicking on the desired button.

The interaction of button groups and the wrapping properties of the toolbar are somewhat obscure. Liant Software Corporation has not fully isolated the interaction of all of these properties, and documentation from Microsoft is sketchy.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

At the current time, properties unique to the toolbar control (AlignTop, BitmapHeight, BitmapWidth, BtnBitmap, BtnHidden, BtnStyle, BtnToolTipEnabled, BtnToolTipText, BtnWrap, ButtonHeight, Buttons, ButtonWidth, CurButton, Larger, Rows, and Wrapable) can be manipulated only in the WOW Designer.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

The properties that begin with the prefix Btn- refer to a single button on the toolbar. The button being referred to is controlled by the setting of the CurButton property. All other properties apply to the entire toolbar.

Properties

Accelerator | *BtnWrap | Group | TabIndex
*AlignTop | *ButtonHeight | Height | Tag
*BitmapHeight | *ButtonWidth | *Larger | ToolTipEnabled
*BitmapWidth | *Buttons | Left | ToolTipText
*BtnBitmap | ClientEdge | Locked | Top
*BtnEnabled | *CurButton | ModalFrame | Transparent
*BtnHidden | FontBold | Name | Visible
*BtnState | FontItalic | NoRedraw | Width
*BtnStyle | FontName | RightAlignedText | *Wrapable
*BtnText | FontSize | RightToLeftReading | Z-Order
*BtnToolTipEnabled | FontStrikethru | *Rows |
*BtnToolTipText | FontUnderline | StaticEdge |

Event

*Button-n


Trackbar Control

See Also

To add a trackbar control to a form, click Trackbar from the Toolbox.

A trackbar control displays a window containing a slider and optional tick marks used to select a value or a set of consecutive values in a range. The trackbar control can be oriented either horizontally or vertically. Trackbars are useful when you want the user to select a discrete value or a set of consecutive values in a range. For example, you might use a trackbar to allow the user to set the repeat rate of the keyboard by moving the slider to a given tick mark.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

At the current time, certain properties unique to the trackbar control (AutoTicks, BothTicks, EnableSelRange, LeftTicks, NoThumb, NoTicks, SelEnd, SelStart, TopTicks, and Vertical) can be manipulated only in the WOW Designer. The runtime functions, WOWGETPROP and WOWSETPROP, will not recognize these properties.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

*AutoTicks | *LineChange | *PageChange | ToolTipText
*BothTicks | Locked | *SelEnd | Top
ClientEdge | *Maximum | *SelStart | *TopTicks
Enabled | *Minimum | StaticEdge | *Value
*EnableSelRange | ModalFrame | TabIndex | *Vertical
Group | Name | TabStop | Visible
Height | NoRedraw | Tag | Width
Left | *NoThumb | *TickFreq | Z-Order
*LeftTicks | *NoTicks | ToolTipEnabled |

Events

*Bottom | *LineUp | *ThumbPos
*EndTrack | *PageDown | *ThumbTrk
*LineDown | *PageUp | *Top


Updown Control

See Also

To add an updown control to a form, click Updown from the Toolbox.

An updown control is a pair of arrow buttons that the user can click to increment or decrement a value, such as a scroll position or a number displayed in a companion control. The value associated with an updown control is called its current position.

An updown control is most often used with a companion control, which is called a buddy window. To the user, an updown control and its buddy window often look like a single control. You can specify that an updown control automatically position itself next to its buddy window and that it automatically set the caption of the buddy window to its current position. For example, you can use an updown control with an edit box control to prompt the user for numeric input.

An updown control without a buddy window functions as a sort of simplified scroll bar. For example, a tab control sometimes displays an updown control to enable the user to scroll additional tabs into view.

Note This control is not recognized by RM/Panels. If you use the WOW Designer to enhance a panel, this control will not be displayed on the Toolbox.

At the current time, certain properties unique to the updown control (Accelerators, AccelIncrement, AccelSeconds, AlignLeft, AlignRight, ArrowKeys, BuddyInteger, CurAccel, NoThousands, and Wrapable) can be manipulated only in the WOW Designer. The runtime functions, WOWGETPROP and WOWSETPROP, will not recognize these properties.

All of the properties and events for this control are listed in the following tables. Properties and events that apply only to this control, or that require special consideration when used with it, are marked with an asterisk (*). Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether this control’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Properties

*Accelerators | *BuddyInteger | *Maximum | ToolTipEnabled
*AccelIncrement | *CurAccel | *Minimum | ToolTipText
*AccelSeconds | Enabled | Name | Top
*AlignLef t | Group | NoRedraw | *Value
*AlignRight | Height | *NoThousands | Visible
*ArrowKeys | *Horizontal | TabIndex | Width
*Base | Left | TabStop | *Wrapable
*Buddy | Locked | Tag | Z-Order

Events

*EndScroll

*ThumbPos


Common Intrinsic Control Properties

See Also

This topic summarizes the common properties that may be implemented in an intrinsic control. (To determine the unique properties available for a control, refer to the specific control in Properties and Events for Intrinsic Controls.)

Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box.

The following properties are used by several types of intrinsic controls.

Properties

3D | Fill | MCColor | TabIndex
Accelerator | FontBold | MCColorIndex | TabStop
BackBrushHatch | FontItalic | ModalFrame | Tag
BackBrushStyle | FontName | Name | ToolTipEnabled
BackColor | FontSize | NoIntegralHeight | ToolTipText
Caption | FontStrikethru | NoRedraw | Top
ClientEdge | FontUnderline | PenSize | Transparent
CurData | ForeColor | PenStyle | Visible
Data | Group | Range | Width
DataCount | Height | RightAlignedText | Z-Order
DataLoad | Left | RightToLeftReading |
DataSelect | LeftScrollBar | ScrollBar |
Enabled | Locked | StaticEdge |


Common Intrinsic Control Events

See Also

The following common events are implemented by one or more of the intrinsic controls. (Refer to the specific control to determine the unique events available for the control or that require special consideration when used with the control.)

Events can be retrieved and set at runtime using code in the Event-Handling Code dialog box.

Events

Click | KeyDown | LostFocus | MouseUp
DblClick | KeyPress | MouseDown |
GotFocus | KeyUp | MouseMove |


Properties and Events for Forms

See Also

Forms are the containers within which you group controls. In traditional programming, you place fields on the screen or in a pop-up window. With WOW Extensions, you place fields (that is, controls) in a form. Although forms are quite versatile, most of your programming will be involved with manipulating controls, not forms. The form has only default properties associated with it.

Use the Properties dialog box in the WOW Designer to view and set the properties that are available for a form or control while the form is being designed. Most properties also can be retrieved and set at runtime using code in the Event-Handling Code dialog box. To see a list detailing whether the form’s properties can be manipulated at design time, retrieved or set at runtime, or both, click here.

Note If you are working with forms in an RM/Panels panel, click here.

The following properties and events are used by forms.

Properties

3D | ClipSiblings | MinButton | SystemMenu
AllowEventFilter | Cursor | Modal | Tag
BackColor | DialogMotion | Name | Title
Bitmap | Enabled | NoRedraw | ToolWindow
BitmapMode | Height | Parent | Top
Border | Icon | ScrollBars | Visible
Caption | KeyPreview | ShowState | Version
Centered | Left | Style | Width
ClipControls | MaxButton | SysKeyMode | WSDefinition

Events

Activate | KeyPress | MButtonUp | RButtonUp
Close | KeyUp | MouseDown | Show
Create | LButtonDown | MouseMove | Size
Enable | LButtonUp | MouseUp |
GetFocus | LoseFocus | Paint |
KeyDown | MButtonDown | RButtonDown |


Debugging

Debugging with WOW Extensions


Debugging with WOW Extensions

See Also

WOW Extensions makes Windows programming straightforward, but as your application grows in complexity, you will need to test your program and debug your source code.

It is possible to enable messages that aid in debugging a WOW application at runtime by adding the following entry to the WOW runtime initialization file (wowrt.ini):

[WOWRT]
DevelopmentMode=True

For more information about debugging a Windows-based application created with WOW Extensions, click one of the following topics:

· Using COBOL DISPLAY statements

· Using the RM/COBOL Interactive Debugger

· Using CodeWatch (Liant’s standalone source-level debugger)


Debugging with COBOL DISPLAY Statements

See Also

The RM/COBOL runtime system creates a window to use for supporting the standard COBOL user interface. WOW programs create their own windows, which makes it easy to use the RM/COBOL main window for debugging. The first way you might use this window is by inserting DISPLAY statements in your programs. An example form named SHOWME in the SHOWME program (located in the installation samples folder) illustrates this process. The project name is showme.wpj; the executable program name is showme.cbl. For procedures on executing the SHOWME program, click here.

The SHOWME form contains a number of different controls. Every event associated with every control on the form, as well as the form itself, has a DISPLAY statement associated with it. When you run the example, you will see the SHOWME form and the RM/COBOL main window displayed. As you use the form and controls, you will see the result of the DISPLAY statements scrolling by in the RM/COBOL main window.

Since WOW programs are event-driven, rather than sequential, you may wonder if certain events occurred, or if certain sections of logic were executed. You cannot assume that because your program is at point C, you passed points A and B. If you insert DISPLAY statements at key points in the program, you will know whether those points have been reached.

Unlike traditional COBOL code, event-driven coding associates instructions with a particular event on a particular control. This, in turn, means that if there is a syntax error at compile time, the source of the error might not be immediately apparent. To avoid this problem, compile your project every time you put code against an event. In this way, if there is a compile error, you know exactly where it came from. Additionally, the compilation will save the program, which is a good safeguard against system crashes.

It is good practice to test almost as often as you compile. Test fragments as you develop, rather than waiting to test until you’ve finished coding the entire program. Testing fragments allows you to isolate errors in logic.


Execute the SHOWME Program

Compile and run the SHOWME program. Simply starting the program generates a number of events: Create events, Size events, even Change events when the default text is set.

Then see how many different events you can generate by working with the form and the various controls. Windows reports lots of events, giving you many opportunities to customize the behavior of your programs.


How the SHOWME Program Works

Every available event in the WOW Designer for each control has a DISPLAY statement associated with it. When the event occurs, the DISPLAY statement displays the name of the control for which the event occurred and the name of the event.


Debugging with the RM/COBOL Interactive Debugger

See Also

If you have been using RM/COBOL very long, you have probably used the Interactive Debugger in the runtime system. While it is unable to display your source code as you debug, it can be a straightforward way of quickly checking out isolated problems if you have a listing file conveniently available.

The Interactive Debugger works better with WOW programs than it does with DOS, UNIX, or non-WOW Windows programs. Because the Debugger has exclusive access to the RM/COBOL main window, it does not have to share it with the program that is executing. This prevents the Debugger from being limited to operating in a single line or from scrolling the other contents of the display out of view.

The BREAK program (located in the installation samples folder) demonstrates how the Debugger works with a WOW program. The project name is break.wpj; the executable program name is break.cbl. When you run the BREAK program, you will set a breakpoint on the event-handling code for the Size event in the form. When you reach that breakpoint, you can use the Debugger to display the value of the Height, Left, Top, and Width properties of the form.

For procedures on executing the BREAK program, click here.


Execute the BREAK Program

1. Compile the BREAK program with the L and Y RM/COBOL Compile Command options. Look at the listing file and find the line number of the following line of code:

CALL WOWGETPROP USING WIN-RETURN BREAK-H
"Left" LEFT-VALUE
"Top" TOP-VALUE
"Width" WIDTH-VALUE
"Height" HEIGHT-VALUE.

Remember the line number because you will need it to set a breakpoint.

2. Run the program with the D Runtime Command option to start the program and enable the Interactive Debugger. The RM/COBOL main window will display and the debug prompt will be displayed in the lower-left corner of the RM/COBOL main window.

3. Type the following command:

B NNNNN

where NNNNN is the line number of the code identified above, and press Enter. This action sets a breakpoint at the specified line. Now, every time the runtime system is ready to execute this line of code, execution will stop and the debug prompt will be displayed.

4. Type the letter R and press Enter to run the program. The breakpoint is reached immediately because the breakpoint is associated with the Size event. A Size event is generated when a form is created. For more information, see Properties and Events for Forms.

At this point, something very interesting happens. Based on your experience in character-based environments, you would expect the WOW Designer window to freeze and no longer respond to user input. This, however, is not the case. Since Windows -- not the application program -- is controlling the form, the form and controls will continue to respond to user input events. These events are placed in a queue and will wait for the application to retrieve them from the queue.

When the debug prompt is displayed, the RM/COBOL main window is inactive. To work with the Debugger, you must click the mouse in the RM/COBOL main window or press Alt+Tab until you see the RM/COBOL main window listed. Do this now so that the RM/COBOL main window becomes active.

The runtime system is ready to execute the WOWGETPROP function.

5. Type the letter S and press Enter to tell the Debugger to step through the execution of this line. The debug prompt is immediately redisplayed and you can examine the values.

6. To display the value of the fields, type the following Debug commands, pressing Enter after each command:

LEFT-VALUE
TOP-VALUE
WIDTH-VALUE
HEIGHT-VALUE

7. Type R and press Enter to resume execution of the program. If you happened to resize the form while the runtime system was paused for debugging, you will immediately go back to the breakpoint again. Try resizing the form several times and see how the values change.


How the BREAK Program Works

The BREAK program works by using the RM/COBOL main window for the Debugger and the WOW Designer window for the user interface. This is an ideal situation, since the two windows do not interfere with each other.

Note, however, that there are two important items to remember when debugging in this manner. First, one window is always active, either the Debugger or the form. To work with one or the other window, you must click on the desired window or press Alt+Tab. When the Debugger reaches a breakpoint, it will automatically display the debug prompt, but it will not make the RM/COBOL main window active. To type Debug commands, you must make the Debug window active.

Secondly, while the runtime system is stopped at a debug breakpoint, the form will continue to respond to user input. You can move and resize a form, press buttons, and even type data into input fields. The COBOL program will not, however, be made aware of any of these events until the runtime execution is resumed. The events are not lost and will then be processed in the order they occurred.


Debugging with CodeWatch

See Also

To debug using CodeWatch, Liant’s standalone source-level debugger, follow these steps:

1. In the WOW Designer window, click Pre ferences on the Options menu.

2. On the Tools Preferences page of the Preferences dialog box, enter Y=3 in the Command Tail text box of the COBOL Compiler area.

The Y=3 setting places both the symbol table and the debug line table (used by CodeWatch to display the source program) in the object file. Additionally, the Y=3 setting includes the allocation map and cross-reference information in the debug line table if the A and/or X Options are also specified.

3. Set the L Option in the Tools page of the Preferences dialog box in the COBOL Compiler Command Tail text box to get an automatic listing file to help identify the area with the problem.

Note If you set the L Option in this manner, you must remove the entry, E L, from the Compiler Command Line Arguments text box in the Project Options dialog box. Failing to do so will cause the E L entry to take precedence over the L entry. (To open the Project Options dialog box for the current project, click Options on the Project menu.)

4. Click Debug Project on the Project toolbar to invoke CodeWatch.

Make sure that the CodeWatch environment can find the wowrt.dll that WOW Extensions needs at runtime. You can do this either by changing the settings in the Windows registry or by adding the dynamic-link library (DLL) in the CodeWatch wizard as you start it.

Once you have your application loaded in CodeWatch, you can step through it in the normal manner. As you run the program, the additional code that WOW Extensions has generated is displayed as it is executed. If you do not wish to see this code, set a breakpoint at a relevant place in an event code and disable animation until you reach the breakpoint.


Using WOW Extensions Thin Client

Understanding WOW Thin Client


Understanding WOW Thin Client

See Also

WOW Thin Client provides the ability to execute WOW programs in a client/server architecture over a LAN or the Internet. All programs and data reside and execute on the server, but the Windows user interface is presented on a Windows workstation. This client/server implementation is carried out by integrating RPC (Remote Procedure Calls) technology with WOW Extensions.

Note WOW programs version 4 and later are able to use COBOL ACCEPT and DISPLAY statements. For more information, see Thin Client Accept/Display.

From a conceptual standpoint, you can consider a Thin Client application in the following manner. The Windows client workstation executes a small .exe program (wowclient.exe) on Windows that connects to the server. The server, upon receiving this connection request, begins execution of the application on the server. The application runs as a normal RM/COBOL program on the server until a WOW function is invoked. All WOW functions are intercepted by special logic in the runtime, which routes the requests back to the client, where they are executed. This causes the user interface to be presented on the client. When the WOW function completes execution, control is returned to the server.

The WOW Thin Client also allows the RM/COBOL application program running on the server to access the RM/COBOL runtime Windows printing capabilities. For more information, click here.

Only a few files are installed on the client workstation. These files allow the client to initiate the connection to the server and to carry out the Windows user interface functionality.

The bulk of the installation is on the server. The server must host the facilities for receiving the connection request, executing the application, and forwarding the Windows user interface requests to the client. For more information, see installing and configuring WOW Thin Client.


Thin Client Accept/Display

WOW Thin Client Accept/Display allows WOW Extensions programs running in the client/server architecture over a LAN or the Internet to use COBOL ACCEPT and DISPLAY statements. The input/output of these statements appear in the default RM/COBOL for Windows standard graphical user interface window (supported by the dynamic-link library, rmguife.dl l) on the Windows' client machine.

WOW Thin Client has its own configuration file, wowclient.cfg, where wowclient is the name of the wowclient executable file, wowclient.exe. wowclient.cfg is automatically located in the same directory as wowclient.exe. By specifying a complete pathname in the environment variable, WOW_THIN_CLIENT_CFG_FILE, the default name and location can be overridden. This configuration file allows the terminal I/O sub-system for Thin Client Accept/Display to be configured.

Thin Client supports the following RM/COBOL terminal configuration records: TERM-INTERFACE, TERM-INPUT, and TERM-ATTR. For more information, refer to Chapter 10: Configuration in the RM/COBOL User’s Guide.


Benefits of WOW Thin Client

See Also

WOW Thin Client provides benefit in a variety of ways, including:

· Simplified management. Simplified computing means lower ownership costs and increased resource efficiency of each end-user.

· Access to legacy systems. Extends the life of a COBOL application. Customers can retain the access to existing legacy systems, databases, and applications, while benefiting from popular, Windows-based applications.

· Reduced cost of ownership. Thin clients do not require many of the features of a PC because network servers do most of the work running programs and storing data.


Installing and Configuring WOW Thin Client

To use WOW Thin Client, you must install both the WOW Thin Client and the RPC (Remote Procedure Calls) server software. These are supplied on different distribution disks and must be installed individually. Both may be installed on the same computer, allowing that computer to function as both client and server. This is useful for testing and debugging purposes, and an application can be deployed in this manner as well.

For specific instructions on installing the client and server software, refer to the installation instructions included on the distribution media.

Once WOW Thin Client is installed, some configuration must be done before it can be used. Since using the Thin Client portion of WOW Extensions involves little or no additional coding, configuration of the client and server are the primary issues in its use. Configuration information for both the client and server are stored in the rpcplus.ini file. Configuration information can be changed by editing this file.

For more information on configuring WOW Thin Client, click one of the following:

· Files installed on the Windows client workstation

· Files installed on a Windows server

· Files installed on a UNIX server


Files Installed on the Windows Client Workstation

See Also

The following lists and describes each file that must be installed on the Windows client workstation in order to use the Thin Client portion of WOW Extensions.

Files

Description

allegris.dll

This dynamic-link library is the graphical user interface support module.

codebrdg.dll

This dynamic-link library is the RM/COBOL CodeBridge support module, which is a support module for the Windows remote printing module (rmremprt.dll). This DLL must be placed in the same (or working) directory as wowclient.exe or in a directory specified in the PATH environment variable.

rmconfig.exe

This program is the RM/COBOL Configuration utility. It is used to modify the configuration options for one or more RM/COBOL programs (runcobol.exe, rmcobol.exe, and recover1.exe) and data files.

rmguife.dll

This dynamic-link library is part of the RM/COBOL runtime system. It supports the Windows graphical user interface module as a terminal interface.

rmprop.dll

This dynamic-link library is the COBOL program property sheet handler.

rmremprt.dll

This dynamic-link library is the WOW Thin Client remote printing module for Windows. It contains the Windows printing interfaces that would normally exist in the RM/COBOL runtime. However, since the runtime is on the remote (server) machine, this module is needed to implement the remote Windows printing capability. This DLL must be placed in the same (or working) directory as wowclient.exe or in a directory specified in the PATH environment variable.

For more information on remote Windows printing capability, click here.

rpcplus.dll

This file is the RPC (Remote Procedure Calls) dynamic-link library. It handles communications with the server. This DLL must be placed in the same (or working) directory as wowclient.exe or in a directory specified in the PATH environment variable.

rpcplus.ini

This initialization file tells RPC (Remote Procedure Calls) what server to connect to and which port to use. The contents of the file look like the following:

[ClientConfig]
DefaultServer=xxx.xxx.xxx.xxx

[ServerConfig]
Port=portnumber

The DefaultServer entry specifies the IP address or the name of the WOW Thin Client server. The Port entry specifies the port number on the server associated with this service. These entries can be changed as needed for your installation.

The rpcplus.ini file must be in the same (or working) directory as wowclient.exe or in the Windows directory.

rpcplusrm.dll

This dynamic-link library is the RM/COBOL interface to the RPC (Remote Procedure Calls) dynamic-link library, rpcplus.dll. Since wowclient.exe is built using the same parameter-passing mechanisms as an RM/COBOL program, this DLL must be used to interface to the RPC routines. This DLL must be placed in the same (or working) directory as wowclient.exe or in a directory specified in the PATH environment variable.

wowclient.exe

The WOW Thin Client executable program is the module that must be executed to begin the Thin Client session. It will load the required dynamic-link libraries and read the initialization file, rpcplus.ini. The wowclient.exe file may be placed in any location.

wowrt.dll and
wowmfcrt.dll

These are the same WOW runtime dynamic-link libraries that are used with standalone WOW programs. Instead of being invoked by the RM/COBOL runtime, however, they are invoked by wowclient.exe. These DLLs must be placed in the same (or working) directory as wowclient.exe or in a directory specified in the PATH environment variable.


Files Installed on a Windows Server

See Also

The following lists and describes each file that must be installed on a Windows server in order to use the Thin Client portion of WOW Extensions.

Files | Description
helowrld.cob | This file is the WOW Extensions “Hello World” sample program.
rpcplus.dll | This file is the RPC (Remote Procedure Calls) dynamic-link library. It handles communications with the Windows client. This DLL must be placed in the working directory for the application or in a directory specified in the PATH environment variable.
rpcplus.ini | This initialization file includes important information for RPC (Remote Procedure Calls). To see a sample of the contents of this file, click here.
rpcplusserver.exe | This executable program performs the important function of listening for a connection request, then starting the RM/COBOL runtime and application. This file can be installed in any location.
rpcpluswow.dll | This dynamic-link library is the WOW Extensions interface to the RPC (Remote Procedure Calls) dynamic-link library, rpcplus.dll. The application programs make calls to functions such as WOWSETPROP and WOWGETPROP. The rpcpluswow.dll intercepts those calls and uses RPC to route them to the Windows client. This DLL must be installed in the same directory as the RM/COBOL runtime executable. The DLL is loaded automatically once the RM_LOAD_WOW_CLIENT environment variable is set.


Sample Contents of rpcplus.ini for a Windows Server

[ClientConfig]
DefaultServer=CLIENT

[ServerConfig]
CobolType=rmcobol
StartupCommand=runcobol
myapp.cob
Port=5010
LogActivity=True
LogFileName=rpcplus.log
WorkingDir=\myapp

In the initialization file installed on a Windows server, the only entry required in the [ClientConfig] section is DefaultServer. The DefaultServer entry must specify CLIENT. In the Thin Client architecture, CALLs made by code executing on the server must be routed back to the CLIENT. This entry causes that to happen.

The first three entries in the [ServerConfig] section are required. The CobolType entry must specify rmcobol. This causes the rpcplusserver.exe program to use the correct command line format when starting the RM/COBOL runtime.

The StartupCommand entry can be edited to suit your installation. You may need to add a path to the runcobol command, but the runcobol command must be invoked here. You can specify whichever application program should be started for the application, presumably your source program. This program can call any number of subprograms in the normal COBOL manner. You can specify a path to this program. The RUNPATH environment variable or Windows registry setting will be used to locate any called subprograms, but not the initial program.

The Port entry is required, and must specify the same port number that is contained in the rpcplus.ini file on the client.

The last three entries are optional. The LogActivity=True option tells RPC (Remote Procedure Calls) to record all connections in a log file. The LogFileName entry specifies the name of the log file. A path may be added to this filename.

It is highly recommended that you specify a LogFileName. Any communication errors or other problems detected by RPC will be written to this file. If no file is specified, these errors will be displayed in a message box. This will require a user to dismiss the message box before the RM/COBOL runtime can terminate.

The WorkingDir entry specifies a directory that will be established as the working directory for the RM/COBOL runtime, and therefore your application. If this entry is not specified, the working directory will be the working directory associated with the execution of rpcplusserver.exe.

The most important item to install on your Windows server is your application, which can be placed in any location. It is unnecessary to install the application in the same location as any of the WOW Thin Client files, although you certainly may do so, if you wish. If you want to load your application in a separate area, the WorkingDir entry is a handy way to “move” to your application’s directory.


Remote Windows Printing Capability

Remote Windows printing from the server application is available through WOW Thin Client. A new, predefined printer device, “REMOTEPRINTER?”, has been added to the RM/COBOL runtime.

Note If the server is running on UNIX, the remote printer name is case sensitive; that is, the remote printer name must be all upper case.

When this device is opened, a standard Windows Print dialog box is presented to the user on the Windows client machine in order to allow dynamic selection of the Windows printer. All of the P$ subprograms in the RM/COBOL runtime are available to the server application. In addition, standard COBOL write operations to the selected/opened printer are routed to the Windows’ client machine/printer. The DEFINE-DEVICE record in the RM/COBOL runtime configuration file has been modified to accept the “REMOTE-PRINTER=YES” keyword, which indicates that the printer is a remote printer (on the client machine).

To view a sample of the contents of this runtime configuration file, click here.


Sample DEFINE-DEVICE Record (Runtime Configuration File)

Either of the following lines is acceptable:

DEFINE-DEVICE DEVICE=PRINTER1 PATH="DYNAMIC" REMOTE-PRINTER=YES

or

DEFINE-DEVICE DEVICE=REMOTEPRINTER? PATH="DYNAMIC" REMOTE-PRINTER=YES


Files Installed on a UNIX Server

See Also

The following lists and describes each file that must be installed on a UNIX server in order to use the Thin Client portion of WOW Extensions. The first two files in the table, /etc/services and /etc/inetd.conf, are UNIX system files that must be edited to enable the built-in service, inetd, to handle accepting the connection requests from wowclient.exe and launching the COBOL application.

Files

Description

/etc/inetd.conf

This file contains a list of services for which inetd should handle connection requests. An entry must be added to the /etc/inetd.conf file as follows:

rpcplus stream tcp nowait root /bin/sh /bin/sh
/usr/rmcobol/rpcstart

where:

· rpcplus is the name of the service inetd is supposed to listen for. This service must be described in /etc/services, as discussed below. You should not need to change this entry.

· stream tcp nowait options describe the type of network communication needed. Do not change these options.

· root indicates the user for which the server process will be initiated. You may want to have your application executed under a different user name. Be certain that the user name used here has adequate permissions to find and execute the application.

· /bin/sh is the name of the program that inetd should initiate for the service. /bin/sh is specified because a shell script is used to start the application. This entry is repeated and should not be changed.

· /usr/rmcobol/rpcstart is a shell script that starts the RM/COBOL runtime system. The rpcstart script can be edited to set additional environment variables required by the application, or to set a working directory.

/etc/services

This file contains a list of service names and TCP/IP configuration information. An entry must be added to the /etc/services file as follows:

rpcplus 5000/tcp

This entry defines rpcplus as a service using tcp protocol on port 5000. Do not change the service name or protocol. You can, however, select a different port number. However, you must be certain that the port number you select is not used by any other service on the server and matches the port number used by the WOW Thin Client.

libtclnt.so

This file is the WOW Thin Client shared object module. This shared object is the WOW interface to the rpcplus.dll file, that is, the RPC (Remote Procedure Calls) server software. The application programs make calls to functions such as WOWSETPROP and WOWGETPROP. This shared object intercepts those calls and uses RPC to route them to the Windows client. This file should be placed in the same directory as the RM/COBOL runtime executable. libtclnt.so is loaded automatically once the RM_LOAD_WOW_CLIENT environment variable is set.

rpcplus.ini

This initialization file contains important information for RPC (Remote Procedure Calls). To see a sample of the contents of this file, click here.

rpcstart

This file is a shell script that starts the application. It must contain at least the following entries:

TERM=ansi
export TERM
runcobol myapp.cob K

This script can be expanded to set environment variables or to establish the current working directory. It is advisable to add a full path to runcobol and to myapp. Myapp is the first RM/COBOL program in your application. It can, however, have any name you wish. The K option is required on the runcobol command line to suppress the banner.


Sample Contents of rpcplus.ini for a UNIX Server

[ClientConfig]
DefaultServer=CLIENT

[ServerConfig]
Port=5000
LogActivity=True
LogFileName=rpcplus.log

In the initialization file installed on a UNIX server, the only entry required in the [ClientConfig] section is DefaultServer. The DefaultServer entry must specify CLIENT. In the Thin Client architecture, CALLs made by code executing on the server must be routed back to the CLIENT. This entry causes that to happen.

The Port entry is required, but it is not used during normal operation. It can be used in some debugging situations.

The last three entries are optional. The LogActivity=True option tells RPC (Remote Procedure Calls) to record all connections in a log file. The LogFileName entry specifies the name of the log file. A path may be added to this filename. It is highly recommended that you specify a LogFileName. Any communication errors or other problems detected by RPC will be written to this file. If no file is specified, these errors will be displayed in a message box. This will require a user to dismiss the message box before the RM/COBOL runtime can terminate.

The most important item to install on your UNIX server is your application, which can be placed in any location. It is unnecessary to install the application in the same location as any of the WOW Thin Client files, although you certainly may do so, if you wish. If you want to load your application in a separate area, adding a cd command to the rpcstart script is a handy way to “move” to your application’s directory.


Running the Application with WOW Thin Client

The following list describes each of the actions necessary to run your application with WOW Thin Client on the server and Windows client workstation.

On this type of hardware

Do This

UNIX server

After editing the configuration files for inetd, the inetd daemon must be refreshed. This can be accomplished on all servers by rebooting the machine, but also can be accomplished on most systems with the following command:

kill -HUP pid

Where pid is the process id of the inetd process. This command causes inetd to reread its configuration files.

You can use the following command to determine whether inetd is listening for a connection on the rpcplus service port:

netstat -a | grep "rpcplus"

This command should show an rpcplus port in a LISTEN state. Once that is shown, you are ready to start the client.

Windows client workstation

Once a server is listening for connections, you can execute wowclient.exe on the client workstation. The application’s interface will appear on the client.

WOW Thin Client can be run from the command line using the following command:

wowclient [character set options]
[client arguments]

where character set options is either /cs_ansi to select the ANSI character set or /cs_oem to select the OEM character set. Refer to the topic “Character Set Considerations for Windows” in the RM/COBOL User’s Guide for more information.

Windows server

After you have installed your files, you need to execute rpcplusserver.exe on the server. This will cause the server to start listening for connections from the client workstation. When a connection is received, the server will automatically start the application.


Using WOW Extensions with RM/Panels

Enhancing Existing RM/Panels Panel Libraries


Enhancing Existing RM/Panels Panel Libraries

See Also

For those RM/Panels users who would like to improve their Windows presentation without modifying application code, the WOW Designer can be used to enhance existing panels to use the full spectrum of Windows fonts and colors. Developers are no longer restricted to using a single, fixed-width font or to working with a limited color palette.

These enhanced panels can be used by existing programs without source code changes, simply by using the RM/Panels runtime module (runpan2.cob, supplied with RM/COBOL for Windows, version 7.00.02 and higher) supplemented with a WOW Extensions panel runtime (wowpanrt.dll). Enhancing a panel in this manner for Windows does not limit portability, or prevent the panel or panel library from continued use in DOS or UNIX. Nor is it necessary to enhance every panel in the application.

Key features for enhancing existing RM/Panels panel libraries include the following:

· Ability to edit RM/Panels screens with the WOW Designer.

· No need to change RM/Panels source code.

· WOW Extensions editing of panels does not create additional files.

· Ability to test panels from the WOW Designer.

For more information about opening and modifying an existing panel, click here.


Character-Based GUI Portability and Cross Development

The move to a full graphical user interface does not sacrifice the ability to continue to deploy an application in a character-based form. However, some issues must be considered in order to continue application development with an interface optimized for both environments.

When a panel is enhanced, the data fields/controls added to the panel will be present on both the character-based and graphical representations of the panel. Some controls have properties that are specific to either the graphical or character-based environment. For example, each field/control has a Line and Column property, and Top and Left properties. The Top and Left properties are used in Windows only. The Line and Column properties are used in DOS and UNIX only.

The character-based RM/Panels Library Manager does not allow access to the Windows-only properties. The WOW Designer, however, does allow you to edit the character-only properties. The effects of the character-only properties are not visible from the WOW Designer.

New fields/controls can be added to a panel using either the RM/Panels Library Manager or the WOW Designer. Theoretically, if you added a control in the WOW Designer, you could set its character properties and immediately use the panel in the character environment. Practically speaking, though, you will want to edit the panel using the RM/Panels Library Manager to accurately tailor the panel before deploying the panel in the character environment.

Note After adding controls to a panel using the RM/Panels Library Manager, you will have to edit the panel using the WOW Designer before running a WOW-enhanced panel in RM/Panels. Failure to do so will result in the panel being displayed without the WOW enhancements.


Communicating with RM/Panels

See Also

The WOW Designer must interface to the RM/Panels COBOL programs. This is accomplished via TCP/IP using RPC (Remote Procedure Calls), which paves the way for client/server implementations. Two files, which are included with WOW Extensions, are specifically required to handle this communication. These files are rmrpc32s.dll and cobolrpc.ini.

The RPC dynamic-link library, rmrpc32s.dll, allows RM/Panels COBOL programs to be invoked by the WOW Designer. When the WOW Designer needs to invoke a COBOL program, it starts a new process. This process executes the RM/COBOL runtime and includes rmrpc32s.dll on the command line with the L= option.

The Windows initialization file, cobolrpc.ini, contains configuration information for rmrpc32s.dll. If problems occur, the following two entries can be manually changed:

[ServerConfig]
Port=5000
StartupCommand=runcobol
rpcinit.cob l=rmrpc32S.DLL l=wowpan.obj

The Port value can be changed if port 5000 is already in use on the system. Any value can be used, but values over 1024 are best.

The StartupCommand entry must be changed if the runcobol.exe file is not in the path.


Modifying an Existing RM/Panels Panel Library

See Also

The first step in the process is modifying an existing RM/Panels panel library to create a more typical Windows "look-and-feel." WOW facilitates this process by allowing you to specify certain graphical characteristics that will determine the way character-based panels in an RM/Panels library will appear when the library is opened in the WOW Designer. To specify these settings, click Import Preferences on the Panel menu. The Panel Import Preferences dialog box opens. Use this dialog box to determine general as well as control-specific characteristics.

Once you have established these preferences, you are ready to open the panel library. This process begins the same way as any WOW session. To allow the WOW Designer to load and save an existing panel or panels directly from the panel library:

· On the Panel menu, click Open to open a single panel or Open All to open all the panels in a panel library. The supplied sample library, sample.lib (located in the installation pansmple folder), can be used to follow this exercise exactly.

For more complete procedures on opening a panel library, click here.

For additional procedures on how to modify existing panels and work with them in the WOW Designer, click one of the following topics:

· Change controls

· Add controls

· Delete controls

· Save a panel

· Test a panel

· Run an application


Open the panel library

1. Start the WOW Designer.

2. On the Panel menu, click Open or Open All.

Any open project will be closed automatically. The Select Panel Library dialog box opens.

3. From the Select Panel Library dialog box, find the desired panel library and open it. Panel libraries have the extension .lib.

Note WOW Extensions must interface to RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls).

4. What occurs next depends on whether, in step 1, you clicked Open to open a single panel in the library or Open All to open all the panels in the library:

· If you clicked Open, the Select Panel dialog box opens. Select the panel to be modified and click OK. The RM/COBOL runtime will be executed, and the panel will be opened in the WOW Designer.

· If you clicked Open All, the RM/COBOL runtime will be executed and all the panels in the library will be opened in the WOW Designer.

A default graphical representation will be displayed. The size, shape, location, color, fonts, and other properties of the controls and overall window can then be modified.


Change controls

Note RM/Panels refers to the objects called "controls" in WOW Extensions as "data fields." All types of RM/Panels data fields can be added to the panel using the Toolbox.

The properties of each field/control are displayed in the Properties dialog box. Each of the properties listed can be modified. Some properties, such as Column and Line, affect only the character implementation of the panel. Others, such as ForeColor, affect only the Windows implementation.

Remember that it is possible to modify several fields/controls at once by selecting multiple fields/controls, and using the Background Color, Foreground Color, and Font commands on the Control menu.


Add controls

Note RM/Panels refers to the objects called "controls" in WOW Extensions as "data fields." All types of RM/Panels data fields can be added to the panel using the Toolbox.

When you open a panel in WOW Extensions, the Toolbox automatically displays only the RM/Panels data fields that can be added to the panel. All types RM/Panels fields/controls can be added to the panel using the Toolbox. If you add a field/control to a panel, you will want to use the Character Panel Editor to adjust the size, location, and color of the field/control before executing the panel in a character environment.

Note ActiveX controls cannot be added to an enhanced panel. The following intrinsic controls also cannot be added to an enhanced panel:

· Animation

· Date Time Picker

· Month Calendar

· Progress bar

· Status Bar

· Tab

· Timer

· Toolbar

· Trackbar

· Updown

· Any shapes (Ellipse, Line, Rectangle, and Rounded Rectangle)


Delete controls

Note RM/Panels refers to the objects called "controls" in WOW Extensions as "data fields." All types of RM/Panels data fields can be added to the panel using the Toolbox.

Panel fields/controls may be deleted from within the WOW Designer. The modified .ws file will be generated automatically when the panel is saved. Be sure to recompile any programs that use the panel.


Save a panel

Enhanced panels can be saved at any time during the editing session using either the Save or Save All command on the Panel menu. If any panels have been modified, the message box prompt will depend on whether or not more than one modified panel needs to be saved. If more than one panel needs to be saved, then a message box with Yes, Yes To All, No, and No To All command buttons will appear.

· If you click Yes To All, WOW Extensions will save all open panels under their current names and then close them.

· If you click No To All, WOW Extensions will close all the panels without saving any changes.

· The Yes and No options apply to the current panel being referenced by the message.

When enhanced panels are saved in this manner, the panel descriptions are written back into the standard panel library. No WOW-specific files are created. The panel library must be used to re-open the panels in the WOW Designer and to operate the panels at runtime.

When enhanced panels are saved, the panel copy files are automatically (re)generated. This is a slight variation in behavior from the DOS or UNIX versions of RM/Panels version 2 where the copy files could be generated optionally. Always generating these files preserves the integrity of the relationship between the copy files and the actual panel definition in the RM/Panels library and helps prevent undesirable problems, such as 104 errors.

The copy file generation is done based on the definition in the panel library (maintained through the RM/Panels Library Manager's Code Generation dialog box). This includes the path used for placing the generated files.

If you do not wish to save your edits, use either the Recreate GUI or Recreate GUI All commands on the Panel menu.


Test a panel

The Test command on the Panel menu enables testing of panels during editing. There is a small difference from the way in which previous versions of WOW Extensions performed this task. Before testing the panel, any editing changes that have been made are permanently saved to the panel library.


Run an application with an enhanced panel

To use the enhanced panel, take the following steps:

1. Run the program using runpan2.cob, which is shipped with WOW Extensions version 2.26 and higher.

2. Load the WOW panels runtime dynamic-link library (wowpanrt.dll) by adding the following line to the command line:

l=wowpanrt.dll

Any panel that has been edited with WOW Extensions will be displayed using the full Windows appearance. Any panels that have not been edited with WOW Extensions will continue to be displayed in the same manner as RM/Panels version 2.x.


Properties for RM/Panels Data Fields

See Also

RM/Panels refers to the objects called "controls" in WOW Extensions as "data fields." All types RM/Panels data fields can be added to the panel using the Toolbox. To view the Toolbox configured for RM/Panels, click here.

Data fields/controls have a number of configurable characteristics. These characteristics are called properties. Properties are the primary means by which fields/controls are manipulated. Setting properties defines how fields/controls are displayed and how they function in the running application.

When you open a panel in the WOW Designer, you use the Properties dialog box, which lists each property and its value, to set the default (initial) properties of a selected field/control.

The following table summarizes the data fields found in the Toolbox when you open a panel in the WOW Designer. To see the complete description of each data field and its properties, click the data field name.

Data Field | Data Field Name | Description
 | Bitmap | Displays bitmap files. The bitmap control acts like a command button when clicked.
 | Check Box | Displays a Yes/No, True/False, or On/Off option. You can check any number of check boxes on a form at one time.
 | Combo Box | Combines a text box with a list box. Allows a user to type in a selection or select an item from a drop-down list.
 | Command Button | Carries out a command or action when a user chooses it.
 | Date Edit Box | Provides an area in which a date can be displayed or entered.
 | Edit Box | Provides an area to enter or display text.
 | Group Box | Provides a visual and functional container for other controls. It is generally used to enclose related controls (usually check boxes or option buttons).
 | List Box | Displays a list of choices from which the user can select one or more items.
 | Multi-Line Edit Box | Provides a small, fixed space into which a user can enter several lines of text, a portion of which is hidden until the user scrolls its contents using scroll bars.
 | Numeric Edit Box | Provides an area to input or display numeric data.
 | Option Button | Presents mutually exclusive options in an option control. Option buttons are usually used with the group box control to form groups where only one of the listed buttons can be selected at one time.
 | Scroll Bar | Allows a user to add scroll bars to controls that do not automatically provide them. (These are not the same as the built-in scroll bars that are found with many controls.)
 | Static Text | Displays text, such as titles or captions, in regular outlines or filled rectangles, which the user cannot interact with or modify.
 | Time Edit Box | Provides an area in which the time can be displayed or entered.


Bitmap Field/Control

To add a bitmap field/control to a panel/form, click Bitmap from the Toolbox.

The Bitmap field/control is used to display bitmapped images. The image can be displayed in several ways, including being tiled or scaled to fit the size of the field/control. A bitmap defines an image or picture as a pattern of dots (or pixels) and has the file extension .bmp. Even though Windows does not implement or package a bitmap control, it does provide bitmap handling. WOW Extensions adds the bitmap field/control to provide a convenient way to use bitmaps on a panel/form.

All of the properties and events for this control are listed in the following table. When used with a panel, none of these properties can be manipulated at runtime.

Properties

BackColor | Enabled | Name | Transparent
Bitmap | Height | RightAlignedText | Width
BitmapMode | Left | RightToLeftReading | Xoffset
Border | Locked | StaticEdge | Yoffset
ClientEdge | ModalFrame | Top |


Check Box Field/Control

To add a check box field/control to a panel/form, click Check Box from the Toolbox.

The check box data field/control displays an option that can be turned on or off. The check box is similar to the command button, in that the primary method of operation is clicking it. The check box, however, represents data, not a request for action.

All of the properties for this field/control are listed in the following table.

Properties

3D | EntryOrder | HelpMessage | SelectedAttr
Accelerator | ErrorMessage | Left | StartOfGroup
BackColor | FontBold | Length | StaticEdge
Beep | FontItalic | Line | TimeOut
ClientEdge | FontName | MnemonicAttr | TimeOutValue
Column | FontSize | ModalFrame | Title
DefaultToPressed | FontStrikethru | Name | Top
DisabledAttr | FontUnderline | PromptText | Transparent
EnabledAttr | ForeColor | RightAlignedText | Width
EnabledForInput | Height | RightToLeftReading |


Combo Box Field/Control

To add a combo box field/control to a panel/form, click Combo Box from the Toolbox.

The combo box field/control combines the list selection capability of a list box with the edit box’s ability to type in a value. Alternatively, to save screen space, you may wish to show only a portion of the list box’s selections. And, there may be instances when you would like to display the currently selected item in a static text box area when the entire list is not displayed. The combo box control can perform both tasks.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*).

Properties

3D | DisabledAttr | ForeColor | ScrollBar
BackColor | DoubleClick | Height | SelectedAttr
Beep | DropDown | HelpMessage | StartOfGroup
Border | EnabledAttr | *InputField | StaticChoices
BorderAttr | EnabledForInput | Left | StaticEdge
ChoiceHelp | EntryOrder | Length | TimeOut
ChoicesToDisplay | ErrorMessage | Line | TimeOutValue
ChoicesToStore | FontBold | ModalFrame | Top
ChoiceValue | FontItalic | Name | Transparent
ChoiceWidth | FontName | NoIntegralHeight | Width
ClientEdge | FontSize | PromptText |
Column | FontStrikethru | RightAlignedText |
CurChoice | FontUnderline | RightToLeftReading |


Command Button Field/Control

To add a command button field/control to a panel/form, click Command Button from the Toolbox.

The command button (also known as push button) field/control causes an action to occur when the user either clicks the button or presses a key.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*).

Properties

3D | EnabledForInput | Height | SelectedAttr
Accelerator | EntryOrder | HelpMessage | *SizeType
BackColor | ErrorMessage | Left | *SizeValue
Beep | FontBold | Length | StartOfGroup
Border | FontItalic | Line | StaticEdge
ClientEdge | FontName | MnemonicAttr | TimeOu t
Column | FontSize | ModalFrame | TimeOutValue
DefaultValue | FontStrikethru | Name | Title
DisabledAttr | FontUnderline | PromptText | Top
EnabledAttr | ForeColor | *PushedAttr | Width


Date Edit Box Field/Control

To add a date edit box field/control to a panel/form, click Date Edit Box from the Toolbox.

The date edit box field/control provides an area on a panel/form in which a date can be displayed or entered.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*). To see a list detailing whether this control’s properties can be manipulated at design time, at runtime, or both, click here.

Properties

3D | EnabledAttr | Height | SelectedAttr
AlwaysDisabled | EnabledForDisplay | HelpMessage | StartOfGroup
AutoExit | EnabledForInput | Left | *StorageFormat
BackColor | EntryForma t | Length | TimeOu t
Beep | EntryOrder | Line | TimeOutValue
BlankWhenZero | ErrorMessage | Name | Top
Border | FontBold | OccColOffset | Update
Column | FontItalic | OccLineOffset | Validation
DefaultToSystem | FontName | Occurrences | Width
DefaultValue | FontSize | OccXOffset |
DisabledAttr | FontStrikethru | OccYOffset |
DisplayFormat | FontUnderline | PromptText |
DoubleClick | ForeColor | Protected |


Edit Box Field/Control

To add an edit field/control to a panel/form, click Edit Box from the Toolbox.

The edit box field/control provides an area to input or display text. This field/control replaces the COBOL ACCEPT statement. The user can enter any type of alphanumeric data in an edit box, including numeric data. Because no formatting is provided, numbers are entered in the same manner as text.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*).

Properties

3D | EnabledForDisplay | Left | RightToLeftReading
AlwaysDisabled | EnabledForInput | Length | SelectedAttr
AutoExit | EntryOrder | Line | StartOfGroup
BackColor | ErrorMessage | ModalFrame | StaticEdge
Beep | FontBold | Name | TimeOut
Border | FontItalic | OccColOffset | TimeOutValue
Case | FontName | OccLineOffset | Top
*Class | FontSize | Occurrences | Transparent
ClientEdge | FontStrikethru | OccXOffset | Update
Column | FontUnderline | OccYOffset | Validation
DefaultValue | ForeColor | *Prompt | Width
DisabledAttr | Height | PromptText |
DoubleClick | HelpMessage | Protected |
EnabledAttr | *Justify | RightAlignedText |


Group Box Field/Control

To add a group box field/control to a panel/form, click Group Box from the Toolbox.

Note A group box field/control that is added to a panel/form in the WOW Designer will not be reflected in the character-based version of the panel.

The group box is a specialized box that is used to group other fields/controls, such as check boxes and option buttons.

All of the properties for this field/control are listed in the following table.

Properties

3D | FontName | Left | *TabStop
BackColor | FontSize | *Locked | Top
Caption | FontStrikethru | ModalFrame | Transparent
ClientEdge | FontUnderline | Name | Width
*Enabled | ForeColor | RightAlignedText |
FontBold | *Group | RightToLeftReading |
FontItalic | Height | StaticEdge |


List Box Field/Control

To add a list box field/control to a panel/form, click List Box from the Toolbox.

The list box field/control allows the selection of one or several items from a list of items.

All of the properties for this field/control are listed in the following table.

Properties

3D | CurChoice | FontStrikethru | RightAlignedText
BackColor | DisabledAttr | FontUnderline | RightToLeftReading
Beep | DoubleClick | ForeColor | ScrollBar
Border | DropDown | Height | SelectedAttr
BorderAttr | EnabledAttr | HelpMessage | StartOfGroup
ChoiceHelp | EnabledForInput | Left | StaticChoices
ChoicesToDisplay | EntryOrder | Length | StaticEdge
ChoicesToStore | ErrorMessage | Line | TimeOut
ChoiceValue | FontBold | ModalFrame | TimeOutValue
ChoiceWidth | FontItalic | Name | Top
ClientEdge | FontName | NoIntegralHeight | Transparent
Column | FontSize | PromptText | Width


Multi-Line Edit Box Field/Control

To add a multi-line edit box field/control to a panel/form, click Multi-Line Edit Box from the Toolbox.

Sometimes you need to store a lot of text, but you do not want to use up a lot of screen space in your display. You can create a multi-line edit box field/control that lets users enter several lines of text into a small, fixed space. Because the text box is smaller than the amount of information stored, part of the information is hidden. The user uses scroll bars to display the hidden information. You can design the text box to scroll its contents vertically or horizontally.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*). To see a list detailing whether this control’s properties can be manipulated at design time, at runtime, or both, click here.

Properties

3D | EnabledAttr | Height | SelectedAttr
BackColor | EnabledForInput | HelpMessage | StartOfGroup
Beep | EntryOrder | Left | *Stream
Border | ErrorMessage | Length | TimeOut
Case | FontBold | Line | TimeOutValue
*ColsToDisplay | FontItalic | *LinesToDisplay | Top
*ColsToStore | FontName | *LinesToStore | Width
Column | FontSize | Name | *Wrap
DefaultValue | FontStrikethru | PromptText |
DisabledAttr | FontUnderline | Protected |
DoubleClick | ForeColor | *Required |


Numeric Edit Box Field/Control

To add a numeric edit box field/control to a panel/form, click Numeric Edit Box from the Toolbox.

The numeric edit box field/control provides an area to input or display numeric data.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*). To see a list detailing whether this control’s properties can be manipulated at design time, at runtime, or both, click here.

Properties

3D | DisplayFormat | FontUnderline | OccYOffset
AlwaysDisabled | DoubleClick | ForeColor | PromptText
*AssumeDecimal | EnabledAttr | Height | Protected
AutoExit | EnabledForDisplay | HelpMessage | SelectedAttr
BackColor | EnabledForInput | IntegerDigits | *Signed
Beep | EntryFormat | Left | StartOfGroup
BlankWhenZero | EntryOrder | Length | TimeOut
Border | ErrorMessage | Line | TimeOutValue
*CalculatorEntry | FontBold | Name | Top
Column | FontItalic | OccColOffset | Update
DecimalDigits | FontName | OccLineOffset | Validation
DefaultValue | FontSize | Occurrences | Width
DisabledAttr | FontStrikethru | OccXOffset |


Option Button Field/Control

To add an option button field/control to a panel/form, click Option Button from the Toolbox.

The option button (also known as radio button) field/control displays an option that can be turned on or off. Option buttons are usually used in groups where turning one button on turns the others off. For more information on grouping option buttons, click here.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*).

Properties

3D | DisabledAttr | Height | RightToLeftReading
Accelerator | EnabledAttr | HelpMessage | SelectedAttr
BackColor | EnabledForInput | IntegerDigits | StartOfGroup
Beep | EntryOrder | Left | StaticEdge
ClientEdge | ErrorMessage | Length | TimeOut
Column | FontBold | Line | TimeOutValue
*DataItemName | FontItalic | MnemonicAttr | Title
*DataSigned | FontName | ModalFrame | Top
*DataSize | FontSize | Name | Transparent
*DataValue | FontStrikethru | *NumericData | Width
DecimalDigits | FontUnderline | PromptText |
DefaultToPressed | ForeColor | RightAlignedText |


Scroll Bar Field/Control

To add a scroll bar field/control to a panel/form, click either Horizontal Scroll or Vertical Scroll from the Toolbox. A horizontal scroll bar displays a horizontal bar that can be used to scroll information. A vertical scroll bar displays a vertical bar that can be used to scroll information.

The scroll bar field/control is used to allow a numeric value to be manipulated as a thumb position on a bar. By specifying the minimum and maximum, the value can be viewed relative to a range of possible values. This value and the scroll bar are often used to scroll the display of other information on a panel. For more information on using scroll bars, click here.

All of the properties for both the horizontal and vertical scroll bar are listed in the following table. Properties that apply only to these fields/controls, or that require special consideration when used with them, are marked with an asterisk (*).

Properties

Border | EnabledForInput | *MaximumValue | *StepSize
Column | EntryOrder | *MinimumValue | *ThumbAttr
DefaultValue | Height | Name | Top
DisabledAttr | Left | *PageSize | Width
EnabledAttr | Line | *Size |


Static Text Field/Control

To add a static text field/control to a panel/form, click Static Text from the Toolbox.

Note A static text field/control that is added to a panel/form in the WOW Designer will not be reflected in the character-based version of the panel.

The static text field/control is used to display text, rectangular outlines, or filled rectangles. The static text control is also used to draw rectangles or outlines to highlight parts of a panel, group controls, or even create a design.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*).

Properties

3D | FontBold | Height | RightAlignedText
*Alignment | FontItalic | Left | RightToLeftReading
BackColor | FontName | Length | StaticEdge
Caption | FontSize | Line | Top
Column | FontStrikethru | ModalFrame | Transparent
ClientEdge | FontUnderline | Name | Width
*Effect | ForeColor | *NoPrefix | *WordWrap


Time Edit Box Field/Control

To add a time edit box field/control to a panel/form, click Time Edit Box from the Toolbox.

The time edit box field/control provides an area on a panel in which the time can be displayed or entered.

All of the properties for this field/control are listed in the following table. Properties that apply only to this field/control, or that require special consideration when used with it, are marked with an asterisk (*). To see a list detailing whether this control’s properties can be manipulated at design time, at runtime, or both, click here.

Properties

*24HourFormat | DoubleClick | ForeColor | Protected
3D | EnabledAttr | Height | SelectedAttr
AlwaysDisabled | EnabledForDisplay | HelpMessage | StartOfGroup
AutoExit | EnabledForInput | Left | *StorageFormat
BackColor | EntryFormat | Length | TimeOut
Beep | EntryOrder | Line | TimeOutValue
BlankWhenZero | ErrorMessage | Name | Top
Border | FontBold | OccColOffset | Update
Column | FontItalic | OccLineOffset | Validation
DefaultToSystem | FontName | Occurrences | Width
DefaultValue | FontSize | OccXOffset |
DisabledAttr | FontStrikethru | OccYOffset |
DisplayFormat | FontUnderline | PromptText |


Common Data Field Properties

This topic summarizes the common properties that may be implemented in a field/control on a panel. To determine the unique properties available for the field/control, refer to the specific field/control.

The following properties are used by several types of fields/controls.

Properties

3D | ChoiceWidth | EntryFormat | Line | StartOfGroup
Accelerator | ClientEdge | EntryOrder | MnemonicAttr | StaticChoices
AlwaysDisabled | Column | ErrorMessage | ModalFrame | StaticEdge
AutoExit | CurChoice | FontBold | Name | TimeOut
BackColor | DecimalDigits | FontItalic | OccColOffset | TimeOutValue
Beep | DefaultValue | FontName | OccLineOffset | Title
BlankWhenZero | DefaultToPressed | FontSize | Occurrences | Top
Border | DefaultToSystem | FontStrikethru | OccXOffset | Transparent
BorderAttr | DisabledAttr | FontUnderline | OccYOffset | Update
Caption | DisplayFormat | ForeColor | PromptText | Validation
Case | DoubleClick | Height | Protected | Width
ChoiceHelp | DropDown | HelpMessage | RightAlignedText |
ChoicesToDisplay | EnabledAttr | IntegerDigits | RightToLeftReading |
ChoicesToStore | EnabledForDisplay | Left | ScrollBar |
ChoiceValue | EnabledForInput | Length | SelectedAttr |


Properties for RM/Panels Panels

See Also

RM/Panels refers to the objects called "forms" in WOW Extensions as "panels." Panels are the containers within which you group fields/controls.

Like fields/controls, panels/forms have a number of configurable characteristics called properties. When you open a panel/form in the WOW Designer, you use the Properties dialog box, which lists each property and its value, to set the default (initial) properties of a selected panel/form.

The following properties are used by panels/forms.

Properties

3D | BorderType | GeographicMotion | Prefix
BackColor | Description | Height | StoreByName
BackgroundAttr | DropShadow | HelpAttr | Title
Bitmap | EndUserEditing | HelpMessage | Top
BitmapMode | ErrorAttr | Icon | Width
BorderAttr | ErrorMessage | Left | Windowed


Configuring Function Keys

See Also

WOW Extensions uses a different methodology for configuring function keys than RM/Panels.

With RM/Panels 2.x, keyboard input was done through a COBOL ACCEPT statement in the RM/Panels runtime module (runpan2.cob). Because of this, the keys that terminated input and the exception numbers generated by those keys were configured through the RM/COBOL configuration file. In this configuration file, a key was specified as terminating input and returning a specific exception number. To see an example, click here.

WOW Extensions does not use COBOL ACCEPT statements for keyboard input. The RM/Panels runtime module, runpan2.cob, shipped with WOW Extensions (Cobol-WOW) version 2.26 and higher, uses the WOW Extensions runtime to receive and monitor the messages generated by Windows, including the keystroke messages. This means that the RM/COBOL runtime system does not do any function key interpretation. This also means that the entries in the RM/COBOL configuration file will have no effect.

Consequently, a different mechanism is required in order to associate exception numbers with keyboard keys. The same mechanism of returning numeric values in RMP--EXCEPTION-NUMBER should be preserved, however, so that application code does not have to be altered. The WOW runtime must be notified, for example, that an exception number of 27 is expected when the Escape key is pressed.

This is accomplished through a section added to the WOW runtime initialization file, wowrt.ini. The [RMPanelsFunctionKeys] section contains entries that specify exception numbers for each key that needs to be detected. The following sample shows how to associate an exception value of 27 with the Escape key:

[RMPanelsFunctionKeys]
ESC=27

The left half of the entry is the name of the key as labeled on the keyboard. The right half of the entry is the exception number the key should return.

RM/Panels function keys can be configured using the Windows key names or the RM/COBOL key names.

To see sample entries, click here. These approaches can be mixed in the wowrt.ini initialization file. The F1 and F2 entries rely on the names used internally by Windows for the keys. The entries WF4 and WF5 are names used by RM/COBOL.


Example showing Keyboard Input with RM/Panels v2.x

Keyboard Input with RM/Panels v2.x

The following is a sample entry from an RM/COBOL configuration file that assigns an exception value of 27 to the Escape key:

TERM-INPUT Action=Screen-Escape Code=27 ESC

When a user pressed the Escape key from an RM/Panels 2.x application, the ACCEPT statement terminated and returned the value of 27. runpan2.cob stored this exception value in RMP--EXCEPTION-NUMBER. Typically, condition names assigned to RMP--EXCEPTION-NUMBER were then used to determine which function key was pressed. Here is an excerpt from rmpanels.ws that shows how this is declared:

05 RMP--EXCEPTION-NUMBER PIC 9(3) VALUE 0.
88 F10-KEY VALUE 10.
88 ESCAPE-KEY VALUE 27.

In application code, the developer can then do something like the following to take action when the Escape key is pressed:

IF ESCAPE-KEY
PERFORM CANCEL-INPUT.


Using Global Default Property Settings

See Also

Each form or control that you create using WOW Extensions includes a set of initial properties and values. During design time, you can change and customize these property settings. Once you have modified the property values for a form or a control, you may want to save the new settings and reuse them "globally" in other projects. Global default property settings for controls are those that have been customized and saved using the Save Properties | For Global Use command on the Control, Form, or Options menus, and stored in the WOW runtime initialization file, wowrt.ini.

For example, if you have saved global defaults for a static text field, including font information, all static fields that are created will have that font. The same applies to background and foreground colors. This applies to all control types, not just static text fields. Therefore, by manipulating the global default property settings using commands on the Control or Options menus in a WOW session before editing the panel with WOW, you can eliminate much of the work you would otherwise have to do manually in the WOW Designer to alter font and color settings. As WOW Extensions creates the GUI versions of the controls for the first time, it will follow these defaults.

You may want to establish the FixedSys font as the global default for static text fields. This will create the panels in the WOW Designer with the closest representation of the existing character layout. However, you will almost certainly want to change this font to something that is more typical of Windows, such as MS Sans Serif.

When you create a new project and want to use global default property settings, go to the Project Properties dialog box and select the Use Global Default Properties check box. This option directs WOW Extensions to ignore the initial property values and use the global settings instead.


Restrictions

The following restrictions apply to using panels with WOW Extensions:

· Since panels that are displayed by WOW Extensions are displayed in their own windows, COBOL ACCEPT and DISPLAY statements cannot be used to affect these windows. Programs that use ACCEPT and DISPLAY statements should be modified to replace the statements with RM/Panels functions, such as the following:

RMP--DF--fieldname.

· The RM/COBOL C$ routines for reading and writing to the screen function in the COBOL main window. WOW-enhanced panels do not use the COBOL main window, so these C$ routines cannot be used with these panels.

· RM/Panels version 2.1 allowed RM/Panels applications to generate panels dynamically. Dynamically-generated panels are not stored in a panel library, however, which means they cannot be opened in the WOW Designer. You cannot make dynamic changes to a WOW-enhanced panel. Dynamic modifications of panels are not compatible with the WOW method of displaying.


Migrating RM/Panels Panel Libraries to WOW Forms

See Also

For those users who want to take advantage of all the capabilities in WOW Extensions, it is not necessary to manually recreate your panels as WOW forms. You can immediately begin programming with the form using WOW Extensions. Moreover, RM/Panels panels and WOW forms can coexist in the same application, which provides a gradual migration path for those who want it. For procedures on migrating an RM/Panels panel to WOW Extensions, click here.


Migrate an RM/Panels panel library

1. Start the WOW Designer.

2. On the Panel menu, click Open or Open All.

Any open project will be closed automatically. The Select Panel Library dialog box opens.

3. From the Select Panel Library dialog box, find the desired panel library and open it. Panel libraries have the extension .lib.

Note WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls).

4. What occurs next depends upon whether, in step 1, you clicked Open to open a single panel in the library or Open All to open all the panels in the library:

· If you clicked Open, the Select Panel dialog box opens. Select the panel to be modified and click OK. The RM/COBOL runtime will be executed, and the panel will be opened in the WOW Designer.

· If you clicked Open All, the RM/COBOL runtime will be executed and all the panels in the library will be opened in the WOW Designer.

A default graphical representation will be displayed. The size, shape, location, color, fonts, and other properties of the controls and overall window can then be modified.

5. Edit the panel(s) as desired.

6. On the Panel menu, click Export (if you are working with a single panel) or Export All (if you are working with all the panels in a panel library). The panel(s) will be saved as a WOW form with the extension .wow.

7. On the Panel menu, click either Close or Close All.

8. On the Project menu, click either Open or New and open or create the project to which you want to add the form.

The former panel(s) can be edited in the same manner as any other WOW form.

Note Panels that are generated dynamically by an RM/Panels application cannot be migrated to WOW forms. Dynamically-generated panels are not stored in a panel library, which means they cannot be opened in the WOW Designer.


Reference Information

WOW Designer Window


WOW Designer Window

See Also

When you first start WOW Extensions, you see the WOW Designer window. (If you have selected the Initial About Box option on the General Preferences page, the About WOW Designer dialog box temporarily appears in the window and will close automatically, or you can click OK to close it manually.)

The WOW Designer window contains various regions, each of which has a specific use and function. For information about the key areas of the WOW Designer window, click one of the following topics:

· Title Bar

· Menu Bar

· Toolbars

· Project Tree

· Code Templates Tree

· Desktop Area

· Project Output Dialog Bar

· Toolbox

· Status Bar


Title Bar

The title bar, shown here and which is displayed at the top of the WOW Designer window, contains the name "WOW Designer." In addition, if a project is open, the title bar displays the name of the project and the current form.

To move the WOW Designer window to a different location:

1. Point the cursor at the text display section of the title bar.

2. Press and hold the primary mouse button.

3. Drag the window by moving the mouse.

4. Release the mouse button.

You can move, close, maximize, minimize, or restore the WOW Designer window by using the four icons in the title bar.

Icon

Description

Control menu

The Control menu (also knows as the System menu) icon is a pictorial equivalent of the Control menu used to manipulate the window. This icon is located at the leftmost position on the title bar. The Control menu contains these menu commands: Restore, Move, Size, Minimize, Maximize, and Close.

The Minimize icon is a pictorial equivalent of the Minimize command to shrink a window to an icon. This icon is the third button from the right on the title bar.

The Maximize icon is a pictorial equivalent of the Maximize command to enlarge an icon to a window. This icon occupies the second button position from the right on the title bar.

The Restore icon is present when the window fills the inside of another window or if a window fills the screen. The Restore icon is a pictorial equivalent of the Restore command to restore an icon or maximized window to its previous window size.

You can also quit a program by clicking the Close button, which is located at the far right of the title bar.


Menu Bar

The WOW Designer menu bar, shown here and which is located below the title bar in the WOW Designer window, contains the names of the menus. The menu names and commands that appear depend on whether a form or a project has been opened. Menus that are not currently available are temporarily removed from the menu bar.

For example, if a form or project has not been opened, the File, View, Project, Form, Panel, Options, and Help menus are visible. If a form or project has been opened, the menu bar contains the additional menu names Edit and Control. Furthermore, if a form or project has not been opened, some of the buttons on the various toolbars are disabled.

Clicking a menu name displays a list of commands for accessing various WOW Designer operations. Choose one of the following topics for more information about the commands located on each menu:

· File Menu Commands

· Edit Menu Commands

· Control Menu Commands

· View Menu Commands

· Project Menu Commands

· Form Menu Commands

· Panel Menu Commands

· Options Menu Commands

· Help Menu Commands


File Menu Commands

The commands displayed on the File menu of the WOW Designer window depend on whether or not a project has been opened. Note that the equivalent toolbar buttons, if applicable, also are shown in the following table.

Choose

To

New Form or
New

Add a new, blank form to an open project.

Note If a project is open but no forms are open in that project, this command is shown as New on the menu. If a project is not open, this command is unavailable.

This command is equivalent to the New command on the Form menu.

Shortcut: Ctrl+N
Alternative: When a project is open, click New Form on the File toolbar.

Open Form or
Open

Retrieve an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified.

Note If a project is open but no forms are open in that project, this command is shown as Open on the menu. If a project is not open, this command is unavailable.

This command is equivalent to the Open command on the Form menu.

Shortcut: Ctrl+O
Alternative: When a project is open, click Open Form on the File toolbar.

Close Form

Close a form file without leaving WOW Extensions.

· If you have not made changes to the form since you last opened or saved it, WOW Extensions will immediately close the form.

· If you have made changes to the form, however, WOW Extensions will display a message box asking whether you want to save the changes to the form.

-  If you choose Yes and the current form has previously been saved, WOW Extensions will save the form under its current name and then close it.

-  If you choose Yes and the form has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it, as described under the Save Form As command.

-  If you choose No, WOW Extensions will close the form without saving the changes.

-  If you choose Cancel, WOW Extensions will return you to the form without saving it or closing it.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Close command on the Form menu.

Shortcut: Ctrl+F4
Alternative: Click Close on the Control menu.

Save Form

Save changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Save command on the Form menu.

Shortcut: Ctrl+S
Alternative: Click Save Form and Generate Code on the File toolbar.

Save Form As

Save a form file under a new name or in a different directory/folder or drive. The standard Windows Save As dialog box opens so that you can specify a filename.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Save As command on the Form menu.

Note The name of the form file is significant, as it identifies the form to the underlying program. Form files are, by default, given the extension of .wow. The form filename is also used to identify and generate two copy files:

· The first copy file, with the filename extension of .wpr, contains the COBOL logic necessary for the form.

· The second file, with the extension of .wss, is the COBOL Working Storage copy file needed for the form.

For more information, click here.

Open All Forms or
Open All

Open all forms in the project that is currently open (or active) for this session.

Note If a project is open but no forms are open in that project, this command is shown as Open All on the menu. If no project is open, this command is not available.

This command is equivalent to the Open All command on the Form menu.

Save All Forms

Save all open forms if you are working on more than one form at a time. If any open forms have not been saved before, WOW Extensions displays a standard Windows Save As dialog box so that you can specify a filename.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Save All command on the Form menu.

Alternative: Click Save All Forms on the File toolbar.

Close All Forms

Close all open forms. If a form has changes that have not been saved, WOW Extensions prompts you to save the changes in each form before closing.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Close All command on the Form menu.

Recent Forms or
Recent Projects

List up to the last four projects and/or forms most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.

Exit

Close form and/or project files and exit WOW Extensions. If you have not made any changes since the last time you saved the open files, WOW Extensions will terminate. If you have made changes, you will see a message box asking whether you want to save your changes. You can save or discard your changes by choosing Yes or No for each item. You can also cancel the Exit command any time by choosing Cancel. You will return to the file without saving it or closing it.

Shortcut: Alt+F4
Alternative: Double-click the Control-menu icon in the WOW Designer window.


Edit Menu Commands

The commands displayed on the Edit menu of the WOW Designer window are disabled until a control has been added to a form. The control must be selected before it can be manipulated using the Edit menu commands. Note that the equivalent toolbar buttons, if applicable, also are shown in the following table.

Choose

To

Undo

Reverse the effect of the most recent editing operation. You must choose Undo before performing any other operation or the control is not restored.

Note Not all editing operations can be undone. In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms.

Shortcut: Ctrl+Z
Alternative: Click Undo on the Editing toolbar.

Redo

Restore the result of the last editing operation or action, if you decide that you do not want to undo the action.

Note Not all editing operations can be restored.

Shortcut: Ctrl+Shift+Z
Alternative: Click Redo on the Editing toolbar.

Cut

Cut a control(s) from a form. The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms. You can select multiple controls to be cut from within a single form. The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation.

Shortcut: Ctrl+X
Alternative: Click Cut on the Editing toolbar.

Copy

Copy a control(s) on a form or between forms. The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged. Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can select multiple controls to be copied from within a single form. Tip

Shortcut: Ctrl+C
Alternative: Click Copy on the Editing toolbar.

Paste

Paste a control(s) after cutting or copying to the Clipboard.

Note This command is not available if the Clipboard is empty.

Shortcut: Ctrl+V
Alternative: Click Paste on the Editing toolbar.

Duplicate

Create a copy of a control or controls. The copy will be offset slightly to the lower right and placed on top of the original control. The new duplicate copy is automatically selected. When you use this method of copying, WOW Extensions does not use the Clipboard to transfer the control(s). Tip

Shortcut: Ctrl+D

Delete

Erase a control or controls from a form.

Caution You cannot reinsert control(s) removed by using the Delete command since this command does not place the deleted selection in the Clipboard. You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation.

Shortcut: Del
Alternative: Click Delete on the Editing toolbar.

Select All

Select all the controls on the current form. To quickly deselect all controls on a form, click the left mouse button anywhere in the form that is not a control. Once you have selected multiple controls, you can manipulate them as though they were a single control. For example, you can cut, copy, delete, or duplicate them as one unit. For more information on manipulating controls in a form, click here.

Shortcut: Ctrl+A

Find

Display a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box.

Note This command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

Shortcut: Ctrl+F
Alternative: Click Find on the Editing toolbar.

Find Next

Find the next instance of the text string specified with the Find command.

Note This command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

Shortcut: Ctrl+N

Find Previous

Find the previous instance of the text string specified with the Find command.

Shortcut: Shift+F3

Find & Replace

Display a variation of the standard Windows Find & Replace dialog box in order to enter a text string that you want to locate and modify in the Code Entry area of the Event-Handling Code dialog box.

Note This command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

Shortcut: Ctrl+H

Find in Code

Display the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code. Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window. To see an example, click here.

Shortcut: Ctrl+Shift+F
Alternative: Click Find in Code Fragments on either the Editing or Find toolbar.

Edit Bookmarks

Open the Edit Bookmarks dialog box in order to add a bookmark, which identifies a location or selection of text that you name and identify for future reference; for example, to a frequently-used position of the COBOL source code that you may wish to revise in the code edit windows.

Shortcut: Alt+F2

Go To Bookmark

Open the Go To Bookmark dialog box in order to jump quickly to a certain line in the COBOL source code that has been identified by a bookmark name. When you select a bookmark from the dropdown list, the editor scrolls to the location of the bookmark in the code edit windows.

Shortcut: Ctrl+G

Toggle Marker

Show or hide the display of markers in the code edit windows. The default is to show markers, which is a setting on the Code Edit Windows Preferences page.

Shortcut: Ctrl+F2
Alternative: Click Toggle Marker on the Editing toolbar.

Go To First Marker

Go to the first marker in the code edit windows.

Go To Next Marker

Go to the next marker in the code edit windows.

Shortcut: F2
Alternative: Click Go To Next Marker on the Editing toolbar.

Go To Previous Marker

Go to the previous marker in the code edit windows.

Shortcut: Shift+F2
Alternative: Click Go To Previous Marker on the Editing toolbar.

Go To Last Marker

Go to the last marker in the code edit windows.

Clear All Markers

Remove all markers in the code edit windows.

Alternative: Click Toggle Marker on the Editing toolbar.


Control Menu Commands

See Also

Some of the commands displayed on the Control menu of the WOW Designer window are disabled until a control has been added to a form. Several of the Control menu commands have submenus attached to the right side of the menu item listing additional commands. Menu commands that lead to submenus are marked with a right-pointing triangle after the menu item name. You open a submenu by selecting the menu command with any of the usual techniques for choosing menu commands. Note that the equivalent toolbar buttons, if applicable, also are shown in the following table.

Choose

To

Foreground Color

Change the foreground color (that is, the line or text color) of one or more selected controls. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the foreground color of the control(s). You cannot set the foreground color for a command button, or for the horizontal or vertical scroll bars.

Note You can also set the foreground color of a control from the selected control’s Properties dialog box. On the Properties dialog box, this property is called ForeColor.

Background Color

Change the background (fill) color of one or more selected controls. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of the control(s). You cannot set the background color for a command button, or for the horizontal or vertical scroll bars.

Note You can also set the background color of a control from the selected control’s Properties dialog box. On the Properties dialog box, this property is called BackColor.

Font

Change the font, style (such as bold and italic), size, underline, color, and font effects (such as strikeout and underline) for text displayed in one or more selected controls. This command also allows you to set new defaults. The standard Windows Font dialog box opens. You cannot set font settings for a form, or for the horizontal and vertical scroll bars.

Note You can also set the font characteristics of a control from the selected control’s associated Properties dialog box. On the Properties dialog box, these properties are called FontBold, FontItalic, FontName, FontSize, FontStrikethru, and FontUnderline.

Tab Order

Determine and change the current tab order for your program.

Note For complicated forms having many controls, the preferred method of changing the tab order is with the Tab Order Editor dialog box.

WOW Extensions initially sets the tab order for each control to correspond to the order in which they were added to the form. When you select this command, WOW Extensions displays a number in blue in the upper-left corner of each control that corresponds to its current tab order on the form. To change the tab order, select the Tab Order command (a check mark will appear to the left of the command), then double-click the control you want to be first in the tab order. Its number will change. Then, single-click on the rest of the controls in the order in which you want them to be selected in the form when a user presses the Tab key. To exit tab order mode, click the mouse anywhere in the form or click the Tab Order command again. (Note that the Toolbox temporarily closes when the WOW Designer is in tab order mode.) For more information on dictating order entry for controls at runtime, click here.

You also can change the tab order for selected controls by changing the value of the TabIndex property in the Properties dialog box. (The first control in the tab order should have the TabIndex value of 1.) Note, however, that there is a limitation when using this method since you can only change the value of the TabIndex property to a value that has not already been set.

Note Although some controls (animation, bitmap, progress bar, static text box, status bar, tab, timer, toolbar, and all shapes) cannot accept mouse or keyboard focus, they will still have a valid tab order. When the user presses Tab, the focus skips over such a control and goes to the next control in the tab order.

Shortcut: Ctrl+T

Z-Order

Determine and change the control stacking order (or z-order), that is, the order in which controls are created.

Note For complicated forms having many controls, the preferred method of changing the z-order is with the Z-Order Editor dialog box.

The controls with the smaller numbers are stacked "behind" the controls with the larger numbers. The controls with the larger numbers are "on top" of all the other controls. WOW Extensions initially sets the z-order for each control to correspond to the order in which they are added to the form.

When you select this command, WOW Extensions displays a number in red in the upper-left corner of each control that corresponds to its current z-order on the form. To change the z-order, select the Z-Order command (a check will appear to the left of the command), then click the control you want to be first in the stacking order. Its number will change. Then, continue to click controls until they are in the desired order. To exit z-order mode, click the mouse anywhere in the form or click the Z-Order command again. (Note that the Toolbox temporarily closes when the WOW Designer is in z-order mode.)

You also can change the z-order for selected controls by changing the value of the Z-Order property in the Properties dialog box. (The first control in the z-order should have the z-order value of 1.)

Shortcut: Ctrl+R

Edit Code

Open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the selected control.

Alternatives: Click Edit Control Code on the View toolbar.

Or, from the Project tree, select a control name, then right-click to display a pop-up menu. Choose Edit Code on the pop-up menu. Or, double-click the selected control on the form.

Align

Precisely align multiple controls at the same time. WOW Extensions presents the horizontal and vertical alignment submenus where you can choose options for aligning selected controls horizontally or vertically. (The Alignment Preferences page of the Preferences dialog box determines how the Align command aligns selected controls horizontally and vertically relative to each other on a form.)

Note Aligning controls moves them to the positions you specify. If you align controls and later change the size of the form, the controls do not move to reflect the new form dimensions.

Alternatives: Click the dropdown arrow on the Aligning toolbar button on the Layout toolbar and select an option, or click the buttons on the Aligning toolbar.

Center

Center selected controls on a form. Controls are centered relative to the form. When you choose the Center command, two options appear:

· Vertical. The Vertical option aligns the selected controls vertically with respect to the center of the form between the top and bottom borders.

· Horizontal. The Horizontal option aligns the selected controls horizontally with respect to the center of the form between the left and right borders of the form.

Alternatives: Click the dropdown arrow on the Centering toolbar button on the Layout toolbar and select an option, or click the buttons on the Centering toolbar.

Space

Create equal distances between selected controls. Under the default settings in WOW Extensions, when you distribute selected controls, the spacing of the controls is determined by the exact centers of the controls. To change this default setting, see the Alignment Preferences page of the Preferences dialog box. When you choose the Space command, two options appear:

· Vertical. The Vertical spacing option distributes the selected controls in the vertical direction, placing equal amounts of space between the selected controls.

· Horizontal. The Horizontal spacing option distributes the selected controls in a horizontal direction such that the spacing between the controls is the same.

Alternatives: Click the dropdown arrow on the Spacing toolbar button on the Layout toolbar and select an option, or click the buttons on the Spacing toolbar.

Size

Change the size and shape of a selected control after you have created it. Sizing occurs relative to the first control selected. For this reason, it is preferable to select the first control and then use the Shift key to select subsequent controls rather than selecting all controls at one time. When you choose the Size command, three submenus appear:

· Match Height. Resizes the selected controls in a vertical direction.

· Match Width. Resizes the selected controls in a horizontal direction.

· Match Both. Resizes the selected controls in both directions simultaneously.

Alternatives: Click the dropdown arrow on the Sizing toolbar button on the Layout toolbar and select an option, or click the buttons on the Sizing toolbar.

Or, after you select a control, use the mouse and the selection handles that appear on it to change the size manually. You can size the control one direction at a time or both directions at once, depending on which handle you drag. To size the control proportionally, drag a corner handle.

Save Properties

Save the modified property settings for selected controls in a form. Each intrinsic control included in WOW Extensions, and any ActiveX custom control that you may add, include a set of initial properties and values. During design time, you include these controls in your form, change and customize their property settings, and attach code to them to create the user interface appearance of your program. Once you have modified a control, you may want to save it and reuse it in other projects or forms. Such predefined controls are helpful in providing a consistent look and behavior throughout your program. When you choose the Save Properties command, two options appear:

· For Project Use. Choosing this option saves the selected controls’ properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.

· For Global Use. If you want to reuse the modified controls in a different project, choose the For Global Use option to save the selected controls’ properties to the cblwow.ini initialization file.

Restore Properties

Restore the default property settings for selected controls. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets selected controls’ properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets selected controls’ properties from the cblwow.ini initialization file.

Bring to Front

Move the selected control all the way to the front of the stack of controls.

Note The Bring to Front command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

Shortcut: Ctrl+PageUp
Alternative: Click Bring to Front on the Layout toolbar.

Send to Back

Move the selected control behind all other controls in the stack on a form.

Note The Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

Shortcut: Ctrl+PageDown
Alternative: Click Send to Back on the Layout toolbar.

Toggle Lock

Lock or unlock the selected control(s), which keeps the control(s) from being moved accidentally. When the control is locked, a lock icon appears in the upper-left corner of the control and the Locked property value changes to True.

Shortcut: Ctrl+L
Alternatives: Click Toggle Lock on the Layout toolbar or change the value of the Locked property.

Tab Editor

Open the Tab Control Editor dialog box in order to delete the current tab within a tab control, shift the controls contained within that tab to the left or right, and modify certain tab properties that require special consideration with the tab control. Changing these properties for the tab control in the Tab Control Editor is equivalent to setting their values in the Properties dialog box.

Note This command is available only if you have selected a tab control on a form.

Tab Order Editor

Open the Tab Order Editor dialog box in order to display a list of controls on the active form and change their tab order.

Note For simple forms having few controls, the Tab Order command can be used to change the tab order.

Z-Order Editor

Open the Z-Order Editor dialog box in order to display a list of controls on the active form and change their control stacking order (z-order).

Note For simple forms having few controls, the Z-Order command can be used to change the control stacking order.

Drop Down Combo Box

Display the drop-down portion of the combo box control if the value of the Style property is either of these two values: 1 (Drop-down combo box) or 2 (Drop-down list box). This command allows all of the pre-defined data entries to be visible in the drop-down list box during the design process and provides the capability to select one of the entries for display in the edit box portion of the combo box control. Once you select one entry or select another object or click anywhere else on the screen, which cause focus to be lost, the drop-down list box is removed.


Tab Order

Tab order is the order in which the Tab key moves the input focus from one control to the next. (Pressing Shift+Tab moves the focus in the reverse order.) When a control has focus, it can receive input from the user through the mouse or keyboard. The tab order is initially set by WOW Extensions and corresponds to the order in which controls are added to the form. (Compare with z-order.)

To enable the Tab key to shift focus to a control on a form in a running application, the TabStop property must be set to True.

To determine the current tab order for your program, click Tab Order on the Control menu in the WOW Designer window, or use the shortcut key, Ctrl+T. A number in blue in the upper-left corner of each control shows its place in the current tab order. (Note that the Toolbox temporarily closes when the WOW Designer is in tab order mode.) To change the tab order, double-click the control you want to be first in the tab order, and then single-click on the rest of the controls in the order in which you want them to be selected in the form when a user presses the Tab key. To exit tab order mode, click the mouse anywhere in the form or click the Tab Order command again. For more information on dictating order entry for controls at runtime, click here.

Alternatively, you can change the tab order for selected controls by changing the TabIndex property for each control in the Properties dialog box. (The first control in the tab order should have the TabIndex value of 1.) Note, however, that there is a limitation when using this method since you can only change the value of the TabIndex property to a value that has not already been set.

Note Although some controls (animation, bitmap, progress bar, static text box, status bar, tab, time, toolbar, and all shapes) cannot accept mouse or keyboard focus, they will still have a valid tab order. When the user presses Tab, the focus skips over such a control and goes to the next control in the tab order.


Z-Order

The z-order is the control stacking order. The controls with the smaller numbers are stacked "behind" the controls with the larger numbers. The controls with the larger numbers are "on top" of all the other controls. The z-order is initially set by WOW Extensions and corresponds to the order in which controls are created and added to the form. (Compare with tab order.)

To determine the current z-order, click Z-Order on the Control menu in the WOW Designer window, or use the shortcut key, Ctrl+R. A number in red in the upper-left corner of each control shows its place in the current z-order. (Note that the Toolbox temporarily closes when the WOW Designer is in z-order mode.) To change the z-order, click the control you want to be first in the stacking order, and then continue to single-click on the rest of the controls until they are in the desired order. To exit z-order mode, click the mouse anywhere in the form or click the Z-Order command again.

Alternatively, you can change the z-order for selected controls by changing the Z-Order property for each control in the Properties dialog box. (The first control in the z-order should have the Z-Order value of 1.) The Z-Order property can be manipulated by the Bring to Front and Send to Back commands on the Control menu.


View Menu Commands

In the WOW Designer window, the View menu allows you to control what appears on the screen and offers access to several components that you use to customize the form and its controls. Note that the equivalent toolbar buttons, if applicable, also are shown in the following table.

Choose

To

Toolbars

Display a submenu that lists the following commands:

· All Toolbars. Displays all toolbars if any have been hidden (toggled off).

· File Toolbar. Toggles the display of the File Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Editing Toolbar. Toggles the display of the Editing Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Find Toolbar. Toggles the display of the Find Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Layout Toolbar. Toggles the display of the Layout Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Aligning Toolbar. Toggles the display of the Aligning Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Sizing Toolbar. Toggles the display of the Sizing Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Centering Toolbar. Toggles the display of the Centering Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Spacing Toolbar. Toggles the display of the Spacing Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· View Toolbar. Toggles the display of the View Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Project Toolbar. Toggles the display of the Project Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Help Toolbar. Toggles the display of the Help Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

· Custom Toolbar 1 and 2. Toggles the display of the selected Custom Toolbar. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.

Status Bar

Toggle the display of the status bar. When a check mark appears next to this command on the menu, it indicates that the status bar is visible. If the command is no longer active, the check mark is removed and the status bar is hidden.

Toolbox

Toggle the display of the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form. You must have a mouse to access the tools on the Toolbox.

Alternative: Click Show Toolbox on the View toolbar.

Project Tree

Toggle the display of the Project tree, a window that shows the current project and lists all its forms.

Project Output

Toggles the display of the Project Output dialog bar, a dockable window that shows the results of an application code search or a compilation.

Alternatives: Choose the Find in Code command on the Edit menu or click Find in Code Fragments on either the Editing or Find toolbar.

Code Templates

Open the Code Templates tree, which displays a list of available templates (also called shortcuts) for a function call or a message and provides different ways of viewing this information.

Lock Icons

Toggle the visual display of a lock icon on a control. (Note that when a control is locked, a lock icon appears in the upper left corner of the control.)

Note If no form is open in the project, this command is not available.

Controls may be locked by any of the following methods:

· Selecting the Toggle Lock command.

· Pressing the Toggle Lock button.

· Setting the Locked property.

· Using the Ctrl+L shortcut.

Properties

Open the Properties dialog box for the selected object.

Note If no form is open in the project, this command is not available.

Shortcut: Alt+Return
Alternatives: Click Show Properties on the View toolbar or single-click the right mouse button in the selected form or control.

Menu Editor

Create Windows-style pulldown menus for a selected form. The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box. You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance.

Note If no form is open in the project, this command is not available.

Shortcut: Shift+Return
Alternative: Click Show Menu Editor on the View toolbar.

ActiveX Methods

Opens the ActiveX Methods dialog box, which allows you to select method(s) for the control.

Note If no form is open in the project, this command is not available.

Shortcut: Shift+F2
Alternative: Click Show ActiveX Methods on the View toolbar.


Project Menu Commands

See Also

In the WOW Designer window, the Project menu commands can be used to simplify and manage the development of programs that use multiple forms. (Note that the equivalent toolbar buttons, if applicable, also are shown in the following table.) With a project, WOW Extensions will generate a skeleton program that uses multiple forms. When multiple forms are included in the project, each form is called a project member.

Note A form file (filename extension .wow) can be included in multiple projects. Because all changes made to a form are stored in the form file and not in the project, changes made to a form will affect every project in which it is included.

Choose

To

New

Create a new WOW project. After you enter a name for the project and the directory/folder for the project files (.wpj) in the Save Project dialog box (a standard Windows dialog box), the Project Properties dialog box opens and you can add forms (members) to the project.

Note Only one project can be opened at one time. If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created.

Alternative: Click New Project on the Project toolbar.

Open

Open an existing project, and include the forms and custom controls listed in its project file (.wpj). The Open Project dialog box, which is a standard Windows dialog box, opens.

Note Only one project can be opened at one time. If you are already in an open project when you choose the Open command on the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.

Alternative: Click Open Project on the Project toolbar.

Save

Save changes made to an active (open) project. When you save a project, WOW Extensions automatically generates COBOL source code.

Alternative: Click Save Project and Generate Code on the Project toolbar.

Save As

Saves a copy of the open project with a different name using a standard Windows Save As dialog box.

Close

Close a project. If you have made any changes to the file, you are prompted to save the changes.

Recent Projects

Lists up to the last four projects most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.

Open Member

Open or access a member of a project. A list box containing all the form files (.wow) in the project is displayed below the toolbar button.

Note Members can be added to and deleted from the project at any time with the Properties command.

Alternative: Click Open Member on the File toolbar.

Properties

Open the Project Properties dialog box in order to edit the current project by adding or deleting members. The settings in the Project Properties dialog box affect only the currently open project.

Alternatives: From the Project tree, select the active project name, then right-click to display a pop-up menu. Choose Properties on the pop-up menu. Or, double-click the project name.

Options

Specify configuration options for the current project using the Project Options dialog box.

Alternative: From the Project tree, select the active project name, then right-click to display a pop-up menu. Choose Options on the pop-up menu.

Regenerate

Regenerate COBOL source code for the active project if changes have been made to a form.

Regenerate w/Forms

Regenerate COBOL source code for the active project and for all forms in the project that have been modified.

Edit Code

Open the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the project.

Alternatives: Click Edit Project Code on the View toolbar.

Or, from the Project tree, select the active project name, then right-click to display a pop-up menu. Choose Edit Code on the pop-up menu.

Build

Generate and compile a COBOL source program if one does not exist.

Shortcut: F7
Alternative: Click Build Project on the Project toolbar.

Run

Execute the project by running the COBOL source program after it has been compiled.

Shortcut: F5
Alternative: Click Execute Project on the Project toolbar.

Debug

Debug the project. For more information about debugging a WOW project, click here.

Alternative: Click Debug Project on the Project toolbar.

Print Packaging List

Print a list of the application components (such as the COBOL program, bitmaps, icons, animation files, ActiveX controls, and so on) that are required for distribution. Selecting this command opens a standard Windows Print dialog box.


Form Menu Commands

See Also

In the WOW Designer window, the Form menu allows you to turn the form grid and snap-to-grid options on or off, set the background color for a form, rearrange and switch among forms, arrange icons, force a compile, save and close all form files, and save and restore a form's properties. Note that the equivalent toolbar buttons, if applicable, also are shown in the following table.

Choose

To

New

Add a new, blank form to an open project.

Note If a project is not open, this command is unavailable.

This command is equivalent to the New Form command on the File menu.

Shortcut: Ctrl+N
Alternative: When a project is open, click New Form on the File toolbar.

Open

Retrieve an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified.

Note If a project is not open, this command is unavailable.

This command is equivalent to the Open Form command on the File menu.

Shortcut: Ctrl+O
Alternative: When a project is open, click Open Form on the File toolbar.

Close

Close a form file without leaving WOW Extensions. If you have not made changes to the form since you last opened or saved it, WOW Extensions will immediately close the form.

If you have made changes to the form, however, WOW Extensions will display a message box asking whether you want to save the changes to the form. If you choose Yes and the current form has previously been saved, WOW Extensions will save the form under its current name and then close it. If you choose Yes and the form has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it, as described under the Save As command. If you choose No, WOW Extensions will close the form without saving the changes. If you choose Cancel, WOW Extensions will return you to the form without saving it or closing it.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Close Form command on the File menu.

Shortcut: Ctrl+F4
Alternative: Click Close on the Control menu.

Save

Save changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Save Form command on the File menu.

Shortcut: Ctrl+S
Alternative: Click Save Form and Generate Code on the File toolbar.

Save As

Save a form file under a new name or in a different directory/folder or drive. The standard Windows Save As dialog box opens so that you can specify a filename.

Note The name of the form file is significant, as it identifies the form to the underlying program. Form files are, by default, given the extension of .wow. The form filename is also used to identify and generate two copy files. The first copy file, with the filename extension of .wpr, contains the COBOL logic necessary for the form. The second file, with the extension of .wss, is the COBOL Working Storage copy file needed for the form. For more information, click here.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Save Form As command on the File menu.

Open All

Open all forms in the project that is currently open in this session.

Note If a project is not open, this command is unavailable.

This command is equivalent to the Open All Forms command on the File menu.

Save All

Save all open forms if you are working on more than one form at a time. If any open forms have not been saved before, WOW Extensions displays a standard Windows Save As dialog box so that you can specify a filename.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Save All Forms command on the File menu.

Alternative: Click Save All Forms on the File toolbar.

Close All

Close all open forms. If a form has changes that have not been saved, WOW Extensions prompts you to save the changes in each form before closing.

Note If a project is open but no forms are open in that project, or if no project is open, this command is not available.

This command is equivalent to the Close All Forms command on the File menu.

Print

Print the form. If more than one form is open, the form on top of the stack is printed. Selecting this command opens a standard Windows Print dialog box.

Shortcut: Ctrl+P
Alternative: Click Print Form on the File toolbar.

Show Grid

Toggle the display of the grid, an evenly spaced pattern of pixels (screen dots) that appear in a form, on and off. The grid helps you to draw, position, align, and size controls exactly where you want them in a form. The grid is displayed by default. When a check mark appears next to this command on the menu, it indicates that the grid is visible. If the command is no longer active, the check mark is removed and the grid is hidden.

The default spacing of the grid points is 10 x 10 pixels. To modify the vertical and horizontal spacing of the grid marks (the X and Y coordinates), see the Show Grid option on the General Preferences page of the Preferences dialog box. Although you see the grid marks on the form in the WOW Designer, they are not displayed at runtime.

Snap to Grid

Toggle the snap-to-grid option, which forces controls into perfect horizontal and/or vertical alignment to the nearest grid point, on and off. The Snap to Grid option is enabled by default (see the Snap to Grid option on the General Preferences page of the Preferences dialog box for more information).

When a check mark appears next to this command on the menu, it indicates that the snap-to-grid option is enabled. If the command is no longer active, the check mark is removed and the snap-to-grid option is no longer in effect. When you align or move a control with Snap to Grid enabled, the handles on the selected control are forced to the nearest grid point. You determine which of the eight handles snaps to the grid by controlling the direction in which you move the control.

Background Color

Change the background (fill) color of a form. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of a form.

Note You can also set the background color of a form from the form’s Properties dialog box. On the Properties dialog box, this property is called BackColor.

Cascade

Arrange multiple open forms in an overlapped pattern so that the title bar of each form is visible in the WOW Designer window. You can access the form you want by clicking on the title bar to bring it to the front of the stack.

Tile Horizontally

Arrange multiple open forms in rows with no overlap so that all forms are visible within the workspace. To access the form you want, click the title bar.

Tile Vertically

Arrange multiple open forms in columns (side by side) with no overlap so that all forms are visible within the workspace. To access the form you want, click the title bar.

Arrange Icons

Distribute forms that have been reduced (using the Minimize button) to icons evenly along the lower edge of the WOW Designer window.

Regenerate

Generate an existing COBOL source program if modifications have been made to a form. This command regenerates COBOL source code for the active form.

Regenerate All

Regenerate COBOL source programs for all forms in the project, not just the active form.

Edit Code

Open a submenu that allows you to select from two options: Form Events or Menus Events. After the selection is made, the Event-Handling Code dialog box opens in order to write, add, edit, or maintain the event-driven code associated with the selected item.

Alternatives: Click Edit Form Code or Edit Form Menu Code on the View toolbar.

Or, from the Project tree, select a form name, then right-click to display a pop-up menu. Choose one of the options on the Edit Code submenu.

Test

Run, from within the WOW Designer, a simplified version of the WOW runtime (wowtestform.exe) without executing COBOL code in order to see how a form will appear at runtime and test its operation during the design process. This test program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

Shortcut: F6
Alternative: Click Test Form on the Project toolbar.

Save Properties

Save the modified property settings for a form. Each form that you create includes a set of initial properties and values. During design time, you can change and customize the property settings, and attach code to create the user interface appearance of your program. Once you have modified a form, you may want to save it and reuse it in other projects. Such predefined forms are helpful in providing a consistent look and behavior throughout your program. When you choose the Save Properties command, two submenus appear:

· For Project Use. Choosing this option saves the form’s properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.

· For Global Use. If you want to reuse the modified form in a different project, choose the For Global Use option to save the form’s properties to the cblwow.ini initialization file.

Restore Properties

Restore the default property settings for a form. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets the properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets the properties from the cblwow.ini initialization file.

Recent Forms

List the forms that are open in the current project of the WOW Designer. To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.


Panel Menu Commands

See Also

In the WOW Designer window, the Panel menu provides options for working with panels and applications created with RM/Panels. Until a project is opened, only the Open, Open All, Recent Panel Library, and Import Preferences commands, are enabled. For more information on working with RM/Panels, click here.

Choose

To

Open

Open an RM/Panels panel in the WOW Designer. WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified. Once a library has been selected, a subsequent dialog box is displayed so that a specific panel may be selected. For more information, click here.

Note WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls).

Save

Save an existing RM/Panels panel modified with WOW Extensions and write the description of the panel back into the standard panel library. No WOW-specific files are created. For more information about saving a panel, click here.

Close

Close a panel without leaving WOW Extensions.

· If you have not made changes to the panel since you last opened or saved it, WOW Extensions will immediately close the panel.

· If you have made changes to the panel, however, WOW Extensions will display a message box asking whether you want to save the changes to the panel:

-  If you choose Yes and the current panel has previously been saved, WOW Extensions will save the panel under its current name and then close it.

-  If you choose Yes and the panel has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it.

-  If you choose No, WOW Extensions will close the panel without saving the changes.

-  If you choose Cancel, WOW Extensions will return you to the panel without saving it or closing it.

Open All

Open all RM/Panels panels in a panel library in the WOW Designer. WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified. Once you select a library, WOW then opens each of the panels in the library. For more information, click here.

Note WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls).

Save All

Save all existing RM/Panels panels in a panel library that were modified with WOW Extensions and write their descriptions back into that standard panel library. If any panels have been modified, the message box prompt will depend on whether or not more than one modified panel needs to be saved. If more than one panel needs to be saved, then a message box with Yes, Yes To All, No, and No To All command buttons will appear.

· If you click Yes To All, WOW Extensions will save all open panels under their current names and then close them.

· If you click No To All, WOW Extensions will close all the panels without saving any changes.

· The Yes and No options apply to the current panel being referenced by the message.

For more information about saving panels, click here.

Close All

Close all open panels without leaving WOW Extensions. If any panels have been modified, the message box prompt will depend on whether or not more than one modified panel needs to be saved. If more than one panel needs to be saved, then a message box with Yes, Yes To All, No, and No To All command buttons will appear.

· If you click Yes To All, WOW Extensions will save all open panels under their current names and then close them.

· If you click No To All, WOW Extensions will close all the panels without saving any changes.

· The Yes and No options apply to the current panel being referenced by the message.

Recent Panel Library

List up to the last four panel libraries most recently opened by the WOW Designer. To close the current panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.

Export

Save a single panel created with RM/Panels as a WOW form, providing the ability to create a new WOW program using an existing panel. For more information, click here.

Export All

Save all panels in a panel library created with RM/Panels as WOW forms, providing the ability to create a new WOW program using existing panels.

Recreate GUI

Restore a single RM/Panels panel to its original state after it has been opened in WOW Extensions. Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted. For more information, click here.

Recreate GUI All

Restore all panels in an RM/Panels library to their original states after the panels have been opened in WOW Extensions. Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted. For more information, click here.

Test

Run, from within the WOW Designer, a generic COBOL program to see how an RM/Panels panel will appear at runtime. For more information, click here.

Import Preferences

Display the Panel Import Preferences dialog box in order to specify certain graphical characteristics that will determine the way that character-based panels in an RM/Panels library will appear when the library is opened in the WOW Designer.


Options Menu Commands

See Also

In the WOW Designer window, the Options menu provides commands to customize many of operations in WOW Extensions to suit your requirements and to configure the Toolbox.

Choose

To

Preferences

Change the default settings and customize the WOW Designer development environment to your specifications using the Preferences dialog box.

Customize Toolbars

Add or remove buttons from most existing toolbars (the Find and Layout toolbars require special handling and are, therefore, excluded) or create up to two new toolbars (Custom Toolbar 1 and Custom Toolbar 2). When you choose the Customize Toolbars command, a submenu appears. Select the toolbar you want to customize and the Customize Toolbar dialog box is displayed. You can specify a title for the custom toolbar(s) by using the Custom Toolbar Titles area in the Tools Preferences page of the Preferences dialog box.

Customize Toolbox

Add or remove controls to or from the Toolbox using the Customize Toolbox dialog box.

Select ActiveX Controls

Choose from a list of ActiveX controls that are installed on your Windows machine using the Select ActiveX Controls dialog box.

Save Properties

Save the modified property settings for the currently selected object (control or form) in the Properties dialog box. When you choose the Save Properties command, two options appear:

· For Project Use. Choosing this option saves the selected object's properties to the project definition file (.wpj). These property settings become the new default settings for the selected object when they are used in that particular project.

· For Global Use. If you want to reuse the modified form or control in a different project, choose the For Global Use option to save the selected object's properties to the cblwow.ini initialization file.

Restore Properties

Restore the default property settings for the currently selected object (control or form) in the Properties dialog box. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets selected object's properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets selected object's properties from the cblwow.ini initialization file.


Help Menu Commands

WOW Extensions comes with extensive online assistance and step-by-step instructions. For more information on using Help, click here.

The Help menu of the WOW Designer window contains the following commands. Note that any equivalent toolbar buttons, if applicable, also are shown in the following table.

Choose | To
Designer | Launch the WOW Extensions Designer online Help file.
Functions and Messages | Launch the Functions and Messages for WOW Extensions online Help file.
About | Display the About WOW Designer window, which includes the version number, copyright notice, the name and company name of the person the copy is licensed to, the serial number, and other information about the WOW Extensions Designer product that is currently running. Alternative: Click About on the Help toolbar.

Note In addition to the commands on the Help menu, you can easily obtain context-sensitive Help for menu commands, toolbar buttons, and other screen elements by clicking the What's This? button on the Help toolbar, and then clicking the screen element or area you want information on. If necessary, press the Esc key to exit the context-sensitive Help window.


Toolbars

The toolbars, accessible by mouse only, provide immediate access to commonly used commands. By default, the toolbars are displayed horizontally beneath the menu bar of the WOW Designer window. The toolbars, however, can be dragged and dropped to different locations of your choosing.

The toolbars that appear, and the buttons that are enabled on those toolbars, depend on whether a project or form has been opened, or whether one or more controls on a form have been selected. Toolbar buttons that are not available are disabled and appear dimmed.

The buttons on the toolbars are grouped by function, as follows:

· File Toolbar

· Editing Toolbar

· Find Toolbar

· Layout Toolbar

-  Aligning Toolbar

-  Centering Toolbar

-  Sizing Toolbar

-  Spacing Toolbar

· View Toolbar

· Project Toolbar

· Help Toolbar

· Custom Toolbar

To use the toolbars, simply point with the mouse to the button that represents the command you want, and click. You can display or hide the various toolbars as you work. Choose a tool group from the Toolbars command on the View menu to toggle its respective toolbar on and off.

Note WOW Extensions offers the ability to customize an existing toolbar to your liking. If there are some features you use more often than others, you can add those feature buttons for faster access, or you can delete ones you never use. For more information, see the Customize Toolbar dialog box.


File Toolbar

The following commands are available from the buttons on the File toolbar in the WOW Designer window.

Button

Description

The Open Member button displays a list of all the files (members) in the open, active project from which you can open a member.

Note Members can be added to and deleted from the project at any time with the Properties command.

This button corresponds to the Open Member command on the Project menu.

The New Form button adds a new, blank form to an open project.

This button corresponds to the New Form command on either the File or Form menu.

The Open Form button retrieves an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified.

This button corresponds to the Open command on either the File or Form menu.

The Save Form and Generate Code button saves changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

This button corresponds to the Save command on either the File or Form menu.

The Save All Forms button saves changes made to all open form files. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

This button corresponds to the Save All command on either the File or the Form menu.

The Print Form button is used to print a form. If more than one form is open, the form on top of the stack is printed. Selecting this command opens a standard Windows Print dialog box.

This button corresponds to the Print command on the Form menu.


Editing Toolbar

Note The Editing toolbar buttons are disabled until a control has been added to a form. The control must be selected before it can be manipulated using these buttons.

The following commands are available from the buttons on the Editing toolbar in the WOW Designer window.

Button

Description

The Cut button cuts a control(s) from a form. The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms. You can select multiple controls to be cut from within a single form. The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation.

This button corresponds to the Cut command on the Edit menu.

The Copy button copies a control(s) on a form or between forms. The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged. Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can select multiple controls to be copied from within a single form. Tip

This button corresponds to the Copy command on the Edit menu.

The Paste button pastes a control(s) after cutting or copying to the Clipboard.

Note This command is not available if the Clipboard is empty.

This button corresponds to the Paste command on the Edit menu.

The Delete button erases a control or controls from a form.

Caution You cannot reinsert control(s) removed by using the Delete button since this command does not place the deleted selection in the Clipboard. You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation.

This button corresponds to the Delete command on the Edit menu.

The Undo button reverses the effect of the most recent editing operation. You must choose Undo before performing any other operation or the control is not restored.

Note Not all editing operations can be undone. In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms.

This button corresponds to the Undo command on the Edit menu.

If you decide that you do not want to undo an action (as described in Undo), click the Redo button to restore the result of the last editing operation or action.

Note Not all editing operations can be restored.

This button corresponds to the Redo command on the Edit menu.

The Find button displays a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box.

Note This button is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

This button corresponds to the Find command on the Edit menu.

The Find in Code Fragments button displays the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code. Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window. To view an example, click here.

Note This button is enabled only if a project is opened.

This button corresponds to the Find in Code command on the Edit menu and to the Find in Code Fragments button on the Find Toolbar.

The Toggle Marker button shows or hides the display of the markers in the code edit windows. The default is to show markers, which is a setting on the Code Edit Windows Preferences page.

This button corresponds to the Toggle Marker command on the Edit menu.

The Go To Next Marker button goes to the next marker in the code edit windows.

This button corresponds to the Go To Next Marker command on the Edit menu.

The Go To Previous Marker button goes to the previous marker in the code edit windows.

This button corresponds to the Go To Previous Marker command on the Edit menu.

The Clear Markers button removes all markers in the code edit windows.

This button corresponds to the Clear Markers command on the Edit menu.


Find Toolbar

The following commands are available from the options on the Find toolbar in the WOW Designer window.

Button

Description

The Select Find String list box allows you to enter a text string that you want to locate in your application code or to select a particular text string for which you have previously searched. (This list box corresponds to the Find What edit box in the Find in Code dialog box, a variation of the standard Windows Find dialog box.)

After entering or selecting a text string in the list box, click the Find in Code Fragments button to display the Find in Code dialog box. In the dialog box, simply choose the Find command button to start a search. Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window. To view an example, click here.

This button corresponds to the Find in Code command on the Edit menu and to the Find in Code Fragments button on the Editing toolbar.


Layout Toolbar

The Layout toolbar combines the capabilities of the Aligning, Centering, Sizing, and Spacing toolbars, but presents those capabilities in a different format. A down arrow appears to the right of each of the first four buttons on the toolbar. When you click the arrow, a submenu appears. When you select an option on the submenu, the toolbar button changes to the one you selected. (Note that the buttons shown here on the Layout toolbar depict the default view.)

Note At least two controls must be selected on a form before the Layout toolbar buttons can be accessed. To select more than one control at a time, hold down the Shift key while you right-click the desired control.

The following commands are available from the buttons on the Layout toolbar in the WOW Designer window.

Button

Description

Click the down arrow next to the Align button to select one of the alignment commands: Align Lefts, Align Centers, Align Rights, Align Tops, Align Middles, or Align Bottoms. You also may access these options from the Aligning toolbar.

Click the down arrow next to the Center button to select one of the centering commands: Center Vertical or Center Horizontal. You also may access these options from the Centering toolbar.

Click the down arrow next to the Size button to select one of the sizing commands: Match Width, Match Height, or Match Both. You also may access these options from the Sizing toolbar.

Click the down arrow next to the Space button to select one of the spacing commands: Space Vertical or Space Horizontal. You also may access these options from the Spacing toolbar.

The Bring to Front button moves the selected control all the way to the front of the stack of controls.

Note The Bring to Front command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

This button corresponds to the Bring to Front command on the Control menu.

The Send to Back button moves the selected control behind all other controls in the stack on a form.

Note The Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

This button corresponds to the Send to Back command on the Control menu.

The Toggle Lock button locks or unlocks the selected control(s), which keeps the control(s) from being moved accidentally. When the control is locked, a lock icon appears in the upper left corner of the control and the Locked property value changes to True.

This button corresponds to the Toggle Lock command on the Control menu. Locking can also be set by using the Locked property for the control.


Aligning Toolbar

Alignment tools allow you to precisely align multiple controls at the same time. For more information on manipulating controls in a form, click here.

The following commands are available from the buttons on the Aligning toolbar (or from the dropdown alignment options on the Layout toolbar) in the WOW Designer window.

Button

Description

The Align Lefts button aligns the left side of each selection with the left side of the first (primary) selection.

This button corresponds to the Lefts option from the Align command’s Vertical submenu on the Control menu.

The Align Centers button aligns the vertical (up/down) center of each selected control with the vertical center of the primary selection.

This button corresponds to the Centers option from the Align command’s Vertical submenu on the Control menu.

The Alight Rights button aligns the right side of each selection with the left side of the primary selection.

This button corresponds to the Rights option from the Align command’s Vertical submenu on the Control menu.

The Align Tops button aligns the top edge of each selected control with the top edge of the primary selection.

This button corresponds to the Tops option from the Align command’s Horizontal submenu on the Control menu.

The Align Middles aligns the horizontal (left/right) center of each selected control with the horizontal center of the primary selection.

This button corresponds to the Middles option from the Align command’s Horizontal submenu on the Control menu.

The Align Bottoms button aligns the bottom edge of each selected control with the bottom edge of the primary selection.

This button corresponds to the Bottoms option from the Align command’s Horizontal submenu on the Control menu.


Sizing Toolbar

Sizing tools change the size and shape of a selected control after you have created it. Sizing occurs relative to the first control selected. For this reason, it is preferable to select the first control and then use the Shift key to select subsequent controls rather than selecting all controls at one time. For more information on manipulating controls in a form, click here.

The following commands are available from the buttons on the Sizing toolbar (or from the dropdown sizing options on the Layout toolbar) in the WOW Designer window.

Button | Description
 | The Match Widths button resizes the selected controls in a horizontal direction. This button corresponds to the Match Width option from the Size command submenu on the Control menu.
 | The Match Heights button resizes the selected controls in a vertical direction. This button corresponds to the Match Height option from the Size command submenu on the Control menu.
 | The Match Both button resizes the controls in both directions simultaneously. This button corresponds to the Match Both option from the Size command submenu on the Control menu.


Centering Toolbar

Centering tools allow you to center selected controls on a form. Controls are centered relative to the form. For more information on manipulating controls in a form, click here.

The following commands are available from the buttons on the Centering toolbar (or from the dropdown centering options on the Layout toolbar) in the WOW Designer window.

Button

Description

The Center Vertically button aligns the controls vertically with respect to the center of the form between the top and bottom borders.

This button corresponds to the Vertical option from the Center command submenu on the Control menu.

The Center Horizontally button aligns the controls horizontally with respect to the center of the form between the left and right borders of the form.

This button corresponds to the Horizontal option from the Center command submenu on the Control menu.


Spacing Toolbar

Spacing tools allow you to create equal distances between selected controls. For more information on manipulating controls in a form, click here.

The following commands are available from the buttons on the Spacing toolbar (or from the dropdown spacing options on the Layout toolbar) in the WOW Designer window.

Button

Description

The Space Vertically button distributes the controls in the vertical direction, placing equal amounts of space between the selected controls.

This button corresponds to the Vertical option from the Space command submenu on the Control menu.

The Space Horizontally button distributes the selected controls in a horizontal direction such that the spacing between the controls is the same.

This button corresponds to the Horizontal option from the Space command submenu on the Control menu.


View Toolbar

The following commands are available from the buttons on the View toolbar in the WOW Designer window.

Button | Description
 | The Show Toolbox button accesses the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form. You must have a mouse to access the controls on the Toolbox. This button corresponds to the Toolbox command on the View menu.
 | The Show Properties button opens the Properties dialog box for the selected object. This button corresponds to the Properties command on the View menu.
 | The Show Menu Editor button creates Windows-style pulldown menus for a selected form. The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box. You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance. This button corresponds to the Menu Editor command on the View menu.
 | The Show ActiveX Methods button opens the ActiveX Methods dialog box, which allows you to select method(s) for the control. This button corresponds to the ActiveX Methods command on the View menu.
 | The Edit Project Code button opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the project. This button corresponds to the Edit Code command on the Project menu.
 | The Edit Form Code button opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the form. This button corresponds to the Edit Code command on the Form menu.
 | The Edit Control Code button opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the selected control. This button corresponds to the Edit Code command on the Control menu.
 | The Edit Form Menu Code button opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the specified menu. This button corresponds to the Edit Code command on the Form menu.


Project Toolbar

See Also

The following commands are available from the buttons on the Project toolbar in the WOW Designer window.

Button

Description

The New Project button creates a new WOW project. After you enter a name for the project and the directory/folder for the project files (.wpj) in the Save Project dialog box (a standard Windows dialog box), the Project Properties dialog box opens and you can add or delete forms (members) to the project.

Note Only one project can be opened at one time. If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created. After creating a new project, the Save Project dialog box opens, which establishes the project name and the directory/folder for the project files.

This button corresponds to the New command on the Project menu.

The Open Project button opens an existing project, and includes the forms and custom controls listed in its project (.wpj) file. The Open Project dialog box, which is a standard Windows dialog box, opens.

Note Only one project can be opened at one time. If you are already in an open project when you choose the Open command on the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.

This button corresponds to the Open command on the Project menu.

The Save Project and Generate Code button saves changes made to an active (open) project. When you save a project, WOW Extensions automatically generates COBOL source code.

This button corresponds to the Save command on the Project menu.

The Build Project button generates and compiles a COBOL source program if one does not exist.

This button corresponds to the Build command on the Project menu.

The Execute Project button executes the project by running the COBOL source program after it has been compiled.

This button corresponds to the Run command on the Project menu.

The Test Form button causes a simplified version of the WOW runtime (wowformtest.exe) to run from within the WOW Designer without executing COBOL code in order to see how a form will appear at runtime and test its operation during the design process. This test form program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

This button corresponds to the Test command on the Form menu.

The Debug Project button debugs the project.

This button corresponds to the Debug command on the Project menu.


Help Toolbar

WOW Extensions comes with extensive online assistance and step-by-step instructions. For more information on using Help, click here.

The following commands are available from the buttons on the Help toolbar in the WOW Designer window.

Button | Description
 | The About button displays the About WOW Designer dialog box, which provides the version number, copyright notice, the name and company name of the person the copy is licensed to, the serial number, and other information for the installed product. This button corresponds to the About command on the Help menu.
 | The What’s This? button provides access to context-sensitive Help for control icons, menu commands, toolbar buttons, and other screen elements.


Custom Toolbar

You can customize the toolbars in the WOW Designer to fit your work preferences. For more information, see the Customize Toolbar dialog box.


Toolbox

The Toolbox is a window, accessible by mouse only, which contains the icons of the controls that you select, draw, and place on your form. By default, the Toolbox is displayed vertically along the right-hand side of the WOW Designer window. It can, however, be dragged and attached to a different location of your choosing or it can be detached, or floated, in the WOW Designer window.

To access the Toolbox, do one of the following:

· Click Toolbox on the View menu.

· Click Show Toolbox on the View toolbar.

Notes

· The controls that appear in the Toolbox are the default Windows intrinsic controls. When you open and modify an RM/Panels panel library in WOW Extensions, the Toolbox automatically displays only the RM/Panels data fields (controls) that can be added to the panel. To view the Toolbox configured for RM/Panels, click here.

· The first tool in the Toolbox is the Pointer. This tool provides a way to select the form or a control on the form, and to move and resize forms and controls. The Pointer tool is not a control.

When you select the Pointer in the Toolbox, it will appear highlighted. To select a form or control, select the Pointer tool and then move the pointer over the object, and click the form or control to select it. In the case of a selected control, handles will appear. To select multiple controls, hold down the Shift key while clicking on the other controls you want to select.

· You can customize the way the Toolbox appears in the WOW Designer by using the Customize Toolbox command on the Options menu.

· You can also install ActiveX controls on the Toolbox by using the Select ActiveX Controls command on the Options menu.


Project Tree

See Also

When you create or open a project, the Project tree region of the WOW Designer window displays a hierarchical list of forms in the active project. The list can be expanded (to display the member forms and the controls in each form) and contracted, similar to how one might navigate a directory/folder structure of files, an index, or a table of contents. To view an example, click here.

The Project tree is displayed by default in the WOW Designer window. It can, however, be dragged and attached to a different location of your choosing or it can be detached, or floated, in the WOW Designer window. To toggle the display of the Project tree on and off, choose the Project Tree command on the View menu. When a check mark appears next to this command on the menu, it indicates that the Project tree is visible. If the command is no longer active, the check mark is removed and the Project tree is hidden.

Right-clicking on a highlighted project name displays a submenu that contains the following options:

· Edit Code. Open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the project. This command corresponds to the Edit Code command on the Project menu.

· Options. Specify configuration options for the current project using the Project Options dialog box. This command corresponds to the Options command on the Project menu.

· Properties. Edit the current project by adding or deleting members. The Project Properties dialog box opens. The settings in the Project Properties dialog box affect only the currently open project. This command corresponds to the Properties command on the Project menu.

· Close. Close a project. If you have made any changes to the file, you are prompted to save the changes. This command corresponds to the Close command on the Project menu.

Member forms are displayed below the project name. Right-clicking on a highlighted form name displays a submenu that contains the following options:

· Open. Opens a form in the project.

· Edit Code. Opens a submenu that allows you to select from two options: Form Events or Menus Events. After the selection is made, the Event-Handling Code dialog box opens in order to write, add, or maintain the event-driven code associated with the selected item. This command corresponds to the Edit Code command on the Form menu.

· Properties. Open the Properties dialog box for the selected object. This command corresponds to the Properties command on the View menu.

· Delete. Deletes the selected form from the project. If you have made any changes to the form, you are prompted to save the changes before the deletion.

Note that you can easily add the form back to your project either by right-clicking the highlighted project in the Project tree and clicking Properties or by clicking Properties on the Project menu. Each of these actions opens the Project Properties dialog box where you can add members to the project.

The controls in each form are also listed. Right-clicking on a highlighted control displays a submenu that contains the following options:

· Select. Selects the highlighted control.

· Edit Code. Open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the selected control. This command corresponds to the Edit Code command on the Control menu.

· Properties. Open the Properties dialog box for the selected object. This command corresponds to the Properties command on the View menu.

· Delete. Delete the selected control. This command corresponds to the Delete command on the Edit menu or the Delete button on the Editing toolbar.

Note that you can retrieve the control by immediately choosing the Undo command on the Edit menu before performing any other operation


Code Templates Tree

See Also

The Code Templates tree region of the WOW Designer window lists all the available templates (also called shortcuts) by category for a function call or a message and provides different ways of viewing this information. WOW Extensions provides shortcuts for frequently-used functions and messages so that it is easier to understand what the parameters are for a particular function or message. Each shortcut contains a brief description of the function or message, the calling sequence, and the parameter values.

The list can be expanded and contracted, similar to how you navigate a directory/folder structure of files, an index, or a table of contents by clicking the plus [+] or minus [-] icons next to each category.

The Code Templates tree is displayed by default in the WOW Designer window. It can, however, be dragged and attached to a different location of your choosing or it can be detached, or floated, in the WOW Designer window. To toggle the display of the Code Templates tree on and off, click Code Templates on the View menu. When a check mark appears next to this command on the menu, it indicates that the Code Templates tree is visible. If the command is no longer active, the check mark is removed and the Code Templates tree is hidden.

The Code Templates tree region contains the following options:

Option

Description

Code Templates list

The Code Templates list displays categories of the available templates, also called shortcuts, for function calls and messages. You can expand and collapse the lists within each category by clicking the plus [+] or minus [-] icons next to an item. The categories include the following:

· WOW Functions lists templates available for functions specific to WOW Extensions. See the Functions and Messages online Help file for detailed information about each function. In the Help file, the WOW functions begin with the prefix of WOW.

Note In addition to listing the WOW functions, this item displays three subcategories: ActiveX Functions, Thin Client Functions, and RPC Functions. Each of these categories list templates available for functions specific to ActiveX controls, Thin Client applications, and the addition of RPC (Remote Procedure Calls) capabilities to the WOW Thin Client implementation, respectively. Again, the Functions and Messages online Help file provides detailed information about each function. In the Help file, the ActiveX functions begin with the prefix of AX. The Thin Client functions begin with the prefix of WOWThinClient.

· Windows API Functions lists templates available for functions specific to the Windows Application Programming Interface. This large set of Windows API functions is further categorized by how the functions are used: Character, Class, Device Context/GDI, Dialog, Font, Menu, Profile, Scroll Bar, System, and Window. See the Functions and Messages online Help file for detailed information about each function.

· Animation Control Shortcuts lists templates available for sending messages specific to animation controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, ACM-.

· Button Shortcuts lists templates available for sending messages specific to command button, check box, and option button controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, BM-.

· Combo Box Shortcuts lists templates available for sending messages specific to combo box controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, CB-.

· Edit Box Shortcuts lists templates available for sending messages specific to edit box controls. See the Functions and Messages online Help file for detailed information about each message. In the help file, these messages are preceded by the prefix, EM-.

· List Box Shortcuts lists templates available for sending messages specific to list box controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, LB-.

· Progress Bar Shortcuts lists templates available for sending messages specific to progress bar controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, PB-.

· Send Message Shortcuts lists templates available for sending messages commonly used by a variety of controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, WM-.

Flat Tree

When selected, the Flat Tree check box removes the categorical grouping of the functions and message shortcuts available in WOW Extensions and lists all the available functions in alphabetical order.

Note In this view, the names of the ActiveX functions are preceded by the prefix ActiveX-, the names of the RPC functions are preceded by RPC-, and the names of the Thin Client functions are preceded by ThinClient-, and thus are alphabetized accordingly.

Expand Tree

The Expand Tree command button expands the categorical grouping of functions and message shortcuts to include the individual functions and message shortcuts within each group. You can then click the plus [+] and minus [-] icons next to an item to expand or collapse the hierarchical list.

Collapse Tree

The Collapse Tree command button causes the list of functions and message shortcuts to collapse to the highest group in the tree. You can then click the plus [+] and minus [-] icons next to an item to expand or collapse the hierarchical list.


Project Output Dialog Bar

The Project Output dialog bar shows the results of an application code search (displayed on the Find in Code tab) or the results of a compilation (displayed on the Compiler Output tab).

To toggle the display of the Project Output dialog bar in the WOW Designer window, click Project Output on the View menu. The dialog bar is located below the Project tree and Code Templates tree. To view an example, click here.

Note The Project Output dialog bar is also displayed when you choose the Find in Code command on the Edit menu, or when you click Find in Code Fragments on either the Editing or Find toolbar.


Desktop Area

See Also

The desktop area is the region of the WOW Designer window where forms are displayed and manipulated in projects.


Status Bar

The status bar, which is a horizontal area at the bottom of the WOW Designer window, provides information about the active file or task that you are working on.

The status bar is displayed by default. To toggle the display of the status bar, click Status Bar on the View menu. When a check mark appears next to this command on the menu, it indicates that the status bar is visible. If the command is no longer active, the check mark is removed and the status bar is hidden.

The status bar is divided into the following panes that display varying information depending on the action being taken in the WOW Designer window:

· Current State. Describes the toolbar button or Toolbox control currently highlighted by the cursor, or, if no button or control is highlighted, this pane displays the word, "Ready."

· Current Tool. Identifies the Toolbox control that is currently selected.

· Caps Lock. Indicates whether the Caps Lock key is pressed on the keyboard.

· Num Lock. Indicates whether the Num Lock key is pressed on the keyboard.

· Position. Indicates the X,Y coordinates (in pixels) of the currently selected control on a form.

· Size. Indicates the size (in pixels) of the currently selected control on a form.


Dialog Boxes

Click on one of the following topics for more information about specific options in the dialog boxes provided in the WOW Designer.

ActiveX Methods Dialog Box

Customize Toolbar Dialog Box

Customize Toolbox Dialog Box

Edit Bookmarks Dialog Box

External Edit Comparison Dialog Box

Event-Handling Code Dialog Box

Find and Find & Replace Dialog Boxes

Go To Bookmark Dialog Box

Menu Editor Dialog Box

Panel Import Preferences Dialog Box

Project Options Dialog Box

Project Properties Dialog Box

Properties Dialog Box

Select ActiveX Controls Dialog Box

Tab Control Editor Dialog Box

Tab Order Editor and Z-Order Editor Dialog Boxes


ActiveX Methods Dialog Box

See Also

Some ActiveX controls provide special capabilities that are invoked as methods. These methods can be thought of as functions or procedures built into the control. The ActiveX Methods dialog box allows you to view all the method(s) for an ActiveX control. The code for that method can be inserted into the Code Entry area of the Event-Handling Code dialog box by double-clicking on the method. Depending on your configuration, the method's description and comment lines also may be inserted in this area.

To display the ActiveX Methods dialog box, do one of the following:

· Click Show ActiveX Methods on the View toolbar.

· On the View menu, click ActiveX Methods.

· Press Shift+F2.

· Select a control, press Ctrl, and then right-click the mouse.

The ActiveX Methods dialog box contains the following options.

Option

Description

ActiveXs

The ActiveXs list box displays the name(s) of the ActiveX control(s) on the current form. Click the arrow to the right of the box to select a control name from the list.

Note When you select an ActiveX control in the form, the ActiveX Methods dialog box displays all of the methods that are available for that control. If you click on another ActiveX control, the methods for that control are displayed.

Methods

The Methods list box displays an alphabetical listing of all of the methods associated with the selected ActiveX control. To view more methods if there are more than can fit in the list box, click the scroll box or arrows to the right of the list box, or use the arrow keys from the keyboard.


Customize Toolbar Dialog Box

See Also

The Customize Toolbar dialog box allows you to add or remove controls from most existing toolbars (the Find and Layout toolbars require special handling and are, therefore, excluded) or create up to two new toolbars (Custom Toolbar 1 and Custom Toolbar 2). Changes will be recorded in the WOW initialization file, cblwow.ini. You can specify a title for the custom toolbar(s) by using the Custom Toolbar titles area in the Tools Preferences page of the Preferences dialog box.

You can then view the custom toolbars from the Toolbars command on the View menu.

Use either of the following methods to display the Customize Toolbar dialog box:

· Choose the Customize Toolbars command on the Options menu. On the submenu, select the toolbar you want to customize.

· From any toolbar, right-click to display a pop-up menu and choose Customize Toolbars. On the submenu, select the toolbar you want to customize.

The Customize Toolbar dialog box contains the following options.

Option | Description
Available toolbar buttons | The Available toolbar buttons area displays the buttons that you can add to the toolbar.
Add | The Add command button moves the button selected in the Available toolbar buttons area to the Current toolbar buttons area.
Remove | The Remove command button moves the button selected in the Current toolbar buttons area to the Available toolbar buttons area.
Current toolbar buttons | The Current toolbar buttons area displays the buttons in the order they appear (from left to right) on the toolbar.
Close | The Close command button closes the dialog box and saves the changes you have made.
Reset | The Reset command button removes any changes you made to the selected toolbar and restores the original settings (the default set of buttons) on the toolbar.
Help | The Help command button displays an overview of this dialog box.
Move Up | The Move Up command button moves the selected button up one line. On the toolbar, the button shifts left one space.
Move Down | The Move Down command button moves the selected button down one line. On the toolbar, the button shifts right one space.


Customize Toolbox Dialog Box

See Also

The Customize Toolbox dialog box allows you to reconfigure the Toolbox by adding more tools to or removing existing tools. Changes will be recorded in the WOW initialization file, cblwow.ini.

To display the Customize Toolbox dialog box, click Customize Toolbox on the Options menu.

The Customize Toolbox dialog box contains the following options.

Option | Description
Available Tools | The Available Tools area displays the tools that can be added to the Toolbox.
Add | The Add command button moves the selected tool in the Available Tools area to the Current Tools area.
Remove | The Remove command button moves the selected tool in the Current Tools area to the Available Tools area.
Current Tools | The Current Tools area displays the tools that are currently on the Toolbox.
OK | The OK command button completes the Customize Toolbox dialog box by accepting all the entries and closing the dialog box.
Cancel | The Cancel command button closes the Customize Toolbox dialog box without accepting any changes.


Edit Bookmarks Dialog Box

The Edit Bookmarks dialog box allows you add a new bookmark or manipulate existing bookmarks. A bookmark identifies a location or selection of text that you name and identify for future reference; for example, to a frequently-used position of the source code that you may wish to revise.

Prior to displaying the Edit Bookmarks dialog box, the Event-Handling Code dialog box must be open and the line of code that you wish to bookmark must be selected. To display the Edit Bookmarks dialog box, do either of the following:

· Click the Edit Bookmarks command on the Edit menu.

· Press the Alt+F2 shortcut keys.

The Edit Bookmarks dialog box contains the following options.

Option | Description
Name | The Name list box allows you either to enter the name of the new bookmark or select from a list of existing bookmarks.
Bookmark Display Area | The Bookmark Display Area displays the current bookmark in the Name list box.
Event/Section | The Event/Section area displays the event and/or code section associated with the selected bookmark.
Line | The Line area displays the line number of the code associated with the selected bookmark.
Add | The Add command button adds the bookmark specified in the Name list box.
Close | The Close command button closes the Edit Bookmarks dialog box.
Delete | The Delete command button deletes the selected bookmark.
Go To | The Go To command button closes the Edit Bookmarks dialog box and highlights the line of code associated with the selected bookmark.


External Edit Comparison Dialog Box

See Also

The External Edit Comparison dialog box allows you to accept or ignore any changes that have been made to your program source code, which is part of the programname.wpr copy file, outside of WOW Extensions using a standard text editor. You may wish to use such an editor when developing a large program in order to take advantage of more extensive editing and search features.

Note The changes you make through external editing do not become permanent-until you recompile your program.

The External Edit Comparison dialog box is displayed when you open a form after it has been externally edited and depending upon the options you have selected on the External-Editing Preferences page of the Preferences dialog box.

The External Edit Comparison dialog box contains the following options.

Option | Description
Code Fragment Name | The Code Fragment Name text box displays the name of the code fragment that was modified externally.
Change Description | The Change Description text box displays the type of change that was applied to the code fragment.
Original Code | The Original Code window displays the original code fragment before the changes. Use the vertical and horizontal scroll bars to view the code that is not visible in the window.
Externally Edited Code | The Externally Edited Code area displays the edited version of the code fragment. Use the vertical and horizontal scroll bars to view the code that is not visible in the window.
Run Diff | The Run Diff command button causes the WOW Designer to write the information in the Original Code and Externally Edited Code areas to a file and invokes a file comparison tool to report the results of the comparison. The Microsoft Windows windiff tool is the default, but a different comparison tool can be specified in the File Difference Program area of the Tools Preferences page.
Accept Changes | The Accept Changes command button accepts the external editing changes made to the code.
Ignore Changes | The Ignore Changes command button causes the external editing changes to be ignored.


Event-Handling Code Dialog Box

See Also

The Event-Handling Code dialog box allows you to write, add, edit, or maintain the event-driven code associated with the selected project, form, control, or menu.

WOW Extensions offers several methods to display this dialog box. For more information, click here.

The Event-Handling Code dialog box contains the following elements.

Option

Description

Events/Sections

The Events/Sections list displays all the events and/or code sections associated with the selected object. The list box displays the name of the selected event or code section (for example, Click is displayed for the Click event, such as when a user clicks a command button). Choose the arrow to the right of the box to display all the events and/or code sections for the object. Note that an asterisk after an event or code section indicates that code is already attached to this event or code section.

Show Sections with Code Only

When selected, the Show Sections with Code Only check box causes only those code sections that are not empty to be displayed.

Working Storage

The Working Storage area, which is available for forms, controls, and menus but not projects, allows you to make entries in the Working-Storage Section associated with the selected event. The <<Common>> special section will appear in the Working-Storage Section of the main (nested) program for a control or form. Review the generated code for a nested program in a WOW project to become more familiar with the naming and structure of WOW-generated nested programs. This ability facilitates the generation of nested programs, which allows for a more structured approach to COBOL programming.

Notes

· This area can be resized as necessary by using a track bar located on the right-hand side of the form. Alternatively, a default size for this area, based on percentage, can be set using the Working Storage Edit Window Percentage option on the Code Edit Windows Preferences page.

· This application source code displayed in this area may be further modified by the Code Edit, Find in Code, and Compiler Output Windows option on the Fonts & Colors Preferences page.

Program

The Program area identifies the COBOL program for which code is being written. The name of the program changes depending upon whether the selected event is for a project, a form, a control, or a menu.

Code Entry

The Code Entry area is where you enter and edit your source code. When you select an event that is already coded, the code is displayed in this area. Depending on your configuration, the description and comment lines may be inserted in this area.

Notes

· This area can be resized as necessary using a track bar located on the right-hand side of the form.

· This application source code displayed in this area may be further modified by the Code Edit, Find in Code, and Compiler Output Windows option on the Fonts & Colors Preferences page as well as a number of settings available on the Code Edit Windows Preferences page.

Line, Col

The Line, Col area indicates the current row and column on which the cursor is positioned in the Code Entry area when the Event-Handling Code dialog box has input focus


Display the Event-Handling Code Dialog Box

Use any of the following methods:

· Click Edit Project Code on the View toolbar. Alternatively, on the Project menu, click Edit Code.

· Click Edit Form Code on the View toolbar. Alternatively, on the Form menu, click Edit Code, and then click the submenu option: Form Events.

Or, from the Project tree, select a form name, then right-click to display the pop-up menu. From the Edit Code submenu, choose the Form Events option.

· Click Edit Control Code on the View toolbar. Alternatively, on the Control menu, click Edit Code.

Or, from the Project tree, select a control name, then right-click to display the pop-up menu. Choose Edit Code on the submenu.

· Click Edit Form Menu Code on the View toolbar. Alternatively, on the Form menu, click Edit Code, and then click the submenu option: Menus Events.

Or, from the Project tree, select a form name, then right-click to display the pop-up menu. On the Edit Code submenu, choose the Menus Events option.


Find and Find & Replace Dialog Boxes

The Find and Find & Replace dialog boxes are very similar in function.

· The Find dialog box allows you to search for a text string (including the use of regular expressions in the search string) that you want to locate in the Code Entry area of the Event-Handling Code dialog box. To open the Find dialog box, do one of the following:

-  Click the Find command on the Edit menu.

-  Click Find on the Editing toolbar.

-  Press the Ctrl+F shortcut keys.

· The Find & Replace dialog box allows you to optionally replace the search criteria that you want to locate and modify in the Code Entry area of the Event-Handling Code dialog box. Replace behaves much the same as Find, except that Replace With and Replace All options are available. To open the Find & Replace dialog box, do one of the following:

-  Click the Find & Replace command on the Edit menu.

-  Press the Ctrl+H shortcut keys.

Note These commands are enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

The Find and Find & Replace dialog boxes contain the following options.

Option

Description

Find What

In the Find What box, enter the text-string for which you intend to search. You can type or paste text into this box.

Replace With

In the Replace With box of the Find & Replace dialog box, type the text that you want to use as replacement text for the text entered in the Find What box. You can type or paste text into this box. To delete the text in the Find What box, leave the Replace With box empty.

Match Whole Word Only

When Match Whole Word is selected, WOW Extensions searches only for occurrences that are whole words and not part of a larger word.

Match Case

The Match Case option distinguishes between uppercase and lowercase characters. When this option is selected, WOW Designer finds only those instances in which the capitalization matches the text you typed in the Find What box.

Regular Expression

Selecting the Regular Expression check box allows a regular expression to be used in the search string. Regular expressions can match inexact sequences of text that optionally span more than one line. Regular expressions are used for searching through textual data. They allow you to search for pieces of text that match a certain form, instead of searching for a piece of text identical to the one you supply. For a complete list, see Regular Expressions.

Note If regular expressions are used in a search, the replacement string is formed from the text string with any sequences of \1 through \9 replaced by tagged matches from the most recent regular expression search.

Direction

The Up and Down option buttons specify the search (find), or the find and replace direction. Note that regular expressions can only be used when searching in a forward direction.

Find Next

The Find Next button finds and selects the next occurrence of the search criteria specified in the Find What box. Note that the Find Next operation searches from the current position to the beginning or end, depending on the direction selection, and does not wrap.

Mark All

The Mark All button, when selected, searches all the text in the code edit window and causes a marker to be placed to the left of the text specified in the Find What box. Note that the Mark All operation ignores the direction selection and marks from the beginning of the code edit window text.

Replace

In the Find and Replace dialog box, the Replace button replaces the selected instance of the search criteria, finds the next occurrence, and then stops. If you want to replace all occurrences of the search criteria automatically, click Replace All.

Replace All

In the Find and Replace dialog box, if you want to replace all occurrences of the search criteria automatically, click the Replace All button. To search and replace the selected instance of the search criteria, find the next occurrence, and then stop, click the Replace button. Note that the Replace All operation ignores the direction selection and marks from the beginning of the code edit window text.

Close

The Close button closes the dialog box and retains any changes that you may have made.


Regular Expressions

The WOW Designer supports the following regular expression syntax in a search string:

Expression Syntax | Description
. | Matches any character.
\( | Marks the start of a region for tagging a match.
\) | Marks the end of a tagged region.
\n | Where n is 1 through 9. Refers to the first through ninth tagged region when replacing. For example, if the search string was Fred\([1-9]\)XXX and the replace string was Sam\1YYY, when applied to Fred2XXX this would generate Sam2YYY.
\< | Matches the start of a word using Scintilla's definitions of words.
\> | Matches the end of a word using Scintilla's definition of words.
\x | Allows you to use a character x that would otherwise have a special meaning. For example, \[ would be interpreted as [ and not as the start of a character set.
[...] | Indicates a set of characters, for example, [abc] means any of the characters a, b or c. You can also use ranges, for example [a-z] for any lowercase character.
[^...] | Indicates the complement of the characters in the set. For example, [^A-Za-z] means any character except an alphabetic character.
^ | Matches the start of a line (unless used inside a set; see above).
$ | Matches the end of a line.
* | Matches 0 or more times. For example, Sa*m matches Sm, Sam, Saam, Saaam, and so on.
+ | Matches 1 or more times. For example, Sa+m matches Sam, Saam, Saaam, and so on.

Note If regular expressions are used in a search, the replacement string is formed from the text string with any sequences of \1 through \9 replaced by tagged matches from the most recent regular expression search.


Go To Bookmark Dialog Box

The Go To Bookmark dialog box allows you to jump quickly to a certain line in the source code file that has been identified by a bookmark name using the Edit Bookmarks dialog box. When you select a bookmark from the dropdown list, the editor scrolls to the location of the bookmark.

To display the Go To Bookmark dialog box, do either of the following:

· Click the Go To Bookmark command on the Edit menu.

· Press the Ctrl+G shortcut keys.

The Go To Bookmark dialog box contains the following options.

Option | Description
Name | The Name list box allows you to select from a list of existing bookmarks.
Event/Section | The Event/Section area displays the event and/or code section associated with the selected bookmark.
Line | The Line area displays the line number of the code associated with the selected bookmark.
Go To | The Go To command button closes the Go To Bookmark dialog box and highlights the line of code specified by the selected bookmark.
Close | The Close command button closes the Go To Bookmark dialog box.


Menu Editor Dialog Box

See Also

The Menu Editor dialog box allows you to create Windows-style pulldown menus. You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance. The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box.

To display the Menu Editor dialog box, do one of the following:

· Click Show Menu Editor on the View toolbar.

· Select the form and on the View menu, click Menu Editor.

Note It is important to understand menu terminology in WOW Extensions. A menu consists of a menu title and one or more menu items (or options). A menu bar, which appears immediately below the title bar on the form, contains one or more menu titles. A pulldown menu, by far the most common type of menu, is represented by a menu title (for example, File, Edit, and Help) that appears on the menu bar of an application window (form). When you select a menu title either with the mouse or keyboard, a list of menu items drops down. Menu items can include commands (such as New, Open, Close, and so forth), separator bars, accelerators, and submenu titles. Each menu title and menu item the user sees corresponds to a menu control that you define in the Menu Editor dialog box.

The Menu Editor dialog box contains the following options.

Option

Description

Menu Control

Use the Menu Control list box to design and view the structure of all the menu controls (menu titles and menu items) for the selected form. If you have just opened the Menu Editor dialog box, the first position in this list box is blank and highlighted. It serves as a placeholder. When you type an entry in the Title text box, the menu control appears on the highlighted line in the Menu Control list box. The menu titles you create are also displayed on the form.

To edit the properties for an existing menu control, select the control from this list box. Double-clicking on a menu item opens the Event-Handling Code dialog box with the code for that item displayed in the Code Entry area.

Up and Down

The Up and Down command buttons move the selected menu control among the existing menu controls. When you click these buttons, the selected object moves to the new position either above or below the selected line.

Left and Right

The Left and Right command buttons indent menu controls to the left or right of the preceding line. A menu control that appears flush left in the Menu Control list box is displayed on the menu bar in the form as the menu title. A menu control that is indented once to the right in the list box is a menu item (that is, commands, separator bars, and submenu titles). A menu control that is further indented to the right is called a submenu item (also known as a cascading menu).

Note Submenus present additional and related commands in a drop-down list box. Menu controls that lead to submenus are marked with a right-pointing triangle after the menu item name. Although you can create as many levels of these submenus as you wish, Liant recommends that you use only two or three menu levels in your interface design.

Insert and Delete

The Insert command button inserts a new, blank line in the Menu Control list box between existing menu controls in order to add a new menu control.

The Delete command button deletes a selected menu control or line.

Title

As you type in the Title text box in the Properties area, WOW Extensions automatically assigns the Name property of the menu control to a default value. Under the default configuration for WOW Extensions, the naming convention used for menu controls includes the prefix M- followed by the text entered in the Title box. For example, if you type File in the Title box, the default name entered in the Name box is M-FILE. (You can configure the way in which the menu names are generated by changing the options in the Code Preferences page of the Preferences dialog box.) This name is displayed in the Events/Sections list of the menus Event-Handling Code dialog box, and it is the name that WOW Extensions uses to reference the menu control in the generated code.

Note To specify a mnemonic character for quick keyboard access in a menu control, add an ampersand (&) in front of the appropriate letter in the Title property value. The letter following the ampersand appears underlined in the menu control. For example, to add a File menu command with the letter F as a mnemonic, type &File. The user will then be able to type Alt and the letter F to quickly access the menu. Be careful to keep track of the mnemonic key values that you enter since WOW Extensions does not check for duplicates.

It is also possible to place a tab character in a pulldown menu item. This is useful for aligning text used to describe accelerator key sequences. In the Title property, a tab character can be added by placing the sequence \t in the menu item followed by the accelerator key sequence selected in the Accelerator list box (for example, type Open\tAlt+o). This should be done only for pulldown menu items, not for top-level titles. Only one tab character should be added to a menu item.

Name

As you type in the Title text box in the Properties area, WOW Extensions automatically assigns the Name property of the menu control to a default value. Under the default configuration for WOW Extensions, the naming convention used for menu controls includes the prefix M- followed by the text entered in the Title box. For example, if you type File in the Title box, the default name entered in the Name text box is M-FILE. (You can configure the way in which the menu names are generated by changing the options in the Code Preferences page of the Preferences dialog box.) This menu name appears in the Events/Sections list of the menu Event-Handling Code dialog box), and it is the name that WOW Extensions uses to reference the menu control in the generated code.

Name Locking

The Name Locking option in the Properties area provides three choices for specifying what part, if any, of a menu name should change when a menu is moved:

· None prevents any of the menu names from being locked. This option is selected by default.

· Suffix locks only the portion of the name following the prefix; that is, those characters that follow the hyphen character (-) in the name.

· All locks the entire menu name.

Accelerator

Accelerators, sometimes known as shortcut keys, enable users to access a menu command from the keyboard by pressing a key or key combination. The Accelerator list box in the Properties area displays a drop-down list of key combinations that may be used to assign accelerator keys to access pulldown menu commands. (For more information, click here.)

In order for the accelerator to appear next to the pulldown menu item, you must type the accelerator key sequence selected from the list box following the text you entered in the Title box. It is also possible to place a tab character in the pulldown menu item to align the text that describes the accelerator key sequence. For example, if you select Alt+o in the Accelerator list box, you will type Open\tAlt+o in the Title box.

Note This should be done only for pulldown menu items, not for top-level titles. Only one tab character should be added to a menu item.

Checked

The Checked check box in the Properties area allows you to display a check mark on a menu item at design time. Check marks are commonly used to indicate an on/off condition. Choosing the menu command alternately adds and removes the check mark. If a menu command is active, a check mark will appear next to the menu item. For more information about displaying a check mark on a menu item at runtime, click here.

Enabled

The Enabled check box in the Properties area allows you to initially enable a menu control at design time. When the Enabled property is selected (the default), the menu responds to user actions. If a menu control is disabled, it appears grayed or dimmed. For information about enabling a menu control at runtime, click here.

Separator

The Separator check box in the Properties area allows you to insert a horizontal line, known as a separator bar, between the menu items. You can use separator bars to indicate groupings within the menu item list, or simply to provide a visual break in a list.

Last Error

The Last Error text box displays informational messages for the changes that you apply when you add or modify menu controls in the Menu Control area. For example, the message "First menu option must not be indented" appears if you try to indent the first top-level menu control, since this is not allowed.

Load

The Load command button displays the Open Menu dialog box, a variation of the standard Windows Open dialog, so that you can open an existing menu file (a file having the extension .wmn). You can then use the menu design “as is” or as a starting point which you then further customize.

Save

The Save command button displays the Save Menu dialog box, a variation of the standard Windows Save dialog, so that you can save any changes to a menu file. These files are stored as .wmn files. The Menu Editor dialog allows you to save any menu that you design so that you can use it again in another WOW project.


Panel Import Preferences Dialog Box

See Also

The Panel Import Preferences dialog box allows you to specify certain graphical characteristics that will determine the way that character-based panels in an RM/Panels library will appear when the library is opened in the WOW Designer.

Problems with the appearance of both character-based and GUI-based panels can occur when importing these types of panels into WOW Extensions. Because both character-based and GUI-based panels are dependent upon a fixed font size as well as rows and columns for their positioning, sizing, and alignment, controls can overlap or appear distorted when viewed in WOW. The ability to set defaults prior to importing the library may allow these sorts of problems to be avoided.

To access the Panel Import Preferences dialog box in the WOW Designer:

· On the Panel menu, click Import Preferences.

The Panel Import Preferences dialog box contains two tabs:

· The General tab displays a page of options allowing you to specify the default margins of the panels within a panel library, and to set default values for the alignment and spacing of the fields/controls on those panels when importing them to WOW forms.

· The Control-Specific tab displays a page of options allowing you to specify font information of the fields/controls on those panels/forms when importing them to WOW forms. For information about options on this page, click here.

Three command buttons, OK, Cancel, and Apply, appear in the lower-right corner in the Panel Import Preferences dialog box no matter which tab is selected and displayed. They perform the same functions in each of the pages of the Panel Import Preferences dialog box.

The General tab of the Panel Import Preferences dialog box contains the following options.

Option

Description

For Form Sizing

The edit boxes in the For Form Sizing group allow you to specify the margin settings for the outermost fields/controls on the panels/forms in the library. The Top Margin, Left Margin, Right Margin, and Bottom Margin edit boxes determine the amount of space, in pixels, between the edges of those outermost fields/controls and the edge of the panel/form. The default value is two pixels.

For Aligning Controls

The edit boxes and check boxes in the For Aligning Controls group allow you to control the conversion from row and column positioning of controls on character- and GUI-based panels to pixel positioning when those panels are converted to WOW forms.

· The value in the Line Height edit box is multiplied by the row number of a panel field in order to determine the vertical pixel position of the control on a form when it is converted to WOW. This edit box provides an alternative to using the default Static Text font size to determine vertical pixel positioning and is enabled unless the Use Static Text Font Size for Line/Column Spacing check box is not selected.

· The value in the Line Height Factor edit box, which is preset to 1, specifies a factor by which to multiply the value in the Line Height edit box or the Static Text font height.

· The value in the Column Width edit box is multiplied by the column number of a panel field in order to determine its horizontal pixel position when it is converted to a WOW control. This edit box provides an alternative to using the default Static Text font size to determine horizontal pixel positioning and is enabled unless the Use Static Text Font Size for Line/Column Spacing check box is not selected.

· The value in the Column Width Factor edit box specifies a factor by which to multiply the Column Width or the Static Text font width.

· The Use Static Text Font Size for Line/Column Spacing check box, selected by default, uses the size of the font specified for the Static Text field/control to determine vertical and horizontal pixel positioning of controls when panels are converted to WOW forms.

· The value in the Vertical Gap edit box determines the amount of additional space, in pixels, to add to the vertical positioning value as determined in the above calculations.

· The value in the Horizontal Gap edit box determines the amount of additional space, in pixels, to add to the horizontal positioning value as determined in the above calculations.

· The Compute actual width of controls with text check box, when selected, computes the width of fields/controls based on the font size and the text inside the field.

OK

The OK command button closes the Panel Import Preferences dialog box and saves any changes that you have made on the specified page (General or Control-Specific).

Cancel

The Cancel command button closes the Panel Import Preferences dialog box without saving any changes you have made to the settings on the specified page (General or Control-Specific).

Apply

The Apply command button saves all the changes you have made (either to the General or Control-Specific page) without closing the Panel Import Preferences dialog box.


Control-Specific Page (Panel Import Preferences Dialog Box)

The Control-Specific tab in the Panel Import Preferences dialog box allows you to specify control size and font information of the fields/controls on those panels/forms when importing them to WOW forms.

The Control-Specific tab of the Panel Import Preferences dialog box contains the following options.

Option

Description

Control Type

The Control Type column lists the available fields/controls for panels/forms in a panel library.

Height

The Height column refers to control-specific edit boxes that control the computation of the height of a control, override the default setting of either the Line Height edit box or the Use Static Text Font Size for Line/Column Spacing check box on the General tab. The Height column edit boxes allow you specify a different height for the control when a panel library is converted to WOW. If this value is set to zero, the control’s height will be computed based on one of the following:

· the values in the Font Size and Font Name columns (if specified), or

· the value in the Line Height edit box, or

· the Static Text font height (when the Use Static Text Font Size for Line/Column Spacing check box is selected) on the General tab

plus the value specified in the Extra Height column.

Extra Height

The Extra Height column refers to control-specific edit boxes that allow you to specify an additional number of pixels that will be added when computing the height of the field/control.

Extra Width

The Extra Width column refers to control-specific edit boxes that allow you to specify an additional number of pixels that will be added when computing the width of the field/control.

Font Size

The Font Size column refers to control-specific edit boxes that allow you to specify the size, in pixels, of the font specified in the Font Name column.

Font Name

The Font Name column refers to control-specific edit boxes that allow you to specify the name of the font to use for text in the field/control.

Vertical Scroll Bar

The edit boxes and option buttons in the Vertical Scroll Bar group allow you to determine the width of a vertical scroll bar field/control when a panel library is converted to WOW.

· The value in the Width edit box, when set to any number other than zero, overrides the default setting of either the Column Width edit box or the Static Text font width when the Use Static Text Font Size for Line/Column Spacing check box is selected on the General tab in determining the width of a vertical scroll bar.

· The value in the Width Factor edit box, which is preset to 1, specifies a value by which to multiply either the value of the Width edit box or the default setting of either the Column Width edit box or the Static Text font width when the Use Static Text Font Size for Line/Column Spacing check box is selected on the General tab. This multiplier is applied depending on the settings of the following option buttons:

-  The Use width factor always option button, when selected, causes WOW to always use the value specified in the Width Factor edit box to determine the width of the vertical scroll bar on a panel/form.

-  The Use width factor only when border was present in panel definition option button, selected by default, causes WOW to always use the value specified in the Width Factor edit box to determine the width of the vertical scroll bar only if a border was present in the panel definition.

Horizontal Scroll Bar

The edit box and option buttons in the Horizontal Scroll Bar group allow you to determine the height of a horizontal scroll bar field/control when a panel library is converted to WOW.

· The value in the Height Factor edit box, which is preset to 1, specifies a value by which to multiply the default setting of either the Line Height edit box or the or the Static Text font height when the Use Static Text Font Size for Line/Column Spacing check box is selected on the General tab. This multiplier is applied depending on the settings of the following option buttons:

-  The Use height factor always option button, when selected, causes WOW to always use the value specified in the Height Factor edit box to determine the height of the horizontal scroll bar.

-  The Use height factor only when border was present in panel definition option button, selected by default, causes WOW to always use the value specified in the Height Factor edit box to determine the height of the horizontal scroll bar only if a border was present in the panel definition.


Project Options Dialog Box

The Project Options dialog box allows you to specify configuration options for the current project.

To display the Project Options dialog box:

· On the Project menu, click Options.

· From the Project tree, select the active project name, then right-click to display a pop-up menu. Choose Options on the pop-up menu.

The Project Options dialog box contains the following options.

Option

Description

Runtime Command Line Arguments

The Runtime Command Line Arguments option sets the RM/COBOL Runtime Command options for the project.

Note You can also set this configuration option on the Tools Preferences page of the Preferences dialog box.

Compiler Command Line Arguments

The Compiler Command Line Arguments option sets the RM/COBOL Compiler Command options for the project.

Note You can also set this configuration option on the Tools Preferences page of the Preferences dialog box.

At Project Open

The At Project Open area allows you to specify which of your application’s forms you want WOW Extensions to display when a project opens. The At Project Open area contains three option buttons:

· Open all forms at project open. By default, WOW Extensions automatically opens all forms when a project opens.

· Open no forms at project open. No forms are displayed when the project opens at design time. To open a form, click Open Member on the Project menu or click Open Member on the toolbar. The names of all the forms in the project are displayed in the list. Click any form(s) you want to open.

· Open showstate forms at project open. WOW Extensions automatically creates a form and shows it when the project is initially executed. Showstate forms are indicated by an asterisk (*) in the Members in Project area of the Project Properties dialog box.

Menu Name Generation

As with all controls, when you add a menu control to the form, WOW Extensions assigns it a default name. The group of options in the Menu Name Generation area determines the naming conventions used for menu controls.

· If you select the Generate Long Names option and give a menu control a Title property value of File in the Menu Editor dialog box, for example, WOW Extensions automatically assigns the menu control a Name property of MENU-FILE.

Tip The Generate Long Names option causes the full name of the menu option to be used to create the internal menu name in the COBOL source code by adding hyphens (-) to it. If your menu entries are long, this can result in the name being truncated as the internal name is created. Furthermore, internal names may be duplicated inadvertently. If you are using menus, set the preference to Generate Short Names to avoid this problem.

· If you select the Generate Short Names option (the default), WOW Extensions sets the Name property for the control with the prefix M-; in the preceding example, the Name would be abbreviated to M-File.

· Selecting the Do Not Generate Names option allows you to assign a more descriptive and meaningful name to the menu control.

In all cases, the menu name appears in the Events/Code Sections list of the menu Event-Handling Code dialog box.

Note Because the Name property provides the name WOW Extensions uses to reference the menu control in the underlying code, you cannot leave the Name property blank. Be careful also to assign a unique name to the control to avoid possible name conflicts with duplicate names.

Generate Short Control Handles

The Generate Short Control Handles option, which is enabled by default, removes the suffix -H from the name of the control or form in order to avoid duplicate variable names.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.

Generate Form -FRMH Handles

The Generate Form -FRMH Handles option adds the suffix -FRMH to the name of the form. This prevents a form from having the same name as a control, which would cause duplicate variables.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.

Generate Nested Programs

The Generate Nested Programs option, when selected, overrides the default setting on the Code Preferences page of the Preferences dialog box that was established when the project was created. This option causes the project to be generated in a fully block-structured form.

Generate Working Storage Comments

The Generate Working Storage Comments option, when selected, generates comment lines in the Working Storage copy file (.wws) for WOW forms. To make the source file smaller, deselect this option. Having a smaller source file helps ensure that the RM/COBOL compiler can accommodate the WOW program.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.

Generate Old-Style Paragraph Names

The Generate Old-Style Paragraph Names option, when selected, overrides the setting on the Code Preferences page of the Preferences dialog box that allows projects created with WOW Extensions to use old-style paragraph names; that is, with the format, WP-DESTROY-FORMNAME. In order for old-style paragraph names to be used, the Generate Nested Programs option must not be selected. If the Generate Nested Programs option is selected, the value of Generate Old-Style Paragraph Names option is ignored.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code page of the Preferences dialog box.

Generate Old-Style Working-Storage Guard Names

The Generate Old-Style Working Storage Guard Names option, when selected, causes the WOW Designer to generate Working-Storage guard names that are limited to 30 characters in length, which was the case in versions prior to v10.01. Versions 10.01 and later of the WOW Designer will generate names up to 240 characters long. Selecting this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Generate Untruncated Paragraph Names

The Generate Untruncated Paragraph Names option, when selected, allows the WOW Designer to generate paragraph names that are no longer abbreviated (or truncated) in order to avoid duplicate paragraph names caused by the previous truncation scheme. Selecting this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.

Generate Short
(72 column) Lines

The Generate Short (72 column) Lines option, when selected, causes the WOW Designer to generate COBOL source records ending at column 72 (for backward compatibility). If this option is not selected, source records with longer line lengths (now allowed by an RM/COBOL compiler directive) are generated.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code page of the Preferences dialog box.

Generate Multiple Evaluate Events Paragraphs

The Generate Multiple Evaluate Events Paragraphs option, when selected, causes the WOW Designer to generate multiple paragraphs (instead of the default, single paragraph) when evaluating events in large applications in order to avoid reaching the COBOL compiler paragraph size limit.

ActiveX Enum Generation

The group of check boxes in the ActiveX Enum Generation area allows you to control the generation of constants that can be used when writing code for ActiveX properties, methods, and events. All options are selected by default.

· Checking the Generate Form Level check box causes 88-level condition-names for the ActiveX control to be generated at the form level in the Working Storage section.

· Checking the Generate Control Level check box causes 78-level condition-names for the ActiveX control to be generated at the control level in the Working Storage section.

· Checking the Generate Event Level check box causes 78-level condition-names for the ActiveX control to be generated at the event level in the Working Storage section.

Note Selecting these options allow you to specify different values for the project than the ones initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.

OK

The OK command button completes the Project Options dialog box by accepting the project options settings and saving them in the .wpj project file.

Cancel

The Cancel button backs out of the Project Options dialog box by canceling all entries made within the dialog box.


Project Properties Dialog Box

See Also

The Project Properties dialog box allows you to edit the current project by adding or deleting members.

To display the Project Properties dialog box, do one of the following:

· On the Project toolbar, click New Project and enter and save the project name and folder for the project file.

· On the Project menu, click New and save the project name.

· On the Project menu, click Properties.

· Double-click a project name in the Project tree of the WOW Designer window.

· Right-click a project name in the Project tree of the WOW Designer window, and click Properties on the pop-up menu.

Note The settings in the Project Properties dialog box affect only the currently open project.

The Project Properties dialog box contains the following options.

Option

Description

List

The List area below the Look in list box shows all the files in the currently selected location that match the specified file type entry in the Files of type list box. Note that the initial content of this list box is set to *.wow, which is the default extension for a WOW form file.

You can toggle the manner in which information is displayed in this area with the List and Details toolbar buttons.

To add one of the listed files to the project, select the file and click Add. To add more than one of the listed files to the project, first hold down the Ctrl key. Then click the remaining files you want to select, one at a time. When all the desired files are selected, click Add. To add a group of files, select the first file in the group, hold down the Shift key, and then select the last file in the group. All files in the group will then be selected. Click Add to add the group of files to the projects.

Look in

The Look in list box indicates the current target folder (designated by the "open" file-folder icon to the left of the folder name). To see where the current folder is located in the hierarchy of folders on your computer or to select a different location, click the arrow to the right of the box. To open the folder one level higher, click the Up One Level toolbar button.

Files of type

The Files of type list box specifies which filenames are listed in the List area from a preset list of file types, based on the filename extensions (listed in parentheses). To look for a file type other that the default, use the mouse or keyboard to select any file type from the list. WOW Extensions will substitute that extension for the current entry in the Files of Type list box and display only files with the same extension in the List area.

Note The initial content of the list box is set to *.wow, the default extension for a WOW form file.

List and Details

This area contains several toolbar buttons that allow you to perform the following tasks:

· Up One Level Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· View Desktop Click to see the contents of the Desktop hierarchy in the Look in list box.

· Create New Folder Click to create a new folder within the folder you are currently viewing.

· List Click to view the contents of a folder in a simple list format (only the names of the files are shown in the List area). This is the default view.

· Details Click to display details of the files in the List area: filename, size, file type, and date modified. You can click any of these column headings to sort the list by that category. Click the List button to view only the filenames.

Project Description

The Project Description text box allows you to enter a comment for the project. The description will be displayed in the status bar while the project is selected.

Use Global Default Properties

The Use Global Default Properties check box, when selected, causes any property settings defined in the WOW Designer initialization file (cblwow.ini) to be used for the project (except as noted below).

The global default property settings defined in the cblwow.ini file allow you to provide a consistent look and behavior throughout your application. Each form or control that you create includes a set of initial properties and values. During design time, you can change and customize the property settings. Once you have modified the properties for a form or a control, you may want to save them and reuse them in other projects. This is done using the Save Properties | For Global Use command on the Form menu, Control menu, or Options menu. Such predefined form and control properties can provide a starting point that enables you to design an overall user interface that presents your application to its best advantage.

Note When applying initial property values in a new project, WOW Extensions first checks the project definition file (.wpj) to see whether any properties have been established as defaults for a project. If there are no project defaults, WOW Extensions then checks the cblwow.ini file to see if any global defaults have been defined. If global defaults have been defined, and if the Use Global Default Properties check box has been selected, those global defaults will be applied to the new project. If there are no project defaults and no global defaults, WOW Extensions applies the initial built-in defaults.

Members in Project

The Members in Project area lists all of the form files (members) that are in or have been added to a project and allows you to delete form files from a project. An asterisk (*) indicates that the form will be shown at project startup (open), which is determined by the options configured for the project in the Project Options dialog box.

Delete

The Delete command button removes the selected file from the current project.

Show State

The Show State command button indicates the forms that will be displayed at project startup (open), which is determined by the options configured for the project in the Project Options dialog box.

Close

The Close command button accepts the changes and closes the Project Properties dialog box. The changes take effect as soon as the dialog box closes.


Properties Dialog Box

See Also

WOW Extensions considers forms, as well as the form’s controls, as objects. Each of these objects has a specific set of properties and values, the attributes that define how the objects look and how they behave in the running application. In other words, an object’s properties represent all the characteristics associated with that object. For example, the BackColor property for a form, as its name implies, defines the background color fill of the form.

You can change the default properties and their settings for selected forms and controls during design time (the time you implement the visual portion of the program) using the Properties dialog box. Make sure that the object is selected by clicking anywhere inside the object.

Note When more than one control is selected in the form, a single Properties dialog box displays all the properties that are shared among the selected controls. (The Objects list box in the Properties dialog box will indicate "Form - Multiple Objects Selected".) This is true even when the value for the shared property differs among the selected controls. In this case, the property value column is empty (or blank). However, when you click on the value area, the value of the first control selected is displayed. When you change any of the shared properties in the Properties dialog box, the property value changes to the new value in all the selected controls. There is one notable exception to this: when you select multiple controls in a form, their Name property no longer appears in the Properties area, even though they all have a Name property. This is because you cannot assign the same value for the Name property to more than one control in a form.

To display the Properties dialog box, do one of the following:

· Click Show Properties on the View toolbar. Alternatively, on the View menu, click Properties.

· Right-click the right mouse button in the selected form or control.

· From the Project tree, select a form or control, then right-click to display a pop-up menu. Click Properties on the pop-up menu.

Note It is also possible to set and retrieve most properties at runtime using the WOWSETPROP and WOWGETPROP functions. Changing properties during runtime means that the value of the property changes from within the code of the program. While some properties may be changed during runtime, some properties may be set only during design time, and some properties may be set only during runtime. For example, the Caption property of the static text control may be set during design time as well as at runtime.

The Properties dialog box contains the following options.

Option

Description

Objects

The Objects list box displays the name and type of the object (form or control) having the properties you want to change. Click the arrow to the right of the box to select a form or control name from the list of objects for the current form.

Note When you select a form or a control in the form, the Properties dialog box displays all of the properties that you can work with for that object at design time. If you click on another object, the properties for that object are displayed. When more than one control is selected in the form, a single Properties dialog box displays all the properties that are shared among the selected controls. The Objects list area will indicate "Form - Multiple Objects Selected".

Properties

The Properties list box is divided into two columns. The left column of this list box displays all of the properties associated with the selected object (that is, the form or control). The right column displays the current value (or setting) for each property. To view more properties if there are more than can fit in the list box, click the scroll box or arrows to the right of the list box, or use the arrow keys from the keyboard.

Notice that the property names are listed alphabetically for the selected object when the Alphabetic tab is selected, as shown here. You may also view the properties by functional category when you click the Categorized tab. Functional categories always include the Appearance, Behavior, and Position. Other categories, such as Font and Miscellaneous, can be displayed as well, depending on whether a form or a control is the selected object. To see an example of this page of the Properties dialog box, click here.

At design time, there are several ways to edit properties in the settings column of the Properties dialog box. You can directly type in values in the entry boxes. Some values can be changed by clicking the arrow to the right of the entry box; this action will display a drop-down list of pre-existing choices. You can then click an item in the list to select it. With certain properties, double-clicking an ellipsis (...) button in the settings column opens a dialog box that you use to set the property.

Note Certain properties associated with the selected object show a logical value of True or False. Your COBOL code, however, uses integer data types to implement these values.


Select ActiveX Controls Dialog Box

See Also

The Select ActiveX Controls dialog box lists the ActiveX controls that are installed on your system and that appear to be compatible with WOW Extensions. WOW Extensions determines what controls to list here by searching the Windows registry entries on the computer to find the registered ActiveX controls. When WOW Extensions finds a control, it looks to see if the necessary registry entries are there to allow it to use the control, and also checks to see if the control requires any features not provided by WOW Extensions.

To display the Select ActiveX Controls dialog box:

· On the Options menu, click Select ActiveX Controls.

To add any listed control to your Toolbox, click on the control to select it. When you have selected all the controls you want, click OK. The Toolbox will be reformatted to display the controls you have selected. The controls will also be recorded in the WOW Designer initialization file, cblwow.ini.

In some cases, several controls may be added to the Toolbox by selecting a single entry in the list box as some controls are distributed and registered as a group.

To remove a single control from the Toolbox, press Ctrl and click the cursor on the control to deselect it in the Select ActiveX Controls dialog box and click OK. To remove all the controls from the Toolbox, click the Clear All button.

The Select ActiveX Controls dialog box contains the following options.

Option

Description

Select the desired ActiveX controls

The Select the desired ActiveX controls list box lists the ActiveX controls that are installed on your system and that appear to be compatible with WOW Extensions. From this list, select the control(s) that you wish to add to the Toolbox and click the OK command button.

To select controls that are contiguous in this list, press the Shift key and move the cursor until all of the controls between the anchor (the first selected control) and the destination (the last selected control) are highlighted. Or, press Ctrl and move the cursor to highlight and add a non-continuous single control to a selected group.

OK

The OK command button completes the Select ActiveX Controls dialog box by accepting the selections and recording them in the WOW Designer initialization file, cblwow.ini.

Cancel

The Cancel command button backs out of the Select ActiveX Controls dialog box by canceling all entries made within the dialog box.

Clear All

Use the Clear All command button to deselect controls from the Select the desired ActiveX controls list and remove them from the Toolbox. To deselect one or more controls in the list, press Ctrl and then click the cursor on the control or controls you wish to remove. The highlight is removed. Click the OK command button.

Note that if you click Clear All and click OK without deselecting a control or controls, and then click OK, all the controls will be removed from the Toolbox.


Tab Control Editor Dialog Box

The Tab Control Editor dialog box allows you to delete the current tab within a tab control, shift the controls contained within that tab to the left or right, and modify certain tab properties that require consideration with the tab control. (Changing these properties for the tab control in the Tab Control Editor is equivalent to setting their values in the Properties dialog box.) The Tab Control Editor dialog also provides a means to retain the controls within a tab when the tab itself is deleted.

For example, let’s say you add a tab control with three tabs and populate the second of those tabs with controls. Then you decide that you need only two tabs, but you want to keep all the controls contained within the second tab. Using the Tab Control Editor dialog, you could delete the second tab, but shift all of its controls left to the original first tab or right to the original third tab.

To display the Tab Control Editor dialog box:

· Select a tab control on a form and then click Tab Editor on the Control menu.

Note This command is available only if you have selected a tab control on a form.

The Tab Control Editor dialog box contains the following options.

Option

Description

Tab Control Name

The Tab Control Name is a static text box that indicates the name of the tab control currently having focus. This is the value that appears in the Name property for that tab.

Current Tab

The Current Tab text box indicates the number of the currently selected tab within the tab control. You can use the spin buttons to change the selection to a different tab number. This is the value that appears in the CurTab property for the tab control. Note that this value also can be changed using the CurTab property in the Properties dialog box.

Tab Accelerator

The Tab Accelerator list box allows you to specify what key, if any, should simulate the pressing of the tab. This property cannot be modified or retrieved at runtime.

Note Wow Extensions automatically creates an Accelerator property if you use an ampersand (&) in a caption for the tab control. The accelerator will be “Alt + ” the character following the ‘&’. You may override this automatic accelerator. If you remove the ‘&’ character, the accelerator will not be deleted.

Note that this value also can be changed using the Accelerator property in the Properties dialog box.

To view the possible values of the tab accelerator, click here.

Tab Text

The Tab Text edit box indicates the text that appears in the currently selected tab (in this example, the tab text "File" is shown for illustrative purposes only). This is the value that appears in the tab control's TabText property for the currently selected tab. Note that this value also can be changed using the TabText property in the Properties dialog box.

Tab Enabled

The Tab Enabled check box controls whether the tab identified in the Current Tab text box can be selected at runtime. Note that the Tab Enabled value also can be changed using the TabEnabled property n the Properties dialog box.

Apply Changes and Delete Current Tab

The Apply Changes and Delete Current Tab command button allows you to apply any changes made in the dialog box and additionally allows you to delete the currently selected tab. The controls contained on that tab will be moved left or right, or deleted, depending on the merge options selected.

Apply Changes and Insert Tab Before Current Tab

The Apply Changes and Insert Tab Before Current Tab command button allows you to apply any changes made in the dialog box and additionally allows you to insert a tab before the currently selected tab. The controls contained on that tab will be moved left or right, or deleted, depending on the merge options selected.

Apply Changes and Add Tab After Current Tab

The Apply Changes and Add Tab After Current Tab command button allows you to apply any changes made in the dialog box and additionally allows you to insert a tab after the currently selected tab. The controls contained on that tab will be moved left or right, or deleted, depending on the merge options selected.

Delete Current Tab Merge Control Options

The Delete Current Tab Merge Control Options area allows you to select the behavior applied to controls on the current tab when the tab is to be deleted. The Delete Current Tab Merge Control Options area contains three option buttons:

· Delete Controls. When the current tab is deleted, all controls within the tab will be deleted. This is the default.

· Merge Controls Left. When the current tab is deleted, the controls on that tab will be shifted to the tab on the left. If you are deleting the first tab, the controls will be shifted to the new first tab.

· Merge Controls Right. When the current tab is deleted, the controls on that tab will be shifted to the tab on the right. If you are deleting the last tab, the controls will be shifted to the new last tab.

Number of Tabs

The Number of Tabs text box indicates the number of tabs within the tab control. You can change that number by using the spin buttons to increase or decrease the value. This is the value that appears in the Tabs property for the tab control.

Get Focus

The Get Focus area allows you to change the following properties for the tab control. These properties determine whether the text of the selected tab has input focus:

· Default. When selected, the Default option button causes the Tab key on the keyboard to be used to give input focus to the selected tab (the default). Note that this value also can be changed using the GetFocus property in the Properties dialog box and selecting a value of 0.

· On Button Down. When selected, the On Button Down option button causes the selected tab to receive input focus when clicked with the mouse. Note that this value also can be changed using the GetFocus property in the Properties dialog box and selecting a value of 1.

· Never. When selected, the Never option button prevents input focus from going to the text of the selected tab. It does not prevent focus from going to any of the controls on the tab. Note that this value also can be changed using the GetFocus property in the Properties dialog box and selecting a value of 2.

Styles

The Styles area allows you to change the following properties for the tab control:

· Buttons. When selected, the Buttons check box causes tabs to appear as buttons. Note that this value also can be changed using the Buttons property in the Properties dialog box.

· Fixed Width. When selected, the Fixed Width check box causes all tabs to be the same width. Note that this value also can be changed using the FixedWidth property in the Properties dialog box.

· Force Label Left. When selected, the Force Label Left check box forces tab texts to the left. If the Force Label Left check box is selected, the Fixed Width check box must also be selected. Note that this value also can be changed using the ForceLabelLeft property in the Properties dialog box.

· Vertical. When selected, the Vertical check box forces tabs to appear at the left side of the control, with tab text displayed vertically. If the Vertical check box is selected, the Multi-Line check box must also be selected. Note that this value also can be changed using the Vertical property in the Properties dialog box.

· Multi-Line. When selected, the Multi-Line check box causes the tabs to occupy multiple lines if the tab control is too narrow for all the tabs to be displayed on a single line. Note that this value also can be changed using the MultiLine property in the Properties dialog box.

· Right. When selected, the Right check box causes tabs to appear vertically on the right side of any control that has the Vertical property set to True. Note that this value also can be changed using the Right property in the Properties dialog box.

· Ragged Right. When selected, the Ragged Right check box causes the width of each tab to be increased so that each row of tabs fills the entire width of the tab control. Note that this value also can be changed using the RaggedRight property in the Properties dialog box.

OK

The OK command button accepts all changes and closes the Tab Control Editor dialog box.

Cancel

The Cancel button cancels all changes and closes the Tab Control Editor dialog box.

Apply

The Apply command button accepts all changes without closing the Tab Control Editor dialog box.


Tab Order Editor and Z-Order Editor Dialog Boxes

These two dialog boxes are very similar in function:

· The Tab Order Editor dialog box displays a list of controls on the active form and allows you to easily change their tab order. A number to the left of the control name indicates the control’s current tab order.

· The Z-Order Editor dialog box displays a list of controls on the active form and allows you to easily change their control stacking order (or z-order), that is, the order in which controls are created. A number to the left of the control name indicates the control’s current z-order. (Note that the controls with the smaller numbers are stacked “behind” the controls with the larger numbers. The controls with the larger numbers are “on top” of all the other controls. WOW Extensions initially sets the z-order for each control to correspond to the order in which they are added to the form.)

In either dialog box, click on the controls in the order in which you want to set the tab order or z-order. Use the Next Index edit box to assign the next order number. The list can be expanded and contracted, similar to the way in which one might navigate a directory/folder structure of files.

Note For simple forms having few controls, use either the Tab Order command to change the tab order or the Z-Order command to change the control stacking order.

To display these dialog boxes:

· On the Control menu, click either the Tab Order Editor or the Z Order Editor command.

The Tab Order Editor and Z-Order Editor dialog boxes contain the following options.

Option | Description
Next Index | Next Index is an edit box that allows you assign the next order number in the tab order or z-order of controls on a form.
OK | The OK command button accepts all changes and closes the dialog box.
Apply | The Apply command button accepts all changes without closing the dialog box.
Cancel | The Cancel button cancels all changes and closes the dialog box.


Property Manipulation Checklist

See Also

While most object properties can be manipulated at design time and either retrieved or set at runtime, there are exceptions:

· To see a table detailing whether the properties for a form can be manipulated at design time, retrieved or set at runtime, or both, click here.

· To see a table detailing whether the properties for an ActiveX control, the intrinsic controls, and particular RM/Panels field/controls can be manipulated at design time, retrieved or set at runtime, or both, click one of the following topics:

ActiveX Control | Numeric Edit Box Control
Animation Control | Option Button Control
Bitmap Control | Progress Bar Control
Check Box Control | Rectangle Shape
Combo Box Control | Rounded Rectangle Shape
Command Button Control | Scroll Bar Control
Date Edit Box Control | Static Text Control
Date Time Picker Control | Status Bar Control
Edit Box Control | Tab Control
Ellipse Shape | Time Edit Box Control
Group Box Control | Timer Control
Line Shape | Toolbar Control
List Box Control | Trackbar Control
Month Calendar Control | Updown Control
Multi-Line Edit Box Control |


Form Object

See Also

The following table details whether the properties for a form can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes | Yes |  |
AllowEventFilter | Yes |  |  |
BackColor | Yes | Yes (but not for a panel) | Yes |
Bitmap | Yes | Yes (but not for a panel) | Yes |
BitmapMode | Yes | Yes (but not for a panel) | Yes |
Border | Yes |  |  |
Caption | Yes |  |  |
Centered | Yes |  |  |
ClipControls | Yes |  |  |
ClipSiblings | Yes |  |  |
Cursor | Yes | Yes |  |
DialogMotion | Yes |  |  |
Enabled | Yes | Yes |  |
Height | Yes | Yes (but not for a panel) | Yes |
Icon | Yes |  | Yes |
KeyPreview | Yes |  |  |
Left | Yes | Yes (but not for a panel) | Yes |
MaxButton | Yes |  |  |
MinButton | Yes |  |  |
Modal | Yes | Yes |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
Parent | Yes |  |  |
ScrollBars | Yes |  |  |
ShowState | Yes | Yes |  |
SysKeyMode | Yes |  |  |
SystemMenu | Yes |  |  |
Style | Yes |  |  |
Tag | Yes | Yes |  |
Title | Yes | Yes (but not for a panel) | Yes |
ToolWindow | Yes |  |  |
Top | Yes | Yes (but not for a panel) | Yes |
Version |  | Yes |  | At runtime, can be retrieved, but not set.
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
WSDefinition | Yes | Yes |  |

The following table details whether the properties (attributes) for an RM/Panels panel can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
BackgroundAttr |  |  | Yes |
BorderAttr |  |  | Yes |
BorderType |  |  | Yes |
Description |  |  | Yes |
DropShadow |  |  | Yes |
EndUserEditing |  |  | Yes |
ErrorAttr |  |  | Yes |
ErrorMessage |  |  | Yes |
GeographicMotion |  |  | Yes |
HelpAttr |  |  | Yes |
HelpMessage |  |  | Yes |
Prefix |  |  | Yes |
StoreByName |  |  | Yes |
Windowed |  |  | Yes |


Animation Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
AnimationFile | Yes | Yes |  |
AutoPlay | Yes |  |  |
Border | Yes |  |  |
Center | Yes |  |  |
ClientEdge | Yes |  |  |
Enabled | Yes | Yes |  |
Group | Yes | Yes |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
ModalFrame | Yes |  |  |
Name | Yes | Yes |  |
Play | Yes |  |  |
StaticEdge | Yes |  |  |
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
Top | Yes | Yes |  |
Transparent | Yes |  |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Bitmap Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
BackColor | Yes | Yes (but not for a panel) | Yes |
Bitmap | Yes | Yes (but not for a panel) | Yes |
BitmapMode | Yes | Yes (but not for a panel) | Yes |
Border | Yes |  | Yes |
ClientEdge | Yes |  | Yes |
Enabled | Yes | Yes | Yes |
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
Locked | Yes |  |  |
ModalFrame | Yes |  | Yes |
Name | Yes | Yes (but not for a panel) | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
XOffset | Yes | Yes (but not for a panel) | Yes |
YOffset | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |


Check Box Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes |  | Yes |
Accelerator | Yes |  |  |
Alignment | Yes | Yes |  |
AutoCheck | Yes | Yes |  |
BackColor | Yes | Yes | Yes |
Caption | Yes | Yes |  |
ClientEdge | Yes |  | Yes |
Enabled | Yes | Yes |  |
FontBold | Yes | Yes | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
ForeColor | Yes | Yes | Yes |
Group | Yes | Yes |  | At runtime, must be a child control.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
Locked | Yes |  | Yes |
ModalFrame | Yes |  | Yes |
Name | Yes | Yes (but not for a panel) | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
ThreeState | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
Value | Yes | Yes |  |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels check box field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Beep |  |  | Yes |
Column |  |  | Yes |
DefaultToPressed |  |  | Yes |
DisabledAttr |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
Length |  |  | Yes |
Line |  |  | Yes |
MnemonicAttr |  |  | Yes |
PromptText |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Title |  |  | Yes |


Combo Box Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes |  | Yes | The former name for this parameter was ThreeD.
AutoHScroll | Yes |  |  |
BackColor | Yes | Yes (but not for a panel) | Yes |
ClientEdge | Yes |  | Yes |
Count |  | Yes |  |
CurData | Yes |  |  |
CurSel |  | Yes |  |
Data | Yes |  |  |
DataCount | Yes |  |  |
DataLoad | Yes |  |  |
DataSelect | Yes |  |  |
DisableNoScroll | Yes |  |  |
Enabled | Yes | Yes |  |
FontBold | Yes | Yes (but not for a panel) | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
ForeColor | Yes | Yes (but not for a panel) | Yes |
Group | Yes | Yes |  | At runtime, must be a child control.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
LeftScrollBar | Yes |  |  |
Locked | Yes |  | Yes |
ModalFrame | Yes |  | Yes |
Name | Yes | Yes (but not for a panel) | Yes |
NoIntegralHeight | Yes |  | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
OEMConvert | Yes |  |  |
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
ScrollBar | Yes |  | Yes |
SelText |  | Yes |  | Can be retrieved, but not set, at runtime.
Sort | Yes |  |  |
StaticEdge | Yes |  | Yes |
Style | Yes |  |  |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  | Does not work with a drop-down list box.
ToolTipText | Yes | Yes |  | Does not work with a drop-down list box.
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels combo box field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Beep |  |  | Yes |
Border |  |  | Yes |
BorderAttr |  |  | Yes |
ChoiceHelp |  |  | Yes |
ChoicesToDisplay |  |  | Yes |
ChoicesToStore |  |  | Yes |
ChoiceValue |  |  | Yes |
ChoiceWidth |  |  | Yes |
Column |  |  | Yes |
CurChoice |  |  | Yes |
DisabledAttr |  |  | Yes |
DropDown |  |  | Yes |
DoubleClick |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
InputField |  |  | Yes |
Line |  |  | Yes |
Length |  |  | Yes |
PromptText |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
StaticChoices |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |


Command Button Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Accelerator | Yes |  | Yes |
Bitmap | Yes | Yes |  |
Cancel | Yes | Yes |  |
Caption | Yes | Yes |  |
ClientEdge | Yes |  | Yes |
Default | Yes | Yes |  |
Enabled | Yes | Yes |  |
FontBold | Yes | Yes (but not for a panel) | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
Group | Yes | Yes |  | At runtime, must be a child control.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
Locked | Yes |  | Yes |
ModalFrame | Yes |  | Yes |
Name | Yes | Yes (but not for a panel) | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  |
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels commmand button field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Beep |  |  | Yes |
Border |  |  | Yes |
Column |  |  | Yes |
DefaultValue |  |  | Yes |
DisabledAttr |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
InputField |  |  | Yes |
Line |  |  | Yes |
MnemonicAttr |  |  | Yes |
PushedAttr |  |  | Yes |
PromptText |  |  | Yes |
SelectedAttr |  |  | Yes |
SizeType |  |  | Yes |
SizeValue |  |  | Yes |
StartOfGroup |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Title |  |  | Yes |


Date Time Picker Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
ClientEdge | Yes |  |  |
Enabled | Yes | Yes |  |
FontBold | Yes | Yes |  |
FontItalic | Yes | Yes |  |
FontName | Yes | Yes |  |
FontSize | Yes | Yes |  |
FontStrikethru | Yes | Yes |  |
FontUnderline | Yes | Yes |  |
Format | Yes | Yes |  | Can be set, but not retrieved, at runtime.
Height | Yes | Yes |  |
Group | Yes | Yes |  | At runtime, must be a child control.
Left | Yes | Yes |  |
LeftScrollBar | Yes |  |  |
Locked | Yes |  |  |
LongDateFormat | Yes |  |  |
MCColor | Yes |  |  |
MCColorIndex | Yes |  |  |
MCFontBold | Yes |  |  |
MCFontItalic | Yes |  |  |
MCFontName | Yes |  |  |
MCFontSize | Yes |  |  |
MCFontStrikethru | Yes |  |  |
MCFontUnderline | Yes |  |  |
ModalFrame | Yes |  |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
Range |  | Yes |  | Can be retrieved, but not set, at runtime.
RightAlign | Yes |  |  |
RightAlignedText | Yes |  |  |
RightToLeftReading | Yes |  |  |
ShortDateCenturyFormat | Yes |  |  |
ShowNone | Yes |  |  |
StaticEdge | Yes |  |  |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
Text |  | Yes |  | Can be retrieved, but not set, at runtime.
Time |  | Yes |  | Can be retrieved, but not set, at runtime.
TimeFormat | Yes |  |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes |  |
Transparent | Yes |  |  |
UpDown | Yes |  |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Edit Box Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes |  | Yes | The former name for this parameter was ThreeD.
Alignment | Yes | Yes |  | Can be retrieved, but not set at runtime
AutoHScroll | Yes | Yes |  |
AutoVScroll | Yes | Yes |  |
BackColor | Yes | Yes | Yes |
Border | Yes |  | Yes |
Case | Yes | Yes | Yes |
ClientEdge | Yes |  | Yes |
DataType |  | Yes |  | Old runtime property. A string value of “Numeric” sets this property to True; any other value sets it to False.
DecDigits |  | Yes |  | Old runtime property.
Enabled | Yes | Yes |  |
FontBold | Yes | Yes (but not for a panel) | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
ForeColor | Yes | Yes | Yes |
Group | Yes | Yes |  | At runtime, must be a child control.
Height | Yes | Yes (but not for a panel) | Yes |
IntDigits |  | Yes |  | Old runtime property.
Left | Yes | Yes (but not for a panel) | Yes |
LeftScrollBar | Yes |  |  |
Locked | Yes |  | Yes |
MaxChars | Yes | Yes |  |
ModalFrame | Yes |  | Yes |
MultiLine | Yes | Yes |  |
Name | Yes | Yes (but not for a panel) | Yes |
NoHideSel | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
Numeric | Yes | Yes |  |
NumericDecDigits | Yes | Yes |  |
NumericIntDigits | Yes | Yes |  |
NumericSign | Yes | Yes |  |
OEMConvert | Yes | Yes |  |
Password | Yes | Yes |  |
PasswordChar | Yes | Yes |  |
ReadOnly | Yes | Yes |  |
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
ScrollBars | Yes |  |  |
SelectAllOnGotFocus | Yes |  |  |
Sign |  | Yes |  | Old runtime property. A value of Y or y sets the value to True.
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
TabStops | Yes |  |  |
Tag | Yes | Yes |  |
Text | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
Visible | Yes | Yes |  |
WantPopUpMenu | Yes |  |  |
WantReturn | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels edit box field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
AlwaysDisabled |  |  | Yes |
AutoExit |  |  | Yes |
Beep |  |  | Yes |
Border |  |  | Yes |
Class |  |  | Yes |
Column |  |  | Yes |
DefaultValue |  |  | Yes |
DisabledAttr |  |  | Yes |
DoubleClick |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForDisplay |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
Justify |  |  | Yes |
Line |  |  | Yes |
Length |  |  |  |
OccColOffset |  |  | Yes |
OccLineOffset |  |  | Yes |
Occurrences |  |  | Yes |
OccXOffset |  |  | Yes |
OccYOffset |  |  | Yes |
Prompt |  |  | Yes |
PromptText |  |  | Yes |
Protected |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Update |  |  | Yes |
Validation |  |  | Yes |


Ellipse Shape Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
BackBrushHatch | Yes |  |  |
BackBrushStyle | Yes |  |  |
BackColor | Yes |  |  |
Fill | Yes |  |  |
ForeColor | Yes |  |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Name | Yes | Yes |  |
PenSize | Yes |  |  |
PenStyle | Yes |  |  |
TabIndex | Yes |  |  |
Top | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Group Box Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes |  | Yes |
BackColor | Yes | Yes | Yes |
Caption | Yes | Yes |  |
ClientEdge | Yes |  | Yes |
Enabled | Yes | Yes |  |
FontBold | Yes | Yes (but not for a panel) | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
ForeColor | Yes | Yes | Yes |
Group | Yes | Yes |  | At runtime, must be a child control.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
Locked | Yes |  | Yes |
ModalFrame | Yes |  | Yes |
Name | Yes | Yes (but not for a panel) | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |


Line Shape Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
BackBrushHatch | Yes |  |  |
BackBrushStyle | Yes |  |  |
BackColor | Yes |  |  |
Fill | Yes |  |  |
ForeColor | Yes |  |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Name | Yes | Yes |  |
PenSize | Yes |  |  |
PenStyle | Yes |  |  |
TabIndex | Yes |  |  |
Top | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


List Box Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes |  | Yes |
BackColor | Yes | Yes | Yes |
Border | Yes |  | Yes |
ClientEdge | Yes |  | Yes |
ColumnWidth | Yes |  |  |
Count |  | Yes |  | Can be retrieved, but not set at runtime.
CurData | Yes |  |  |
CurSel |  | Yes |  |
Data | Yes |  |  |
DataCount | Yes |  |  |
DataLoad | Yes |  |  |
DataSelect | Yes |  |  |
DisableNoScroll | Yes |  |  |
Enabled | Yes | Yes |  |
ExtendedSel | Yes |  |  |
FontBold | Yes | Yes (but not for a panel) | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
ForeColor | Yes | Yes | Yes |
Group | Yes | Yes |  | At runtime, must be a child control having the windows style, WS_CHILD.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
LeftScrollBar | Yes |  |  |
Locked | Yes |  | Yes |
ModalFrame | Yes |  | Yes |
MultipleSel | Yes |  |  |
Name | Yes | Yes (but not for a panel) | Yes |
NoIntegralHeight | Yes |  | Yes |
NoRedraw | Yes |  |  |
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
ScrollBar | Yes |  | Yes |
SelText |  | Yes |  | Can be retrieved, but not set at runtime
Sort | Yes |  |  |
Standard | Yes |  |  |
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control
TabStops | Yes |  |  |
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
UseTabStops | Yes |  |  |
Visible | Yes | Yes |  |
WantKeyboard | Yes |  |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels list box field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Beep |  |  | Yes |
BorderAttr |  |  | Yes |
ChoiceHelp |  |  | Yes |
ChoicesToDisplay |  |  | Yes |
ChoicesToStore |  |  | Yes |
ChoiceValue |  |  | Yes |
ChoiceWidth |  |  | Yes |
Column |  |  | Yes |
CurChoice |  |  | Yes |
DisabledAttr |  |  | Yes |
DropDown |  |  | Yes |
DoubleClick |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
Line |  |  | Yes |
PromptText |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
StaticChoices |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |


Month Calendar Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
ClientEdge | Yes |  |  |
Date |  | Yes |  |
DayState |  | Yes |  | Can be set, but not retrieved, at runtime.
Enabled | Yes | Yes |  |
FirstDayOfWeek | Yes | Yes |  |
FontBold | Yes | Yes |  |
FontItalic | Yes | Yes |  |
FontName | Yes | Yes |  |
FontSize | Yes | Yes |  |
FontStrikethru | Yes | Yes |  |
FontUnderline | Yes | Yes |  |
Group | Yes | Yes |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
LeftScrollBar | Yes |  |  |
Locked | Yes |  |  |
MaxSelCount | Yes | Yes |  |
MCColor | Yes |  |  |
MCColorIndex | Yes |  |  |
ModalFrame | Yes | Yes |  |
MonthDelta | Yes | Yes |  |
MonthRangeDayState |  | Yes |  | Can be retrieved, but not set, at runtime.
MonthRangeVisible |  | Yes |  | Can be retrieved, but not set, at runtime.
MultiSelect | Yes |  |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
NoToday | Yes |  |  |
NoTodayCircle | Yes |  |  |
Range |  | Yes |  |
RightAlignedText | Yes |  |  |
RightToLeftReading | Yes |  |  |
SelRange |  | Yes |  |
StaticEdge | Yes |  |  |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
Today |  | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes |  |
Transparent | Yes |  |  |
Visible | Yes | Yes |  |
WeekNumbers | Yes |  |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Option Button Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes |  | Yes |
Accelerator | Yes |  | Yes |
Alignment | Yes | Yes |  |
AutoPress | Yes | Yes |  |
BackColor | Yes | Yes | Yes |
Caption | Yes | Yes |  |
ClientEdge | Yes |  | Yes |
Enabled | Yes | Yes |  |
FontBold | Yes | Yes (but not for a panel) | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
ForeColor | Yes | Yes | Yes |
Group | Yes | Yes |  | At runtime, must be a child control.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
Locked | Yes |  | Yes |
ModalFrame | Yes |  | Yes |
Name | Yes | Yes (but not for a panel) | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
Value | Yes | Yes |  |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels option box field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Beep |  |  | Yes |
Column |  |  | Yes |
DataItemName |  |  | Yes |
DataSigned |  |  | Yes |
DataSize |  |  | Yes |
DataValue |  |  | Yes |
DecimalDigits |  |  | Yes |
DefaultToPressed |  |  | Yes |
DisabledAttr |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
IntegerDigits |  |  | Yes |
Line |  |  | Yes |
MnemonicAttr |  |  | Yes |
NumericData |  |  | Yes |
PromptText |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Title |  |  | Yes |


Progress Bar Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
ClientEdge | Yes |  |  |
Group | Yes | Yes |  |
Height | Yes | Yes |  |
Increment | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Maximum | Yes | Yes |  |
Minimum | Yes | Yes |  |
ModalFrame | Yes |  |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
RightAlignedText | Yes |  |  |
StaticEdge | Yes |  |  |
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes |  |
Value | Yes | Yes |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Rectangle Shape Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
BackBrushHatch | Yes |  |  |
BackBrushStyle | Yes |  |  |
BackColor | Yes |  |  |
Fill | Yes |  |  |
ForeColor | Yes |  |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Name | Yes | Yes |  |
PenSize | Yes |  |  |
PenStyle | Yes |  |  |
TabIndex | Yes |  |  |
Top | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Rounded Rectangle Shape Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
BackBrushHatch | Yes |  |  |
BackBrushStyle | Yes |  |  |
BackColor | Yes |  |  |
Fill | Yes |  |  |
ForeColor | Yes |  |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Name | Yes | Yes |  |
PenSize | Yes |  |  |
PenStyle | Yes |  |  |
RoundnessX | Yes |  |  |
RoundnessY | Yes |  |  |
TabIndex | Yes |  |  |
Top | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Scroll Bar Controls Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Enabled | Yes | Yes |  |
Group | Yes | Yes |  | At runtime, must be a child control.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
LineChange | Yes | Yes |  |
Locked | Yes |  | Yes |
Maximum | Yes | Yes |  |
Minimum | Yes | Yes |  |
Name | Yes | Yes (but not for a panel) | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
PageChange | Yes | Yes |  |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Value | Yes | Yes |  |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels scroll bar box field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Beep |  |  | Yes |
Border |  |  | Yes |
Column |  |  | Yes |
DefaultValue |  |  | Yes |
DisabledAttr |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
Line |  |  | Yes |
MaximumValue |  |  | Yes |
MinimumValue |  |  | Yes |
PageSize |  |  | Yes |
Size |  |  | Yes |
StepSize |  |  | Yes |
ThumbAttr |  |  | Yes |


Static Text Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D | Yes |  | Yes |
Alignment | Yes | Yes (but not for a panel) | Yes |
BackColor | Yes | Yes (but not for a panel) | Yes |
Caption | Yes | Yes (but not for a panel) | Yes |
ClientEdge | Yes |  | Yes |
Effect | Yes |  | Yes |
Enabled | Yes | Yes |  |
FontBold | Yes | Yes (but not for a panel) | Yes |
FontItalic | Yes | Yes (but not for a panel) | Yes |
FontName | Yes | Yes (but not for a panel) | Yes |
FontSize | Yes | Yes (but not for a panel) | Yes |
FontStrikethru | Yes | Yes (but not for a panel) | Yes |
FontUnderline | Yes | Yes (but not for a panel) | Yes |
ForeColor | Yes | Yes (but not for a panel) | Yes |
Group | Yes | Yes |  | At runtime, must be a child control having the windows style, WS_CHILD.
Height | Yes | Yes (but not for a panel) | Yes |
Left | Yes | Yes (but not for a panel) | Yes |
Locked | Yes |  | Yes |
ModalFrame | Yes |  | Yes |
Name | Yes | Yes (but not for a panel) | Yes |
NoPrefix | Yes |  | Yes |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
RightAlignedText | Yes |  | Yes |
RightToLeftReading | Yes |  | Yes |
StaticEdge | Yes |  | Yes |
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
Top | Yes | Yes (but not for a panel) | Yes |
Transparent | Yes |  | Yes |
Visible | Yes | Yes |  |
Width | Yes | Yes (but not for a panel) | Yes |
WordWrap | Yes |  | Yes |
Z-Order | Yes |  |  |

The following table details whether the properties (attributes) for an RM/Panels static text field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Beep |  |  | Yes |
Column |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
HelpMessage |  |  | Yes |
Length |  |  | Yes |
Line |  |  | Yes |
MinimumValue |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
StartOfGroup |  |  | Yes |


Status Bar Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
ClientEdge | Yes |  |  |
CurSection | Yes | Yes |  |
FontBold | Yes | Yes |  |
FontItalic | Yes | Yes |  |
FontName | Yes | Yes |  |
FontSize | Yes | Yes |  |
FontStrikethru | Yes | Yes |  |
FontUnderline | Yes | Yes |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
ModalFrame | Yes |  |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  |
RightAlignedText | Yes |  |  |
RightToLeftReading | Yes |  |  |
SectionNoBorders | Yes | Yes |  |
SectionPopOut | Yes | Yes |  |
SectionStatus | Yes | Yes |  |
SectionWidth | Yes | Yes |  |
Sections | Yes | Yes |  |
SimpleNoBorders | Yes | Yes |  |
SimplePopOut | Yes | Yes |  |
SimpleStatus | Yes | Yes |  |
StaticEdge | Yes |  |  |
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes |  |
Transparent | Yes |  |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Tab Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Accelerator | Yes |  |  |
Buttons | Yes |  |  |
ClientEdge | Yes |  |  |
CurTab | Yes | Yes |  |
FixedWidth | Yes |  |  |
FontBold | Yes | Yes |  |
FontItalic | Yes | Yes |  |
FontName | Yes | Yes |  |
FontSize | Yes | Yes |  |
FontStrikethru | Yes | Yes |  |
FontUnderline | Yes | Yes |  |
ForceLabelLeft | Yes |  |  |
GetFocus | Yes |  |  |
Group | Yes | Yes |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
ModalFrame | Yes | Yes |  |
MultiLine | Yes |  |  |
Name | Yes | Yes |  |
RaggedRight | Yes |  |  |
Right | Yes |  |  |
StaticEdge | Yes |  |  |
TabEnabled | Yes | Yes |  |
TabIndex | Yes |  |  |
Tabs | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
TabText | Yes | Yes |  |
Tag | Yes | Yes |  |
Top | Yes | Yes |  |
Vertical | Yes |  |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Timer Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Enabled | Yes | Yes |  |
Height | Yes | Yes |  |
Interval | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
Top | Yes | Yes |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Toolbar Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Accelerator | Yes |  |  |
AlignTop | Yes |  |  |
BitmapHeight | Yes |  |  |
BitmapWidth | Yes |  |  |
BtnBitmap | Yes |  |  |
BtnEnabled | Yes | Yes |  |
BtnHidden | Yes | Yes |  |
BtnState | Yes | Yes |  |
BtnStyle | Yes |  |  |
BtnText | Yes | Yes |  |
BtnToolTipEnabled | Yes | Yes |  |
BtnToolTipText | Yes | Yes |  |
BtnWrap | Yes |  |  |
ButtonHeight | Yes |  |  |
Buttons | Yes |  |  |
ButtonWidth | Yes |  |  |
ClientEdge | Yes |  |  |
CurButton | Yes | Yes |  |
FontBold | Yes | Yes |  |
FontItalic | Yes | Yes |  |
FontName | Yes | Yes |  |
FontSize | Yes | Yes |  |
FontStrikethru | Yes | Yes |  |
FontUnderline | Yes | Yes |  |
Height | Yes | Yes |  |
Larger | Yes |  |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
ModalFrame | Yes |  |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
RightAlignedText | Yes |  |  |
RightToLeftReading | Yes |  |  |
Rows | Yes |  |  |
StaticEdge | Yes |  |  |
TabIndex | Yes |  |  |
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes |  |
Transparent | Yes |  |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Wrapable | Yes |  |  |
Z-Order | Yes |  |  |


Trackbar Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
AutoTicks | Yes |  |  |
BothTicks | Yes |  |  |
ClientEdge | Yes |  |  |
Enabled | Yes | Yes |  |
EnableSelRange | Yes |  |  |
Group | Yes | Yes |  |
Height | Yes | Yes |  |
Left | Yes | Yes |  |
LeftTicks | Yes |  |  |
LineChange | Yes | Yes |  |
Locked | Yes |  |  |
Maximum | Yes | Yes |  |
Minimum | Yes | Yes |  |
ModalFrame | Yes |  |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
NoThumb | Yes |  |  |
NoTicks | Yes |  |  |
Page Change | Yes | Yes |  |
SelEnd | Yes | Yes |  | At runtime, the property name is SelectionEnd.
SelStart | Yes | Yes |  | At runtime, the property name is SelectionStart.
StaticEdge | Yes |  |  |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
TickFreq | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes |  |
TopTicks | Yes |  |  |
Value | Yes | Yes |  |
Vertical | Yes |  |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


Updown Control Object

See Also

The following table details whether the properties for this intrinsic control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
Accelerators | Yes |  |  |
AccelIncrement | Yes |  |  |
AccellSeconds | Yes |  |  |
AlignLeft | Yes |  |  |
AlignRight | Yes |  |  |
ArrowKeys | Yes |  |  |
Base | Yes | Yes |  |
Buddy | Yes | Yes |  |
BuddyInteger | Yes |  |  |
CurAccel | Yes |  |  |
Enabled | Yes | Yes |  |
Group | Yes | Yes |  |
Height | Yes | Yes |  |
Horizontal | Yes |  |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Maximum | Yes | Yes |  |
Minimum | Yes | Yes |  |
Name | Yes | Yes |  |
NoRedraw |  | Yes |  | Can be set, but not retrieved, at runtime.
NoThousands | Yes |  |  |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | At runtime, must be a child control.
Tag | Yes | Yes |  |
ToolTipEnabled | Yes | Yes |  |
ToolTipText | Yes | Yes |  |
Top | Yes | Yes |  |
Value | Yes | Yes |  |
Visible | Yes | Yes |  |
Width | Yes | Yes |  |
Wrapable | Yes |  |  |
Z-Order | Yes |  |  |


Date Edit Box Control Object

See Also

The following table details whether the properties for this RM/Panels field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D |  |  | Yes |
AlwaysDisabled |  |  | Yes |
AutoExit |  |  | Yes |
BackColor |  |  | Yes |
Beep |  |  | Yes |
BlankWhenZero |  |  | Yes |
Border |  |  | Yes |
Column |  |  | Yes |
DefaultToSystem |  |  | Yes |
DefaultValue |  |  | Yes |
DisabledAttr |  |  | Yes |
DisplayFormat |  |  | Yes |
DoubleClick |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForDisplay |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryFormat |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
FontBold |  |  | Yes |
FontItalic |  |  | Yes |
FontName |  |  | Yes |
FontSize |  |  | Yes |
FontStrikethru |  |  | Yes |
FontUnderline |  |  | Yes |
ForeColor |  |  | Yes |
Height |  |  | Yes |
HelpMessage |  |  | Yes |
Left |  |  | Yes |
Length |  |  | Yes |
Line |  |  | Yes |
Name |  |  | Yes |
OccColOffset |  |  | Yes |
OccLineOffset |  |  | Yes |
Occurrences |  |  | Yes |
OccXOffset |  |  | Yes |
OccYOffset |  |  | Yes |
PromptText |  |  | Yes |
Protected |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
StorageFormat |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Top |  |  | Yes |
Update |  |  | Yes |
Validation |  |  | Yes |
Width |  |  | Yes |


Multi-Line Edit Box Control Object

See Also

The following table details whether the properties for this RM/Panels field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D |  |  | Yes |
BackColor |  |  | Yes |
Beep |  |  | Yes |
Border |  |  | Yes |
Case |  |  | Yes |
ColsToDisplay |  |  | Yes |
ColsToStore |  |  | Yes |
Column |  |  | Yes |
DefaultValue |  |  | Yes |
DisabledAttr |  |  | Yes |
DoubleClick |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
FontBold |  |  | Yes |
FontItalic |  |  | Yes |
FontName |  |  | Yes |
FontSize |  |  | Yes |
FontStrikethru |  |  | Yes |
FontUnderline |  |  | Yes |
ForeColor |  |  | Yes |
Height |  |  | Yes |
HelpMessage |  |  | Yes |
Left |  |  | Yes |
Length |  |  | Yes |
Line |  |  | Yes |
LinesToDisplay |  |  | Yes |
LinesToStore |  |  | Yes |
Name |  |  | Yes |
PromptText |  |  | Yes |
Protected |  |  | Yes |
Required |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
Stream |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Top |  |  | Yes |
Width |  |  | Yes |
Wrap |  |  | Yes |


Numeric Edit Box Control Object

See Also

The following table details whether the properties for this RM/Panels field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
3D |  |  | Yes |
AlwaysDisabled |  |  | Yes |
AssumeDecimal |  |  | Yes |
AutoExit |  |  | Yes |
BackColor |  |  | Yes |
Beep |  |  | Yes |
BlankWhenZero |  |  | Yes |
Border |  |  | Yes |
CalculatorEntry |  |  | Yes |
Column |  |  | Yes |
DecimalDigits |  |  | Yes |
DefaultValue |  |  | Yes |
DisabledAttr |  |  | Yes |
DisplayFormat |  |  | Yes |
DoubleClick |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForDisplay |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryFormat |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
FontBold |  |  | Yes |
FontItalic |  |  | Yes |
FontName |  |  | Yes |
FontSize |  |  | Yes |
FontStrikethru |  |  | Yes |
FontUnderline |  |  | Yes |
ForeColor |  |  | Yes |
Height |  |  | Yes |
HelpMessage |  |  | Yes |
IntegerDigits |  |  | Yes |
Left |  |  | Yes |
Length |  |  | Yes |
Line |  |  | Yes |
Name |  |  | Yes |
OccColOffset |  |  | Yes |
OccLineOffset |  |  | Yes |
Occurrences |  |  | Yes |
OccXOffset |  |  | Yes |
OccYOffset |  |  | Yes |
PromptText |  |  | Yes |
Protected |  |  | Yes |
SelectedAttr |  |  | Yes |
Signed |  |  | Yes |
StartOfGroup |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Top |  |  | Yes |
Update |  |  | Yes |
Validation |  |  | Yes |
Width |  |  | Yes |


Time Edit Box Control Object

See Also

The following table details whether the properties for this RM/Panels field/control can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
24HourFormat |  |  | Yes |
3D |  |  | Yes |
AlwaysDisabled |  |  | Yes |
AutoExit |  |  | Yes |
BackColor |  |  | Yes |
Beep |  |  | Yes |
BlankWhenZero |  |  | Yes |
Border |  |  | Yes |
Column |  |  | Yes |
DefaultToSystem |  |  | Yes |
DefaultValue |  |  | Yes |
DisabledAttr |  |  | Yes |
DisplayFormat |  |  | Yes |
DoubleClick |  |  | Yes |
EnabledAttr |  |  | Yes |
EnabledForDisplay |  |  | Yes |
EnabledForInput |  |  | Yes |
EntryFormat |  |  | Yes |
EntryOrder |  |  | Yes |
ErrorMessage |  |  | Yes |
FontBold |  |  | Yes |
FontItalic |  |  | Yes |
FontName |  |  | Yes |
FontSize |  |  | Yes |
FontStrikethru |  |  | Yes |
FontUnderline |  |  | Yes |
ForeColor |  |  | Yes |
Height |  |  | Yes |
HelpMessage |  |  | Yes |
Left |  |  | Yes |
Length |  |  | Yes |
Line |  |  | Yes |
Name |  |  | Yes |
OccColOffset |  |  | Yes |
OccLineOffset |  |  | Yes |
Occurrences |  |  | Yes |
OccXOffset |  |  | Yes |
OccYOffset |  |  | Yes |
PromptText |  |  | Yes |
Protected |  |  | Yes |
SelectedAttr |  |  | Yes |
StartOfGroup |  |  | Yes |
StorageFormat |  |  | Yes |
TimeOut |  |  | Yes |
TimeOutValue |  |  | Yes |
Top |  |  | Yes |
Update |  |  | Yes |
Validation |  |  | Yes |
Width |  |  | Yes |


ActiveX Control Object

See Also

The following table details whether the properties for ActiveX controls can be manipulated at design time, retrieved or set at runtime, or both.

Property Name | Manipulate at Design time? | Retrieve or Set at Runtime? | Manipulate with WOW Panel Designer? | Notes
About | Yes |  |  |
Accelerator | Yes |  |  |
AllowMultipleEvents | Yes |  |  |
Cancel | Yes | Yes |  |
Custom | Yes |  |  |
Default | Yes | Yes |  |
EnableKeyPress ForTabMode | Yes |  |  |
Group | Yes | Yes |  | Available only if control is visible at runtime.
Height | Yes | Yes |  |
Left | Yes | Yes |  |
Locked | Yes |  |  |
Name | Yes | Yes |  |
NewDoMethod ArgumentPassing | Yes |  |  |
TabIndex | Yes |  |  |
TabStop | Yes | Yes |  | Available only if control is visible at runtime.
Tag | Yes |  |  |
Top | Yes | Yes |  |
Visible | Yes | Yes |  | Available only if control is visible at runtime.
Width | Yes | Yes |  |
Z-Order | Yes |  |  |


3D Common Panels Data Fields

The 3D property controls the appearance of a field/control. If this property is set to True, the field/control will have a three-dimensional effect.

The following table lists the possible values of the 3D property:

Value | Description
False | A three-dimensional field/control is not displayed (the default).
True | A three-dimensional field/control is displayed.

Note The panel/form 3D property settings of 1 (All 3D) and 2 (No 3D) will override the 3D property settings of individual controls. See Properties for RM/Panels Panels.


3D Property

The 3D property is a design-time-only property that controls the appearance of a control. If this property is set to True, the control will have a three-dimensional effect.

The following table lists the possible values of the 3D property:

Value | Description
False | A three-dimensional control is not displayed (the default).
True | A three-dimensional control is displayed.

Note Setting the 3D property to True for the check box and option button controls is compatible only if the Alignment property for these particular controls is set to the default. (The default setting displays text to the right of the check box or option button, respectively.)

The 3D property is not available for the command button control because the three-dimensional effect is already implemented by Windows. Windows always displays check box and option button controls in 3D, regardless of the property settings.

The form 3D property settings of 1 (All 3D) and 2 (No 3D) will override the 3D property settings of individual controls.


3D Property Form

The 3D property is a design-time-only property that controls the three-dimensional appearance of intrinsic controls in a form.

The following table lists the possible values of the 3D property:

Value | Description
0 | Mixed. Allows two-dimensional and three-dimensional settings of individual intrinsic controls in a form (the default).
1 | All 3D. Forces all intrinsic controls to a three-dimensional appearance.
2 | No 3D. Forces all intrinsic controls to a two-dimensional appearance.

Note The form 3D property settings of 1 (All 3D) or 2 (No 3D) will override the 3D property settings of individual controls.


3D Property Panel

The 3D property controls the three-dimensional appearance of fields/controls in a panel/form.

The following table lists the possible values of the 3D property:

Value | Description
0 | Mixed. Allows two-dimensional and three-dimensional settings of individual fields/controls in a panel/form (the default).
1 | All 3D. Forces all fields/controls to a three-dimensional appearance.
2 | No 3D. Forces all fields/controls to a two-dimensional appearance.

Note The form 3D property settings of 1 (All 3D) or 2 (No 3D) will override the 3D property settings of individual fields/controls.


24HourFormat

The 24HourFormat property specifies whether the field/control displays information in 12-hour or 24-hour format.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the 24HourFormat property:

Value | Description
False | Time is not displayed in 24-hour format, but rather in 12-hour format (the default).
True | Time is displayed in 24-hour format.


About Property ActiveX

The About property provides access to the ActiveX control’s About box (assuming it has one). When you click on the value area of the property in the Properties dialog box, an ellipsis appears. Clicking on the ellipsis opens the About box for the ActiveX control.

Note In the Properties dialog box, the About property will appear enclosed by parentheses (About) so that it will be sorted to the top of the alphabetical listing of properties.


Accelerator

Accelerators, sometimes known as shortcut keys, enable users to access a menu command from the keyboard by pressing a key or key combination. The Accelerator list box displays a drop-down list of key combinations that may be used to assign accelerator keys to access pulldown menu commands. (For more information, click here.)

In order for the accelerator to appear next to the pulldown menu item, you must type the accelerator key sequence selected from the list box following the text you entered in the Title box. It is also possible to place a tab character in the pulldown menu item to align the text that describes the accelerator key sequence. For example, if you select Alt+o in the Accelerator list box, you will type Open\tAlt+o in the Title box.

Note This should be done only for pulldown menu items, not for top-level titles. Only one tab character should be added to a menu item.


Accelerator Common Panels Data Fields

The Accelerator property specifies the accelerator key to be associated with this field/control. The value is an RM/COBOL termination code in the range 1 - 98. Pressing a key that generates this value while operating the panel is equivalent to pressing the field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Accelerator Property

The Accelerator property is a design-time-only property that determines what key, if any, should simulate the pressing of the command button, check box, option button, or tab control. This property cannot be modified or retrieved at runtime. An accelerator key is defined for the control by selecting one of the available keys for the Accelerator property listed in the Properties dialog box and shown in the following table. You should include the name of the accelerator key in the caption of the control so that the user knows it is available.

Note Wow Extensions automatically creates an Accelerator property if you use an ampersand (&) in a caption for the command button, check box, option button, or tab control. The accelerator will be "Alt + " the character following the '&'. You may override this automatic accelerator. If you remove the '&' character, the accelerator will not be deleted.

Note that for the tab control, this value also can be changed using the Tab Accelerator list box on the Tab Control Editor dialog box.

The following table lists the possible values of the Accelerator property:

Value | Description
Alt + alphabetic character | The accelerator is the Alternate key plus the first letter of the Caption property value (the default).
Ctrl + alphabetic character | The accelerator is the Control key plus any character of the alphabet.
F1 - F12 | The accelerator is a function key.
Ctrl + F1 - F12 | The accelerator is the Control key plus a function key.
Shift + F1 - F12 | The accelerator is the Shift key plus a function key.
Ctrl + Shift + F1 - F12 | The accelerator is the Control key plus the Shift key plus a function key.
Ctrl + Ins | The accelerator is the Control key plus the Insert key.
Shift + Ins | The accelerator is the Shift key plus the Insert key.
Shift + Del | The accelerator is the Shift key plus the Delete key.
Alt + Bksp | The accelerator is the Alternate key plus the Backspace key.
Del | The accelerator is the Delete key.
Escape | The accelerator is the Escape key.


Accelerator Property ActiveX

The Accelerator property determines, at runtime, what key, if any, should simulate an ActiveX Click event. An accelerator key is defined for the ActiveX control by selecting one of the available keys for the Accelerator property listed in the Properties dialog box and shown in the following table.

The following table lists the possible values of the Accelerator property:

Value | Description
Alt + alphabetic character | The accelerator is the Alternate key plus any character of the alphabet (the default).
Ctrl + alphabetic character | The accelerator is the Control key plus any character of the alphabet.
F1 - F12 | The accelerator is a function key.
Ctrl + F1 - F12 | The accelerator is the Control key plus a function key.
Shift + F1 - F12 | The accelerator is the Shift key plus a function key.
Ctrl + Shift + F1 - F12 | The accelerator is the Control key plus the Shift key plus a function key.
Ctrl + Ins | The accelerator is the Control key plus the Insert key.
Shift + Ins | The accelerator is the Shift key plus the Insert key.
Shift + Del | The accelerator is the Shift key plus the Delete key.
Alt + Bksp | The accelerator is the Alternate key plus the Backspace key.
Del | The accelerator is the Delete key.
Escape | The accelerator is the Escape key.


Accelerators Property

The Accelerators property is a design-time-only property that determines the rate at which the current position changes when the Up Arrow key or Down Arrow key is clicked.


AccelIncrement Property

The AccelIncrement property is a design-time-only property that specifies the position change increment to use after the time specified by the AccelSeconds property elapses. The value of the CurAccel property determines which accelerator is affected.


AccelSeconds Property

The AccelSeconds property is a design-time-only property that specifies the amount of elapsed time, in seconds, before the position change increment specified by the AccelIncrement property is used. The value of the CurAccel property determines which accelerator is affected.


Accept Changes

The Accept Changes command button accepts the external editing changes made to the code.


Activate Event Form

The Activate event occurs whenever the form becomes active or inactive.


ActiveX Control Events See Also

ActiveX Control Limitations

ActiveX Control Methods

ActiveX Control Properties

Process ActiveX Control Event Arguments


ActiveX Control Limitations See Also

Adding ActiveX Controls to the WOW Designer


ActiveX Control Methods See Also

ActiveX Control Events

ActiveX Control Limitations

ActiveX Control Properties


ActiveX Control Object See Also

Property Manipulation Checklist


ActiveX Control Properties See Also

ActiveX Control Events

ActiveX Control Limitations

ActiveX Control Methods


ActiveX Enum Generation

The check boxes in the ActiveX Enum Generation group of the New Project Options area allow you to control the generation of constants that can be used when writing code for ActiveX properties, methods, and events. All options are enabled by default.

· Generate Form Level causes 88-level condition-names for the ActiveX control to be generated at the form level in the Working-Storage section.

· Generate Control Level causes 78-level condition-names for the ActiveX control to be generated at the control level in the Working-Storage section.

· Generate Event Level causes 78-level condition-names for the ActiveX control to be generated at the event level in the Working-Storage section.


ActiveX Enum Generation (Project Options)

The group of check boxes in the ActiveX Enum Generation area allows you to control the generation of constants that can be used when writing code for ActiveX properties, methods, and events. All options are selected by default.

· Checking the Generate Form Level check box causes 88-level condition-names for the ActiveX control to be generated at the form level in the Working Storage section.

· Checking the Generate Control Level check box causes 78-level condition-names for the ActiveX control to be generated at the control level in the Working Storage section.

· Checking the Generate Event Level check box causes 78-level condition-names for the ActiveX control to be generated at the event level in the Working Storage section.

Note Selecting these options allow you to specify different values for the project than the ones initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.


ActiveX Methods Dialog Box See Also

ActiveX Control Methods

Adding ActiveX Controls to the WOW Designer


ActiveXs

The ActiveXs list box displays the name(s) of the ActiveX control(s) on the current form. Click the arrow to the right of the box to select a control name from the list.

Note When you select an ActiveX control in the form, the ActiveX Methods dialog box displays all of the methods that are available for that control. If you click on another ActiveX control, the methods for that control are displayed.


Add All Project Properties

No longer valid. Not used.


Add Button (Customize Toolbar)

The Add command button moves the button selected in the Available toolbar buttons area to the Current toolbar buttons area.


Add (CustTool)

The Add command button moves the selected tool in the Available Tools area to the Current Tools area.


Add (Edit Bookmark)

The Add command button adds the bookmark specified in the Name list box.


Adding ActiveX Controls to the WOW Designer See Also

ActiveX Control Events

ActiveX Control Limitations

ActiveX Control Methods

ActiveX Control Properties

Distribution Issues

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Add Project Properties

The Add command button adds one or more existing form file(s) to the current project. The file(s) must be selected from those appearing in the List area.


Addressing Issues in Data Entry Programs See Also

Developing Event-Driven Applications

Looking Behind the Scenes

Using WOW Projects

Working with Menus

WOW Extensions Development Process


Align Controls

When you have placed all the controls you need on a form, you can arrange or move them to make the form more balanced and organized. You move a control on a form by selecting and dragging it with the mouse. Rather than moving every control individually, you can use the Align command.

Under the default settings, WOW Extensions arranges each control relative to the first control you select when you align a group of selected controls. In other words, the first control you select is used as a guide to which the other controls are aligned. (Think of this first control as your primary selection.) The first control selected maintains its position; all others move to align with this control. The default setting for this option is configurable in the Alignment Preferences page of the Preferences dialog box.

To align controls relative to the first control (the primary selection), select the control that you want to align other controls to. Hold down the Shift key and select subsequent controls with the left mouse button. (You can also select the controls you want to align by choosing the Select All command on the Edit menu.) Then choose the Align command, which presents two submenus where you can choose options for aligning selected controls horizontally or vertically.


Aligning submenu

Horizontal and Vertical Align Submenu


Aligning Toolbar Align Bottoms

Align Bottoms (Aligning and Layout toolbars)

Use the Align Bottoms button to align the bottom edge of each selected control with the bottom edge of the primary selection.

This button corresponds to the Bottoms option from the Align command’s Horizontal submenu on the Control menu.


Aligning Toolbar Align Centers

Align Centers (Aligning and Layout toolbars)

Use the Align Centers button to align the vertical (up/down) center of each selected control with the vertical center of the primary selection.

This button corresponds to the Centers option from the Align command’s Vertical submenu on the Control menu.


Aligning Toolbar Align Lefts

Align Lefts (Aligning and Layout toolbars)

Use the Align Lefts button to align the left side of each selection with the left side of the primary selection.

This button corresponds to the Lefts option from the Align command’s Vertical submenu on the Control menu.


Aligning Toolbar Align Middles

Align Middles (Aligning and Layout toolbars)

Use the Align Middles button to align the horizontal (left/right) center of each selected control with the horizontal center of the primary selection.

This button corresponds to the Middles option from the Align command’s Horizontal submenu on the Control menu.


Aligning Toolbar Align Rights

Align Rights (Aligning and Layout Toolbar)

Use the Alight Rights button to align the right side of each selection with the right side of the primary selection.

This button corresponds to the Rights option from the Align command’s Vertical submenu on the Control menu.


Aligning Toolbar Align Tops

Align Tops (Aligning and Layout toolbars)

Use the Align Tops button to align the top edge of each selected control with the top edge of the primary selection.

This button corresponds to the Tops option from the Align command’s Horizontal submenu on the Control menu.


AlignLeft Property

The AlignLeft property is a design-time-only property that determines whether the updown control is aligned with the left edge of its buddy window. The width of the buddy window is decreased to accommodate the width of the updown control.

The following table lists the possible values of the AlignLeft property:

Value | Description
False | The updown control is not aligned with the left edge of its buddy window (the default).
True | The updown control is aligned with the left edge of its buddy window.


Alignment

This pair of option buttons determines how the Align command on the Control menu aligns selected controls horizontally and vertically relative to each other on a form.

· The Use First Control option button aligns controls relative to the first control selected. This option is enabled by default.

· The Use Average Control option button aligns controls based on the average size and position of the selected controls.


Alignment Preferences See Also

Manipulating Controls in a Form

Setting Preferences


Alignment Property CKBX

The Alignment property controls the position of the text in a check box control. By default, the caption of a check box displays to the right of the box. The text may be moved to the left of the box with the Alignment property. When using the 3D property, however, the text must always be on the right.

This property can be set and retrieved either at design time or at runtime.

The following table lists the possible values of the Alignment property:

Value | Description
0 | Displays text to the right of the check box (the default).
1 | Displays text to the left of the check box.


Alignment Property Edit

The Alignment property determines how text is positioned in an edit box control.

This property can be retrieved either at design time or at runtime. It cannot, however, be set at runtime.

Note The Alignment property has an affect only when the MultiLine property has a value of True.

The following table lists the possible values of the Alignment property:

Value | Description
0 | Normal. Performs no justification (the default).
1 | Left justifies all text.
2 | Center justifies all text.
3 | Right justifies all text.


Alignment Property Option

The Alignment property controls the position of the text in an option button control.

By default, the caption of an option button displays to the right of the box. The text may be moved to the left of the button with the Alignment property. When using the 3D property, however, the caption must be on the right.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Alignment property:

Value | Description
False | Displays text to the right of the option button (the default).
True | Displays text to the left of the option button.


Alignment Property STEXT

The Alignment property determines how text is positioned in a static text control. The Alignment property allows the text of any static text control, not just multi-line controls, to be aligned to the right, left, or center of the control.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Alignment property:

Value | Description
0 | Normal. Performs no justification (the default).
1 | Left justifies text.
2 | Centers text.
3 | Right justifies text.


AlignRight Property

The AlignRight property is a design-time-only property that determines whether the updown control is aligned with the right edge of its buddy window. The width of the buddy window is decreased to accommodate the width of the updown control.

The following table lists the possible values of the AlignRight property:

Value | Description
False | The updown control is not aligned with the right edge of its buddy window (the default).
True | The updown control is aligned with the right edge of its buddy window.


AlignTop Property

The AlignTop property is a design-time-only property that determines the placement of the toolbar on the form.

The following table lists the possible values of the AlignTop property:

Value | Description
False | Places the toolbar at the bottom of the form.
True | Places the toolbar at the top of the form (the default).


AllowEventFilter Property Form

The AllowEventFilter property is a design-time-only property that determines whether WOW Extensions performs filtering on events returned to the COBOL program.

WOW Extensions returns the messages generated by Windows to the COBOL program to be handled as events by the form and controls. Windows generates many messages, and in most cases, a small minority of these messages is actually acted upon by the COBOL program. To maximize performance, particularly in networked environments, WOW Extensions filters the messages (events) returned to the COBOL program. This can be done because the WOW Designer knows which events have code associated with them. If the AllowEventFilter property is set to True, this filtering is performed for the form and all controls on it.

In some cases, you may add code to your COBOL program that acts on additional messages. Since WOW Extensions is not aware of this code, it would filter out the associated messages and the code would never be invoked. To prevent this, set the AllowEventFilter property to False when adding additional message handling code directly to your programs.

Note The AllowEventFilter property can be overridden at runtime by selecting the Do Not Filter Events option on the Runtime Preferences page of the Preferences dialog box or by customizing the [WOWRT] section of the WOW runtime initialization file, wowrt.ini.

The following table lists the possible values of the AllowEventFilter property:

Value | Description
False | Filtering is not performed for the form and all controls on it.
True | Filtering is performed for the form and all controls on it (the default).


AllowMultipleEvents Property ActiveX

The AllowMultipleEvents property determines whether event code for an ActiveX control can be executed at the same time that another event is being processed. In order to prevent multiple events from occurring, the value for the AllowMultipleEvents property must be set to False and the wowrt.ini file option, EnableActiveXMultipleEventBlocking, must be set to True.

Note In the Properties dialog box, the AllowMultipleEvents property will appear enclosed by parentheses (AllowMultipleEvents) so that it will be sorted to the top of the alphabetical listing of properties.

The following table lists the possible values of the AllowMultipleEvents property:

Value | Description
False | Multiple events cannot occur at the same time.
True | Multiple events can occur at the same time (the default).


AlwaysDisabled

The Always Disabled property indicates that the field/control will never be enabled for input. In a GUI environment, this enables the field/control to be created as a static text control, rather than an edit box, which allows you to control the foreground color, rather than having Windows force a gray text color.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Animation Control Object See Also

Property Manipulation Checklist


Animation Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Animation File Property

The AnimationFile property specifies the name of the AVI file containing the animation to play in the control.

This property can be set and retrieved either at design time or at runtime.


Apply Changes and Add Tab After Current Tab (Tab Editor)

The Apply Changes and Add Tab After Current Tab command button allows you to apply any changes made in the dialog box and additionally allows you to insert a tab after the currently selected tab. The controls contained on that tab will be moved left or right, or deleted, depending on the merge options selected.


Apply Changes and Delete Current Tab (Tab Editor)

The Apply Changes and Delete Current Tab command button allows you to apply any changes made in the dialog box and additionally allows you to delete the currently selected tab. The controls contained on that tab will be moved left or right, or deleted, depending on the merge options selected.


Apply Changes and Insert Tab Before Current Tab (Tab Editor)

The Apply Changes and Insert Tab Before Current Tab command button allows you to apply any changes made in the dialog box and additionally allows you to insert a tab before the currently selected tab. The controls contained on that tab will be moved left or right, or deleted, depending on the merge options selected.


Apply Command Button (Preferences Dialog)

The Apply command button saves all the changes you have made on the specified page without closing the Preferences dialog box.


Apply (Panel Import Preferences)

The Apply command button saves all the changes you have made without closing the Panel Import Preferences dialog box.


Apply (Tab and Z Order Editor)

The Apply command button accepts all changes without closing the dialog box.


Apply (Tab Editor)

The Apply command button accepts all changes without closing the Tab Control Editor dialog box.


ArrowKeys Property

The ArrowKeys property is a design-time-only property that provides a keyboard interface for an updown control. If this property is set to True, the control processes the Up Arrow and Down Arrow keys. The control also subclasses the buddy window so that it can process these keys when the buddy window has the focus.

The following table lists the possible values of the ArrowKeys property:

Value | Description
False | The updown control does not process the Up Arrow and Down Arrow keys (the default).
True | The updown control processes the Up Arrow and Down Arrow keys.


AssumeDecimal

The AssumeDecimal property specifies that input to this field/control should be assumed to contain decimal digits even if no decimal is present.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the AssumeDecimal property:

Value | Description
False | A decimal is not assumed.
True | A decimal is assumed (the default).


At Application Activation

The At Application Activation area, which consists of a check box and three option buttons, controls how WOW Extensions behaves when you switch back to WOW Extensions after making external edits to a form that is already open in WOW Extensions. The options are as follows:

· The Prompt When Code Has Been Externally Edited check box, selected by default, displays a message box informing you that external changes may have occurred (file modification times do not match the times when WOW Extensions opened the file). This message box asks if you want WOW Extensions to look for these changes. If you answer No, WOW Extensions will ignore the external changes. If you answer Yes, the remaining options in this group control how WOW Extensions will behave when it finds the changes.

Note If you have selected the Do Not Use External Changes option in the At Form/Project Open group, WOW Extensions displays the External Edit Comparison dialog box, noting that a code section has been deleted when the form is opened or WOW Extensions is activated again).

· The Use External Changes option unconditionally uses any external edits without notifying you (except as indicated under the Prompt When Code Has Been Externally Edited option.

· The Do Not Use External Changes option causes no external edits to be used and you will not be notified.

· The Ask To Use External Changes option, selected by default, displays the External Edit Comparison dialog box, prompting you to accept or ignore the external changes. The dialog box displays both the original and edited code.


At Form/Project Open

The At Form/Project Open area, which contains a group of option buttons, controls how WOW Extensions behaves when a form is opened after it has been externally edited. The options are as follows:

· The Use External Changes option unconditionally uses any external edits without notifying you (except as indicated under the Prompt When Code Has Been Externally Edited option in the At Application Activation group).

· If you select the Do Not Use External Changes option, no external edits are used and you will not be notified.

· The Ask To Use External Changes option, selected by default, displays the External Edit Comparison dialog box, prompting you to accept or ignore the external changes. The dialog box displays both the original and edited code.


At Project Open

The At Project Open area allows you to specify which of your application’s forms you want WOW Extensions to display when a project opens. The At Project Open area contains three option buttons:

· Open all forms at project open. By default, WOW Extensions automatically opens all forms when a project opens.

· Open no forms at project open. No forms are displayed when the project opens at design time. To open a form, click Open Member on the Project menu or click Open Member [image] on the toolbar. The names of all the forms in the project are displayed in the list. Click any form(s) you want to open.

· Open showstate forms at project open. WOW Extensions automatically creates a form and shows it when the project is initially executed. Showstate forms are indicated by an asterisk (*) in the Members in Project area of the Project Properties dialog box.


AutoCheck Property

The AutoCheck property determines whether the state of a check box control is automatically changed when clicked.

This property can be set and retrieved either at design time or at runtime.

The following table lists the possible values of the AutoCheck property:

Value | Description
False | Check box will not automatically check or uncheck when clicked.
True | Check box will automatically check or uncheck when clicked (the default).


AutoExit

The AutoExit property indicates whether the input cursor should move to the next field/control if the current field/control has had input that is of maximum length, as specified by its Length property.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


AutoHScroll Property

The AutoHScroll property is a design-time-only property that indicates whether the edit portion of a combo box control will automatically scroll horizontally as text is entered. If the value of this property is set to 0, the user will not be allowed to enter more text than fits within the width of the control.

The following table lists the possible values of the AutoHScroll property:

Value | Description
False | Disables horizontal scrolling.
True | Enables horizontal scrolling of text when typed (the default).


AutoHScroll Property Edit

The AutoHScroll property indicates whether an edit box control will automatically scroll horizontally as text is entered. If the value of this property is set to False, the user will not be allowed to enter more text than fits within the width of the control.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the AutoHScroll property:

Value | Description
False | Disables horizontal scrolling.
True | Enables horizontal scrolling of text when typed (the default).


Auto Indent

When selected, the Auto Indent option causes the next line to be indented the same number of spaces as the current line when the Enter key is pressed. By default, the Auto Indent option is selected.


AutoPlay Property

The AutoPlay property is a design-time only property that determines when the animation will begin playing.

The following table lists the possible values of the AutoPlay property:

Value | Description
False | Causes the control to wait until it receives an ACM-PLAY message to begin playing (the default).
True | Causes the animation to begin playing as soon as the control is created (and an animation file is specified).


AutoPress Property

The AutoPress property determines whether the state of an option button control is automatically changed when pressed. This behavior is similar to the AutoCheck property of the check box control.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the AutoPress property:

Value | Description
False | Option button state will not automatically change when pressed.
True | Option button state will automatically change when pressed (the default).


AutoTicks Property

The AutoTicks property is a design-time-only property that determines whether the trackbar control has tick marks for each increment in its range of values.

The following table lists the possible values of the AutoTicks property:

Value | Description
False | The trackbar control does not have a tick mark for each increment in its range of values.
True | The trackbar control has a tick mark for each increment in its range of values (the default).


AutoVScroll Property

The AutoVScroll property determines whether an edit box control will scroll vertically as text is entered. If the value of AutoVScroll property is set to False, the user will not be allowed to enter more text than the control will display.

This property can be manipulated at design time and either retrieved or set at runtime.

Note The AutoVScroll property has an affect only when the MultiLine property has a value of True.

The following table lists the possible values of the AutoVScroll property:

Value | Description
False | Disables vertical scrolling of text when typed (the default).
True | Enables vertical scrolling of text when typed.


Available Toolbar Buttons

The Available toolbar buttons area displays the buttons that you can add to the toolbar.


Available Tools

The Available Tools area displays the tools that can be added to the Toolbox.


BackBrushHatch Property

The BackBrushHatch property is a design-time-only property that specifies the hatch style of the brush used to paint the interior of the geometric shape (ellipse, line, rectangle, or rounded rectangle control).

The following table lists the possible values of the BackBrushHatch property:

Value | Description
0 | Horizontal hatch.
1 | Vertical hatch.
2 | Forward diagonal (a 45-degree downward, left-to-right hatch).
3 | Backward diagonal (a 45-degree upward, left-to-right hatch).
4 | Horizontal and vertical cross-hatch (the default).
5 | 45-degree diagonal cross-hatch.


BackBrushStyle Property

The BackBrushStyle property is a design-time-only property that specifies the style of the brush used to paint the interior of the geometric shape (ellipse, line, rectangle, or rounded rectangle control).

The following table lists the possible values of the BackBrushStyle property:

Value | Description
0 | Solid brush.
1 | Hollow brush.
2 | Hatched brush.


BackColor Property

The BackColor property determines the background color of a control. The property is a numeric value with nine digits specifying colors as RRR,GGG,BBB.

In the RGB color model, valid red, green, and blue values are in the range from 0 through 255, with 0 indicating the minimum intensity and 255 indicating the maximum intensity. Set the BackColor property with any value in the range from 000 to 255255255.

When you click on the value area of the property, an ellipsis appears. Clicking on the ellipsis causes a variation of the standard Windows Color dialog box to open so that you can define the basic colors, custom colors, and system colors for the foreground color of the control(s).

Note This property can be manipulated at design time and either retrieved or set at runtime for most controls; however, this property cannot be set or retrieved at runtime for the ellipse, line, rectangle, and rounded rectangle shapes.


BackColor Property Form

The BackColor property determines the background color of a form. The property is a numeric value with nine digits specifying colors as RRR,GGG,BBB.

In the RGB color model, valid red, green, and blue values are in the range from 0 through 255, with 0 indicating the minimum intensity and 255 indicating the maximum intensity. Set the BackColor property with any value in the range from 000 to 255255255.

When you click on the value area of the property, an ellipsis appears. Clicking on the ellipsis causes a variation of the standard Windows Color dialog box to open so that you can define the basic colors, custom colors, and system colors for the foreground color of the form(s).

This property can be manipulated at design time and either retrieved or set at runtime.


BackgroundAttr

The BackgroundAttr property indicates the default attribute code for the background of the panel/form. Valid values are blank (the library default) or A through P.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Base Property

The Base property specifies the radix base for an updown control. The base value determines whether the buddy window displays numbers in decimal or hexadecimal digits. Hexadecimal numbers are always unsigned, and decimal numbers are signed.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Base property:

Value | Description
0 | The updown control’s buddy window displays numbers in decimal digits.
1 | The updown control’s buddy window displays numbers in hexadecimal digits.


Beep

The Beep property determines whether a beep should be sounded when this field/control has input focus.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the Beep property:

Value | Description
Default | The default set for the panel library applies to the field/control.
Yes | A beep sounds when the field/control has input focus, overriding any default set for the panel library.
No | No beep sounds when the field/control has input focus, overriding any default set for the panel library.


Benefits of WOW Thin Client See Also

Understanding WOW Thin Client

WOW Thin Client


Bitmap Control Object See Also

Property Manipulation Checklist


Bitmap Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


BitmapHeight Property

The BitmapHeight property is a design-time-only property that specifies the height of the bitmaps to be placed on the toolbar. This is not only the height at which bitmaps are displayed, but also the height of the bitmaps as they were created. All bitmaps placed in the toolbar must be the same size.


BitmapMode Panel

The BitmapMode property determines how the bitmap is displayed in a panel/form.

Note Single and double borders are identical when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll).

The following table lists the possible values of the BitmapMode property:

Value | Description
0 | Displays the bitmap in its original size (the default). If the bitmap is smaller than the panel, the remaining space is filled with the background color. If the bitmap is larger than the panel, only the portion of the bitmap that fits inside the panel is displayed.
1 | Stretches the bitmap to fit exactly within the panel. This may result in some distortion of the bitmap image, especially if the size difference between the bitmap and the panel is substantial.
2 | Tiles bitmap to fit the panel. If BitmapMode is set to Tile, the bitmap, if smaller than the panel, is displayed in a tiled pattern multiple times within the panel.


BitmapMode Property

The BitmapMode property determines how the bitmap is displayed in a control.

This property can be set and retrieved either at design time or at runtime.

The following table lists the possible values of the BitmapMode property:

Value | Description
0 | Displays the bitmap in its original size (the default). If the bitmap is smaller than the control, the remaining space is filled with the background color. If the bitmap is larger than the control, only the portion of the bitmap that fits inside the control is displayed.
1 | Scales bitmap to fit exactly within the control. This may result in some distortion of the bitmap image, especially if the size difference between the bitmap and the control is substantial.
2 | Tiles bitmap to fit the control. If BitmapMode is set to Tile, the bitmap, if smaller than the control, is displayed in a tiled pattern multiple times within the control.
3 | Sizes the control automatically to fit the specified bitmap exactly.

Note Changing the value of the BitmapMode property to 1, 2, or 3 at design time or runtime will set the values of the Xoffset and Yoffset properties to 0.


BitmapMode Property Form

The BitmapMode property determines how a bitmap is displayed in a form. Very rarely will the size of a form and bitmap match exactly. The bitmap can be displayed in its original size, which may not completely fill the form or may truncate part of the bitmap. The bitmap can also be scaled to match the exact size of the form. You can choose the most appropriate technique. Results will vary depending on the original size of the bitmap, the size of the form, and the nature of the bitmap.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the BitmapMode property:

Value | Description
0 | Displays the bitmap in its original size (the default). If the bitmap is smaller than the form, the bitmap will be displayed in the upper-left corner of the form, and the remainder of the form will be filled with the background color of the form. If the bitmap is larger than the form, only the portion of the bitmap that will fit in the form will be displayed.
1 | Scales the bitmap to fit the exact size of the form. This setting may distort the bitmap image, especially if the size difference between the bitmap and the form is substantial.
2 | Arranges (tiles) the bitmap in multiple images side by side on the form.


Bitmap Property

The Bitmap property specifies the bitmap image that is displayed on the control. (For a bitmap control, the BitmapMode property setting determines the bitmap’s appearance. If you set the Bitmap property for a form, the bitmap you select is displayed on the background of the form, behind any controls you have placed on the form.)

This property can be set and retrieved either at design time or at runtime.

Note The value of this property must be the complete name of a bitmap file. If a full pathname is specified or if the file is in the working directory, the file will be opened. If the file is not located, WOW Extensions will attempt to open the bitmap file using each of the directories specified in the RUNPATH environment variable. If the bitmap is not in the working directory or in a directory specified in the RUNPATH environment variable, a pathname is also required.


Bitmap Property Form

The Bitmap property specifies that a bitmap is displayed as the background of the form. The BitmapMode property setting determines the bitmap’s appearance. All controls on the form will be displayed on top of the bitmap.

This property can be manipulated at design time and either retrieved or set at runtime.

Note The value of this property must be the complete name of a bitmap file. If the bitmap is not in the working directory or in a directory specified in the RUNPATH environment variable, a pathname is also required.


BitmapWidth Property

The BitmapWidth property is a design-time-only property that specifies the width of the bitmaps to be placed on the toolbar. This is not only the width at which the bitmaps are displayed, but also the width of the bitmaps as they were created. All bitmaps placed in the toolbar must be the same width.


BlankWhenZero

The BlankWhenZero property causes the field/control to display as blank when the value of the field/control is zero.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Bookmark Display Area (Edit Bookmark)

The Bookmark Display Area displays the current bookmark in the Name list box.


Border

The Border property determines whether this field/control is to have a border when displayed.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the Border property:

Value | Description
False | A border is not displayed (the default).
True | A border is displayed.


BorderAttr Field

The BorderAttr property determines whether a border will be displayed around a list box or the list box portion of a combo box field/control. Valid values are blank (the library default) or A through P (as defined by the attribute code assigned to a block of text within a panel).

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


BorderAttr Panel

The BorderAttr property determines whether a border will be displayed around a panel/form if the Windowed property is set to True. Valid values are blank (the library default) or A through P.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Border Property

The Border property is a design-time only property that determines whether a border is displayed around the animation.

The following table lists the possible values of the Border property:

Value | Description
False | Does not display a border around the animation.
True | Displays a border around the animation (the default).


Border Property BMAP

The Border property is a design-time-only property that determines whether a border is displayed around the bitmap.

The following table lists the possible values of the Border property:

Value | Description
False | Does not display a border around the bitmap.
True | Displays a border around the bitmap (the default).


Border Property Edit

The Border property is a design-time-only property that determines whether a border is displayed around an edit box control.

The following table lists the possible values of the Border property:

Value | Description
False | A border is not displayed (the default).
True | A border is displayed.


Border Property Form

The Border property is a design-time-only property that determines whether the form displays a border.

The following table lists the possible values of the Border property:

Value | Description
0 | Form does not have a border.
1 | Form has a thin border.
2 | Form has a thick, sizable border (the default).
3 | Form has a thick, sizable, dialog-box-style border.


Border Property Lbox

The Border property is a design-time-only property that determines whether a border is displayed around a list box control.

The following table lists the possible values of the Border property:

Value | Description
False | A border is not displayed.
True | A border is displayed (the default).


BorderType

The BorderType property specifies the kind of border that will be displayed around the panel/form if the Windowed property is set to True.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the BorderType property:

Value | Description
S | Panel/form is bordered by a single line (the default).
D | Panel/form is bordered by a double line.
N | Panel/form has no border.


BothTicks Property

The BothTicks property is a design-time-only property that determines whether tick marks are displayed on both sides of the trackbar control.

The following table lists the possible values of the BothTicks property:

Value | Description
False | The trackbar control does not display tick marks on both sides of the control (the default).
True | The trackbar control displays tick marks on both sides of the control.


Bottom Event

The Bottom event occurs when the user interacts with trackbar control the using the End key.


BtnBitmap Property

The BtnBitmap property is an optional bitmap that will be displayed in the button. An example of such a bitmap is the scissors in the Cut button. This is a design-time-only property.


BtnEnabled Property

The BtnEnabled property controls whether the button can be clicked at runtime. WOW Extensions provides runtime support for the BtnEnabled property using WOWGETPROP and WOWSETPROP, which allows the enabled state of the toolbar button to be set or retrieved at runtime. Before getting or setting the BtnEnabled property value, the CurButton property must be set to the zero-based index of the desired button. Setting the CurButton property has no effect on the user interface.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the BtnEnabled property:

Value | Description
False | The toolbar button cannot be clicked at runtime.
True | The toolbar button can be clicked at runtime (the default).


BtnHidden Property

The BtnHidden property determines whether the button is displayed.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the BtnHidden property:

Value | Description
False | The toolbar button is displayed (the default).
True | The toolbar button is not displayed.


BtnState Property

The BtnState property determines the initial state of the button. WOW Extensions provides runtime support for the BtnState property using WOWGETPROP and WOWSETPROP, which allows the state of the toolbar button to be set or retrieved at runtime. Before getting or setting the BtnState property value, the CurButton property must be set to the zero-based index of the desired button. Setting the CurButton property has no effect on the user interface.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the BtnState property:

Value | Description
0 | Normal. The button accepts user input.
1 | Checked. The button is being clicked.
2 | Pressed. The button is being clicked.
3 | Indeterminate. The button is grayed.


BtnStyle Property

The BtnStyle property is a design-time-only property that determines the style of the button. The check style creates a button that stays pressed. Group and CheckGroup are normal and check buttons, respectively, that begin a group of buttons that work together. The Separator style creates a button that looks like a space between buttons and that cannot be pressed.

The following table lists the possible values of the BtnStyle property:

Value | Description
0 | Button. Creates a standard button.
1 | Check. Creates a dual-state push button that toggles between the pressed and nonpressed states each time the user clicks it. The button has a different background color when it is in the pressed state.
2 | Group. Creates a button that stays pressed until another button in the group is pressed.
3 | CheckGroup. Creates a button that stays pressed until another button in the group is pressed, similar to option buttons.
4 | Separator. Creates a separator, providing a small gap between button groups. A button that has this style does not receive user input.


BtnText Property

The BtnText property allows optional text to display on the button.

This property can be manipulated at design time and either retrieved or set at runtime.


BtnToolTipEnabled Property

The BtnToolTipEnabled property determines whether a tool tip will be displayed when the mouse hovers over an individual toolbar button. The text of the tool tip is specified by the BtnToolTipText property.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the BtnToolTipEnabled property:

Value | Description
False | Disable tool tip for this toolbar button (the default).
True | Enable tool tip for this toolbar button.


BtnToolTipText Property

The BtnToolTipText property contains the tool tip text that is displayed for an individual toolbar button if the BtnToolTipEnabled property is set to True.

Set the value of the BtnToolTipText property with any COBOL data item.

This property can be manipulated at design time and either retrieved or set at runtime.


BtnWrap Property

The BtnWrap property is a design-time-only property that will allow the toolbar to wrap to the next line after the current button. Wrapping is also done at separators, but will not be done within a group.

The following table lists the possible values of the BtnWrap property:

Value | Description
False | The toolbar is wrapped (the default).
True | The toolbar is not wrapped.


BuddyInteger Property

The BuddyInteger property is a design-time-only property that causes the updown control to set the text of the buddy window (using the WM-SETTEXT message) when the position changes. The text consists of the position formatted as a decimal or hexadecimal string.

The following table lists the possible values of the BuddyInteger property:

Value | Description
False | The text of the buddy window is not set when its position changes.
True | The text of the buddy window is set when its position changes (the default).


Buddy Property

The Buddy property specifies the name of the buddy window for an updown control. If no buddy window is specified, the value <None> will display in the Properties dialog box for the updown control.

This property can be manipulated at design time and either retrieved or set at runtime.


ButtonHeight Property

The ButtonHeight property is a design-time-only property that determines the displayed height of the buttons. If this value is set less than the height required by the button’s bitmap or text, this value will be ignored.


Button-n Event

The Button-n event indicates that the user clicked on the button on the toolbar specified by n. Each button on the toolbar control is identified by a number, with 0 indicating the first button, 1 indicating the second button, and so forth.


Buttons Property Tab

The Buttons property is a design-time-only property that controls the way the tabs are displayed. Setting its value to True makes tabs appear as buttons. This implies that the application should take immediate action when one of the buttons is pressed. Note that this property also can be changed using the Buttons check box in the Tab Control Editor dialog box.

The following table lists the possible values of the Buttons property:

Value | Description
False | Causes tabs to appear as tabs (the default).
True | Causes tabs to appear as buttons.


Buttons Property Toolbar

The Buttons property is a design-time-only property that determines the number of buttons on the toolbar.


ButtonWidth Property

The ButtonWidth property is a design-time-only property that determines the displayed width of the buttons. If this value is set less than the width required by the button’s bitmap or text, this value will be ignored.


CalculatorEntry

The CalculatorEntry property determines whether input to this field/control should be fully formatted while being input, with digits inserting to the left of the decimal point as with a calculator.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the CalculatorEntry property:

Value | Description
Default | The default set for the panel library applies to the field/control.
Yes | Input to the field/control is fully formatted while being input, overriding any default set for the panel library.
No | Input to the field/control is not fully formatted while being input, overriding any default set for the panel library.


Cancel (ActiveX)

The Cancel command button backs out of the Select ActiveX Controls dialog box by canceling all entries made within the dialog box.


Cancel Command Button (Preferences Dialog)

The Cancel command button closes the Preferences dialog box without saving any changes you have made to the settings.


Cancel (CustTool)

The Cancel command button closes the Customize Toolbox dialog box without accepting any changes.


Cancel (Panel Import Preferences)

The Cancel command button closes the Panel Import Preferences dialog box without saving any changes you have made to the settings.


Cancel Project Properties

No longer valid. Not used.


Cancel (ProjOpts)

The Cancel button backs out of the Project Options dialog box by canceling all entries made within the dialog box.


Cancel Property

The Cancel property indicates that a command button control should be pressed when the Escape key is pressed while input focus is anywhere on the form. Only one command button on a form should be set with the Cancel property.

This property can be set and retrieved either at design time or runtime.

The following table lists the possible values of the Cancel property:

Value | Description
False | Button is not a Cancel button (the default).
True | Button is a Cancel button.


Cancel Property ActiveX

The Cancel property indicates that an ActiveX control should be pressed when the Escape key is pressed while input focus is anywhere on the form. Only one ActiveX control (or command button) on a form should be set with the Cancel property.

Notes

· This property can be set and retrieved either at design time or runtime; however, at runtime, the name of the property is AXCancel.

· In the Properties dialog box, the Cancel property will appear enclosed by parentheses (Cancel) so that it will be sorted to the top of the alphabetical listing of properties.

· The Cancel property works only for an ActiveX control that supports the Click "stock event."

The following table lists the possible values of the Cancel property:

Value | Description
False | Control is not a Cancel button (the default).
True | Control is a Cancel button.


Cancel (Tab and Z Order Editor)

The Cancel button cancels all changes and closes the dialog box.


Cancel (Tab Editor)

The Cancel button cancels all changes and closes the Tab Control Editor dialog box.


Caption Property

The Caption property specifies the caption (or static text) associated with a control.

Set the value of the Caption property with any alphanumeric character, including space.

This property can be manipulated at design time and either retrieved or set at runtime.


Caption Property Form

The Caption property is a design-time-only property that determines whether a form has a title bar.

The following table lists the possible values of the Caption property:

Value | Description
False | Form does not have a title (the default).
True | Form has a title bar.


Case Property

The Case property determines the case conversion of alphabetic characters entered into an edit box control.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Case property:

Value | Description
0 | Mixed. Text case is not altered; accepted as typed (the default).
1 | Converts all text to lowercase.
2 | Converts all text to uppercase.


Case RMPanels

The Case property determines the case conversion of alphabetic characters entered into an edit box or multi-line edit box field/control.

The following table lists the possible values of the Case property:

Value | Description
0 | Mixed. Text case is not altered; accepted as typed (the default).
1 | Converts all text to lowercase.
2 | Converts all text to uppercase.


Categorized Tab View Properties dialog box

Categorized Tab - Properties Dialog Box


Centered Property Form

The Centered property is a design-time-only property that determines whether and how the form is centered on the screen display. When set to a value other than zero, this property value overrides the settings in the Top and Left properties.

The following table lists the possible values of the Centered property:

Value | Description
0 | None. The form is not centered on the screen display (the default).
1 | Horizontal. The form is centered horizontally on the screen display.
2 | Vertical. The form is centered vertically on the screen display.
3 | Both. The form is centered both horizontally and vertically on the screen display.


Centering Toolbar Center Horizontally

Center Horizontally (Centering and Layout toolbars)

Use the Center Horizontally button to align the controls horizontally with respect to the center of the form between the left and right borders of the form.

This button corresponds to the Horizontal option from the Center command submenu on the Control menu.


Centering Toolbar Center Vertically

Center Vertically (Centering and Layout toolbars)

Use the Center Vertically button to align the controls vertically with respect to the center of the form between the top and bottom borders.

This button corresponds to the Vertical option from the Center command submenu on the Control menu.


Center Property

The Center property is a design-time only property that determines whether the animation is centered in the control.

The following table lists the possible values of the Center property:

Value | Description
False | Does not center the animation (the default).
True | Centers the animation.


Change Description

The Change Description text box displays the type of change that was applied to the code fragment.


Change Event Date Time Picker

The Change event occurs when a change has occurred within the date time picker control.


Change Event Edit

The Change event occurs when the value of the text in an edit box control changes. Any of the following actions will cause this event to occur:

· A character is typed in the edit box control.

· The WOWSETPROP function is used to set the text.

· The edit box control is created with a text value assigned in the WOW Designer.


Change Event Month Calendar Control

The Change event occurs when a change has occurred within the month calendar control.


Check and Uncheck Menu Items See Also

Create a Menu


Check Box Control Object See Also

Property Manipulation Checklist


Check Box Control See Also

Group Box Control

Handling Different Types of Data

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Checked

The Checked check box allows you to display a check mark on a menu item at design time. Check marks are commonly used to indicate an on/off condition. Choosing the menu command alternately adds and removes the check mark. If a menu command is active, a check mark will appear next to the menu item. For more information about displaying a check mark on a menu item at runtime, click here.


CHECKMENUITEM

Menu Windows API Function

The CHECKMENUITEM function selects (places a check mark next to) or clears (removes a check mark from) a specified menu item in the given pop-up menu.

The ITEM-ID parameter may identify a pop-up menu item as well as a menu item. No special steps are required to select a pop-up menu item.

Top-level menu items cannot have a check.

A pop-up menu item should be selected by position since it does not have a menu-item identifier associated with it.

Calling Sequence

CALL CHECKMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

Note By first initializing the MENU-FLAGS parameter with the statement MOVE ALL 'N' TO MENU-FLAGS, all existing values are unset so that new values can be specified. For example:

MOVE ALL 'N' TO MENU-FLAGS.
SET MF-BYCOMMAND TO TRUE.
CALL CHECKMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

Parameter | Declaration | Description
WIN-RETURN | numeric | Specifies the previous state of the menu item (either MF-CHECKED or MF-UNCHECKED). If the menu item does not exist, the return value is -1.
MENU-H | PIC 9(10) BINARY(8) | The handle of the menu containing the item to be checked. If the item is a pop-up menu, MENU-H should be the handle of the pop-up menu, rather than the top-level menu.
ITEM-ID | numeric | Specifies the identifier of the menu item to be checked (selected or cleared).
MENU-FLAGS | windows.cpy | Specifies the action to take. This parameter can be MF-CHECKED or MF-UNCHECKED, combined with MF-BYCOMMAND or MF-BYPOSITION. These values have the following meanings. (For more information on using the MENU-FLAGS parameter to check or uncheck menu items, click here.
 | Value | Meaning
 | MF-BYCOMMAND | Specifies that the ITEM-ID parameter gives the menu-item identifier (MF-BYCOMMAND is the default).
 | MF-BYPOSITION | Specifies that the ITEM-ID parameter gives the position of the menu item (the first item is at position zero).
 | MF-CHECKED | Places a check mark next to the menu item. If the application has supplied check-mark bitmaps, setting this flag displays the bitmap next to the menu item.
 | MF-UNCHECKED | Does not place a check mark next to the menu item. No check mark is the default condition is neither MF-CHECKED nor MF-UNCHECKED is set.


ChoiceHelp

The ChoiceHelp property determines whether a help message is specified for a choice in a list box or the list box portion of a combo box field/control. For example, in a list box displaying country names, "America" might be the list box choice and USAHELP might be the name of the help message.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the ChoiceHelp property:

Value | Description
False | A help message is not displayed (the default).
True | A help message is displayed.


ChoicesToDisplay

The ChoicesToDisplay property specifies the number of choices to display in a list box or combo box field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ChoicesToStore

The ChoicesToStore property specifies the number of choices to be stored for a list box or the list box portion of a combo box field/control. If the value in the ChoicesToStore property is greater than the value in the ChoicesToDisplay property, a scroll bar is created automatically. If at runtime execution, the list box or combo box does not contain more choices than can be displayed at one time, the scroll bar is disabled. The scroll bar does not change attributes.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ChoiceValue

The ChoiceValue property specifies the initial value of a list box or the list box portion of a combo box field/control when it is displayed.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ChoiceWidth

The ChoiceWidth property specifies the width of the entry in characters and the size of the data item in a list box or the list box portion of a combo box field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Class

The Class property indicates the categories that RM/Panels allows for defining character sets. Valid values are blank or 1 - 5.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Clear All (ActiveX)

Use the Clear All command button to deselect controls from the Select the desired ActiveX controls list and remove them from the Toolbox. To deselect one or more controls in the list, press Ctrl and then click the cursor on the control or controls you wish to remove. The highlight is removed. Click the OK command button.

Note that if you click Clear All and click OK without deselecting a control or controls, and then click OK, all the controls will be removed from the Toolbox.


Click Event

The Click event occurs when the user clicks a mouse button on a control.


ClientEdge Property

The ClientEdge property is a design-time-only property that specifies that a control has a border with a sunken edge.

The following table lists the possible values of the ClientEdge property:

Value | Description
False | Control does not have a border with a sunken edge (the default).
True | Control has a border with a sunken edge.


CLIENTTOSCREEN

Window Windows API Function

The CLIENTTOSCREEN function converts the client coordinates of a given point on the screen-to-screen coordinates. The CLIENTTOSCREEN function replaces the coordinates in the POINT structure with the screen coordinates. The screen coordinates are relative to the upper-left corner of the screen.

Calling Sequence

CALL CLIENTTOSCREEN USING WND-H POINT.

Parameter | Declaration | Description
WND-H | PIC 9(10) BINARY(8) | The handle of the window whose client area is used for the conversion.
POINT | windows.cpy | A POINT structure that contains the client coordinates to be converted.


ClipControls Property Form

The ClipControls property is a design-time-only property that determines whether child controls can extend past the boundaries of a form.

The following table lists the possible values of the ClipControls property:

Value | Description
False | Child controls can extend outside the form (the default).
True | Child controls cannot extend outside the form.


ClipSiblings Property Form

The ClipSiblings property is a design-time-only property that clips child controls relative to each other; that is, when a particular control window receives a WM-PAINT message, this style clips all other top-level child controls out of the region of the child control to be updated. When drawing in the client area of a child control, if the ClipSiblings property is not specified and child controls overlap, it is possible to draw in the client area of a neighboring child control. This property is used only with the Style property when value 2 (the default), which designates the form as a child, is specified.

Note If you experience problems with a parent form bleeding into its child forms, the ClipSiblings property value should be set to True.

The following table lists the possible values of the ClipSiblings property:

Value | Description
False | Child controls are not clipped relative to each other (the default).
True | Child controls are clipped relative to each other.


Close (Customize Toolbar)

The Close command button closes the dialog box and saves the changes you have made.


Close (Edit Bookmark)

The Close command button closes the Edit Bookmarks dialog box.


Close Event Form

The Close event occurs when the form is destroyed.


Close (Go To Bookmark)

The Close command button closes the Go To Bookmarks dialog box.


Close Project Properties

The Close command button accepts the changes and closes the Project Properties dialog box. The changes take effect as soon as the dialog box closes.


COBOL Compiler

Use the COBOL Compiler area to specify directives for the RM/COBOL compiler.

· The RMPath text box allows you to set the RMPATH synonym used by the compiler to locate copy files.

· The Command Tail text box allows you to add additional compiler command-line arguments at the end of the command line. These options will be applied each time you compile any program from the WOW Designer.

· The OEM Compiler check box tells the WOW Designer whether to use the OEM or ANSI compiler to compile the project. This information allows the Designer to properly access the Windows registry to retrieve the RMPATH synonym, which is used to locate and search copy files used in the LINKAGE section of the project COBOL code. Deselecting this check box indicates that the compiler is using the ANSI code set for character data.


COBOL Debugger

Use the COBOL Debugger area to specify the location of the CodeWatch debugger’s installation directory.

The Directory text box allows you to specify the debugger’s installation directory, which must exist or be accessible when using CodeWatch from the WOW Designer. If you enter a value of %RM_PROGRAM_DIR%, the WOW Designer will use the value of the environment variable, RM_PROGRAM_DIR, as the location of the CodeWatch debugger. RM_PROGRAM_DIR is set during the installation of the RM/COBOL development system to point to the directory where the development system is installed. For more information on debugging, click here.


COBOL Runtime

Use the COBOL Runtime area to specify the location of the RM/COBOL runtime system.

· The Directory text box allows you to specify the runtime system’s installation directory, which must exist or be accessible when running the WOW application from the WOW Designer. If you enter a value of %RM_PROGRAM_DIR%, the WOW Designer will use the value of the environment variable, RM_PROGRAM_DIR, as the location of the runtime system. RM_PROGRAM_DIR is set during the installation of the RM/COBOL development system to point to the directory where the development system is installed.

· The Command Tail text box allows you to add additional runtime command-line arguments at the end of the command line. These options will be applied each time you run any program from the WOW Designer.


Code Edit, Find in Code, and Compiler Output Windows

Use the Code Edit, Find in Code, and Compiler Output Windows area to specify the default settings for the appearance of the application source code that is displayed in the Code Entry and Working Storage areas (collectively known as the "code edit" windows) of the Event-Handling Code dialog box, and on the Find in Code and Compiler Output tabs of the Project Output dialog bar as a result of a code search or a compilation.

· The Font and Sample option controls the appearance of the source code text in these windows. Click the ellipsis button (…) to display the standard Windows Font dialog box, which allows you to select the font settings for the text. Once you have determined these settings and closed the Font dialog box, your selections (font name, style, special effects, if any, and size) will appear in the Font and Sample text box.

· The Background Color option controls the default color used for the background of these windows displaying the application source code. Click the ellipsis button (…) to display the standard Windows Color dialog box, which allows you to change the default background color. Once you have determined this setting and closed the Color dialog box, the RGB (Red, Green, Blue) values for the color selection are displayed in the Background Color text box, and a sample of the color is shown in the sample display box.


Code Edit Windows Preferences See Also

Setting Preferences


Code entry

The Code Entry area is where you enter and edit your source code. When you select an event that is already coded, the code is displayed in this area. Depending on your configuration, the description and comment lines may be inserted in this area.

Note This area can be resized as necessary using a track bar located on the right-hand side of the form.


Code Fragment Name

The Code Fragment Name text box displays the name of the code fragment that was modified externally.


Code Preferences See Also

Project Options Dialog Box

Setting Preferences

Working with Menus


Code Templates

The Code Templates list displays categories of the available templates, also called shortcuts, for function calls and messages. You can expand and collapse the lists within each category by clicking the plus [+] or minus [-] icons next to an item. The categories include the following:

· WOW Functions lists templates available for functions specific to WOW Extensions. See the Functions and Messages online Help file for detailed information about each function. In the Help file, the WOW functions begin with the prefix of WOW.

Note In addition to listing the WOW functions, this item displays three subcategories: ActiveX Functions, Thin Client Functions, and RPC Functions. Each of these categories list templates available for functions specific to ActiveX controls, Thin Client applications, and the addition of RPC (Remote Procedure Calls) capabilities to the WOW Thin Client implementation, respectively. Again, the Functions and Messages online Help file provides detailed information about each function. In the Help file, the ActiveX functions begin with the prefix of AX. The Thin Client functions begin with the prefix of WOWThinClient.

· Windows API Functions lists templates available for functions specific to the Windows Application Programming Interface. This large set of Windows API functions is further categorized by how the functions are used: Character, Class, Device Context/GDI, Dialog, Font, Menu, Profile, Scroll Bar, System, and Window. See the Functions and Messages online Help file for detailed information about each function.

· Animation Control Shortcuts lists templates available for sending messages specific to animation controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, ACM-.

· Button Shortcuts lists templates available for sending messages specific to command button, check box, and option button controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, BM-.

· Combo Box Shortcuts lists templates available for sending messages specific to combo box controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, CB-.

· Edit Box Shortcuts lists templates available for sending messages specific to edit box controls. See the Functions and Messages online Help file for detailed information about each message. In the help file, these messages are preceded by the prefix, EM-.

· List Box Shortcuts lists templates available for sending messages specific to list box controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, LB-.

· Progress Bar Shortcuts lists templates available for sending messages specific to progress bar controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, PB-.

· Send Message Shortcuts lists templates available for sending messages commonly used by a variety of controls. See the Functions and Messages online Help file for detailed information about each message. In the Help file, these messages are preceded by the prefix, WM-.


Code Templates Tree Popup

The Code Templates tree lists all the available templates, also called shortcuts, for a function call or a message and provides different ways of viewing this information. WOW Extensions provides shortcuts for frequently-used messages so that it is easier to understand what the parameters are for a particular function or message. Each shortcut contains a brief description of the function or message, the calling sequence, and the parameter values.

The Code Templates tree is displayed by default in the WOW Designer window. To toggle the display of the Code Templates tree, click Code Templates on the View menu.


Code Templates Tree See Also

Code Preferences

Event-Handling Code Dialog Box

Functions and Messages


Collapse Tree

The Collapse Tree command button causes the list of functions and message shortcuts to collapse to the highest group in the tree. You can then click the plus [+] and minus [-] icons next to an item to expand or collapse the hierarchical list.


ColsToDisplay

The ColsToDisplay property specifies the number of columns to display for the field/control.

Note wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ColsToStore

The ColsToStore property specifies the number of columns to store for the field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Column

The Column property determines the number of columns that each occurrence of a field/control is offset from the previous occurrence. Valid values are 0 to the maximum width of the panel.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ColumnWidth Property

The ColumnWidth property is a design-time-only property that determines the width, in pixels, of the columns in a list box control with multiple columns. If you specify a non-zero value for the ColumnWidth property, the list box will display multiple columns.

Set the ColumnWidth property with any positive value greater than 0 but less than the value specified in the Width property for the list box control.


Combo Box Control Object See Also

Property Manipulation Checklist


Combo Box Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Command Button Control Object See Also

Property Manipulation Checklist


Command Button Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Command Ref Pointer Tool

Pointer Tool (Toolbox)

Use the Pointer tool to select the form or a control on the form, and to move and resize forms and controls. The Pointer tool is not a control.

When you select the Pointer in the Toolbox, it will appear highlighted. To select a form or control, select the Pointer tool and then move the pointer over the object, and click the form or control to select it. In the case of a selected control, handles will appear. To select multiple controls, hold down the Shift key while clicking on the other controls you want to select.


Common ActiveX Control Properties See Also

ActiveX Control Properties


Common Intrinsic Control Events See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Common Intrinsic Control Properties See Also

Dictating Order Entry for Controls

Handling Events for Controls, Forms, and Projects

Setting Properties for Controls and Forms


Communicating with RM/Panels See Also

Enhancing Existing RM/Panels Panel Libraries


Compiler Command Line Arguments

The Compiler Command Line Arguments option sets the RM/COBOL Compiler Command options for the project.

Note You can also set this configuration option on the Tools Preferences page of the Preferences dialog box.


Configuring Function Keys See Also

Communicating with RM/Panels

Enhancing Existing RM/Panels Panel Libraries

Modifying an Existing RM/Panels Panel Library

Properties for RM/Panels Data Fields

Properties for RM/Panels Panels

Restrictions

Using Global Default Property Settings


Configuring WOW Ext See Also

Debugging with WOW Extensions

WOW Designer

WOW Runtime System


Control Font

Use the Control Font area to establish the font settings (font name, style, special effects, if any, and size) for controls at design time and runtime, as well as viewing a sample of how text will appear with the specified font settings.

Use the ellipsis button (…), located next to the font sample box, to open the standard Windows Font dialog box to change the default font and sample font for the controls.


Control Menu Align Bottoms Popup

The Align Bottoms command aligns the bottom edge of each selected control with the bottom edge of the first (primary) control selected.


Control Menu Align Centers Vertical Popup

The Align Centers command aligns the vertical (up/down) center of each selected control with the vertical center of the first (primary) control selected.


Control Menu Align Command Ref

Align (Control menu)

Use this command to precisely align multiple controls at the same time. The Alignment Preferences page of the Preferences dialog box determines how the Align command aligns selected controls horizontally and vertically relative to each other on a form. WOW Extensions presents the horizontal and vertical alignment submenus where you can choose options for aligning selected controls horizontally or vertically.

Note Aligning controls moves them to the positions you specify. If you align controls and later change the size of the form, the controls do not move to reflect the new form dimensions.


Control Menu Align Lefts Vertical Popup

The Align Lefts command aligns the left side of each selected control with the left side of the first (primary) control selected.


Control Menu Align Middles Popup

The Align Middles command aligns the horizontal (left/right) center of each selected control with the horizontal center of the first (primary) control selected.


Control Menu Align Rights Vertical Popup

The Align Rights command aligns the right side of each selected control with the right side of the first (primary) control selected.


Control Menu Align Tops Horizontal Popup

The Align Tops command aligns the top edge of each selected control with the top edge of the first (primary) control selected.


Control Menu Background Command Ref

Background (Control menu)

Use this command to change the background (fill) color of one or more selected controls. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of the control(s). You cannot set the background color for a command button, or for the horizontal or vertical scroll bars.

Note You can also set the background color of a control from the selected control’s Properties dialog box. On the Properties dialog box, this property is called BackColor.


Control Menu Background Popup

The Background command changes the background (fill) color of one or more selected controls. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of the control(s). You cannot set the background color for a command button, or for the horizontal or vertical scroll bars.

Note You can also set the background color of a control from the selected control’s Properties dialog box. On the Properties dialog box, this property is called BackColor.


Control Menu Bring to Front Command Ref

Bring to Front (Control menu)

Use this command to move the selected control all the way to the front of the stack of controls.

Note The Bring to Front command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

Shortcuts

Toolbar: on the Layout toolbar

Keys: Ctrl+PageUp


Control Menu Bring to Front Popup

The Bring to Front command moves the selected control all the way to the front of the stack of controls. The Bring to Front command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).


Control Menu Center Command Ref

Center (Control menu)

Use this command to center selected controls on a form. Controls are centered relative to the form. When you choose this command, two options appear:

· Vertical. The Vertical option aligns the selected controls vertically with respect to the center of the form between the top and bottom borders.

· Horizontal. The Horizontal option aligns the selected controls horizontally with respect to the center of the form between the left and right borders of the form.


Control Menu Center Horizontal Popup

The Center Horizontal command aligns the selected controls horizontally with respect to the center of the form between the left and right borders of the form.


Control Menu Center Vertical Popup

The Center Vertical command aligns the selected controls vertically with respect to the center of the form between the top and bottom borders.


Control Menu Commands See Also

Dictating Order Entry for Controls

Manipulating Controls in a Form

Using Global Default Property Settings


Control Menu Drop Down Combo Box Command Ref

Drop Down Combo Box (Control menu)

Use this command to display the drop-down portion of the combo box control if the value of the Style property is either of these two values: 1 (Drop-down combo box) or 2 (Drop-down list box).

This command allows all of the pre-defined data entries to be visible in the drop-down list box during the design process and provides the capability to select one of the entries for display in the edit box portion of the combo box control. Once you select one entry or select another object or click anywhere else on the screen, which cause focus to be lost, the drop-down list box is removed.


Control Menu Drop Down Combo Box Popup

The Drop Down combo Box command displays the drop-down portion of the combo box control, which allows all of the pre-defined data entries to be visible in the drop-down list box during the design process and provides the capability to select one of the entries for display in the edit box portion of the combo box control.


Control Menu Edit Code Command Ref

Edit Code (Control menu)

Use this command to open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the selected control.

Shortcuts

Toolbar: on the View toolbar

Or, from the Project tree, select a control name, then right-click to display a pop-up menu. Choose Edit Code on the pop-up menu.

Or, double-click the selected control on the form.


Control Menu Edit Code Popup

The Edit Code command opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the selected control.


Control Menu Font Command Ref

Font (Control menu)

Use this command to change the font, style (such as bold and italic), size, underline, color, and font effects (such as strikeout and underline) for text displayed in one or more selected controls. This command also allows you to set new defaults. The standard Windows Font dialog box opens. You cannot set font settings for a form, or for the horizontal and vertical scroll bars.

Note You can also set the font characteristics of a control from the selected control’s associated Properties dialog box. On the Properties dialog box, these properties are called FontBold, FontItalic, FontName, FontSize, FontStrikethru, and FontUnderline.


Control Menu Font Popup

The Font command changes the font, style (such as bold and italic), size, underline, color, and font effects (such as strikeout and underline) for text displayed in one or more selected controls. This command also allows you to set new defaults. The standard Windows Font dialog box opens. You cannot set font settings for a form, or for the horizontal and vertical scroll bars.

Note You can also set the font characteristics of a control from the selected control’s associated Properties dialog box. On the Properties dialog box, these properties are called FontBold, FontItalic, FontName, FontSize, FontStrikethru, and FontUnderline.


Control Menu Foreground Command Ref

Foreground (Control menu)

Use this command to change the foreground color (that is, the line or text color) of one or more selected controls. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the foreground color of the control(s). You cannot set the foreground color for a command button, or for the horizontal or vertical scroll bars.

Note You can also set the foreground color of a control from the selected control’s Properties dialog box. On the Properties dialog box, this property is called ForeColor.


Control Menu Foreground Popup

The Foreground command changes the foreground color (that is, the line or text color) of one or more selected controls. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the foreground color of the control(s). You cannot set the foreground color for a command button, or for the horizontal or vertical scroll bars.

Note You can also set the foreground color of a control from the selected control’s Properties dialog box. On the Properties dialog box, this property is called ForeColor.


Control Menu Restore Properties From Global Defaults Command Ref

Restore Properties (Control menu)

Use this command to restore the default property settings for selected controls on a form. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets selected controls’ properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets selected controls’ properties from the cblwow.ini initialization file.


Control Menu Restore Properties From Global Defaults Popup

The Restore Properties | From Global Defaults command resets the selected controls’ properties from the cblwow.ini initialization file.


Control Menu Restore Properties From Project Defaults Command Ref

Restore Properties (Control menu)

Use this command to restore the default property settings for selected controls on a form. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets selected controls’ properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets selected controls’ properties from the cblwow.ini initialization file.


Control Menu Restore Properties From Project Defaults Popup

The Restore Properties | From Project Defaults command resets the selected controls’ properties from the project definition file (.wpj).


Control Menu Save Properties For Global Use Command Ref

Save Properties (Control menu)

Use this command to save the modified property settings for selected controls in a form. Each intrinsic control included in WOW Extensions, and any ActiveX custom control that you may add, include a set of initial properties and values. During design time, you include these controls in your form, change and customize their property settings, and attach code to them to create the user interface appearance of your program. Once you have modified a control, you may want to save it and reuse it in other projects or forms. Such predefined controls are helpful in providing a consistent look and behavior throughout your program. When you choose the Save Properties command, two options appear:

· For Project Use. Choosing this option saves the selected controls’ properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.

· For Global Use. If you want to reuse the modified controls in a different project, choose the For Global Use option to save the selected controls’ properties to the cblwow.ini initialization file.


Control Menu Save Properties For Global Use Popup

The Saves Properties | For Global Use saves the selected controls’ properties to the cblwow.ini initialization file so that the modified controls may be used in a different project.


Control Menu Save Properties For Project Use Command Ref

Save Properties (Control menu)

Use this command to save the modified property settings for selected controls in a form. Each intrinsic control included in WOW Extensions, and any ActiveX custom control that you may add, include a set of initial properties and values. During design time, you include these controls in your form, change and customize their property settings, and attach code to them to create the user interface appearance of your program. Once you have modified a control, you may want to save it and reuse it in other projects or forms. Such predefined controls are helpful in providing a consistent look and behavior throughout your program. When you choose the Save Properties command, two options appear:

· For Project Use. Choosing this option saves the selected controls’ properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.

· For Global Use. If you want to reuse the modified controls in a different project, choose the For Global Use option to save the selected controls’ properties to the cblwow.ini initialization file.


Control Menu Save Properties For Project Use Popup

The Save Properties | For Project Use command saves the selected controls’ properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.


Control Menu Send to Back Command Ref

Send to Back (Control menu)

Use this command to move the selected control behind all other controls in the stack on a form.

Note The Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

Shortcuts

Toolbar: on the Layout toolbar

Keys: Ctrl+PageDown


Control Menu Send to Back Popup

The Send to Back command moves the selected control behind all other controls in the stack on a form. The Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).


Control Menu Size Both Popup

The Size Match Both command resizes the selected controls in both directions simultaneously.


Control Menu Size Command Ref

Size (Control menu)

Use this command to change the size and shape of a selected control after you have created it. Sizing occurs relative to the first control selected. For this reason, it is preferable to select the first control and then use the Shift key to select subsequent controls rather than selecting all controls at one time. When you choose this command, three submenus appear:

· Match Height. Resizes the selected controls in a vertical direction.

· Match Width. Resizes the selected controls in a horizontal direction.

· Match Both. Resizes the selected controls in both directions simultaneously.

Shortcut

After you select a control, selection handles appear on it. Using the mouse, you can size the control one direction at a time or both directions at once, depending on which handle you drag. (To size the control proportionally, drag a corner handle.)


Control Menu Size Height Popup

The Size Match height command resizes the selected controls in a vertical direction.


Control Menu Size Width Popup

The Size Match Width command resizes the selected controls in a horizontal direction.


Control Menu Space Command Ref

Space (Control menu)

Use this command to create equal distances between selected controls. Under the default settings in WOW Extensions, when you distribute selected controls, the spacing of the controls is determined by the exact centers of the controls. To change this default setting, see the Alignment Preferences page of the Preferences dialog box. When you choose the Space command, two options appear:

· Vertical. The Vertical spacing option distributes the selected controls in the vertical direction, placing equal amounts of space between the selected controls.

· Horizontal. The Horizontal spacing option distributes the selected controls in a horizontal direction such that the spacing between the controls is the same.


Control Menu Space Horizontal Popup

The Space Horizontal command distributes the selected controls in a horizontal direction such that the spacing between the controls is the same. The default setting for the spacing of the controls is determined by the exact centers of the controls.


Control Menu Space Vertical Popup

The Space Vertical command distributes the selected controls in the vertical direction, placing equal amounts of space between the selected controls. The default setting for the spacing of the controls is determined by the exact centers of the controls.


Control Menu Tab Editor Command Ref

Tab Editor (Control menu)

Use this command to open the Tab Control Editor dialog box in order to delete the current tab within a tab control, shift the controls contained within that tab to the left or right, and modify certain tab properties that require special consideration with the tab control. Note that this command is available only if you have selected a tab control on a form.


Control Menu Tab Editor Popup

The Tab Editor command opens the Tab Control Editor dialog box, which allows modifications to the tab control and certain tab properties that require special consideration with the tab control. Note that this command is available only if you have selected a tab control on a form.


Control Menu Tab Order Command Ref

Tab Order (Control menu)

Use this command to determine and change the current tab order for your program.

Note For complicated forms having many controls, the preferred method of changing the tab order is with the Tab Order Editor dialog box.

WOW Extensions initially sets the tab order for each control to correspond to the order in which they were added to the form. When you select this command, WOW Extensions displays a number in blue in the upper-left corner of each control that corresponds to its current tab order on the form. To change the tab order, double-click the control you want to be first in the tab order, and then single-click on the rest of the controls in the order in which you want them to be selected in the form when a user presses the Tab key. To exit tab order mode, click the mouse anywhere in the form or click the Tab Order command again. (Note that the Toolbox temporarily closes when the WOW Designer is in tab order mode.)

You also can change the tab order for selected controls by changing the TabIndex property from the Properties dialog box. (The first control in the tab order should have the TabIndex value of 1.) Note, however, that there is a limitation when using this method since you can only change the value of the TabIndex property to a value that has not already been set.

Note Although some controls (animation, bitmap, progress bar, static text box, status bar, tab, time, toolbar, and all shapes) cannot accept mouse or keyboard focus, they will still have a valid tab order. When the user presses Tab, the focus skips over such a control and goes to the next control in the tab order.

Shortcut

Keys: Ctrl+T


Control Menu Tab Order Editor Command Ref

Tab Order Editor (Control menu)

Use this command to open the Tab Order Editor dialog box in order to display a list of controls on the active form and easily change their tab order.

Note For simple forms having few controls, the Tab Order command can be used to change the tab order.


Control Menu Tab Order Editor Popup

The Tab Order Editor command opens the Tab Editor Control Editor dialog box, which displays a list of controls on the active form and enables you to easily change their tab order. Note that for simple forms having few controls, the Tab Order command can be used to change the tab order.


Control Menu Tab Order Popup

The Tab Order command determines the current tab order for your program. You can change the tab order for selected controls by double-clicking the control you want to be first in the tab order, and then single-clicking on the rest of the controls in the order in which you want them to be selected in the form. Note that for complicated forms having many controls, the preferred method of changing the tab order is with the Tab Order Editor dialog box.


Control Menu Toggle Lock Command Ref

Toggle Lock (Control menu)

Use this command to lock or unlock the selected control(s), which keeps the control(s) from being moved accidentally. When the control is locked, a lock icon appears in the upper left corner of the control and the Locked property value changes to True. The control also can be locked or unlocked using the Locked property.

Shortcuts

Toolbar: on the Layout toolbar

Keys: Ctrl+L


Control Menu Toggle Lock Popup

The Toggle Lock command locks or unlocks the selected control(s), which keeps the control(s) from being moved accidentally.


Control Menu Z-Order Command Ref

Z-Order (Control menu)

Use this command to determine and change the control stacking order, that is, the order in which controls are created. When you select this command, WOW Extensions displays a number in red in the upper-left corner of each control that corresponds to its current z-order) on the form. You can change the z-order for selected controls by clicking the control you want to appear first in the stacking order, and then single-clicking on the rest of the controls until they are in the desired order.

Note For complicated forms having many controls, the preferred method of changing the z-order is with the Z-Order Editor dialog box.

Shortcut

Keys: Ctrl+R


Control Menu Z-Order Editor Command Ref

Z-Order Editor (Control menu)

Use this command to open the Z-Order Editor dialog box, which allows you to specify the control stacking order (or z-order).

Note For simple forms having few controls, the Z-Order command can be used to change the control stacking order.


Control Menu Z-Order Editor Popup

The Z-Order Editor command opens the Z-Order Editor Control Editor dialog box, which allows you to specify the control stacking order (or z-order). Note that for simple forms having few controls, the Z-Order command can be used to change the control stacking order.


Control Menu Z-Order Popup

The Z-Order command determines the control stacking order, that is, the order in which controls are created. You can change the z-order for selected controls by clicking the control you want to appear first in the stacking order, and then single-clicking on the rest of the controls until they are in the desired order. Note that for complicated forms having many controls, the preferred method of changing the z-order is with the Z-Order Editor dialog box.


Controls See Also

Using Global Default Property Settings

Windows GUI Elements

WOW Extensions Development Process


Control Type (Control Specific Page)

The Control Type column lists the available fields/controls for panels/forms in a panel library.


Count Property

The Count property is a runtime-only property that lets you determine how many items are included in the list box portion of the combo box. To get the number of items in the list box:

CALL WOWGETPROP USING WIN-RETURN MYCOMBO-H "COUNT"
COUNT-FIELD.


Count Property Lbox

The Count property is a runtime-only property that lets you determine how many items are contained in the list box.

Note This property can only be retrieved, not set, at runtime.


Create a Menu See Also

Pop-Up Menus

Using Menus


Create Event Form

The Create event occurs when the form is created.


CurAccel Property

The CurAccel property is a design-time-only property that controls the currently selected accelerator for the updown control. Change this value to select the desired accelerator before setting the AccelIncrement property and AccelSeconds property, both of which apply to each accelerator individually. The value is a zero-based index to the accelerator, where 0 indicates the first accelerator, 1 indicates the second accelerator, and so on.


CurButton Property

The CurButton property specifies which button’s properties are displayed and are accessible through the Btn-prefixed property values. Setting the CurButton property has no effect on the user interface. Before getting or setting either the BtnState property value or the BtnEnabled property value, the CurButton property must be set to the zero-based index of the desired button. Beginning with version 11 of the WOW Designer, the current toolbar button can be changed simply by clicking on the desired button.

This property can be manipulated at design time and either retrieved or set at runtime.


CurChoice

The CurChoice property specifies the subscript of the value in the ChoiceValue property of a list box or the list box portion of a combo box field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


CurData Property

The CurData property is a design-time-only property that WOW Extensions uses to predefine data that will be loaded into the control at runtime. The CurData property controls which data item is displayed in the Data property and which data item will be pre-selected at runtime. The data item specified by the CurData property will be selected only if both the DataLoad and DataSelect properties are set to True.


Current Tab (Tab Editor)

The Current Tab text box indicates the number of the currently selected tab within the tab control. You can use the spin buttons to change the selection to a different tab number. This is the value that appears in the CurTab property for the tab control. Note that this value also can be changed using the CurTab property in the Properties dialog box.


Current Toolbar Button

The Current toolbar buttons area displays the buttons in the order they appear (from left to right) on the toolbar.


Current Tools

The Current Tools area displays the tools that are currently on the Toolbox.


CurSection Property

The CurSection property controls the currently selected section (or pane) in the status bar. The value is a zero-based index to the status bar panes, where 0 indicates the first pane, 1 indicates the second pane, and so on. The number of panes is controlled by the Sections property. Beginning with version 11 of the WOW Designer, the current pane of the status bar can be changed simply by clicking on the desired section.

This property can be manipulated at design time and either retrieved or set at runtime.


CurSel Property

The CurSel property is a runtime-only property that represents the current selection in the list box portion of the combo box. This value can be queried to determine which item in the list box is selected, or set to move the selection to a different item.


CurSel Property Lbox

The CurSel property is a runtime-only property that represents the current selection in the list box. This value can be queried to determine which item in the list box is selected, or set to move the selection to a different item. If no item is selected, this property has the value LB-ERR.


Cursor Property Form

The Cursor property sets the default state (shape) of the cursor to display as the mouse pointer moves over the form. Each form can have one cursor shape. This value can be set and retrieved at runtime.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Cursor property:

Value | Description
0 | ARROW. Cursor shape is a diagonal arrow.
1 | IBEAM. Cursor shape is an I-bar, indicating editable text.
2 | WAIT. Cursor shape is an hourglass, indicating that the program is busy and the user should wait.
3 | CROSS. Cursor shape is a simple crosshair.
4 | UPARROW. Cursor shape is an up arrow.
5 | SIZENWSE. Cursor shape is arrows with a diagonal bar separating them, indicating the northwest and southeast edges of the form are to be resized.
6 | SIZENESW. Cursor shape is arrows with a diagonal bar separating them, indicating the northeast and southwest edges of the form are to be resized.
7 | SIZEWE. Cursor shape is arrows pointing left and right with a horizontally bar separating them, indicating the form is to be resized horizontally.
8 | SIZENS. Cursor shape is arrows pointing up and down with a vertical bar separating them, indicating the form is to be resized vertically.
9 | SIZEALL. Cursor shape is arrows with a diagonal bar separating them, indicating the northeast and southwest edges of the form are to be resized.
10 | NO. Cursor shape is a circle with a slash through it.
11 | APPSTARTING. Cursor shape is an arrow with an hourglass.
12 | HELP. Cursor shape is an arrow with question mark, indicating help is available.


CurTab Property

The CurTab property controls the currently selected tab in the WOW Designer. Change this value to select the desired tab before adding controls to it, and before setting the TabEnabled and TabText properties, which apply to each tab individually. The value is a zero-based index to the tabs, where 0 indicates the first tab, 1 indicates the second tab, and so on. Note that this property also can be changed using the Current Tab spin box in the Tab Control Editor dialog box. Beginning with version 11 of the WOW Designer, the current tab can be changed simply by clicking on the desired tab.

This property can be manipulated at design time and either retrieved or set at runtime.


Customize Toolbar Dialog Box See Also

Configuring WOW Extensions

Toolbars


Customize Toolbox Dialog Box See Also

Configuring WOW Extensions


Customizing the WOW Designer Ini File See Also

Debugging with WOW Extensions

WOW Designer


Customizing the WOW Runtime Ini File See Also

Debugging with WOW Extensions

WOW Runtime System


Custom Property ActiveX

The Custom property provides access to the ActiveX control’s property sheet (assuming it has one). When you click on the value area of the Custom property in the Properties dialog box, an ellipsis appears. Clicking on the ellipsis opens the ActiveX control’s property sheet so that you can view and change property values. To view an example of a property sheet for an ActiveX control (in this case, a calendar control), click here.

Note In the Properties dialog box, the Custom property will appear enclosed by parentheses (Custom) so that it will be sorted to the top of the alphabetical listing of properties.


Custom Toolbar Titles

Use the Custom Toolbar Titles area to specify the title of the new custom toolbar(s), Custom 1 and Custom 2, which can be created with the Customize Toolbar dialog box. Changes will be recorded in the WOW Designer initialization file, cblwow.ini. The WOW Designer must be restarted before the titles will take effect. When a custom toolbar is undocked, the title will be visible.


DataCount Property

The DataCount property is a design-time-only property that WOW Extensions uses to predefine data that will be loaded into the control at runtime. The DataCount property determines how many data items are displayed in a list box.


DataItemName

The DataItemName property specifies the data item name to be associated with the COBOL representation of this option button group.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


DataLoad Property

The DataLoad property is a design-time-only property that determines whether data items specified by the Data property get loaded at runtime.

The following table lists the possible values of the DataLoad property:

Value | Description
False | Do not load data item(s) (the default).
True | Load data item(s).


Data Property

The Data property is a design-time-only property that WOW Extensions uses to predefine data that will be loaded into the control at runtime. The Data property contains the actual data item string. The CurData property controls which data item is displayed in the Data property and which data item will be pre-selected at runtime. In a list box, if the UseTabStops property is set True, then a \t in the string will cause a tab character to inserted in the string before it is loaded into the control.


DataSelect Property

The DataSelect property is a design-time-only property that determines whether the data item specified by the CurData property will be preloaded at runtime if the DataLoad property is set to True.

Value | Description
False | The selected data item will not be preloaded at runtime (the default).
True | The selected data item will be preloaded at runtime.


DataSigned

The DataSigned property specifies whether this field, if numeric, stores signed numbers.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the DataSigned property:

Value | Description
False | The field/control does not store signed numbers.
True | The field/control stores signed numbers (the default).


DataSize

The DataSize property specifies the size of the data item.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


DataValue

The DataValue property specifies the value to be given to the data item representing this group of option buttons when this button is pressed.

Note T This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Date Edit Box Control Object See Also

Property Manipulation Checklist


Date MC Property

The Date property is a is a runtime-only property that retrieves date information representing the upper and lower limits of the date range currently selected by the user. The specific date information can be determined by examining the values in the MONTHCAL-SYSTEMTIMES GLOBAL statement in windows.cpy.


Date Time Picker Control Object See Also

Property Manipulation Checklist


Date Time Picker Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


DayState MC Property

The DayState property is a runtime-only property that determines which dates will be displayed in bold.

This property can be set, but not retrieved, at runtime.

The following table lists the possible values of the DayState property:

Value | Description
1 | The displayed date is not bold (the default).
0 | The displayed date is bold.


DblClick Event

The DblClick event occurs when the user double-clicks a mouse button on a control.

Note This event has an affect for a combo box control only when the Style property has a value of 0 (Simple, standard combo box).


Debugging with COBOL DISPLAY Statements See Also

Debugging with WOW Extensions


Debugging with CodeWatch See Also

Debugging with WOW Extensions


Debugging with the RM/COBOL Interactive Debugger See Also

Debugging with WOW Extensions


Debugging with WOW Extensions See Also

Project Menu Commands

Tools Preferences

[WOWRT] Section


DecimalDigits

The DecimalDigits property indicates the number of digits that can be entered to the right of the decimal point in a numeric field.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Default Property

The Default property indicates that a command button control should be pressed when the Enter (or Return) key is pressed while input focus is anywhere on the form. A command button with the Default property set to True is displayed with a heavy border. Only one command button on a form should be set with the Default property.

Note The value of the Default property cannot be set at runtime. The value can, however, be retrieved at runtime.

The following table lists the possible values of the Default property:

Value | Description
False | Button is not a default button (the default).
True | Button is a default button.


Default Property ActiveX

The Default property indicates that an ActiveX control should be pressed when the Enter (or Return) key is pressed while input focus is anywhere on the form. Only one ActiveX control (or command button) on a form should be set with the Default property.

Notes

· This property can be set and retrieved either at design time or runtime; however, at runtime, the name of the property is AXDefault.

· In the Properties dialog box, the Default property will appear enclosed by parentheses (Default) so that it will be sorted to the top of the alphabetical listing of properties.

· The Default property works only for an ActiveX control that supports the Click "stock event."

The following table lists the possible values of the Default property:

Value | Description
False | Control is not a default button (the default).
True | Control is a default button.


DefaultToPressed

The DefaultToPressed property determines whether this field/control is to default to having the appearance of being pressed.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the DefaultToPressed property:

Value | Description
False | The field/control is not pressed (the default).
True | The field/control is pressed.


DefaultToSystem

The DefaultToSystem property causes the default value of the field/control to be set to the system date of the computer.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


DefaultValue Common

The DefaultValue property specifies the default value for the field/control that is set if the RM/Panels standard runtime function, INITIALIZE FUNCTION, is executed.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Delete Current Tab Merge Control Options Area (Tab Editor)

The Delete Current Tab Merge Control Options area allows you to select the behavior applied to controls on the current tab when the tab is to be deleted. The Delete Current Tab Merge Control Options area contains three option buttons:

· Delete Controls. When the current tab is deleted, all controls within the tab will be deleted. This is the default.

· Merge Controls Left. When the current tab is deleted, the controls on that tab will be shifted to the tab on the left. If you are deleting the first tab, the controls will be shifted to the new first tab.

· Merge Controls Right. When the current tab is deleted, the controls on that tab will be shifted to the tab on the right. If you are deleting the last tab, the controls will be shifted to the new last tab.


Delete (Edit Bookmark)

The Delete command button deletes the selected bookmark.


Delete Project Properties

The Delete command button removes the selected file from the current project.


Description

The Description property describes the panel/form and is displayed on the RM/Panels Library Manager screen.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Designer Window with Open Project and Form Example

For version 12, this topic was removed.


Desktop Area See Also

Forms

Using WOW Projects

WOW Extensions Development Process


Determining the Selection

At some point, you will want to determine what selection was made in the list box. This is accomplished by checking the value of the list box’s CurSel property as follows:

CALL WOWGETPROP USING WIN-RETURN CTL-H "CURSEL" SEL-VALUE.

SEL-VALUE returns the 0 relative index of the selected item. CTL-H is the handle of the list box. If there is no selection, SEL-VALUE will equal LB-ERR. Note that LB-ERR is a -1 value, so SEL-VALUE must be a signed field to properly return this value.


Developing Event-Driven Applications See Also

Addressing Issues in Data Entry Programs

Looking Behind the Scenes

Using WOW Projects

Working with Menus

WOW Extensions Development Process


Development Mode

The Development Mode option enables messages that aid in debugging a WOW application at runtime.


DialogMotion Property Form

The DialogMotion property is a design-time-only property that determines whether Tab key motion between fields and arrow key motion within groups should automatically be performed for a form.

The following table lists the possible values of the DialogMotion property:

Value | Description
False | Dialog motion should not automatically be performed.
True | Dialog motion should automatically be performed (the default).


DisabledAttr

The DisabledAttr property determines whether the field/control is disabled for data entry. Valid values are blank (the library default) or A through P (as defined by the attribute code assigned to a block of text within a panel).

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


DisableNoScroll Property

The DisableNoScroll property is a design-time-only property that determines whether a scroll bar is displayed when the list box portion of a combo box control is not completely full.

The following table lists the possible values of the DisableNoScroll property:

Value | Description
False | Scroll bar disappears if combo box is not full (the default).
True | Scroll bar is disabled if combo box is not full.


DisableNoScroll Property Lbox

The DisableNoScroll property is a design-time-only property that determines whether a scroll bar is displayed when a list box control is not completely full.

The following table lists the possible values of the DisableNoScroll property:

Value | Description
False | Scroll bar disappears if list box is not full (the default).
True | Scroll bar is disabled if list box is not full.


Disable Restore Focus When Dialog Motion Is False

In the Version Compatibility area, the Disable Restore Focus When Dialog Motion Is False option, when selected, prevents the WOW Extensions runtime from restoring focus to the control that had focus prior to the user or application moving focus to a different form or application.


DisplayFormat

The DisplayFormat property specifies the COBOL picture format to be used when displaying this field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Do Not Filter Events

The Do Not Filter Events option causes event filtering not to be performed for a form and its controls at runtime, overriding the default of the AllowEventFilter property setting (True).


DoubleClick

The DoubleClick property indicates whether the double click of a mouse should be reported on the field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the DoubleClick property:

Value | Description
False | A double click is not reported on the field/control (the default).
True | A double click is reported on the field/control.


DropDown

The DropDown property specifies that a drop-down list box is supported in a list box or the list box portion of a combo box field/control. A drop-down list box displays only one item until the user takes an action to display the other choices. A drop-down list box appears initially as a rectangular box showing the current choice with a down arrow. When you choose the down arrow, a list of available choices appears.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the DropDown property:

Value | Description
False | A drop-down list box is not supported (the default).
True | A drop-down list box is supported.


DropDown Event

The DropDown event occurs when the user double-clicks the left mouse button on the drop-down arrow in the edit box portion of the drop-down combo box and drop-down list box.

Note This event is not supported if the Style property is set to a value of 0 (Simple, standard combo box).


DropShadow

The DropShadow property determines whether a shaded edge should be displayed around the lower and right borders of the panel/form if the Windowed property is set to True.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the DropShadow property:

Value | Description
False | A shaded edge is not displayed around the windowed panel/form (the default).
True | A shaded edge is not displayed around the windowed panel/form.


Edit Box Control Object See Also

Property Manipulation Checklist


Edit Box Control See Also

Handling Events for Controls, Forms, and Projects

Handling Different Types of Data

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


EditChange Event

The EditChange event occurs whenever the text displayed in the edit box portion of the combo box is changed.


Editing Toolbar Clear Markers

Clear Markers (Editing Toolbar)

Use the Clear Markers button to remove all markers in the code edit windows.


Editing Toolbar Copy

Copy (Editing Toolbar)

Use the Copy button to copy a control(s) on a form or between forms. The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged. Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can select multiple controls to be copied from within a single form. Tip

This button corresponds to the Copy command on the Edit menu.


Editing Toolbar Cut

Cut (Editing Toolbar)

Use the Cut button to cut a control(s) from a form. The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms. You can select multiple controls to be cut from within a single form. The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation.

This button corresponds to the Cut command on the Edit menu.


Editing Toolbar Delete

Delete (Editing Toolbar)

Use the Delete button to erase a control or controls from a form.

Caution You cannot reinsert control(s) removed by using the Delete button since this command does not place the deleted selection in the Clipboard. You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation.

This button corresponds to the Delete command on the Edit menu.


Editing Toolbar Find

Find (Editing Toolbar)

Use the Find button to display a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box. Note that this button is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

This button corresponds to the Find command on the Edit menu.


Editing Toolbar Find in Code Fragments

Find in Code Fragments (Editing and Find toolbars)

Use the Find in Code Fragments button to display the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code. Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window. Note that this button is enabled only if a project is opened.

This button corresponds to the Find in Code command on the Edit menu.


Editing Toolbar Go To Next Marker

Go To Next Marker (Editing Toolbar)

Use the Go To Next Marker button to go to the next marker in the code edit windows.


Editing Toolbar Go To Previous Marker

Go To Previous Marker (Editing Toolbar)

Use the Go To Previous Marker button to go to the previous marker in the code edit windows.


Editing Toolbar Paste

Paste (Editing Toolbar)

Use the Paste button to paste a control(s) after cutting or copying to the Clipboard.

Note This command is not available if the Clipboard is empty.

This button corresponds to the Paste command on the Edit menu.


Editing Toolbar Redo

Redo (Editing Toolbar)

Use the Redo button to restore the result of the last editing operation or action, if you decide that you do not want to undo the action. This button corresponds to the Redo command on the Edit menu.


Editing Toolbar Toggle Marker

Toggle Marker (Editing Toolbar)

Use the Toggle Marker button to show or hide the display of the markers in the code edit windows. The default is to show markers, which is a setting on the Code Edit Windows Preferences page.


Editing Toolbar Undo

Undo (Editing Toolbar)

Use the Undo button to reverse the effect of the most recent editing operation. You must choose Undo before performing any other operation or the control is not restored.

Note Not all editing operations can be undone. In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms.

This button corresponds to the Undo command on the Edit menu.


Edit Menu Clear All Markers Command Ref

Clear All Markers (Edit menu)

Use this command to clear all markers in the code edit windows.


Edit Menu Clear All Markers Popup

The Clear All Markers command clears all markers in the code edit windows.


Edit Menu Copy Command Ref

Copy (Edit menu)

Use this command to copy a control(s) on a form or between forms. The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged. Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can select multiple controls to be copied from within a single form. Tip

Shortcuts

Toolbar: on the Editing toolbar

Keys: Ctrl+C


Edit Menu Copy Popup

The Copy command copies a control(s) on a form or between forms. The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged. Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can select multiple controls to be copied from within a single form. Shortcut: Ctrl+C.


Edit Menu Cut Command Ref

Cut (Edit menu)

Use this command to cut a control(s) from a form. The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms. You can select multiple controls to be cut from within a single form. The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation.

Shortcuts

Toolbar: on the Editing toolbar

Keys: Ctrl+X


Edit Menu Cut Popup

The Cut command removes a control(s) from a form. The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms. You can select multiple controls to be cut from within a single form. The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation. Shortcut: Ctrl+X.


Edit Menu Delete Command Ref

Delete (Edit menu)

Use this command to erase a control or controls from a form.

Caution You cannot reinsert control(s) removed by using the Delete command since this command does not place the deleted selection in the Clipboard. You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation.

Shortcuts

Toolbar: on the Editing toolbar

Keys: Del


Edit Menu Delete Popup

The Delete command erases a control or controls from a form. You cannot reinsert control(s) removed by using the Delete command since this command does not place the deleted selection in the Clipboard. You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation. Shortcut: Del


Edit Menu Duplicate Command Ref

Duplicate (Edit menu)

Use this command to create a copy of a control or controls. The copy will be offset slightly to the lower right and placed on top of the original control. The new duplicate copy is automatically selected. When you use this method of copying, WOW Extensions does not use the Clipboard to transfer the control(s). Tip

Note This command is not available if the Clipboard is empty.

Shortcut

Keys: Ctrl+D


Edit Menu Duplicate Popup

The Duplicate command creates a copy of a control or controls. The copy will be offset slightly to the lower right and placed on top of the original control. The new duplicate copy is automatically selected. When you use this method of copying, WOW Extensions does not use the Clipboard to transfer the control(s). This command is not available if the Clipboard is empty. Shortcut: Ctrl+D.


Edit Menu Edit Bookmarks Command Ref

Edit Bookmarks (Edit menu)

Use this command to open the Edit Bookmarks dialog box in order to add a bookmark, which identifies a location or selection of text that you name and identify for future reference; for example, to a frequently-used position of the COBOL source code that you may wish to revise in the code edit windows.

Shortcut

Keys: Alt+F2


Edit Menu Edit Bookmarks Popup

The Edit Bookmarks command opens the Edit Bookmarks dialog box in order to add a bookmark, which identifies a location or selection of text that you name and identify for future reference; for example, to a frequently-used position of the COBOL source code that you may wish to revise in the code edit windows. Shortcut: Alt+F2.


Edit Menu Find Command Ref

Find (Edit menu)

Use this command to display a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box. Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

Shortcuts

Toolbar: on the Editing toolbar

Keys: Ctrl+F


Edit Menu Find in Code Command Ref

Find in Code (Edit menu)

Use this command to display the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code. Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window.

Shortcuts

Toolbar: on either the Editing or Find toolbar

Keys: Ctrl+Shift+F


Edit Menu Find in Code Popup

The Find in Code command displays the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code. Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window. Shortcut: Ctrl+Shift+F.


Edit Menu Find Next Command Ref

Find Next (Edit menu)

Use this command to find the next instance of the text string specified with the Find command. Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

Shortcut

Keys: Ctrl+N


Edit Menu Find Next Popup

The Find Next command finds the next instance of the text string specified with the Find command. Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project. Shortcut: Ctrl+N.


Edit Menu Find Popup

The Find command displays a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box. Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project. Shortcut: Ctrl+F.


Edit Menu Find Previous Command Ref

Find Previous (Edit menu)

Use this command to find the previous instance of the text string specified with the Find command.

Shortcut

Keys: Shift+F3


Edit Menu Find Previous Popup

The Find Previous command finds the previous instance of the text string specified with the Find command. Shortcut: Shift+F3.


Edit Menu Go To Bookmark Command Ref

Go To Bookmark (Edit menu)

Use this command to open the Go To Bookmark dialog box in order to in order to jump quickly to a certain line in the COBOL source code that has been identified by a bookmark name. When you select a bookmark from the dropdown list, the editor scrolls to the location of the bookmark in the code edit windows.

Shortcut

Keys: Ctrl+G


Edit Menu Go To Bookmark Popup

The Go To Bookmark command opens the Go To Bookmark dialog box in order to jump quickly to a certain line in the COBOL source code that has been identified by a bookmark name. When you select a bookmark from the dropdown list, the editor scrolls to the location of the bookmark in the code edit windows. Shortcut: Ctrl+G.


Edit Menu Go To First Marker Command Ref

Go To First Marker (Edit menu)

Use this command to go to the first marker in the code edit windows.


Edit Menu Go To First Marker Popup

The Go To First Marker command goes to the first marker in the code edit windows.


Edit Menu Go To Last Marker Command Ref

Go To Last Marker (Edit menu)

Use this command to go to the last marker in the code edit windows.


Edit Menu Go To Last Marker Popup

The Go To Last Marker command goes to the last marker in the code edit windows.


Edit Menu Go To Next Marker Command Ref

Go To Next Marker (Edit menu)

Use this command to go to the next marker in the code edit windows.

Shortcut

Keys: F2


Edit Menu Go To Next Marker Popup

The Go To Next Marker command goes to the next marker in the code edit windows. Shortcut: F2.


Edit Menu Go To Previous Marker Command Ref

Go To Previous Marker (Edit menu)

Use this command to go to the previous marker in the code edit windows.

Shortcut

Keys: Shift+F2


Edit Menu Go To Previous Marker Popup

The Go To Previous Marker command goes to the previous marker in the code edit windows. Shortcut: Shift+F2.


Edit Menu Paste Command Ref

Paste (Edit menu)

Use this command to paste a control(s) after cutting or copying to the Clipboard.

Note This command is not available if the Clipboard is empty.

Shortcuts

Toolbar: on the Editing toolbar

Keys: Ctrl+V


Edit Menu Paste Popup

The Paste command pastes a control(s) after cutting or copying to the Clipboard. This command is not available if the Clipboard is empty. Shortcut: Ctrl+V.


Edit Menu Redo Command Ref

Redo (Edit menu)

Use this command to restore the result of the last editing operation or action, if you decide that you do not want to undo the action. Note that not all editing operations can be restored.

Shortcuts

Toolbar: on the Editing toolbar

Keys: Ctrl+Shift+Z


Edit Menu Redo Popup

The Redo command restores the result of the last editing operation or action, if you decide that you do not want to undo the action. Note that not all editing operations can be restored. Shortcut: Ctrl+Shift+Z.


Edit Menu Replace Command Ref

Find & Replace (Edit menu)

Use this command to display a variation of the standard Windows Find & Replace dialog box in order to enter a text string that you want to locate and modify in the Code Entry area of the Event-Handling Code dialog box. Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

Shortcut

Keys: Ctrl+H


Edit Menu Replace Popup

The Find & Replace command displays a variation of the standard Windows Find and Replace dialog box in order to enter a text string that you want to locate and modify in the Code Entry area of the Event-Handling Code dialog box. Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project. Shortcut: Ctrl+H.


Edit Menu Select All Command Ref

Select All (Edit menu)

Use this command to select all the controls on the current form. To quickly deselect all controls on a form, click the left mouse button anywhere in the form that is not a control. Once you have selected multiple controls, you can manipulate them as though they were a single control. For example, you can cut, copy, delete, or duplicate them as one unit.

Shortcut

Keys: Ctrl+A


Edit Menu Select All Popup

The Select All command selects all the controls on the current form. To quickly deselect all controls on a form, click the left mouse button anywhere in the form that is not a control. Once you have selected multiple controls, you can manipulate them as though they were a single control. For example, you can cut, copy, delete, or duplicate them as one unit. Shortcut: Ctrl+A.


Edit Menu Toggle Marker Command Ref

Toggle Marker (Edit menu)

Use this command to show or hide the display of the markers in the code edit windows. The default is to show markers, which is a setting on the Code Edit Windows Preferences page.

Shortcut

Keys: Ctrl+F2


Edit Menu Toggle Marker Popup

The Toggle Marker command shows or hides the display of the markers in the code edit windows. The default is to show markers, which is a setting on the Code Edit Windows Preferences page. Shortcut: Ctrl+F2.


Edit Menu Undo Command Ref

Undo (Edit menu)

Use this command to reverse the effect of the most recent editing operation. You must choose Undo before performing any other operation or the control is not restored.

Note Not all editing operations can be undone. In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms.

Shortcuts

Toolbar: on the Editing toolbar

Keys: Ctrl+Z


Edit Menu Undo Popup

The Undo command reverses the effect of the most recent editing operation. You must choose Undo before performing any other operation or the control is not restored. Not all editing operations can be undone. In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms. Shortcut: Ctrl+Z.


Effect Property

The Effect property is a design-time-only property that changes a static text control into an empty rectangle or a colored group box without text. The color names actually designate one of the Windows configuration options and may not match the color name used.

The Effect property is used to determine the type of static text control that is displayed: text, outline, or rectangle. It is important to note that the text of a static text control is not displayed when the outline or rectangle effect is selected. When the 3D property is set to True, the Effect property also has different appearances.

The following table lists the possible values of the Effect property:

Value | Description
0 | None. Text is displayed (the default).
1 | Draws a rectangle with the window group box color, usually black.
2 | Draws a rectangle with the desktop background color, usually gray.
3 | Draws a rectangle with the parent window’s background, usually white.
4 | Draws a black group box.
5 | Draws a gray group box.
6 | Draws a white group box.


Effect Static Text Field

The Effect property changes a static text field/control into an empty rectangle or a colored group box without text. The color names actually designate one of the Windows configuration options and may not match the color name used.

The Effect property is used to determine the type of static text control that is displayed: text, outline, or rectangle. It is important to note that the text of a static text control is not displayed when the outline or rectangle effect is selected. When the 3D property is set to True, the Effect property also has different appearances.

The following table lists the possible values of the Effect property:

Value | Description
0 | None. Text is displayed (the default).
1 | Draws a rectangle with the window group box color, usually black.
2 | Draws a rectangle with the desktop background color, usually gray.
3 | Draws a rectangle with the parent window’s background, usually white.
4 | Draws a black group box.
5 | Draws a gray group box.
6 | Draws a white group box.


Ellipse Shape Object See Also

Property Manipulation Checklist


Ellipse Shape See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Enable ActiveX Key Press for Tab Mode

In the Version Compatibility area, the Enable ActiveX Key Press for Tab Mode option, when selected, allows the WOW Extensions runtime to use the KeyPress event to control Tab key motion for all ActiveX controls on a form. Note that selecting this option overrides the EnableKeyPressForTabMode property.

If the Enable ActiveX Key Press for Tab Mode check box is not selected, the WOW runtime behavior is controlled by the EnableKeyPressForTabMode property on a per ActiveX control basis.

Version 9 and later of the WOW runtime intercepts keyboard messages before they become ActiveX events and causes tabbing to occur at that point in time, thus causing the KeyPress event not to occur. The Enable ActiveX Key Press for Tab Mode option and the EnableKeyPressForTabMode property were added because not all ActiveX controls allow the WOW runtime to act on the Tab key in this manner, and setting this property to True allows the WOW runtime to behave as it did prior to version 9 (that is, using the KeyPress event to cause Tab key motion).


Enable and Disable Menu Items See Also

Create a Menu


Enable Application Switch Lost Focus Events

In the Version Compatibility area, the Enable Application Switch Lost Focus Events option, when selected, allows the LostFocus event to be received by the WOW application when the user switches to another application. Version 9 of the WOW Extensions runtime suppressed LostFocus events in such instances.


Enable AX Multiple Event Blocking

The Enable AX Multiple Event Blocking option prevents ActiveX event code from being executed while another event is being processed. In order to prevent multiple events from occurring, this option must be selected and each ActiveX control for which the developer wishes to block multiple events must have the property AllowMultipleEvents set to False.


Enable Control Events On Accelerator

In the Version Compatibility area, the Enable Control Events on Accelerator option, when selected, allows a control to receive key events (KeyDown, KeyPress, or KeyUp) when the Accelerator key is being used. Version 9 of the WOW Extensions runtime did not pass key events to controls in such instances.


Enable Control Events On Tab Key

In the Version Compatibility area, the Enable Control Events on Tab Key option, when selected, allows a control to receive key events (KeyDown, KeyPress, or KeyUp) when the Tab key is being used for dialog motion (that is, tab key motion between fields). Version 9 of the WOW Extensions runtime did not pass key events to controls in such instances.


Enabled

The Enabled check box allows you to initially enable a menu control at design time. When the Enabled property is selected (the default), the menu responds to user actions. If a menu control is disabled, it appears grayed or dimmed. For information about enabling a menu control at runtime, click here.


EnabledAttr

The EnabledAttr property determines whether the field/control is enabled for data entry. Valid values are blank (the library default) or A through P (as defined by the attribute code assigned to a block of text within a panel).

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


EnabledForDisplay

The EnabledForDisplay property, when marked with an X, indicates that this field/control is enabled to display values.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


EnabledForInput

The EnabledForInput property, when marked with an X, indicates that this field/control is enabled to accept data entry.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Enable Double Click On Non-Standard List Box

In the Version Compatibility area, the Enable Double Click on Non-Standard List Box option, when selected, turns on the simulation of the double-click event (DblClick) that occurred in pre-version 9 WOW Extensions runtimes for non-standard list box controls. A non-standard list box is one that has the Standard property set to a value of False. Windows does not signal a double-click event on non-standard list boxes.


Enabled Property

The Enabled property determines whether the control can respond to user-generated input (or events).

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Enabled property:

Value | Description
False | Control is disabled for user input.
True | Control is enabled for user input (the default).


Enabled Property Form

The Enabled property determines whether a form can respond to user-generated input (or events).

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Enabled property:

Value | Description
False | Form is not enabled for user input.
True | Form is enabled for user input (the default).


Enable Edit Box Insert Key

In the Version Compatibility area, the Enable Edit Box Insert Key option, when selected, causes the Insert key to toggle between insert and overwrite modes in edit boxes (and the edit box portion of a combo box). Since this is non-standard Windows behavior, versions of WOW Extensions prior to 9.01 did not allow it. Note that the location of the EnableEditBoxInsertKey configuration option is in the [WOWRT] section rather than in the [Version Compatibility] section of wowrt.ini.


Enable Event Form

The Enable event occurs when the form is enabled or disabled.


EnableKeyPressForTabMode Property ActiveX

The EnableKeyPressForTabMode property allows the WOW Extensions runtime to mimic pre-version 9 behavior by using KeyPress events for controlling Tab key motion between controls on the form when the DialogMotion property is set to True.

Additionally, selecting the Enable ActiveX Key Press for Tab Mode check box on the Runtime Preferences page in the Preferences dialog box causes this behavior to affect all ActiveX controls on the form. This runtime option overrides the EnableKeyPressForTabMode property setting. If the Enable ActiveX Key Press for Tab Mode check box is not selected, the WOW runtime behavior is controlled by the EnableKeyPressForTabMode property on a per ActiveX control basis.

Version 9 and later intercepts keyboard messages before they become ActiveX events and causes tabbing to occur at that point in time, thus causing the KeyPress event not to occur. The EnableKeyPressForTabMode property was added because not all ActiveX controls allow the WOW runtime to act on the Tab key in this manner, and setting this property to True allows the WOW runtime to behave as it did prior to version 9, using the KeyPress event to cause Tab key motion.

Note In the Properties dialog box, the EnableKeyPressForTabMode property will appear enclosed by parentheses (EnableKeyPressForTabMode) so that it will be sorted to the top of the alphabetical listing of properties.

The following table lists the possible values of the EnableKeyPressForTabMode property:

Value | Description
False | The WOW Extensions runtime will intercept keyboard messages before they become ActiveX events and cause tabbing to occur without generating KeyPress events.
True | The WOW Extensions runtime will use KeyPress events to control dialog motion (the default).


ENABLEMENUITEM

Menu Windows API Function

The ENABLEMENUITEM function enables, disables, or grays (dims) a menu item.

To disable or enable input to a menu bar, see the WM-SYSCOMMAND message.

Whenever a menu changes (whether or not the menu is in a window that is displayed), the application should call the DRAWMENUBAR function.

The CREATEMENU, INSERTMENU, and MODIFYMENU functions can also set the state (enabled, disabled, or grayed) of a menu item.

Using the MF-BYPOSITION menu-flag value requires an application to specify the correct menu handle. If the menu handle of the menu bar is specified, a top-level menu item (an item in the menu bar) is affected. To set the state of an item in a pop-up menu by position, an application must specify the handle of the pop-up menu.

When an application specifies the MF-BYCOMMAND menu-flag value, Windows checks all pop-up menu items that are subordinate to the menu identified by the specified menu handle; therefore, unless duplicate menu items are present, specifying the menu handle of the menu bar is sufficient.

Calling Sequence

CALL ENABLEMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

Note By first initializing the MENU-FLAGS parameter with the statement MOVE ALL 'N' TO MENU-FLAGS, all existing values are unset so that new values can be specified. For example:

MOVE ALL 'N' TO MENU-FLAGS.
SET MF-BYCOMMAND MF-DISABLED MF-GRAYED TO TRUE.
CALL ENABLEMENUITEM USING WIN-RETURN MENU-H ITEM-ID MENU-FLAGS.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is 0 if the menu item was previously disabled, or 1 if the menu item was previously enabled. The condition WIN-FAILURE is True if the menu item does not exist.
MENU-H | PIC 9(10) BINARY(8) | The handle of the menu to be enabled.
ITEM-ID | numeric | Specifies the menu item to be enabled, disabled, or grayed. This parameter can specify pop-up menu items as well as standard menu items. The interpretation of this parameter depends on the value of the MENU-FLAGS parameter.
MENU-FLAGS | windows.cpy | Specifies the action to take. This parameter can be one of the MF-DISABLED, MF-ENABLED, or MF-GRAYED values, combined with MF-BYCOMMAND or MF-BYPOSITION. These values have the following meanings.
 | Value | Meaning
 | MF-BYCOMMAND | Specifies that the ITEM-ID parameter gives the menu-item identifier.
 | MF-BYPOSITION | Specifies that the ITEM-ID parameter gives the position of the menu item (the first item is at position zero).
 | MF-DISABLED | Disables the menu item so that it cannot be selected, but does not gray (dim) it.
 | MF-ENABLED | Enables the menu item so that it can be selected and restores it from its grayed state.
 | MF-GRAYED | Disables the menu item and grays (dims) it so that it cannot be selected.


Enable Mouse Move Events

The Enable Mouse Move Events option, when selected, causes the WOW Extensions runtime to recognize mouse move events. Mouse move events consume an inordinate amount of CPU resources even when no event code is attached. The ability to de-select this option is useful in preventing such resource consumption unless the developer deems it necessary.


Enable Non-Child Lost Focus Events

In the Version Compatibility area, the Enable Non-Child Lost Focus Events option, when selected, allows the LostFocus event to be received by the WOW application when the user switches to another non-child WOW form in the same application. Version 9 of the WOW Extensions runtime suppressed LostFocus events in such instances.


Enable Old Style Accelerator Mode

In the Version Compatibility area, the Enable Old Style Accelerator Mode option, when selected, causes the simulation of a button being pushed when an accelerator is pressed. This behavior is produced by sending a WM_LBUTTONDOWN message followed by a WM_LBUTTONUP message to the control. Versions of WOW Extensions prior to 9.01 sent a WM_COMMAND BM_CLICKED message to the control when an accelerator was pressed.


Enable Old Style Form Size Mode

In the Version Compatibility area, the Enable Old Style Form Size Mode option, when selected, reverts to the manner of changing form size that was used in versions of WOW Extensions prior to 9.01. Version 9.01 corrected inconsistencies in the handling of the WOWGETPROP and WOWSETPROP functions that existed in previous versions of WOW Extensions. In previous versions, the values set by WOWSETPROP when changing the size of a form were not the same as those returned by subsequent WOWGETPROP function calls.


EnableSelRange Property

The EnableSelRange property is a design-time-only property that determines whether the trackbar control displays a selection range. A "selection range" restricts the user to a specified portion of the total range. The logical units do not change, but only a subset of them is available for use. The trackbar highlights the available range and displays triangular tick marks at the start and end. Typically, an application handles the trackbar's notification messages and sets the trackbar's selection range according to the user's input.

The following table lists the possible values of the EnableSelRange property:

Value | Description
False | The trackbar control does not display a selection range (the default).
True | The trackbar control displays a selection range only. The tick marks at the starting and ending positions of a selection range are displayed as triangles (instead of vertical dashes), and the selection range is highlighted.


ENABLEWINDOW

Window Windows API Function

The ENABLEWINDOW function enables or disables mouse and keyboard input to the given window or control. When input is disabled, the window ignores input such as mouse clicks and key presses. When input is enabled, the window processes all input.

If the enabled state of the window is changing, a WM-ENABLE message is sent before this function returns. If a window is already disabled, all its child windows are implicitly disabled, although they are not sent a WM-ENABLE message.

A window must be enabled before it can be activated. For example, if an application is displaying a pop-up window and has disabled its main window, the application must enable the main window before destroying the pop-up window. Otherwise, another window will receive the input focus and be activated. If a child window is disabled, it is ignored when Windows tries to determine which window should receive mouse messages.

By default, a window is enabled when it is created. An application can specify the WS-DISABLED style in the WIN-STYLE parameter of the CREATEWINDOW or CREATEWINDOWEX function to create a window that is initially disabled. After a window has been created, an application can use the ENABLEWINDOW function to enable or disable the window.

An application can use this function to enable or disable a control in a window. A disabled control cannot receive the input focus, nor can a user access it.

Calling Sequence

CALL ENABLEWINDOW USING WIN-RETURN WND-H STATE.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is nonzero if the window was previously disabled. Otherwise, the return value is zero.
WND-H | PIC 9(10) BINARY(8) | The handle of the window to be enabled or disabled.
STATE | windows.cpy | Specifies whether to enable or disable the window. If the value of this parameter is WIN-TRUE, the window is enabled. If the value of this parameter is WIN-FALSE, the window is disabled.


EndScroll Event Scroll bar

The EndScroll event occurs after every change in the scroll bar thumb position.


EndScroll Event Updown

The EndScroll event occurs when the user stops scrolling.


EndTrack Event

The EndTrack event occurs when the user stops interacting with the trackbar control, whether by the keyboard or with the mouse.


EndUserEditing

The EndUserEditing property determines whether the end-user can edit the panel/form.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the EndUserEditing property:

Value | Description
False | The end-user cannot edit the panel.
True | The end-user can edit the panel (the default).


Enhancing Existing RM/Panels Panel Libraries See Also

Character-Based GUI Portability and Cross Development

Communicating with RM/Panels

Configuring Function Keys

Locating Required Tools

Migrating RM/Panels Panel Libraries to WOW Forms

Properties for RM/Panels Data Fields

Properties for RM/Panels Panels

Restrictions

Using Global Default Property Settings

WOW Extensions Components


EntryFormat

The EntryFormat property specifies the COBOL picture format to be used during data entry.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


EntryOrder

The EntryOrder property determines the order in which the fields/controls are operated, with 1 being first, 2 being next, and so on. Any number between 1 and 150 is valid. The value cannot be greater than the number of fields/controls on the panel. Be default, the value is calculated and set by RM/Panels, but you may change it. This property is required.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ErrorAttr

The ErrorAttr property indicates the default attribute code for error messages. Valid values are blank (the library default) or A through P.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ErrorMessage Field

The ErrorMessage property specifies the error message associated with this field/control. The RM/Panels Message Editor appears when the cursor is on this field/control and you press F3 or double-click the mouse.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ErrorMessage Panel

The ErrorMessage property specifies the error message associated with this panel/form when the end-user enters an invalid value. The RM/Panels Message Editor appears when the cursor is on this panel/form and you press F3 or double-click the mouse.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Event-Handling Code Dialog Box See Also

Adding ActiveX Controls to the WOW Designer

Code Preferences

Code Templates Tree

Developing Event-Driven Applications

Functions and Messages

Handling Events for Controls, Forms, and Projects

Properties

Setting Properties for Controls and Forms

Working with Menus


Event/Section (Edit Bookmark)

The Event/Section area displays the event and/or code section associated with the selected bookmark.


Event/Section (Go To Bookmark)

The Event/Section area displays the event and/or code section associated with the selected bookmark.


Events/Sections

The Events/Sections list displays all the events and/or code sections associated with the selected object. The list box displays the name of the selected event or code section (for example, Click is displayed for the Click event, such as when a user clicks a command button). Choose the arrow to the right of the box to display all the events and/or code sections for the object. Note that an asterisk after an event or code section indicates that code is already attached to this event or code section.


Events See Also

ActiveX Control Events

Handling Events for Controls, Forms, and Projects

Windows GUI Elements

WOW Extensions Development Process


Expand ActiveX Properties in Properties Window

The Expand ActiveX Properties in Properties Window option, which is enabled by default, causes the property page for an ActiveX control to be displayed in the Properties dialog box. If this option is not selected, you must right-click on the ActiveX control to view its properties.


Expand Tree

The Expand Tree command button expands the categorical grouping of functions and message shortcuts to include the individual functions and message shortcuts within each group. You can then click the plus [+] and minus [-] icons next to an item to expand or collapse the hierarchical list.


ExtendedSel Property

The ExtendedSel property allows selections in a multiple selection list box control by using the mouse and the Shift key. Setting the ExtendedSel property to True forces the list box to behave as a multiple selection list box despite the value of the MultipleSel property.

The following table lists the possible values of the ExtendedSel property:

Value | Description
False | No extended selection (the default).
True | Extended selection allowed.


External Edit Comparison Dialog Box See Also

Migrating to WOW Extensions Version 9


External-Editing Preferences See Also

Setting Preferences


Externally Edited Code

The Externally Edited Code area displays the edited version of the code fragment. Use the vertical and horizontal scroll bars to view the code that is not visible in the window.


Extra Height (Control Specific Page)

The Extra Height column refers to control-specific edit boxes that allow you to specify an additional number of pixels that will be added when computing the height of the field/control.


Extra Width (Control Specific Page)

The Extra Width column refers to control-specific edit boxes that allow you to specify an additional number of pixels that will be added when computing the width of the field/control.


File Difference Program

Use the File Difference Program area to specify the location of a file comparison tool other than the default, Microsoft Windows windiff, for comparing code differences in the External Edit Comparison dialog box.

The Path text box allows you to enter the complete pathname of the file comparison program.


File Form Menu Close All Command Ref

Close All Forms (File and Form menus)

Use this command to close all open forms. If a form has changes that have not been saved, WOW Extensions prompts you to save the changes in each form before closing. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Close All Form command on the File menu and the Close All command on the Form menu are equivalent.


File Form Menu Close All Popup

The Close All Forms and Close All commands close all open forms. If a form has changes that have not been saved, WOW Extensions prompts you to save the changes in each form before closing. If a project is open but no forms are open in that project, or if no project is open, this command is not available.


File Form Menu Close Command Ref

Close Form (File and Form menus)

Use this command to close a form file without leaving WOW Extensions. If you have not made changes to the form since you last opened or saved it, WOW Extensions will immediately close the form.

If you have made changes to the form, however, WOW Extensions will display a message box asking whether you want to save the changes to the form. If you choose Yes and the current form has previously been saved, WOW Extensions will save the form under its current name and then close it. If you choose Yes and the form has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it, as described under the Save Form As command. If you choose No, WOW Extensions will close the form without saving the changes. If you choose Cancel, WOW Extensions will return you to the form without saving it or closing it.

If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Close Form command on the File menu and the Close command on the Form menu are equivalent.

Shortcuts

Keys: Ctrl+F4

Alternatively, click Close on the Control menu in the WOW Designer window.


File Form Menu Close Popup

The Close Form and Close commands close a form file without leaving WOW Extensions. If you have not made changes to the form since you last opened or saved it, WOW Extensions will immediately close the form. If you have made changes to the form, however, WOW Extensions will display a message box asking whether you want to save the changes to the form. If you choose Yes and the current form has previously been saved, WOW Extensions will save the form under its current name and then close it. If you choose Yes and the form has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it, as described under the Save Form As command. If you choose No, WOW Extensions will close the form without saving the changes. If you choose Cancel, WOW Extensions will return you to the form without saving it or closing it. If a project is open but no forms are open in that project, or if no project is open, this command is not available.


File Form Menu New Command Ref

New Form (File and Form menus)

Use this command to add a new, blank form to an open project. If a project is open but no forms are open in that project, this command is shown as New on the menu. If a project is not open, this command is unavailable.

The New Form (New) command on the File menu and the New command on the Form menu are equivalent.

Shortcuts

Toolbar: on the File toolbar

Keys: Ctrl+N


File Form Menu New Popup

The New Form and New commands add a new, blank form to an open project. If a project is open but no forms are open in that project, this command is shown as New on the menu. If a project is not open, this command is unavailable.


File Form Menu Open All Forms and Open All Popup

The Open All Forms and Open All commands open all form files of the project that is currently open for this session. If a project is open but no forms are open in that project, this command is shown as Open All on the menu. If a project is not open, this command is unavailable.


File Form Menu Open Command Ref

Open Form (File and Form menus)

Use this command to retrieve an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified. If a project is open but no forms are open in that project, this command is shown as Open on the menu. If a project is not open, this command is unavailable.

The Open Form (Open) command on the File menu and the Open command on the Form menu are equivalent.

Shortcuts

Toolbar: on the File toolbar

Keys: Ctrl+O


File Form Menu Open Popup

The Open Form and Open commands retrieve an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified. If a project is open but no forms are open in that project, this command is shown as Open on the menu. If a project is not open, this command is unavailable.


File Form Menu Save All Popup

The Save All Forms and Save All commands save all open forms if you are working on more than one form at a time. If any open forms have not been saved before, WOW Extensions displays a standard Windows Save As dialog box so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.


File Form Menu Save As Command Ref

Save Form As command (File and Form menus)

Use this command to save a form file under a new name or in a different directory/folder or drive. The standard Windows Save As dialog box opens so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Save Form As command on the File menu and the Save As command on the Form menu are equivalent.

Note The name of the form file is significant, as it identifies the form to the underlying program. Form files are, by default, given the extension of .wow. The form filename is also used to identify and generate two copy files. The first copy file, with the filename extension of .wpr, contains the COBOL logic necessary for the form. The second file, with the extension of .wss, is the COBOL Working Storage copy file needed for the form. For more information, click here.


File Form Menu Save As Popup

The Save Form As and Save As commands save a form file under a new name or in a different directory/folder or drive. The standard Windows Save As dialog box opens so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.


File Form Menu Save Popup

The Save Form and Save commands save changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.


File Menu Exit Command Ref

Exit (File menu)

Use this command to close form and/or project files and exit WOW Extensions. If you have not made any changes since the last time you saved the open files, WOW Extensions will terminate. If you have made changes, you will see a message box asking whether you want to save your changes. You can save or discard your changes by choosing Yes or No for each item. You can also cancel the Exit command any time by choosing Cancel. You will return to the file without saving it or closing it.

Shortcuts

Keys: Alt+F4

Alternatively, double-click the Control-menu icon in the WOW Designer window.


File Menu Exit Popup

Exit (File menu)

The Exit command closes form and/or project files and exit WOW Extensions. If you have not made any changes since the last time you saved the open files, WOW Extensions will terminate. If you have made changes, you will see a message box asking whether you want to save your changes. You can save or discard your changes by choosing Yes or No for each item. You can also cancel the Exit command any time by choosing Cancel. You will return to the file without saving it or closing it.


File Menu Open All Forms Command Ref

Open All Forms (File and Form menus)

Use this command to open all form files of the project that is currently open (or active) for this session. If a project is open but no forms are open in that project, this command is shown as Open All on the menu. If a project is not open, this command is unavailable.

The Open All Forms (Open All) command on the File menu and the Open All command on the Form menu are equivalent.


File Menu Recent Forms/Projects Command Ref

Recent Projects / Forms (File and Form menus)

Use this command to list up to the last four projects and/or forms most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.


File Menu Recent Forms/Projects Popup

The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.


File Menu Recent Forms/Projects Popup2

The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.


File Menu Recent Forms/Projects Popup3

The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.


File Menu Recent Forms/Projects Popup4

The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.


File Menu Save All Command Ref

Save All Forms (File and Form menus)

Use this command to save all open forms if you are working on more than one form at a time. If any open forms have not been saved before, WOW Extensions displays a standard Windows Save As dialog box so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Save All Forms command on the File menu and the Save All command on the Form menu are equivalent.

Shortcut

Toolbar: on the File toolbar


File Menu Save Command Ref

Save Form (File and Form menus)

Use this command to save changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Save Form command on the File menu and the Save command on the Form menu are equivalent.

Shortcuts

Toolbar: on the File toolbar

Keys: Ctrl+S


Files Installed on a UNIX Server See Also

Installing and Configuring WOW Thin Client

Understanding WOW Thin Client


Files Installed on a Windows Server See Also

Installing and Configuring WOW Thin Client

Understanding WOW Thin Client


Files Installed on the Windows Client Workstation See Also

Installing and Configuring WOW Thin Client

Understanding WOW Thin Client


Files of Type Project Properties

The Files of type list box specifies which filenames are listed in the List area from a preset list of file types, based on the filename extensions (listed in parentheses). To look for a file type other that the default, use the mouse or keyboard to select any file type from the list. WOW Extensions will substitute that extension for the current entry in the Files of Type list box and display only files with the same extension in the List area.

Note The initial content of the list box is set to *.wow, the default extension for a WOW form file.


File Toolbar New Form

New Form (File Toolbar)

Use the New Form button to add a new, blank form to an open project.

This button corresponds to the New command on either the File or Form menu.


File Toolbar Open Form

Open Form (File Toolbar)

Use the Open Form button to retrieve an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified.

This button corresponds to the Open command on either the File or Form menu.


File Toolbar Open Member

Open Member (File Toolbar)

Use the Open Member button to display a list of all the files (members) in the open, active project from which you can open a member.

Note Members can also be added to and deleted from the project at any time with the Properties command.

This button corresponds to the Open Member command on the Project menu.


File Toolbar Print Form Command Ref

Print Form (File Toolbar)

Use the Print Form button to print a form. If more than one form is open, the form on top of the stack is printed. Selecting this command opens a standard Windows Print dialog box.

This button corresponds to the Print command on the Form menu.


File Toolbar Save All Forms

Save All Forms (File Toolbar)

Use the Save All Forms button to save changes made to all open form files. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

This button corresponds to the Save All command on either the File or Form menu.


File Toolbar Save Form and Generate Code

Save Form and Generate Code (File Toolbar)

Use the Save Form and Generate Code button to save changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

This button corresponds to the Save command on either the File or Form menu.


Fill Property

The Fill property is a design-time-only property that determines whether the geometric shape (ellipse, line, rectangle, or rounded rectangle control) is filled by the current brush.

The following table lists the possible values of the Fill property:

Value | Description
False | The shape is not filled by the brush.
True | The shape is filled by the brush (the default).


Finding an Item

To find a specific item in a list box, use the LB-FINDSTRING or LB-FINDSTRINGEXACT message. The LB-FINDSTRING message finds the first entry in the list box that begins with the specified value. The LB-FINDSTRINGEXACT message finds the first entry in the list box that exactly matches the specified value. The messages are sent in the same manner:

CALL SENDMESSAGE USING WIN-RETURN LB-H LB-FINDSTRING
INDEX-START SEARCH-TEXT.

WIN-RETURN is the relative position of the item if found, or LB-ERR if an item is not found. LB-H is the handle of the list box. INDEX-START is the zero-based relative position at which the search should begin. SEARCH-TEXT is the alphanumeric literal or data item for which to search.


Find Toolbar Find in Code Fragments

Find in Code Fragments (Find Toolbar)

Use the Find in Code Fragments button to display the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code. Results are displayed on the Find in Code tab on the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window.

This button corresponds to the Find in Code command on the Edit menu and to the Find in Code Fragments button on the Editing toolbar.


FirstDayOfWeek MC Property

The FirstDayOfWeek property specifies the first day of the week for a month calendar control.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the FirstDayOfWeek property:

Value | Description
0 | Monday (the default)
1 | Tuesday
2 | Wednesday
3 | Thursday
4 | Friday
5 | Saturday
6 | Sunday


FixedWidth Property

The FixedWidth property allows all tabs to be the same width. Note that this property also can be changed using the Fixed Width check box in the Tab Control Editor dialog box.

The following table lists the possible values of the FixedWidth property:

Value | Description
False | Tabs are displayed with varying widths (the default).
True | Tabs are displayed in the same width.


Flat Tree

When selected, the Flat Tree check box removes the categorical grouping of the functions and message shortcuts available in WOW Extensions and lists all the available functions in alphabetical order.

Note In this view, the names of the ActiveX functions are preceded by the prefix ActiveX-, the names of the RPC functions are preceded by RPC-, and the names of the Thin Client functions are preceded by ThinClient-, and thus are alphabetized accordingly.


FontBold Property

The FontBold property determines whether the associated text for the control is displayed in bold font format.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must have a WOW form as a parent.

The following table lists the possible values of the FontBold property:

Value | Description
False | Text is not displayed bold (the default).
True | Text is displayed bold.


FontItalic Property

The FontItalic property determines whether the associated text of the control is displayed in italic font format.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must have a WOW form as a parent.

The following table lists the possible values of the FontItalic property:

Value | Description
False | Text is not displayed in italics (the default).
True | Text is displayed in italics.


Font Name (Control Specific Page)

The Font Name column refers to control-specific edit boxes that allow you to specify the name of the font to use for text in the field/control.


FontName Property

The FontName property determines the font used to display text in a control. The font specified must be present on the system.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must have a WOW form as a parent.


Fonts & Colors Preferences See Also

Setting Preferences


Font Size (Control Specific Page)

The Font Size column refers to control-specific edit boxes that allow you to specify the size, in pixels, of the font specified in the Font Name column.


FontSize Property

The FontSize property determines the size of the font to be used for text displayed in a control. The size specified must be supported by the font. If the size is not supported by the font, the system will substitute the nearest supported value.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must have a WOW form as a parent.


FontStrikethru Property

The FontStrikethru property determines whether the associated text for the control is displayed in a strikethrough font style.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must have a WOW form as a parent.

The following table lists the possible values of the FontStrikethru property:

Value | Description
False | No strikeout is used (the default).
True | Strikeout is used.


FontUnderline Property

The FontUnderline property determines whether the associated text for the control is displayed in an underlined font format.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must have a WOW form as a parent.

The following table lists the possible values of the FontUnderline property:

Value | Description
False | Text is not underlined (the default).
True | Text is underlined.


For Aligning Controls (General Page)

The edit boxes and check boxes in the For Aligning Controls group allow you to control the conversion from row and column positioning of controls on character- and GUI-based panels to pixel positioning when those panels are converted to WOW forms.

· The value in the Line Height edit box is multiplied by the row number of a panel field in order to determine the vertical pixel position of the control on a form when it is converted to WOW. This edit box provides an alternative to using the default Static Text font size to determine vertical pixel positioning and is enabled unless the Use Static Text Font Size for Line/Column Spacing check box is not selected.

· The value in the Line Height Factor edit box, which is preset to 1, specifies a factor by which to multiply the value in the Line Height edit box or the Static Text font height.

· The value in the Column Width edit box is multiplied by the column number of a panel field in order to determine its horizontal pixel position when it is converted to a WOW control. This edit box provides an alternative to using the default Static Text font size to determine horizontal pixel positioning and is enabled unless the Use Static Text Font Size for Line/Column Spacing check box is not selected.

· The value in the Column Width Factor edit box specifies a factor by which to multiply the Column Width or the Static Text font width.

· The Use Static Text Font Size for Line/Column Spacing check box, selected by default, uses the size of the font specified for the Static Text field/control to determine vertical and horizontal pixel positioning of controls when panels are converted to WOW forms.

· The value in the Vertical Gap edit box determines the amount of additional space, in pixels, to add to the vertical positioning value as determined in the above calculations.

· The value in the Horizontal Gap edit box determines the amount of additional space, in pixels, to add to the horizontal positioning value as determined in the above calculations.

· The Compute actual width of controls with text check box, when selected, computes the width of fields/controls based on the font size and the text inside the field.


ForceLabelLeft Property

The ForceLabelLeft property is a design-time-only property that determines whether tab static texts are forced to the left. If the ForceLabelLeft property is set, the FixedWidth property must be set to True. Note that this property also can be changed using the Forced Label Left check box in the Tab Control Editor dialog box.

The following table lists the possible values of the ForceLabelLeft property:

Value | Description
False | Tabs are not forced to the left (the default).
True | Tabs are forced to the left.


For Controls Colors

Use the Control Colors area to set the Default Foreground Color and Default Background Color for the controls at design time and runtime. The RGB (Red, Green, Blue) values for the current color selections are displayed in the text entry boxes, and samples of the colors are shown in the sample display boxes.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground and background colors for the controls. For more information on setting the Color dialog box options, see the Foreground Color and Background Color commands on the Control menu.


ForeColor Property

The ForeColor property determines the color of text in a control. The property is a numeric value with nine digits specifying colors as RRR,GGG,BBB.

In the RGB color model, valid red, green, and blue values are in the range from 0 to 255, with 0 indicating the minimum intensity and 255 indicating the maximum intensity. Set the ForeColor property with any value in the range from 000 to 255255255.

When you click on the value area of the property, an ellipsis appears. Clicking on the ellipsis causes a variation of the standard Windows Color dialog box to open so that you can define the basic colors, custom colors, and system colors for the foreground color of the control(s).

Note This property can be manipulated at design time and either retrieved or set at runtime for most controls; however, this property cannot be set or retrieved at runtime for the ellipse, line, rectangle, or rounded rectangle shapes.


For Forms Colors

Use the Form Color is area to set the Default Background Color for a form at design time and runtime. The RGB (Red, Green, Blue) value for the current color selection is displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default background color for the form. For more information on the Color dialog box settings for forms, see the Background Color command on the Form menu.


For Form Sizing (General Page)

The edit boxes in the For Form Sizing group allow you to specify the margin settings for the outermost fields/controls on the panels/forms in the library. The Top Margin, Left Margin, Right Margin, and Bottom Margin edit boxes determine the amount of space, in pixels, between the edges of those outermost fields/controls and the edge of the panel/form. The default value is two pixels.


For Logging

The For Logging area contains options for controlling the use of a tracing log.

· The File option allows you to enter a filename for the trace log.

· The Level option allows you to specify the level of detail contained in the trace log, where:

-  0 = None

-  1 = Log Wow Runtime Calls

-  2 = Log Wow Runtime Call Arguments

-  3 = Log Panels Runtime Calls


Format Property Date Time

The Format property determines the date-time format in which the date is displayed. The date-time format is based on the user’s regional settings in their operating system.

This property can be set either at design time or at runtime. It cannot, however, be retrieved at runtime.

Date and time format elements will be replaced by the actual date and time. They are defined by the following groups of characters:

Value | Description
“d” | The one- or two-digit day.
“dd” | The two-digit day. Single-digit day values are preceded by a zero.
“ddd” | The three-character weekday abbreviation.
“dddd” | The full weekday name.
“h” | The one- or two-digit hour in 12-hour format.
“hh” | The two-digit hour in 12-hour format. Single-digit values are preceded by a zero.
“H” | The one- or two-digit hour in 24-hour format.
“HH” | The two-digit hour in 24-hour format. Single-digit values are preceded by zero.
“m” | The one- or two-digit minute.
“MM” | The two-digit month. Single-digit values are preceded by a zero.
“MMM” | The three-character month abbreviation.
“MMMM” | The full month name.
“t” | The one-letter AM/PM abbreviation (that is, AM is displayed as “A”).
“tt” | The two-letter AM/PM abbreviation (that is, AM is displayed as “AM”).
“yy” | The last two digits of the year (that is, 1996 would be displayed as “96”).
“yyyy” | The full year (that is, 1996 would be displayed as “1996”).

To make the information more readable, you can add body text to the format string by enclosing it in single quotes. Spaces and punctuation marks do not need to be quoted.

Note Non-format characters that are not delimited by single quotes will result in unpredictable display by the date time picker control.

For example, to display the current date with the format “’Today is: 04:22:31 Tuesday Mar 23, 1996”, the format string is “’Today is: ‘hh’:’m’:’s dddd MMM dd’, ‘yyyy”. To include a single quote in your body text, use two consecutive single quotes. For example, “’Don’’t forget’ MMM dd’,’ yyyy” produces output that looks like: Don’t forget Mar 23, 1996. It is not necessary to use quotes with the comma, so “’Don’’t forget’ MMM dd, yyyy” is also valid, and produces the same output.


Form Description Popup

Forms are the containers within which you group controls. In traditional programming, you place fields on the screen or in a pop-up window. With WOW Extensions, you place fields (that is, controls) in a form. The form has only default properties associated with it.


Form Menu Arrange Icons Command Ref

Arrange Icons (Form menu)

Use this command to distribute forms that have been reduced (using the Minimize button) to icons evenly along the lower edge of the WOW Designer window.


Form Menu Arrange Icons Popup

The Arrange Icons command distributes forms that have been reduced (using the Minimize button) to icons evenly along the lower edge of the WOW Designer window.


Form Menu Background Color Command Ref

Background Color (Form menu)

Use this command to change the background (fill) color of a form. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of a form.

Note You can also set the background color of a form from the form’s Properties dialog box. On the Properties dialog box, this property is called BackColor.


Form Menu Background Color Popup

The Background Color command changes the background (fill) color of a form. A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of a form.

Note You can also set the background color of a form from the form’s Properties dialog box. On the Properties dialog box, this property is called BackColor.


Form Menu Cascade Command Ref

Cascade (Form menu)

Use this command to arrange multiple open forms in an overlapped pattern so that the title bar of each form is visible in the WOW Designer window. You can access the form you want by clicking on the title bar to bring it to the front of the stack.


Form Menu Cascade Popup

The Cascade command arranges multiple open forms in an overlapped pattern so that the title bar of each form is visible in the WOW Designer window. You can access the form you want by clicking on the title bar to bring it to the front of the stack.


Form Menu Close All Command Ref

Close All (File and Form menus)

Use this command to close all open forms. If a form has changes that have not been saved, WOW Extensions prompts you to save the changes in each form before closing. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Close All command on the Form menu and the Close All Forms command on the File menu are equivalent.


Form Menu Close Command Ref

Close (Form and File menus)

Use this command to close a form file without leaving WOW Extensions. If you have not made changes to the form since you last opened or saved it, WOW Extensions will immediately close the form.

If you have made changes to the form, however, WOW Extensions will display a message box asking whether you want to save the changes to the form. If you choose Yes and the current form has previously been saved, WOW Extensions will save the form under its current name and then close it. If you choose Yes and the form has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it, as described under the Save As command. If you choose No, WOW Extensions will close the form without saving the changes. If you choose Cancel, WOW Extensions will return you to the form without saving it or closing it.

If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Close command on the Form menu and the Close Form command on the File menu are equivalent.

Shortcuts

Keys: Ctrl+F4

Click Close on the Control menu.


Form Menu Commands See Also

Forms

Manipulating Controls in a Form

Properties and Events for Forms


Form Menu Edit Code Form Events Command Ref

Edit Code | Form Events (Form menu)

Use this command to open the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected item.

Shortcuts

Toolbar: on the View toolbar

Or, from the Project tree, select a form name, then right-click to display a pop-up menu. On the Edit Code submenu, choose Form Events.


Form Menu Edit Code Form Events Popup

The Edit Code | Form Events command opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected item.


Form Menu Edit Code Menus Events Command Ref

Edit Code | Menus Events (Form menu)

Use this command to open the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected item.

Shortcuts

Toolbar: on the View toolbar

Or, from the Project tree, select a form name, then right-click to display a pop-up menu. On the Edit Code submenu, choose Menus Events.


Form Menu Edit Code Menus Events Popup

The Edit Code | Menus Events command opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected item.


Form Menu New Command Ref

New (Form and File menus)

Use this command to add a new, blank form to an open project. If a project is not open, this command is unavailable.

The New command on the Form menu and the New Form command on the File menu are equivalent.

Shortcuts

Toolbar: on the File toolbar

Keys: Ctrl+N


Form Menu Open All Command Ref

Open All (Form and File menus)

Use this command to open all forms in the project that is currently open for this session. If a project is not open, this command is unavailable.

The Open All command on the Form menu and the Open All Forms command on the File menu are equivalent.


Form Menu Open Command Ref

Open (Form and File menus)

Use this command to retrieve an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified. If a project is not open, this command is unavailable.

The Open command on the Form menu and the Open Form command on the File menu are equivalent.

Shortcuts

Toolbar: on the File toolbar

Keys: Ctrl+O


Form Menu Print Command Popup

The Print command prints a form. If more than one form is open, the form on top of the stack is printed. Selecting this command opens a standard Windows Print dialog box.


Form Menu Print Command Ref

Print (Form menu)

Use this command to print a form. If more than one form is open, the form on top of the stack is printed. Selecting this command opens a standard Windows Print dialog box.

Shortcuts

Toolbar: on the File toolbar

Keys: Ctrl+P


Form Menu Recent Forms Command Ref

Recent Forms (Form menu)

Use this command to list the forms that are open in the current project of the WOW Designer. To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.


Form Menu Recent Forms Popup

The Recent Forms command lists the forms that are open in the current project of the WOW Designer. To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.


Form Menu Recent Forms Popup2

The Recent Forms command lists the forms that are open in the current project of the WOW Designer. To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.


Form Menu Recent Forms Popup3

The Recent Forms command lists the forms that are open in the current project of the WOW Designer. To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.


Form Menu Recent Forms Popup4

The Recent Forms command lists the forms that are open in the current project of the WOW Designer. To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.


Form Menu Regenerate All Command Ref

Regenerate All (Form menu)

Use this command to regenerate COBOL source programs for all forms in the project, not just the active form.


Form Menu Regenerate All Popup

The Regenerates All command regenerates COBOL source programs for all forms in the project, not just the active form.


Form Menu Regenerate Command Ref

Regenerate (Form menu)

Use this command to generate an existing COBOL source program if modifications have been made to a form. This command regenerates COBOL source code for the active form.


Form Menu Regenerate Popup

The Regenerate command generates an existing COBOL source program if modifications have been made to a form. This command regenerates COBOL source code for the active form.


Form Menu Restore Properties From Global Defaults Command Ref

Restore Properties (Form menu)

Use this command to restore the default property settings for a form. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets the properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets the properties from the cblwow.ini initialization file.


Form Menu Restore Properties From Global Defaults Popup

The Restore Properties | From Global Defaults command resets the form's properties from the cblwow.ini initialization file.


Form Menu Restore Properties From Project Defaults Command Ref

Restore Properties (Form menu)

Use this command to restore the default property settings for a form. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets the properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets the properties from the cblwow.ini initialization file.


Form Menu Restore Properties From Project Defaults Popup

The Restore Properties | From Project Defaults command resets the form's properties from the project definition file (.wpj).


Form Menu Save All Command Ref

Save All (Form and File menus)

Use this command to save all open forms if you are working on more than one form at a time. If any open forms have not been saved before, WOW Extensions displays a standard Windows Save As dialog box so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Save All command on the Form menu and the Save All Forms on the File menu are equivalent.

Shortcut

Toolbar: on the File toolbar


Form Menu Save As Command Ref

Save As (Form and File menus)

Use this command to save a form file under a new name or in a different directory/folder or drive. The standard Windows Save As dialog box opens so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Save As command on the Form menu and the Save Form As command on the File menu are equivalent.

Note The name of the form file is significant, as it identifies the form to the underlying program. Form files are, by default, given the extension of .wow. The form filename is also used to identify and generate two copy files. The first copy file, with the filename extension of .wpr, contains the COBOL logic necessary for the form. The second file, with the extension of .wss, is the COBOL Working Storage copy file needed for the form. For more information, click here.


Form Menu Save Command Ref

Save (Form and File menus)

Use this command to save changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename. If a project is open but no forms are open in that project, or if no project is open, this command is not available.

The Save command on the Form menu and the Save Form command on the File menu are equivalent.

Shortcuts

Toolbar: on the File toolbar

Keys: Ctrl+S


Form Menu Save Properties For Global Use Command Ref

Save Properties (Form menu)

Use this command to save the modified property settings for a form. Each form that you create includes a set of initial properties and values. During design time, you can change and customize the property settings, and attach code to create the user interface appearance of your program. Once you have modified a form, you may want to save it and reuse it in other projects. Such predefined forms are helpful in providing a consistent look and behavior throughout your program. When you choose the Save Properties command, two submenus appear:

· For Project Use. Choosing this option saves the form’s properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.

· For Global Use. If you want to reuse the modified form in a different project, choose the For Global Use option to save the form’s properties to the cblwow.ini initialization file.


Form Menu Save Properties For Global Use Popup

The Save Properties | For Global Use command saves the form’s properties to the cblwow.ini initialization file so that you may reuse the modified form in a different project.


Form Menu Save Properties For Project Use Command Ref

Save Properties (Form menu)

Use this command to save the modified property settings for a form. Each form that you create includes a set of initial properties and values. During design time, you can change and customize the property settings, and attach code to create the user interface appearance of your program. Once you have modified a form, you may want to save it and reuse it in other projects. Such predefined forms are helpful in providing a consistent look and behavior throughout your program. When you choose the Save Properties command, two submenus appear:

· For Project Use. Choosing this option saves the form’s properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.

· For Global Use. If you want to reuse the modified form in a different project, choose the For Global Use option to save the form’s properties to the cblwow.ini initialization file.


Form Menu Save Properties For Project Use Popup

The Save Properties | For Project Use command saves the form’s properties to the project definition file (.wpj). These property settings become the new default settings for the controls when they are used in that particular project.


Form Menu Show Grid Command Ref

Show Grid (Form menu)

Use this command to toggle the display of the grid, an evenly spaced pattern of pixels (screen dots) that appear in a form, on and off. The grid helps you to draw, position, align, and size controls exactly where you want them in a form. The grid is displayed by default. When a check mark appears next to this command on the menu, it indicates that the grid is visible. If the command is no longer active, the check mark is removed and the grid is hidden.

The default spacing of the grid points is 10 x 10 pixels. To modify the vertical and horizontal spacing of the grid marks (the X and Y coordinates), see the initial Show Grid option on the General Preferences page of the Preferences dialog box. Although you see the grid marks on the form in the WOW Designer, they are not displayed at runtime.


Form Menu Show Grid Popup

The Show Grid command toggles the display of the grid, an evenly spaced pattern of pixels (screen dots) that appear in a form, on and off. The grid helps you to draw, position, align, and size controls exactly where you want them in a form. The grid is displayed by default. When a check mark appears next to this command on the menu, it indicates that the grid is visible. If the command is no longer active, the check mark is removed and the grid is hidden.

The default spacing of the grid points is 10 x 10 pixels. To modify the vertical and horizontal spacing of the grid marks (the X and Y coordinates), see the Show Grid option on the General Preferences page of the Preferences dialog box. Although you see the grid marks on the form in the WOW Designer, they are not displayed at runtime.


Form Menu Snap to Grid Command Ref

Snap to Grid (Form menu)

Use this command to toggle the snap-to-grid option, which forces controls into perfect horizontal and/or vertical alignment to the nearest grid point, on and off. The Snap to Grid option is enabled by default (see the initial Snap to Grid option on the General Preferences page of the Preferences dialog box for more information).

When a check mark appears next to this command on the menu, it indicates that the snap-to-grid option is enabled. If the command is no longer active, the check mark is removed and the snap-to-grid option is no longer in effect. When you align or move a control with Snap to Grid enabled, the handles on the selected control are forced to the nearest grid point. You determine which of the eight handles snaps to the grid by controlling the direction in which you move the control.


Form Menu Snap to Grid Popup

The Snap to Grid command toggles the snap-to-grid option, which forces controls into perfect horizontal and/or vertical alignment to the nearest grid point, on and off. The Snap to Grid option is enabled by default (see the initial Snap to Grid option on the General Preferences page of the Preferences dialog box for more information).

When a check mark appears next to this command on the menu, it indicates that the snap-to-grid option is enabled. If the command is no longer active, the check mark is removed and the snap-to-grid option is no longer in effect. When you align or move a control with Snap to Grid enabled, the handles on the selected control are forced to the nearest grid point. You determine which of the eight handles snaps to the grid by controlling the direction in which you move the control.


Form Menu Test Command Ref

Test (Form menu)

Use this command to run, from within the WOW Designer, a simplified version of the WOW runtime (wowtestform.exe) without executing COBOL code in order to see how a form will appear at runtime and test its operation during the design process. This test program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

Shortcut: F6
Alternative: Click Test Form on the Project toolbar.


Form Menu Test Popup

The Test command runs, from within the WOW Designer, a simplified version of the WOW runtime (wowtestform.exe) without executing COBOL code in order to see how a form will appear at runtime and tests its operation during the design process. This test program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.


Form Menu Tile Horizontally Command Ref

Tile Horizontally (Form menu)

Use this command to arrange multiple open forms in rows with no overlap so that all forms are visible within the workspace. To access the form you want, click the title bar.


Form Menu Tile Horizontally Popup

The Tile Horizontally command arranges multiple open forms in rows with no overlap so that all forms are visible within the workspace. To access the form you want, click the title bar.


Form Menu Tile Vertically Command Ref

Tile Vertically (Form menu)

Use this command to arrange multiple open forms in columns (side by side) with no overlap so that all forms are visible within the workspace. To access the form you want, click the title bar.


Form Menu Tile Vertically Popup

The Tile Vertically command arranges multiple open forms in columns (side by side) with no overlap so that all forms are visible within the workspace. To access the form you want, click the title bar.


Form Object See Also

Property Manipulation Checklist


Forms See Also

Properties and Events for Forms

Using Global Default Property Settings

Windows GUI Elements

WOW Extensions Development Process


Form Test Program

Use the Form Test Program area to specify the location of the form test program, wowtestform.exe. This test form program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

The Directory text box allows you to specify the form test program’s installation directory, which must exist or be accessible when testing a form with the WOW Designer.


Functions and Messages See Also

Windows GUI Elements

WOW Extensions Development Process


General Preferences See Also

Setting Preferences


Generate Form -FRMH Handles (Project Options)

The Generate Form -FRMH Handles option adds the suffix -FRMH to the name of the form. This prevents a form from having the same name as a control, which would cause duplicate variables.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.


Generate - FRMH Form Handles

In the New Project Options area, the Generate -FRMH Form Handles option adds the suffix -FRMH to the name of the form. This prevents a form from having the same name as a control, which would cause duplicate variables.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Multiple Evaluate Events Paragraphs

In the New Project Options area, the Generate Multiple Evaluate Events Paragraphs option, when selected, causes the WOW Designer to generate multiple paragraphs (instead of the default, single paragraph) when evaluating events in large applications in order to avoid reaching the COBOL compiler paragraph size limit.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Multiple Evaluate Events Paragraphs (Project Options)

The Generate Multiple Evaluate Events Paragraphs option, when selected, causes the WOW Designer to generate multiple paragraphs (instead of the default, single paragraph) when evaluating events in large applications in order to avoid reaching the COBOL compiler paragraph size limit.


Generate Nested Programs

In the New Project Options area, the Generate Nested Programs option causes the project to be generated in a fully block-structured form. Subprograms can be nested within the main program and with other subprograms. Each subprogram can own variables not visible to the other programs, and all calls to subprograms can pass parameters. In order to use the Generate Old-Style Paragraph Names option, the Generate Nested Programs option must not be selected.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Nested Programs (Project Options)

The Generate Nested Programs option, when selected, overrides the default setting on the Code Preferences page of the Preferences dialog box that was established when the project was created. This option causes the project to be generated in a fully block-structured form.


Generate Old-Style Paragraph Names

In the New Project Options area, the Generate Old-Style Paragraph Names option, when selected, allows new projects created with WOW Extensions to use old-style paragraph names; that is, paragraph names with the format, WP-DESTROY-FORMNAME. In order for old-style paragraph names to be used, the Generate Nested Programs option must not be selected.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Old-Style Paragraph Names (Project Options)

The Generate Old-Style Paragraph Names option, when selected, overrides the setting on the Code Preferences page of the Preferences dialog box that allows projects created with WOW Extensions later to use old-style paragraph names; that is, with the format, WP-DESTROY-FORMNAME. In order for old-style paragraph names to be used, the Generate Nested Programs option must not be selected. If the Generate Nested Programs option is selected, the value of Generate Old-Style Paragraph Names option is ignored.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code page of the Preferences dialog box.


Generate Old-Style Working Storage Guard Names

In the New Project Options area, the Generate Old-Style Working-Storage Guard Names option, when selected, causes the WOW Designer to generate Working-Storage guard names that are limited to 30 characters in length, which was the case in versions prior to 10.01. Versions 10.01 and later of the WOW Designer can generate names up to 240 characters long. Selecting this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Old-Style Working Storage Guard Names (Project Options)

The Generate Old-Style Working Storage Guard Names option, when selected, causes the WOW Designer to generate Working-Storage guard names that are limited to 30 characters in length, which was the case in versions prior to 10.01. Version 10.01 and later of the WOW Designer will generate names up to 240 characters long. Choosing this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.


Generate Short (72 column) Lines

In the New Project Options area, the Generate Short (72 column) Lines option, when selected, causes the WOW Designer to generate COBOL source records ending at column 72 (for backward compatibility). If this option is not selected, source records with longer line lengths (now allowed by an RM/COBOL compiler directive) are generated.

Note This initial value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Short (72-column) Lines (Project Options)

The Generate Short (72 column) Lines option, when selected, causes the WOW Designer to generate COBOL source records ending at column 72 (for backward compatibility). If this option is not selected, source records with longer line lengths (now allowed by an RM/COBOL compiler directive) are generated.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.


Generate Short Control Handles

In the New Project Options area, the Generate Short Control Handles option, which is enabled by default, removes the suffix -H from the name of the control or form in order to avoid duplicate variable names.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Short Control Handles (Project Options)

The Generate Short Control Handles option, which is enabled by default, removes the suffix -H from the name of the control or form in order to avoid duplicate variable names.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.


Generate Untruncated Paragraph Names

In the New Project Options area, the Generate Untruncated Paragraph Names option, which is enabled by default, allows the WOW Designer to generate paragraph names that are no longer abbreviated (or truncated) in order to avoid duplicate paragraph names caused by the previous truncation scheme. Selecting this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Untruncated Paragraph Names (Project Options)

The Generate Untruncated Paragraph Names option, when selected, allows the WOW Designer to generate paragraph names that are no longer abbreviated (or truncated) in order to avoid duplicate paragraph names caused by the previous truncation scheme. Selecting this option prevents projects created with earlier versions of WOW Extensions from having compilation errors due to references to the older maximum of 30-character names.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.


Generate Working Storage Comments

In the New Project Options area, the Generate Working Storage Comments option, which is enabled by default, generates comment lines in the Working Storage copy file (.wws) for WOW forms. To make the source file smaller, deselect this option. Having a smaller source file helps ensure that the RM/COBOL compiler can accommodate the WOW program.

Note This initial default value can be overridden for a project by specifying a different value for the equivalent configuration option on the Project Options dialog box.


Generate Working Storage Comments (Project Options)

The Generate Working Storage Comments option, when selected, generates comment lines in the Working Storage copy file (.wws) for WOW forms. To make the source file smaller, deselect this option. Having a smaller source file helps ensure that the RM/COBOL compiler can accommodate the WOW program.

Note Selecting this option allows you to specify a different value for the project than the one initially set by default for this configuration option on the Code Preferences page of the Preferences dialog box.


GeographicMotion

The GeographicMotion property determines whether the movement of the cursor between fields/controls on the panel/form during input is based on the field/control sequence number of their physical location on the monitor.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the GeographicMotion property:

Value | Description
False | Cursor motion is not based on the physical location of fields/controls on the monitor (the default).
True | Cursor motion is based on the physical location of fields/controls on the monitor.


GETFOCUS

Window Windows API Function

The GETFOCUS function retrieves the handle of the window that currently has the input focus.

Calling Sequence

CALL GETFOCUS USING WND-H.

Parameter | Declaration | Description
WND-H | PIC 9(10) BINARY(8) | The return value is the handle of the focus window. If no window has the focus, it is zero.


GetFocus Event Form

The GetFocus event occurs when the form gets input focus.


GetFocus Property

The GetFocus property is a design-time-only property that determines whether the text of the selected tab has input focus. Setting the GetFocus property to Never (2) on a tab control prevents input focus from going to the text of the selected tab. It does not prevent focus from going to any of the controls on the tab. When the tab control receives focus, the text of the tab itself gets selected with a box. Note that this property also can be changed using the Get Focus check box in the Tab Control Editor dialog box.

The following table lists the possible values of the GetFocus property:

Value | Description
0 | Default. The Tab key on the keyboard can be used to give input focus to the selected tab (the default).
1 | On Button Down. The selected tab receives input focus when clicked with the mouse.
2 | Never. The selected tab does not receive input focus.


Get Focus (Tab Editor)

The Get Focus area allows you to change the following properties for the tab control. These properties determine whether the text of the selected tab has input focus:

· Default. When selected, the Default option button causes the Tab key on the keyboard to be used to give input focus to the selected tab (the default). Note that this value also can be changed using the GetFocus property in the Properties dialog box and selecting a value of 0.

· On Button Down. When selected, the On Button Down option button causes the selected tab to receive input focus when clicked with the mouse. Note that this value also can be changed using the GetFocus property in the Properties dialog box and selecting a value of 1.

· Never. When selected, the Never option button prevents input focus from going to the text of the selected tab. It does not prevent focus from going to any of the controls on the tab. Note that this value also can be changed using the GetFocus property in the Properties dialog box and selecting a value of 2.


GotFocus Event

The GotFocus event occurs when the control receives the focus.


Go To (Edit Bookmark)

The Go To command button closes the Edit Bookmarks dialog box and highlights the line of code associated with the selected bookmark.


Go To (Go To Bookmark)

The Go To command button closes the Go To Bookmark dialog box and highlights the line of code specified by the selected bookmark.


Graphic ActiveX Methods Dialog Box

Active X Methods Dialog Box


Graphic Alignment Preferences Page

Alignment Preferences Page


Graphic Code Edit Windows Preferences Page

Code Edit Windows Preferences Page


Graphic Code Preferences Page

Code Preferences Page


Graphic Code Templates Tree

Code Templates Tree


Graphic Customize Toolbar Dialog Box

Customize Toolbar Dialog Box


Graphic Customize Toolbox Dialog Box

Customize Toolbox Dialog Box


Graphic Edit Bookmarks Dialog Box

Edit Bookmarks Dialog Box


Graphic Event-Handling Code Dialog Box

Event-Handling Code Dialog Box


Graphic External Edit Comparison Dialog Box

External Edit Comparison Dialog Box


Graphic Find and Replace Dialog Box

Find & Replace Dialog Box


Graphic Find Dialog Box

Find Dialog Box


Graphic Fonts & Colors Preferences Page

Fonts & Colors Preferences Page


Graphic General Preferences Page

General Preferences Page


Graphic Go To Bookmark Dialog Box

Go To Bookmark Dialog Box


Graphic Menu Editor Dialog Box

Menu Editor Dialog Box


Graphic Panel Import Preferences Dialog Box Control-Specific

Control-Specific – Panel Import Preferences Dialog Box


Graphic Panel Import Preferences Dialog Box General

General Tab – Panel Import Preferences Dialog Box


Graphic Project Options Dialog Box

Project Options Dialog Box


Graphic Project Output Dialog Bar

Project Output Dialog Bar


Graphic Project Properties Dialog Box

Project Properties Dialog Box


Graphic Project Tree Expanded

Project Tree


Graphic Properties Dialog Box

Alphabetic Tab - Properties Dialog Box


Graphic Runtime Preferences Page

Runtime Preferences Page


Graphic Select ActiveX Controls Dialog Box

Select ActiveX Controls Dialog Box


Graphic Tab Control Editor Dialog Box

Tab Control Editor Dialog Box


Graphic Tab Order Editor Dialog Box

Tab Order Editor Dialog Box


Graphic Toolbox

Toolbox


Graphic Tools Preferences Page

Tools Preferences Page


Graphic WOW Designer Window

WOW Designer Window


Graphic Z-Order Editor Dialog Box

Z-Order Editor Dialog Box


Grid

The options in the Grid area control the vertical and horizontal spacing of the grid coordinates on the form. The default spacing is 10 x 10 pixels.

· To change the spacing in the horizontal grid, click the X Increment box and type a value.

· To change the spacing in the vertical grid, click the Y Increment box and type how many vertical grid marks you want to be visible.

Note If the Snap to Grid command on the Form menu is enabled, you can align controls to the grid. When you align controls to the grid, the bounds (or edges) of the controls are lined up as specified, snapping to the nearest grid point. The Snap to Grid option on the General Preferences page is enabled by default.


Group Box Control Object See Also

Property Manipulation Checklist


Group Box Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Group Property

The Group property determines whether a control is the start of a group.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must be a child control having the Windows style, WS-CHILD.

The following table lists the possible values of the Group property:

Value | Description
False | Control is not the start of a group (the default).
True | Control is the start of a group.


Group Property ActiveX

The Group property determines whether the ActiveX control is the start of a group.

Note This property can be retrieved or set either at design time or at runtime; however, at runtime, the control must be a child control having the Windows style, WS-CHILD.

The following table lists the possible values of the Group property:

Value | Description
False | Control is not the start of a group (the default).
True | Control is the start of a group.


Handles See Also

Windows GUI Elements

WOW Extensions Development Process


Handling Data See Also

Addressing Issues in Data Entry Programs


Handling Different Types of Data See Also

Addressing Issues in Data Entry Programs


Handling Events for Controls, Forms, and Projects See Also

Properties and Events for Forms

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Height (Control Specific Page)

The Height column refers to control-specific edit boxes that control the computation of the height of a control, override the default setting of either the Line Height edit box or the Use Static Text Font Size for Line/Column Spacing check box on the General tab. The Height column edit boxes allow you specify a different height for the control when a panel library is converted to WOW. If this value is set to zero, the control’s height will be computed based on one of the following:

· the values in the Font Size and Font Name columns (if specified), or

· the value in the Line Height edit box, or

· the Static Text font height (when the Use Static Text Font Size for Line/Column Spacing check box is selected) on the General tab

plus the value specified in the Extra Height column.


Height Property

The Height property determines, in pixels, the height of the control.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Height property with any value from 0 to the value specified in the Height property of the form less the value specified in the Top property of the control.


Height Property ActiveX

The Height property determines, in pixels, the height of the ActiveX control.

Set the Height property with any value from 0 to the value specified in the Height property of the form less the value specified in the Top property of the control.


Height Property Form

The Height property determines the height, in pixels, of a form.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Height property with any value from 0 to the height of the screen display less the value specified in the Top property.


HelpAttr

The HelpAttr property indicates the default attribute code for error messages. Valid values are blank (the library default) or A through P.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Help Button Bar See Also

Using WOW Extensions Help


Help (Customize Toolbar)

The Help command button displays an overview of this dialog box.


Help Menu About Command Ref

About (Help menu)

Use this command to display the version number, copyright notice, the name and company of the person the copy is licensed to, the serial number, and other information about the WOW Designer product that is currently running.

Shortcut

Toolbar: on the Help toolbar


Help Menu About Popup

The About command displays the version number, copyright notice, the name and company name of the person the copy is licensed to, the serial number, and other information about the WOW Designer product that is currently running.


Help Menu Designer Help Command Ref

Designer (Help menu)

Use this command to launch the WOW Designer online Help file.


Help Menu Designer Help Popup

The Designer command opens the WOW Designer online Help file.


Help Menu Functions and Messages Help Command Ref

Functions and Messages (Help menu)

Use this command to launch the Functions and Messages (for WOW Extensions) online Help file.


Help Menu Functions and Messages Help Popup

The Functions and Messages command opens the Functions and Messages (for WOW Extensions) online Help file.


Help Menu What's This Toolbar Button Command Ref F1

What's This? (Help Toolbar)

In addition to the About toolbar button and the About command on the Help menu, you can easily obtain context-sensitive help for menu commands, toolbar buttons, and other screen elements by clicking the What's This? button on the Help toolbar, and then clicking the screen element or area you want information on. If necessary, press the Esc key to exit the context-sensitive Help window.


HelpMessage Field

The HelpMessage property specifies the help message associated with this field/control. The RM/Panels Message Editor appears when the cursor is on this field/control and you press F3 or double-click the mouse.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


HelpMessage Panel

The HelpMessage property specifies the help message associated with this panel/form when the end-user requests help. The RM/Panels Message Editor appears when the cursor is on this panel/form and you press F3 or double-click the mouse.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Help Toolbar About button

About (Help Toolbar)

Use the About button to display the About WOW Designer dialog box, which provides the version number, copyright notice, the name and company name of the person the copy is licensed to, the serial number, and other information for the installed product.

This button corresponds to the About command on the Help menu.


Help Toolbar What This button

What's This? (Help Toolbar)

Use the What's This? button to access context-sensitive Help for control icons, menu commands, toolbar buttons, and other screen elements.


Horizontal Alignment Submenu

The horizontal alignment submenu determines the horizontal alignment to be applied to the selected controls. The submenu presents three options:

· Tops. Aligns the top edge of each selected control with the top edge of the first (primary) control selected.

· Middles. Aligns the horizontal (left/right) center of each selected control with the horizontal center of the first (primary) control selected.

· Bottoms. Aligns the bottom edge of each selected control with the bottom edge of the first (primary) control selected.

Note If the Snap to Grid command is enabled, you can align controls to the grid. When you align controls to the grid, the bounds (or edges) of the controls are lined up as specified, snapping to the nearest grid point. See the Snap to Grid command for more information.


Horizontal Property

The Horizontal property is a design-time-only property that determines whether the updown control is used for horizontal scrolling. If this property is set to True, the updown control's arrows point left and right instead of up and down.

The following table lists the possible values of the Horizontal property:

Value | Description
False | The updown control is not used for horizontal scrolling.
True | The updown control is used for horizontal scrolling (the default).


Horizontal Scroll Bar (Control Specific Page)

The edit box and option buttons in the Horizontal Scroll Bar group allow you to determine the height of a horizontal scroll bar field/control when a panel library is converted to WOW.

· The value in the Height Factor edit box, which is preset to 1, specifies a value by which to multiply the default setting of either the Line Height edit box or the or the Static Text font height when the Use Static Text Font Size for Line/Column Spacing check box is selected on the General tab. This multiplier is applied depending on the settings of the following option buttons:

-  The Use height factor always option button, when selected, causes WOW to always use the value specified in the Height Factor edit box to determine the height of the horizontal scroll bar.

-  The Use height factor only when border was present in panel definition option button, selected by default, causes WOW to always use the value specified in the Height Factor edit box to determine the height of the horizontal scroll bar only if a border was present in the panel definition.


How a WOW Program Works See Also

Initial Creation of a WOW Program


HScroll Event

The HScroll event occurs when the user clicks the horizontal scroll bar for the edit box control.


Icon Property Form

The Icon property is a design-time-only property that determines the icon to be used for a form when the form is minimized.

Note The Icon property must be specified in the WOW Designer, and it must be the complete name of an icon (.ico) file. If the icon file is not in the working directory or in a directory specified in the RUNPATH environment variable, a pathname is also required.


IDs See Also

Windows GUI Elements

WOW Extensions Development Process


Ignore Changes

The Ignore Changes command button causes the external editing changes to be ignored.


Increment Property

The Increment property value is used to increment the progress bar when it receives a PBM-STEPIT message.

This property can be manipulated at design time and either retrieved or set at runtime.


Initial About Box

The Initial About Box check box, when selected, displays the About WOW Designer dialog box each time you start WOW Extensions. This dialog box (which also can be accessed by using the About command on the Help menu) displays information about your copy of WOW Extensions, including the version of the program, copyright notice, the name and company name of the person the copy is licensed to, and the serial number. (The duration of this display is determined by the Initial About Box Timer option.)


Initial About Box Timer

The Initial About Box Timer option tells WOW Extensions to display the About WOW Designer dialog box for whatever interval -- in seconds -- that you specify. The default value is five seconds. If the Initial About Box check box is not selected, this option is inactive (dimmed).


Initial Creation of a WOW Program See Also

How a WOW Program Works


Initial General

The check boxes in the Initial group determine whether a grid (an evenly spaced pattern of pixels, or screen dots) will appear on a form when it is first created and whether its controls will be in perfect horizontal and/or vertical alignment to the nearest grid point.

· If you select the Show Grid check box, the grid will appear on the form when it is initially created. For more information, see the Show Grid command on the Form menu.

· If you select the Snap to Grid check box, the form’s controls will be snapped into perfect horizontal and/or vertical alignment to the nearest grid point. For more information, see the Snap to Grid command on the Form menu.


InputField

The InputField property determines whether an input field is to be attached to a list box, making the field/control a combo box.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the InputField property:

Value | Description
False | An input field/control is not attached to the list box.
True | An input field/control is attached to the list box (the default).


Insert and Delete

The Insert command button inserts a new, blank line in the Menu Control list box between existing menu controls in order to add a new menu control.

The Delete command button deletes a selected menu control or line.


Insert Code Case

The Insert Code Case group determines how the code template, generated by the function or message that you select from the Code Templates tree, is inserted in the Code Entry area of the Event-Handling Code dialog box. These options insert your code in Mixed Case (a combination of uppercase and lowercase letters, which is the default), all Uppercase letters, or all Lowercase letters, respectively. Whatever coding style you choose, the compiler can handle it properly as long as the code is syntactically correct.


Insert Code Template Comments

All the options in the Insert Code Template Comments group are enabled by default.

· Insert Descriptions inserts a description of the code at the beginning of the code template in the Code Entry area. The description is preceded by an asterisk (*).

· Insert Comments displays the remarks in the code template in the Code Entry area, which will help you and other users examine and understand the code’s logic. The compiler ignores all comment lines, which are preceded by an asterisk (*).

· Insert To Do Comments displays remarks in the code template in the Code Entry area. These remarks describe coding activities that need to be done. The compiler ignores all comment lines, which are preceded by an asterisk (*).


Insert Comments

Combined into Insert Code Template Comments area. This section is no longer used as a pop-up.


IntegerDigits

The IntegerDigits property indicates the number of digits that can be entered to the left of the decimal point in a numeric field.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Interval Property

The Interval property specifies the length of time between timer ticks in milliseconds.

This property can be manipulated at design time and either retrieved or set at runtime.


ISCHILD

Window Windows API Function

The ISCHILD function tests whether a given window is a child or other direct descendant of a given parent window. A child window is the direct descendant of a given parent window if that parent window is in the chain of parent windows leading from the original pop-up window to the child window.

Calling Sequence

CALL ISCHILD USING WIN-RETURN PARENT-H CHILD-H.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is nonzero if the child window is a descendant of the parent window. Otherwise, it is zero.
PARENT-H | PIC 9(10) BINARY(8) | The handle of the parent window.
CHILD-H | PIC 9(10) BINARY(8) | The handle of the child window to be tested.


Justify

The Justify property indicates whether left, right, or center justification is required. This affects user input and values placed into the field/control with a MOVE statement.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


KeyDown Event

The KeyDown event occurs when the user presses a key while the control has input focus. The value of the key pressed is contained in the WIN-CHAR variable declared in windows.cpy.


KeyDown Event Form

The KeyDown event occurs when the form has input focus and a key is pressed down. This event does not occur if a control on the form has input focus. The value of the key pressed is contained in the WIN-CHAR variable declared in windows.cpy.


KeyDown Event Tab

The KeyDown event notifies a tab control’s parent window that a key has been pressed. This message is sent in the form of a WM-NOTIFY message.


KeyPress Event

The KeyPress event occurs when the user presses and releases a key (or the key is held down for repeat) while the control has input focus. The value of the key pressed is contained in the WIN-CHAR variable declared in windows.cpy.


KeyPress Event Form

The KeyPress event occurs when the form has input focus and a key is pressed and released. This event does not occur if a control on the form has input focus. The value of the key pressed is contained in the WIN-CHAR variable declared in windows.cpy.


KeyPreview Property Form

The KeyPreview property is a design-time-only property that indicates whether the form will receive key events before the event is passed to the control that has focus.

When this property is set to True, the form will receive all KeyUp|tag=KeyUp Event Form , KeyDown, and KeyPress events. After the form's event handlers have completed processing the keystroke, the keystroke event is then passed to the control with focus.

You can use this property to process all keystrokes in your application and either handle the keystroke in the form event processing, or in the appropriate control, or both. For example, when an application uses function keys, you might want to process the keystrokes at the form level rather than writing code for each control that might receive keystroke events.

Note If a form has no visible or enabled controls, it automatically receives all keyboard events.

The following table lists the possible values of the KeyPreview property:

Value | Description
False | The currently selected control on the form receives key events (the default).
True | Form will receive all key events.


KeyUp Event

The KeyUp event occurs when the user releases a key while the control has input focus. The value of the key pressed is in the WIN-CHAR variable declared in windows.cpy.


KeyUp Event Form

The KeyUp event occurs when the form has input focus and a key is released. This event does not occur if a control on the form has input focus. The value of the key pressed is contained in the WIN-CHAR variable declared in windows.cpy.


Larger Property

The Larger property is a design-time-only property that allows the size of the toolbar to be increased.

The following table lists the possible values of the Larger property:

Value | Description
False | The toolbar occupies the number of rows indicated by the Rows property.
True | Allows the toolbar to occupy more rows than indicated by the Rows property (the default).


Last Error

The Last Error text box displays informational messages for the changes that you apply when you add or modify menu controls in the Menu Control area. For example, the message "First menu option must not be indented" appears if you try to indent the first top-level menu control, since this is not allowed.


Layout Toolbar Bring to Front Command Ref

Bring to Front (Layout Toolbar)

Use the Bring to Front button to move the selected control all the way to the front of the stack of controls.

Note The Bring to Front command will affect the Z-Order setting for the selected control(s) since this command changes the z-order of the selected control(s).

This button corresponds to the Bring to Front command on the Control menu.


Layout Toolbar Send to Back Command Ref

Send to Back (Layout Toolbar)

Use the Send to Back button to move the selected control behind all other controls in the stack on a form.

Note The Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

This button corresponds to the Send to Back command on the Control menu.


Layout Toolbar Toggle Lock Command Ref

Toggle Lock (Layout Toolbar)

Use the Toggle Lock button to lock or unlock the selected control(s), which keeps the control(s) from being moved accidentally. When the control is locked, a lock icon appears in the upper left corner of the control and the Locked property value changes to True.

This button corresponds to the Toggle Lock command on the Control menu. Locking can also be set by using the Locked property for the control.


LButtonDown Event Form

The LButtonDown event occurs when the left mouse button is depressed.


LButtonUp Event Form

The LButtonUp event occurs when the left mouse button is released.


Left and Right

The Left and Right command buttons indent menu controls to the left or right of the preceding line. A menu control that appears flush left in the Menu Control list box is displayed on the menu bar in the form as the menu title. A menu control that is indented once to the right in the list box is a menu item (that is, commands, separator bars, and submenu titles). A menu control that is further indented to the right is called a submenu item (also known as a cascading menu).

Note Submenus present additional and related commands in a drop-down list box. Menu controls that lead to submenus are marked with a right-pointing triangle after the menu item name. Although you can create as many levels of these submenus as you wish, Liant recommends that you use only two or three menu levels in your interface design.


Left Property

The Left property determines, in pixels, the location of the left side of the control. This value is relative to the client area of the form containing the control.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Left property with any value from 0 to the value specified in the Width property for the form.


Left Property ActiveX

The Left property determines, in pixels, the location of the left side of the ActiveX control. This value is relative to the client area of the form containing the control.

Set the Left property with any value from 0 to the value specified in the Width property for the form.


Left Property Form

The Left property determines, in pixels, the location of the left side of a form. This value is relative to the entire desktop area.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Left property with any value from 0 to the width of the screen display.


LeftScrollBar Property

The LeftScrollBar property is a design-time-only property that determines whether the vertical scroll bar, if present, is to the left of the client area.

The following table lists the possible values of the LeftScrollBar property.

Value | Description
False | Vertical scroll bar is not to the left of the client area (the default).
True | Vertical scroll bar is to the left of the client area.


LeftTicks Property

The LeftTicks property is a design-time-only property that determines whether tick marks are displayed to the left of the trackbar control.

The following table lists the possible values of the LeftTicks property:

Value | Description
False | The trackbar control does not display tick marks to the left of the control.
True | The trackbar control displays tick marks to the left of the control (the default).


Length

The Length property specifies the number of characters in the field/control. The values must be in the range of 1 to the maximum width of the panel, as specified by its Width property.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Line

The Line property indicates the number of lines that each occurrence of the field/control is offset from the previous occurrence. Valid values are 1 to the maximum length of a panel, as specified by its Length property.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


LineChange Property Scroll bar

The LineChange property determines the change in position of a scroll bar control when the mouse is clicked on the arrows at the end of the scroll bar.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the LineChange property with any value greater than 0 but less than the difference specified between the Minimum property and Maximum property values. In addition, note that the LineChange setting should be less than the value specified in the PageChange property.


LineChange Property Trackbar

The LineChange property determines the change in position of a trackbar control when the mouse is clicked on the arrows at the end of the scroll bar.

Set the LineChange property with any value greater than 0 but less than the difference specified between the Minimum and Maximum property values. In addition, note that the LineChange setting should be less than the value specified in the PageChange property.

This property can be manipulated at design time and either retrieved or set at runtime.


Line, Col

The Line, Col area indicates the current row and column on which the cursor is positioned in the Code Entry area when the Event-Handling Code dialog box has input focus.


LineDn Event (Vertical)

The LineDn event occurs when the mouse is clicked on the arrow at the bottom of the vertical scroll bar.


LineDown Event

The LineDown event occurs when the user depresses the Down Arrow or PgDn keys.


Line (Edit Bookmark)

The Line area displays the line number of the code associated with the selected bookmark.


Line (Go To Bookmark)

The Line area displays the line number of the code associated with the selected bookmark.


LineLeft Event (Horizontal)

The LineLeft event occurs when the mouse is clicked on the arrow at the left of the horizontal scroll bar.


Line Number Background Color

The Line Number Background Color option specifies the background color of line numbers in the code edit windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default background color for this option.


Line Number Foreground Color

The Line Number Foreground Color option specifies the foreground color of line numbers in the code edit windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground color for this option.


LineRight Event (Horizontal)

The LineRight event occurs when the mouse is clicked on the arrow at the right of the horizontal scroll bar.


Line Shape Object See Also

Property Manipulation Checklist


Line Shape See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


LinesToDisplay

The LinesToDisplay property specifies the number of lines to display for the field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


LinesToStore

The LinesToStore property specifies the number of lines to store for the field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


LineUp Event

The LineUp event occurs when the user depresses the Up Arrow or PgUp keys.


LineUp Event (Vertical)

The LineUp event occurs when the mouse is clicked on the arrow at the top of the vertical scroll bar.


List Area Project Properties

The List area below the Look in list box shows all the files in the currently selected location that match the specified file type entry in the Files of type list box. Note that the initial content of this list box is set to *.wow, which is the default extension for a WOW form file.

You can toggle the manner in which information is displayed in this area with the List and Details toolbar buttons.

To add one of the listed files to the project, select the file and click Add. To add more than one of the listed files to the project, first hold down the Ctrl key. Then click the remaining files you want to select, one at a time. When all the desired files are selected, click Add. To add a group of files, select the first file in the group, hold down the Shift key, and then select the last file in the group. All files in the group will then be selected. Click Add to add the group of files to the projects.


List Box Control Object See Also

Property Manipulation Checklist


List Box Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Loading the List Box

The list box is loaded at runtime, one item at a time, with the WOWADDITEM function. This function can be used to insert an item in a list box at a specific position or to append it to the end of the list. To add an item to the list box, use the WOWADDITEM function as follows:

CALL WOWADDITEM USING WIN-RETURN CTL-H NEWITEM INDEX.

WIN-RETURN returns zero if the function call is successful. CTL-H is the handle of the list box. NEWITEM must be an alphanumeric data item or literal that contains the item to be added to the list box. INDEX is an optional, zero-based integer representing the position within the control where the new item should be added.


Load Menu Editor

The Load command button displays the Open Menu dialog box, a variation of the standard Windows Open dialog, so that you can open an existing menu file (a file having the extension .wmn). You can then use the menu design “as is” or as a starting point which you then further customize.


Locating Required Tools See Also

Enhancing Existing RM/Panels Panel Libraries

Setting Preferences

WOW Extensions Components


Locked Property

The Locked property determines whether a lock is placed on the control in order to prevent the control from being moved accidentally on the form. When the control is locked, a lock icon appears in the upper-left corner of the control and the Locked property value changes to True.

Note that locking can also be handled with the Toggle Lock command from the Control menu or the Toggle Lock button on the Layout toolbar or by pressing Ctrl+L.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Locked property.

Value | Description
False | Control is not locked (the default).
True | Control is locked.


Locked Property ActiveX

The Locked property determines whether a lock is placed on the ActiveX control in order to prevent the control from being moved accidentally on the form.

The following table lists the possible values of the Locked property.

Value | Description
False | Control is not locked (the default).
True | Control is locked.


LongDateFormat Property Date Time

The LongDateFormat property is a design-time-only property that, when set to a value of True, causes the date to display in day, month, date, year format. For example: “Friday, April 19, 2002”.

The following table lists the possible values of the LongDateFormat property:

Value | Description
False | The date is displayed in short date format, for example, “4/19/02” (the default).
True | The date is displayed in long date format, for example, “Friday, April 19, 2002”.


Looking Behind the Scenes See Also

Addressing Issues in Data Entry Programs

Developing Event-Driven Applications

Using WOW Projects

Working with Menus

WOW Extensions Components

WOW Extensions Development Process


Look in Project Properties

The Look in list box indicates the current target folder (designated by the "open" file-folder icon to the left of the folder name). To see where the current folder is located in the hierarchy of folders on your computer or to select a different location, click the arrow to the right of the box. To open the folder one level higher, click the Up One Level toolbar button.


LoseFocus Event Form

The LoseFocus event occurs when the form loses input focus.


LostFocus Event

The LostFocus event occurs when the control loses input focus, either by user action, such as tabbing to or clicking another control, or by changing the focus in code.


Managing User Interaction See Also

Addressing Issues in Data Entry Programs


Manipulating Controls in a Form See Also

Adding ActiveX Controls to the WOW Designer

Handling Events for Controls, Forms, and Projects

Properties and Events for Forms

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Marker Background Color

The Marker Background Color option specifies the background color used for markers in the code edit windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground color for this option.


Marker Foreground Color

The Marker Foreground Color option specifies the foreground color used for markers in the edit code windows.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground color for this option.


Marker Type

You can define the type (style) of marker that is displayed in your source code by choosing one of the items listed in the Marker Type option. The available choices include: Short Arrow (the default), Circle, Round Rectangle, Arrow, Small Rectangle, Empty, Arrow Down, Minus, Plus, Arrows, Dot Dot Dot, Background, and Full Rectangle.


MaxButton Property Form

The MaxButton property is a design-time-only property that determines whether a Maximize button is included on a form.

Note A Maximize button also can be included (along with Minimize and Close buttons) on a form by setting the SystemMenu property to True. Conversely, a Maximize button can be removed (along with Minimize and Close buttons) from a form by setting the SystemMenu property to False.

The following table lists the possible values of the MaxButton property:

Value | Description
False | Form does not have a Maximize button (the default).
True | Form has a Maximize button.


MaxChars Property

The MaxChars property determines how many characters can be entered into an edit box control. A value of 0 will not set any limit.

This property can be manipulated at design time and either retrieved or set at runtime.


Maximum Property Progress

The Maximum property specifies the maximum allowable value for the progress bar and is used in determining how much of the progress bar should be filled.

This property can be manipulated at design time and either retrieved or set at runtime.


Maximum Property Scroll bar

The Maximum property determines the highest value allowed for a scroll bar position.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Maximum property with any value from 0 to 65535. This value should be greater than the value specified in the Minimum property.


Maximum Property Trackbar

The Maximum property determines the highest value allowed for a scroll bar position.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Maximum property with any value from 0 to 65535. Note that this value should be greater than the value specified in the Minimum property.


Maximum Property Updown

The Maximum property sets the maximum position (range) for an updown control. The maximum position can be less than the minimum position. Clicking the Up Arrow button moves the current position closer to the maximum position, and clicking the Down Arrow button moves towards the minimum position.

This property can be manipulated at design time and either retrieved or set at runtime.


MaximumValue

The MaximumValue property specifies the maximum value associated with the scroll bar. Valid values are 0 - 999.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


MaxSelCount MC Property

The MaxSelCount property sets the maximum number of days that can be selected in a month calendar control.

This property can be manipulated at design time and either retrieved or set at runtime.


MaxText Event

The MaxText event occurs when the user attempts to enter more characters than the edit box control will allow. This event occurs only if the AutoHScroll property is not set, or a MaxChars property is not equal to 0.


MButtonDown Event Form

The MButtonDown event occurs when the middle mouse button is depressed.


MButtonUp Event Form

The MButtonUp event occurs when the middle mouse button is released.


MCColorIndex Property

The MCColorIndex property is a design-time-only property that determines the color of the various background or text areas of the month calendar control. The color is specified as an index value into the color selected in the MCColor property.

The following table lists the possible values of the MCColorIndex property:

Value | Description
0 | Returns or sets the background color behind the calendar (the default).
1 | Returns or sets the color of the calendar text.
2 | Returns or sets the background color of the calendar title.
3 | Returns or sets the color of the calendar title text.
4 | Returns or sets the background color of the calendar text.
5 | Returns or sets the color of the trailing text in the calendar.


MCColor Property

The MCColor property is a design-time-only property that determines the color of various background or text areas of the month calendar control, based on the value specified in the MCColorIndex property. The property is a numeric value with nine digits specifying colors as RRR,GGG,BBB.

In the RGB color model, valid red, green, and blue values are in the range from 0 through 255, with 0 indicating the minimum intensity and 255 indicating the maximum intensity. Set the BackColor property with any value in the range from 000 to 255255255.

When you click on the value area of the property, an ellipsis appears. Clicking on the ellipsis causes a variation of the standard Windows Color dialog box to open so that you can define the basic colors, custom colors, and system colors for the foreground color of the control(s).


MCFontBold Property

The MCFontBold property is a design-time-only property that determines whether the associated text for the month calendar is displayed in bold font format.

The following table lists the possible values of the MCFontBold property:

Value | Description
False | Text is not displayed bold (the default).
True | Text is displayed bold.


MCFontItalic Property

The MCFontItalic property is a design-time-only property that determines whether the associated text of the month calendar is displayed in italic font format.

The following table lists the possible values of the MCFontItalic property:

Value | Description
False | Text is not displayed in italics (the default).
True | Text is displayed in italics.


MCFontName Property

The MCFontName property is a design-time-only property that determines the font used to display text in the month calendar. The font specified must be present on the system.


MCFontSize Property

The MCFontSize property is a design-time-only property that determines the size of the font to be used for text displayed in the month calendar. The size specified must be supported by the font. If the size is not supported by the font, the system will substitute the nearest supported value.


MCFontStrikethru Property

The MCFontStrikethru property is a design-time-only property that determines whether the associated text for the month calendar is displayed in a strikethrough font style.

The following table lists the possible values of the MCFontStrikethru property:

Value | Description
False | No strikeout is used (the default).
True | Strikeout is used.


MCFontUnderline Property

The MCFontUnderline property is a design-time-only property that determines whether the associated text for the month calendar is displayed in an underlined font format.

The following table lists the possible values of the MCFontUnderline property:

Value | Description
False | Text is not underlined (the default).
True | Text is underlined.


Members in Project Project Properties

The Members in Project area lists all of the form files (members) that are in or have been added to a project and allows you to delete form files from a project. An asterisk (*) indicates that the form will be shown at project startup (open), which is determined by the options configured for the project in the Project Options dialog box.


Menu Control List Box

Use the Menu Control list box to design and view the structure of all the menu controls (menu titles and menu items) for the selected form. If you have just opened the Menu Editor dialog box, the first position in this list box is blank and highlighted. It serves as a placeholder. When you type an entry in the Title text box, the menu control appears on the highlighted line in the Menu Control list box. The menu titles you create are also displayed on the form. To edit the properties for an existing menu control, select the control from this list box. Double-clicking on a menu item opens the Event-Handling Code dialog box with the code for that item displayed in the Code Entry area.


Menu Editor Dialog Box See Also

Code Preferences

General Preferences

Using Menus

Working with Menus


Menu Name Generation

As with all controls, when you add a menu control to the form, WOW Extensions assigns it a default name. In the New Project Options area, the options in the Menu Name Generation group determine the naming conventions used for menu controls.

· If you select the Generate Long Names option and give a menu control a Title property value of File in the Menu Editor dialog box, for example, WOW Extensions automatically assigns the menu control a Name property of MENU-FILE.

Tip The Generate Long Names option causes the full name of the menu option to be used to create the internal menu name in the COBOL source code by adding hyphens (-) to it. If your menu entries are long, this can result in the name being truncated as the internal name is created. Furthermore, internal names may be duplicated inadvertently. If you are using menus, set the preference to Generate Short Names to avoid this problem.

· If you select the Generate Short Names option (the default), WOW Extensions sets the Name property for the control with the prefix M-; in the preceding example, the Name would be abbreviated to M-File.

· Selecting the Do Not Generate Names option allows you to assign a more descriptive and meaningful name to the menu control.

In all cases, the menu name appears in the Events/Code Sections list of the menu Event-Handling Code dialog box.

Note Because the Name property provides the name WOW Extensions uses to reference the menu control in the underlying code, you cannot leave the Name property blank. Be careful also to assign a unique name to the control to avoid possible name conflicts with duplicate names.


Menu Name Generation (Project Options)

As with all controls, when you add a menu control to the form, WOW Extensions assigns it a default name. The group of options in the Menu Name Generation area determines the naming conventions used for menu controls.

· If you select the Generate Long Names option and give a menu control a Title property value of File in the Menu Editor dialog box, for example, WOW Extensions automatically assigns the menu control a Name property of MENU-FILE.

Tip The Generate Long Names option causes the full name of the menu option to be used to create the internal menu name in the COBOL source code by adding hyphens (-) to it. If your menu entries are long, this can result in the name being truncated as the internal name is created. Furthermore, internal names may be duplicated inadvertently. If you are using menus, set the preference to Generate Short Names to avoid this problem.

· If you select the Generate Short Names option (the default), WOW Extensions sets the Name property for the control with the prefix M-; in the preceding example, the Name would be abbreviated to M-File.

· Selecting the Do Not Generate Names option allows you to assign a more descriptive and meaningful name to the menu control.

In all cases, the menu name appears in the Events/Code Sections list of the menu Event-Handling Code dialog box.

Note Because the Name property provides the name WOW Extensions uses to reference the menu control in the underlying code, you cannot leave the Name property blank. Be careful also to assign a unique name to the control to avoid possible name conflicts with duplicate names.


Methods

The Methods list box displays an alphabetical listing of all of the methods associated with the selected ActiveX control. To view more methods if there are more than can fit in the list box, click the scroll box or arrows to the right of the list box, or use the arrow keys from the keyboard.


Migrating RM/Panels Panel Libraries to WOW Forms See Also

Enhancing Existing RM/Panels Panel Libraries


MinButton Property Form

The MinButton property is a design-time-only property that determines whether a Minimize button is included on a form.

Note A Minimize button also can be included (along with Maximize and Close buttons) on a form by setting the SystemMenu property to True. Conversely, a Minimize button can be removed (along with Maximize and Close buttons) from a form by setting the SystemMenu property to False.

The following table lists the possible values of the MinButton property:

Value | Description
False | Form does not have a Minimize button (the default).
True | Form has a Minimize button.


Minimum Property Progress

The Minimum property specifies the minimum allowable value for the progress bar and is used in determining how much of the progress bar should be filled.

This property can be manipulated at design time and either retrieved or set at runtime


Minimum Property Scroll bar

The Minimum property determines the lowest value allowed for a scroll bar position.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Minimum property with any value from 0 to 65535. This value should be less than the value specified in the Maximum property.


Minimum Property Trackbar

The Minimum property determines the lowest value allowed for a scroll bar position.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Minimum property with any value from 0 to 65535. Note that this value should be less than the value specified in the Maximum property.


Minimum Property Updown

The Minimum property sets the minimum position (range) for an updown control. The maximum position can be less than the minimum position. Clicking the Up Arrow button moves the current position closer to the maximum position, and clicking the Down Arrow button moves towards the minimum position.

This property can be manipulated at design time and either retrieved or set at runtime.


MinimumValue

The MinimumValue property specifies the minimum value associated with the scroll bar. Valid values are 0 - 999.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


MnemonicAttr

The MnemonicAttr property identifies the mnemonic character associated with the field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ModalFrame Property

The ModalFrame property is a design-time-only property that determines whether a control has a double border.

The following table lists the possible values of the ModalFrame property.

Value | Description
False | Control does not have a double border (the default).
True | Control has a double border.


Modal Property Form

The Modal property determines whether the form is the only form the user can operate for the application. If the value of the Modal property is set to True, all other forms will be unavailable to the user until the form is removed, or the value of the Modal property is set to False, or another modal form is displayed.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Modal property:

Value | Description
False | The form is not modal (the default).
True | The form is modal.


Modifying an Existing RM/Panels Panel Library See Also

Enhancing Existing RM/Panels Panel Libraries

Migrating RM/Panels Panel Libraries to WOW Forms

Properties for RM/Panels Data Fields

Properties for RM/Panels Panels


Month Calendar Control Object See Also

Property Manipulation Checklist


Month Calendar Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


MonthDelta MC Property

The MonthDelta property determines the scroll rate for a month calendar control. The scroll rate is the number of months that the control moves its display when the user clicks a scroll button.


MonthRangeDayState MC Property

The MonthRangeDayState property is a runtime-only property that retrieves the year, month, day of week, and day for both the starting and ending months in a range of months currently displayed in their entirety in a month calendar control.

This property can be retrieved, but not set, at runtime.


MonthRangeVisible MC Property

The MonthRangeVisible property is a runtime-only property that retrieves the number of months that are currently displayed in a range of months, including those that are partially displayed as well as those that are displayed in their entirety.

This property can be retrieved, but not set, at runtime.


Mouse-Button Flags and Values

The mouse-button flag can be one of the following values:

Value | Meaning
TPM-LEFTBUTTON | Causes the pop-up menu to track the left mouse button.
TPM-RIGHTBUTTON | Causes the pop-up menu to track the right mouse button instead of the left.


MouseDown Event

The MouseDown event occurs when a mouse button is depressed when the cursor is over a control. The value of the button being depressed and the state of certain keys used to modify your application’s behavior can be determined by examining the values in the MOUSE-EVENT-NOTIFY-WS REDEFINES NMHDR-WS statement in windows.cpy.


MouseDown Event Form

The MouseDown event occurs when a mouse button is depressed when the cursor is over a form. The value of the button being depressed and the state of certain keys used to modify your application’s behavior can be determined by examining the values in the MOUSE-EVENT-NOTIFY-WS REDEFINES NMHDR-WS statement in windows.cpy.


MouseMove Event

The MouseMove event occurs when the mouse cursor is being moved over a control. The value of the mouse cursor’s position can be determined by examining the values in the MOUSE-EVENT-NOTIFY-WS REDEFINES NMHDR-WS statement in windows.cpy.


MouseMove Event Form

The MouseMove event occurs when the mouse cursor is being moved over a form. The value of the mouse’s cursor position can be determined by examining the values in the MOUSE-EVENT-NOTIFY-WS REDEFINES NMHDR-WS statement in windows.cpy.


MouseUp Event

The MouseUp event occurs when a mouse button is released when the cursor is over a control. The value of the button being released and the state of certain keys used to modify your application’s behavior can be determined by examining the values in the MOUSE-EVENT-NOTIFY-WS REDEFINES NMHDR-WS statement in windows.cpy.


MouseUp Event Form

The MouseUp event occurs when a mouse button is released when the cursor is over a form. The value of the button being released and the state of certain keys used to modify your application’s behavior can be determined by examining the values in the MOUSE-EVENT-NOTIFY-WS REDEFINES NMHDR-WS statement in windows.cpy.


Move Up and Move Down (Customize Toolbar)

The Move Up command button moves the selected button up one line. On the toolbar, the button shifts left one space.

The Move Down command button moves the selected button down one line. On the toolbar, the button shifts right one space.


MOVEWINDOW

Window Windows API Function

The MOVEWINDOW function changes the position and dimensions of a window. For top-level windows, the position and dimensions are relative to the upper-left corner of the screen. For child windows, they are relative to the upper-left corner of the parent window’s client area.

Note Using MOVEWINDOW to move or resize a form sets the absolute size of the form, including the borders and title bar. Contrast this behavior with that of WOWSETPROP, which can be used to set the width and height of the form’s client area. Providing identical values to MOVEWINDOW and WOWSETPROP for width and height will result in forms of different sizes.

Calling Sequence

CALL WOWMOVEWINDOW USING WIN-RETURN WND-H LEFT TOP
WIDTH HEIGHT REPAINT.

Parameter

Declaration

Description

WIN-RETURN

numeric

The return value is nonzero if the function is successful. Otherwise, it is zero.

WND-H

PIC 9(10) BINARY(8)

The handle of the window to be changed.

LEFT

numeric

Specifies the new position of the left side of the window.

TOP

numeric

Specifies the new position of the top of the window.

WIDTH

numeric

Specifies the new width of the window.

HEIGHT

numeric

Specifies the new height of the window.

REPAINT

windows.cpy

Specifies whether the window is to be repainted.

· If the value of this parameter is WIN-TRUE, the window receives a WM-PAINT message, as usual.

Note The WM-PAINT message is sent when the system or another application makes a request to paint a portion of the application's window. This message contains one numeric parameter, HWND, which is the handle to the window.

· If the value of this parameter is WIN-FALSE, no repainting of any kind occurs. This applies to the client area, the non-client area (including the title and scroll bars), and any part of the parent window uncovered as a result of the moved window. When the value of this parameter is WIN-FALSE, the application must explicitly invalidate or redraw any parts of the window and parent window that must be redrawn.


Multi-Line Edit Box Control Object See Also

Property Manipulation Checklist


MultiLine Property

The MultiLine property determines whether an edit box control should support single or multiple lines of text.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the MultiLine property:

Value | Description
False | Control has only one line of text (the default).
True | Control can have multiple lines of text.


MultiLine Property Tab

The MultiLine property is a design-time-only property that determines whether the tabs will occupy multiple lines if the tab control is too narrow for all the tabs to be displayed on a single line. Note that this property also can be changed using the Multi-Line check box in the Tab Control Editor dialog box.

The following table lists the possible values of the MultiLine property:

Value | Description
False | Prevents the tabs from occupying multiple lines (the default).
True | Allows the tabs to occupy multiple lines.


MultipleSel Property

The MultipleSel property is a design-time-only property that allows more than one item in a list box control to be selected.

Note The value of the MultipleSel property can be overridden by the ExtendedSel property.

The following table lists the possible values of the MultipleSel property:

Value | Description
False | No multiple selections allowed (the default).
True | Multiple selections allowed.


MultiSelect MC Property

The MultiSelect property is a design-time only property that allows the user to select a range of dates within the control. By default, the maximum range is one week. You can change the maximum range that can be selected by using the MaxSelCount property.

The following table lists the possible values of the MultiSelect property:

Value | Description
False | The user cannot select a range of dates (the default).
True | The user can select a range of dates.


Name

As you type in the Title text box, WOW Extensions automatically assigns the Name property of the menu control to a default value. Under the default configuration for WOW Extensions, the naming convention used for menu controls includes the prefix M- followed by the text entered in the Title box. For example, if you type File in the Title box, the default name entered in the Name text box is M-FILE. (You can configure the way in which the menu names are generated by changing the options in the Code Preferences page of the Preferences dialog box.) This menu name appears in the Events/Sections list of the menu Event-Handling Code dialog box), and it is the name that WOW Extensions uses to reference the menu control in the generated code.


Name (Edit Bookmark)

The Name list box allows you either to enter the name of the new bookmark or select from a list of existing bookmarks.


Name (Go To Bookmark)

The Name list box allows you to select from a list of existing bookmarks.


Name Locking

The Name Locking option in the Properties area provides three choices for specifying what part, if any, of a menu name should change when a menu is moved:

· None prevents any of the menu names from being locked. This option is selected by default.

· Suffix locks only the portion of the name following the prefix; that is, those characters that follow the hyphen character (-) in the name.

· All locks the entire menu name.


Name Property

The Name property identifies the control to the underlying program, and is the name shown in your code. Because every control in a form must have a unique name, WOW Extensions assigns default names and numbers them sequentially as you add them to a form. For example, if you add three check boxes to a form, WOW Extensions names them CB1, CB2, and CB3.

This property can be manipulated at design time and either retrieved or set at runtime.

Note When you have more than one form in a project, and the same control name exists within more than one of those forms, you must distinguish those names in the event-handling code in the following manner:

control-name1 of form-name1, control-name1 of form-name2, and so forth.

Liant recommends that you change the Name property so that it describes the control’s function, rather than simply accepting the default name.


Name Property ActiveX

The Name property identifies the ActiveX control to the underlying program, and is the name shown in your code. Because every control in a form must have a unique name, WOW Extensions assigns default names and numbers them sequentially as you add them to a form. For example, if you add three check boxes to a form, WOW Extensions names them CB1, CB2, and CB3.

Notes

· When you have more than one form in a project, and the same control name exists within more than one of those forms, you must distinguish those names in the event-handling code in the following manner:

control-name1 of form-name1, control-name1 of form-name2, and so forth.

Liant recommends that you change the Name property so that it describes the control’s function, rather than simply accepting the default name.

· This property can be manipulated at design time and either retrieved or set at runtime.

· In the Properties dialog box, the Name property will appear enclosed by parentheses (Name) so that it will be sorted to the top of the alphabetical listing of properties.


Name Property Form

The Name property is a runtime-only property that specifies the name of the form file (without the default extension of .wow). The form file is created by the WOW Designer when a form is first saved. It stores the definition of the form.


Name Tip

When you first add a control to a form, WOW Extensions sets the control’s Name property to a unique, default (initial) value. For example, all command button controls have their Name property initially set to CMDn, where n is 1, 2, 3, and so forth. When you duplicate an existing control on a form, however, you also duplicate that control’s property settings and associated event-handling code as well. Because every control in a given form must have a unique name, WOW Extensions assigns default names to the duplicated controls and numbers them as you add them. If you duplicated the command button control with the name CMD1 two times, WOW Extensions would name the copied controls CMD11 and CMD12, respectively. In this way, each duplicated control maintains a unique identifier. You can check this by inspecting the Name property for each button in the Properties dialog box. Controls added this way share properties and code with the original control. The Name property is one of the most important properties for all controls because it identifies the control to the underlying program, and it is the name shown in your code. Liant recommends that you change the Name property so that it is descriptive of the control’s function, rather than relying on default names.


Net Object Selection General

The option buttons in the Net Object Selection group determine how to select controls when doing "lasso" or "rubber band"-style selection. That is, when you position the mouse pointer beside (not on) one of the controls you want to select and then drag through all the controls you want to select. While you drag, WOW Extensions draws a dotted rectangle around the controls. When you release the mouse button, one or more controls in the rectangle are selected, depending on the following settings. For more information on selecting controls, click here.

· When the Intersects option button is selected, the dotted rectangle can intersect any portion of a control in order to select it. This option is enabled by default.

· When the Surrounds option button is selected, the dotted rectangle must completely surround a control before it is selected.


Network Project Properties

No longer valid. Not used.


NewDoMethodArgumentPassing Property ActiveX

The NewDoMethodArgumentPassing property determines the way in which arguments are passed to AXDOMETHOD functions. Beginning with version 9, a new method was implemented for passing arguments to AXDOMETHOD functions. The wowrt.ini file option, EnableOldStyleDoMethodArgumentPassing, was also added in version 9 to allow the developer to choose pre-version 9 handling or post-version 9 handling for all AXDOMETHOD calls. In version 9.01, the NewDoMethodArgumentPassing property was added, which allowed argument method passing to be controlled on an individual ActiveX basis rather than on a global basis.

Note In the Properties dialog box, the NewDoMethodArgumentPassing property will appear enclosed by parentheses (NewDoMethodArgumentPassing) so that it will be sorted to the top of the alphabetical listing of properties.

The following table lists the possible values of the NewDoMethodArgumentPassing property:

Value | Description
False | Arguments are passed to AXDOMETHOD functions using the method specified in the wowrt.ini file (the default).
True | Arguments are passed to AXDOMETHOD functions using the new method.


Next Index (Tab and Z Order Editor)

Next Index is an edit box that allows you assign the next order number in the tab order or z-order of controls on a form.


NoHideSel Property

The NoHideSel property determines whether the selected text remains highlighted when an edit box control loses the input focus.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the NoHideSel property:

Value | Description
False | Selected text does not remain highlighted when the edit box control loses input focus (the default).
True | Selected text remains highlighted when the edit box control loses input focus.


NoIntegralHeight Property

The NoIntegralHeight property is a design-time-only property that determines whether the height of a list box control or the list box portion of a combo box control is adjusted to contain an even number of items.

The following table lists the possible values of the NoIntegralHeight property:

Value | Description
False | List box height is adjusted (the default).
True | List box height is not adjusted.


NoPrefix Property

The NoPrefix property is a design-time-only property that determines whether the ampersand (&) character causes the subsequent character to be underlined in a static text control.

The following table lists the possible values of the NoPrefix property:

Value | Description
False | The ampersand character (&) causes next character to be underlined (the default).
True | The ampersand character (&) character is displayed.


NoRedraw Property

The NoRedraw property is a runtime-only property that allows changes in a control to be redrawn or prevents changes in the control from being redrawn.

This property can be set, but not retrieved, at runtime.

The following table lists the possible values of the NoRedraw property:

Value | Description
False | The control will be redrawn after a change.
True | The control will not be redrawn after a change


NoRedraw Property Form

The NoRedraw property is a runtime-only property that allows changes in a form to be redrawn or prevents changes in the form from being redrawn.

This property can be set, but not retrieved, at runtime.

The following table lists the possible values of the NoRedraw property:

Value | Description
False | The form’s content will be redrawn after a change.
True | The form’s content will not be redrawn after a change


NoRedraw Property Lbox

The NoRedraw property is a design-time-only property that creates a list box control which will not redraw itself when entries are added at runtime. After entries are loaded, the property can be changed to force the list box to redraw itself. (Compare this with the NoRedraw runtime-only property of intrinsic controls.)

After entries are loaded, the property can be changed to update the screen display.

The following table lists the possible values of the NoRedraw property:

Value | Description
False | List box will be redrawn after a change (the default).
True | List box will not be redrawn after a change.


NoSpace Event

The NoSpace event occurs when Windows cannot allocate enough internal space to store the contents of the combo box.


NoSpace Event Edit

The NoSpace event occurs when the internal Windows memory used to store the text of the edit box control has been depleted.


NoThousands Property

The NoThousands property is a design-time-only property that determines whether the updown control inserts a thousands separator between every three digits of a decimal string.

The following table lists the possible values of the NoThousands property:

Value | Description
False | A thousands separator is not inserted between every three digits of a decimal string (the default).
True | A thousands separator is not inserted between every three digits of a decimal string.


NoThumb Property

The NoThumb property is a design-time-only property that determines whether the trackbar control displays a slider.

The following table lists the possible values of the NoThumb property:

Value | Description
False | The trackbar control displays a slider (the default).
True | The trackbar control does not display a slider.


NoTicks Property

The NoTicks property is a design-time-only property that determines whether the trackbar control displays tick marks.

The following table lists the possible values of the NoTicks property:

Value | Description
False | The trackbar control displays tick marks (the default).
True | The trackbar control does not display any tick marks.


NoTodayCircle MC Property

The NoTodayCircle property is a design-time-only property that specifies that the month calendar control will not circle the “today” date when the NoToday property is set to False.

The following table lists the possible values of the NoTodayCircle property:

Value | Description
False | The "today" date, if displayed, is circled (the default).
True | The "today" date, if displayed, is not circled.


NoToday MC Property

The NoToday property is a design-time-only property that determines whether the month calendar control will not display the “today” date at the bottom of the control.

The following table lists the possible values of the NoToday property:

Value | Description
False | Displays the "today" date at the bottom of the control (the default).
True | The "today" date does not display at the bottom of the control.


Nudge

The options in the Nudge area determine how far the selected control moves when a key is pressed. The arrow keys on your keyboard allow you to move or "nudge" controls on your form in the direction indicated by the arrow and in the increments specified.

· To nudge a control in the horizontal grid, click the X Increment box and type a value.

· To nudge a control in the vertical grid, click the Y Increment box and type a value.

If you press and hold the Ctrl key, the control moves in continuous increments. Other cursor movement keys include PageUp (PgUp), PageDown (PgDn), Home, and End keys, as well as the key combinations Ctrl+Home and Ctrl+End.


Number of Tabs (Tab Editor)

The Number of Tabs text box indicates the number of tabs within the tab control. You can change that number by using the spin buttons to increase or decrease the value. This is the value that appears in the Tabs property for the tab control.


NumericData

The NumericData property specifies whether this field/control is a represented by a numeric data item.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the NumericData property:

Value | Description
False | The field/control is not represented by a numeric data item.
True | The field/control is represented by a numeric data item (the default).


NumericDecDigits Property Edit

The NumericDecDigits property indicates the number of digits that can be entered to the right of the decimal point in a field that is designated as being restricted to numeric data using the Numeric property.

This property can be manipulated at design time and either retrieved or set at runtime.


Numeric Edit Box Control Object See Also

Property Manipulation Checklist


NumericIntDigits Property Edit

The NumericIntDigits property indicates the number of digits that can be entered to the left of the decimal point in a field that is designated as being restricted to numeric data using the Numeric property.

This property can be manipulated at design time and either retrieved or set at runtime.


Numeric Property Edit

The Numeric property determines whether the input in an edit box control will be restricted to numeric data and validated based on the values set for the NumericDecDigits, NumericIntDigits, and NumericSign properties.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Numeric property:

Value | Description
False | Input need not be restricted to numeric data (the default).
True | Input must be restricted to numeric data.


NumericSign Property Edit

The NumericSign property specifies whether the control designated as being restricted to numeric data using the Numeric property includes a plus (+) or minus (-) sign.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the NumericSign property:

Value | Description
False | The control is not signed.
True | The control is signed (the default).


Objects

The Objects list box displays the name and type of the object (form or control) having the properties you want to change. Click the arrow to the right of the box to select a form or control name from the list of objects for the current form.

Note When you select a form or a control in the form, the Properties dialog box displays all of the properties that you can work with for that object at design time. If you click on another object, the properties for that object are displayed. When more than one control is selected in the form, a single Properties dialog box displays all the properties that are shared among the selected controls. The Objects list area will indicate "Form - Multiple Objects Selected".


OccColOffset

The OccColOffset property indicates the number of columns that each occurrence of a field/control is offset from the previous occurrence. Valid values are 0 to the maximum width of a panel, as specified by its Width property.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


OccLineOffset

The OccLineOffset property indicates the number of lines that each occurrence of a field/control is offset from the previous occurrence. Valid values are 1 to the maximum length of a panel, as specified by its Length property.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Occurrences

The Occurrences property indicates the number of times this field/control occurs on the panel.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


OccXOffset

The OccXOffset property specifies the number of pixels that multiple occurrences of the field/control should be offset from each other horizontally. This property affects the display of the panel only when using WOW Extensions.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


OccYOffset

The OccYOffset property specifies the number of pixels that multiple occurrences of the field/control should be offset from each other vertically. This property affects the display of the panel only when using WOW Extensions.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


OEMConvert Property

The OEMConvert property is a design-time-only property that converts characters entered in the edit box portion of a combo box control from the ANSI character set to the OEM character set and then back to ANSI. Use this property for combo box controls that are used to enter filenames. When a character is converted from the ANSI character set to the OEM character set and back to ANSI, the resulting character is not always the same as the original character; however, subsequent conversions from ANSI to OEM to ANSI do result in the same character.

The following table lists the possible values of the OEMConvert property:

Value | Description
False | The characters are not converted (the default).
True | The characters are converted from ANSI to OEM and back to ANSI.


OEMConvert Property Edit

The OEMConvert property converts characters entered in an edit box control from the ANSI character set to the OEM character set and then back to ANSI.

This property should be used for edit box controls that are used to enter filenames. When a character is converted from the ANSI character set to the OEM character set and back to ANSI, the resulting character is not always the same as the original character; however, subsequent conversions from ANSI to OEM to ANSI do result in the same character.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the OEMConvert property:

Value | Description
False | The characters are not converted (the default).
True | The characters are converted from ANSI to OEM and back to ANSI.


OK (ActiveX)

The OK command button completes the Select ActiveX Controls dialog box by accepting the selections and recording them in the WOW Designer initialization file, cblwow.ini.


OK Command Button (Preferences Dialog)

The OK command button closes the Preferences dialog box and saves any changes that you have made on the specified page.


OK (CustTool)

The OK command button completes the Customize Toolbox dialog box by accepting all the entries and closing the dialog box.


OK (Panel Import Preferences)

The OK command button closes the Panel Import Preferences dialog box and saves any changes that you have made on the specified page.


OK (ProjOpts)

The OK command button completes the Project Options dialog box by accepting the project options settings and saving them in the .wpj project file.


OK (Tab and Z Order Editor)

The OK command button accepts all changes and closes the dialog box.


OK (Tab Editor)

The OK command button accepts all changes and closes the Tab Control Editor dialog box.


On Execute/Build General

The check boxes in the On Execute/Build group determine how files are saved prior to compilation.

· When the Build Before Executing check box is selected, the files will be compiled automatically prior to execution. This option is enabled by default.

· When the Save Files Before Building check box is selected, any modifications are automatically saved prior to compiling the file(s). This option is enabled by default.

· When the Prompt Before Saving Files check box is selected, you will be asked whether or not you want to save any modifications before the files are compiled.


On Startup General

The option buttons in the On Startup group determine what you see on the screen whenever you start WOW Extensions.

· When the New Project option button is selected, the WOW Designer window is displayed with the Save Project dialog box, which establishes the project name and the folder for the project files.

· If you select the Empty Workspace option button, the WOW Designer window opens with a blank work area.

· Choosing the Last Project option button opens the most recently used project in the last WOW session. This option is enabled by default.


Operating the List Box

Once the list box is loaded, Windows takes care of the operation of the list box. If the Standard property is set to True, the Click event is executed every time the user makes a selection. Otherwise, no event is associated with making a selection. In general, no action is taken when a selection is made, but the user should press a command button or select a menu option to take an action. In some cases, you may want to display information related to the selection in another part of the form as the selection changes.


Option Button Control Object See Also

Property Manipulation Checklist


Option Button Control See Also

Group Box Control

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Options Menu Commands See Also

Using Global Default Property Settings


Options Menu Customize Toolbars Aligning Command Ref

Customize Toolbars | Aligning Toolbar (Options menu)

Use this command to add or remove buttons from the Aligning toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Aligning Popup

The Customize Toolbars | Aligning Toolbar command adds or removes buttons from the Aligning toolbar.


Options Menu Customize Toolbars Centering Command Ref

Customize Toolbars | Centering Toolbar (Options menu)

Use this command to add or remove buttons from the Centering toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Centering Popup

The Customize Toolbars | Centering Toolbar command adds or removes buttons from the Centering toolbar.


Options Menu Customize Toolbars Command Ref

Customize Toolbars (Options menu)

Use this command to add or remove buttons from most existing toolbars (the Find and Layout toolbars require special handling and are, therefore, excluded) or create up to two new toolbars (Custom Toolbar 1 and Custom Toolbar 2). When you choose the Customize Toolbars command, a submenu appears. Select the toolbar you want to customize and the Customize Toolbar dialog box is displayed. Changes will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Custom 1 Command Ref

Customize Toolbars | Custom 1 Toolbar (Options menu)

Use this command to add or remove buttons from the Custom 1 toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Custom 1 Popup

The Customize Toolbars | Custom 1 Toolbar command adds or removes buttons from the Custom 1 toolbar.


Options Menu Customize Toolbars Custom 2 Command Ref

Customize Toolbars | Custom 2 Toolbar (Options menu)

Use this command to add or remove buttons from the Custom 2 toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Custom 2 Popup

The Customize Toolbars | Custom 2 Toolbar command adds or removes buttons from the Custom 2 toolbar.


Options Menu Customize Toolbars Editing Command Ref

Customize Toolbars | Editing Toolbar (Options menu)

Use this command to add or remove buttons from the Editing toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Editing Popup

The Customize Toolbars | Editing Toolbar command adds or removes buttons from the Editing toolbar.


Options Menu Customize Toolbars File Command Ref

Customize Toolbars | File Toolbar (Options menu)

Use this command to add or remove buttons from the File toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars File Popup

The Customize Toolbars | File Toolbar command adds or removes buttons from the File toolbar.


Options Menu Customize Toolbars Help Command Ref

Customize Toolbars | Help Toolbar (Options menu)

Use this command to add or remove buttons from the Help toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Help Popup

The Customize Toolbars | Help Toolbar command adds or removes buttons from the Help toolbar.


Options Menu Customize Toolbars Popup

The Customize Toolbars command adds or removes buttons from most existing toolbars (the Find and Layout toolbars require special handling and are, therefore, excluded) or create up to two new toolbars.


Options Menu Customize Toolbars Project Command Ref

Customize Toolbars | Project Toolbar (Options menu)

Use this command to add or remove buttons from the Project toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Project Popup

The Customize Toolbars | Project Toolbar command adds or removes buttons from the Project toolbar.


Options Menu Customize Toolbars Sizing Command Ref

Customize Toolbars | Sizing Toolbar (Options menu)

Use this command to add or remove buttons from the Sizing toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Sizing Popup

The Customize Toolbars | Sizing Toolbar command adds or removes buttons from the Sizing toolbar.


Options Menu Customize Toolbars Spacing Command Ref

Customize Toolbars | Spacing Toolbar (Options menu)

Use this command to add or remove buttons from the Spacing toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars Spacing Popup

The Customize Toolbars | Spacing Toolbar command adds or removes buttons from the Spacing toolbar.


Options Menu Customize Toolbars View Command Ref

Customize Toolbars | View Toolbar (Options menu)

Use this command to add or remove buttons from the View toolbar. When you select the toolbar using this command, the Customize Toolbar dialog box is displayed. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbars View Popup

The Customize Toolbars | View Toolbar command adds or removes buttons from the View toolbar.


Options Menu Customize Toolbox Command Ref

Customize Toolbox (Options menu)

Use this command to add or remove controls to or from the Toolbox using the Customize Toolbox dialog box. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Customize Toolbox Popup

The Customize Toolbox command adds or removes controls to or from the Toolbox using the Customize Toolbox dialog box.


Options Menu Preferences Command Ref

Preferences (Options menu)

Use this command to change the default settings in the cblwow.ini initialization file and customize the WOW Designer development environment to your specifications using the Preferences dialog box.


Options Menu Preferences Popup

The Preferences command changes the default settings and customizes the WOW Designer development environment to your specifications using the Preferences dialog box.


Options Menu Restore Properties From Global Default Popup

The Restore Properties | From Global Defaults command resets the selected object's properties from the cblwow.ini initialization file.


Options Menu Restore Properties From Global Defaults Command Ref

Restore Properties (Options menu)

Use this option to restore the default property settings for the currently selected object (control or form) in the Properties dialog box. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets selected object's properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets selected object's properties from the cblwow.ini initialization file.


Options Menu Restore Properties From Project Defaults Command Ref

Restore Properties (Options menu)

Use this option to restore the default property settings for the currently selected object (control or form) in the Properties dialog box. When you choose the Restore Properties command, two submenus appear:

· From Project Defaults. The From Project Defaults option resets selected object's properties from the project definition file (.wpj).

· From Global Defaults. The From Global Defaults option resets selected object's properties from the cblwow.ini initialization file.


Options Menu Restore Properties From Project Defaults Popup

The Restore Properties | From Project Defaults command resets the selected object's properties from the project definition file (.wpj).


Options Menu Save Properties For Global Use Command Ref

Save Properties (Options menu)

Use this command to save the modified property settings for the currently selected object (control or form) in the Properties dialog box. When you choose the Save Properties command, two options appear:

· For Project Use. Choosing this option saves the selected object's properties to the project definition file (.wpj). These property settings become the new default settings for the selected object when they are used in that particular project.

· For Global Use. If you want to reuse the modified form or control in a different project, choose the For Global Use option to save the selected object's properties to the cblwow.ini initialization file.


Options Menu Save Properties For Global Use Popup

The Save Properties | For Global Use command saves the selected object's properties to the cblwow.ini initialization file in order to reuse the modified form or control in a different project.


Options Menu Save Properties For Project Use Command Ref

Save Properties (Options menu)

Use this command to save the modified property settings for the currently selected object (control or form) in the Properties dialog box. When you choose the Save Properties command, two options appear:

· For Project Use. Choosing this option saves the selected object's properties to the project definition file (.wpj). These property settings become the new default settings for the selected object when they are used in that particular project.

· For Global Use. If you want to reuse the modified form or control in a different project, choose the For Global Use option to save the selected object's properties to the cblwow.ini initialization file.


Options Menu Save Properties For Project Use Popup

The Save Properties | For Project Use command saves the selected object's properties to the project definition file (.wpj). These property settings become the new default settings for the selected object (control or form) when they are used in that particular project.


Options Menu Select ActiveX Controls Command Ref

Select ActiveX Controls (Options menu)

Use this command to choose from a list of ActiveX controls that are installed on your Windows machine using the Select ActiveX Controls dialog box. Any changes that you make will be recorded in the cblwow.ini initialization file.


Options Menu Select ActiveX Controls Popup

The Select ActiveX Controls command chooses from a list of ActiveX controls that are installed on your Windows machine using the Select ActiveX Controls dialog box.


Original Code

The Original Code window displays the original code fragment before the changes. Use the vertical and horizontal scroll bars to view the code that is not visible in the window.


PageChange Property Scroll bar

The PageChange property determines the amount the position of a scroll bar control changes when the mouse is clicked on the scroll bar.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the PageChange property with any value greater than 0 but less than the difference specified between the Minimum property and Maximum property values. In addition, note that the PageChange setting should be greater than the value specified in the LineChange property.


PageChange Property Trackbar

The PageChange property determines the amount the position of a trackbar control changes when the mouse is clicked on the trackbar.

Set the PageChange property with any value greater than 0 but less than the difference specified between the Minimum property and Maximum property values. In addition, note that the PageChange setting should be greater than the value specified in the LineChange property.

This property can be manipulated at design time and either retrieved or set at runtime.


PageDn Event (Vertical)

A PageDn event occurs when the mouse is clicked on the bar to the right of or below the thumb on a vertical scroll bar.


PageDown Event

The PageDown event occurs when the user clicks the area below or to the right of the slider with the mouse or moves to that area using the keyboard.


PageLeft Event (Horizontal)

The PageLeft event occurs when the mouse is clicked on the bar to the left of the thumb on a horizontal scroll bar.


PageRight Event (Horizontal)

The PageRight event occurs when the mouse is clicked on the bar to the right of the thumb on a horizontal scroll bar.


PageSize

The PageSize property specifies the change in value to be associated with clicking on the scroll bar, above or below the thumb object, but not on the end-arrows.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


PageUp Event

The PageUp event occurs when the user clicks the area above or to the left of the slider with the mouse or moves to that area using the keyboard.


PageUp Event (Vertical)

A PageUp event occurs when the mouse is clicked on the bar to the left of or above the thumb on a vertical scroll bar.


Paint Event Form

The Paint event occurs when the form receives a WM-PAINT message (see the Functions and Messages online Help file). Although WOW Extensions and the COBOL runtime together automatically draw whatever image is required within the form, if you want to dynamically draw something else, the Paint event provides notification that it is permissible to do so.


Panel Import Preferences Dialog Box See Also

Modifying an Existing RM/Panels Panel Library

Properties for RM/Panels Data Fields


Panel Menu Close All Command Ref

Close All (Panel Menu)

Use this command to close all open panels without leaving WOW Extensions. WOW Extensions will display a message box with Yes To All and No To All command buttons. If you click Yes To All, and if you have not made changes to any of the panels since you last opened or saved them, WOW Extensions will immediately close all the panels. If you have made changes to any panel in the library, however, WOW Extensions will display a message box asking whether you want to save those changes. If you click No To All, none of the panels will be closed.


Panel Menu Close All Popup

The Close All command closes all open panels without leaving WOW Extensions. WOW Extensions will display a message box with Yes To All and No To All command buttons. If you click Yes To All, and if you have not made changes to any of the panels since you last opened or saved them, WOW Extensions will immediately close all the panels. If you have made changes to any panel in the library, however, WOW Extensions will display a message box asking whether you want to save those changes. If you click No To All, none of the panels will be closed.


Panel Menu Close Command Ref

Close (Panel Menu)

Use this command to close a panel without leaving WOW Extensions. If you have not made changes to the panel since you last opened or saved it, WOW Extensions will immediately close the panel. If you have made changes to the panel, however, WOW Extensions will display a message box asking whether you want to save the changes to the panel. If you choose Yes and the current panel has previously been saved, WOW Extensions will save the panel under its current name and then close it.


Panel Menu Close Popup

The Close command closes a panel without leaving WOW Extensions. If you have not made changes to the panel since you last opened or saved it, WOW Extensions will immediately close the panel. If you have made changes to the panel, however, WOW Extensions will display a message box asking whether you want to save the changes to the panel. If you choose Yes and the current panel has previously been saved, WOW Extensions will save the panel under its current name and then close it.


Panel Menu Commands See Also

Migrating RM/Panels Panel Libraries to WOW Forms

Modifying an Existing RM/Panels Panel Library


Panel Menu Export All Command Ref

Export All (Panel menu)

Use this command to save all panels in a panel library created with RM/Panels as WOW forms, providing the ability to create a new WOW program using existing panels.


Panel Menu Export All Popup

The Export All command saves all panels in a panel library created with RM/Panels as WOW forms, providing the ability to create a new WOW program using an existing panel.


Panel Menu Export Command Ref

Export (Panel menu)

Use this command to save a single panel created with RM/Panels as a WOW form, providing the ability to create a new WOW program using an existing panel. For more information about saving a panel, click here.


Panel Menu Export Popup

The Export command saves a single panel created with RM/Panels as a WOW form, providing the ability to create a new WOW program using an existing panel.


Panel Menu Import Preferences Command Ref

Import Preferences (Panel menu)

Use this command to display the Panel Import Preferences dialog box in order to specify certain graphical characteristics that will determine the way that character-based panels in an RM/Panels library will appear when the library is opened in the WOW Designer.


Panel Menu Import Preferences Popup

The Import Preferences command displays the Panel Import Preferences dialog box in order to specify certain graphical characteristics that will determine the way that character-based panels in an RM/Panels library will appear when the library is opened in the WOW Designer.


Panel Menu Open All Command Ref

Open All (Panel menu)

Use this command to open all RM/Panels panels in a panel library in the WOW Designer. WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified. WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls). Once a library has been selected, a subsequent dialog box is displayed so that a specific panel may be selected. For more information, click here.


Panel Menu Open All Popup

The Open All command opens all RM/Panels panels in a panel library in the WOW Designer. WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified. WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls). Once a library has been selected, a subsequent dialog box is displayed so that a specific panel may be selected.


Panel Menu Open Command Ref

Open (Panel menu)

Use this command to open an RM/Panels panel in the WOW Designer. WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified. WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls). Once a library has been selected, a subsequent dialog box is displayed so that a specific panel may be selected. For more information, click here.


Panel Menu Open Popup

The Open command opens an RM/Panels panel in the WOW Designer. WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified. WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls). Once a library has been selected, a subsequent dialog box is displayed so that a specific panel may be selected.


Panel Menu Recent List Command Ref

Recent Panel Library (Panel Menu)

Use this command to list up to the last four panel libraries most recently opened in the WOW Designer. To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.


Panel Menu Recent List Popup

The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer. To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.


Panel Menu Recent List Popup2

The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer. To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.


Panel Menu Recent List Popup3

The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer. To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.


Panel Menu Recent List Popup4

The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer. To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.


Panel Menu Recreate GUI All Command Ref

Recreate GUI All (Panel menu)

Use this command to restore all panels in an RM/Panels library to their original states after the panels have been opened in WOW Extensions. Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted. For more information, click here.


Panel Menu Recreate GUI All Popup

The Recreate GUI All command restores all panels in an RM/Panels library to their original states after the panels have been opened in WOW Extensions. Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted.


Panel Menu Recreate GUI Command Ref

Recreate GUI (Panel menu)

Use this command to restore an RM/Panels panel to its original state after it has been opened in WOW Extensions. Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted. For more information, click here.


Panel Menu Recreate GUI Popup

The Recreate GUI command restores an RM/Panels panel to its original state after it has been opened in WOW Extensions. Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted.


Panel Menu Save All Command Ref

Save All (Panel Menu)

Use this command to save all existing RM/Panels panels in a panels library that were modified with WOW Extensions and write their descriptions back into that standard panel library. (No WOW-specific files are created). WOW Extensions will display a message box with a Yes/No To All command button. If you choose Yes To All and the current panel has previously been saved, WOW Extensions will save the panel under its current name and then close it. If you choose Yes To All and the current panel has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it. This process will be repeated for all open panels. If you choose No To All, WOW Extensions will close all the panels without saving any changes. For more information about saving existing panels, click here.


Panel Menu Save All Popup

The Save All command saves all existing RM/Panels panels in a panels library that were modified with WOW Extensions and write their descriptions back into that standard panel library. (No WOW-specific files are created). WOW Extensions will display a message box with a Yes/No To All command button. If you choose Yes To All and the current panel has previously been saved, WOW Extensions will save the panel under its current name and then close it. If you choose Yes To All and the current panel has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it. This process will be repeated for all open panels. If you choose No To All, WOW Extensions will close all the panels without saving any changes.


Panel Menu Save Command Ref

Save (Panel Menu)

Use this command to save an existing RM/Panels panel modified with WOW Extensions and write the description of the panel back into the standard panel library. No WOW-specific files are created. For more information about saving an existing panel, click here.


Panel Menu Save Popup

The Save command saves an existing RM/Panels panel modified with WOW Extensions and writes the description of the panel back into the standard panel library. No WOW-specific files are created.


Panel Menu Test Command Ref

Test (Panel menu)

Use this command to run, from within the WOW Designer, a generic COBOL program to see how an RM/Panels panel will appear at runtime. For more information, click here.


Panel Menu Test Popup

The Test command runs, from within the WOW Designer, a generic COBOL program to see how an RM/Panels panel will appear at runtime.


Parent Property Form

The Parent property is a design-time-only property that designates the form that serves as the parent of the current form.

The Parent property value should be specified in the WOW Designer, using the name of another form in the project. Leaving the value blank indicates that there is no parent form. If a parent is specified, the current form will be positioned relative to the parent and minimized with the parent.


PasswordChar Property

The PasswordChar property determines the character that is displayed if an edit box control has the Password property set.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the value of the PasswordChar property with any alphanumeric character, including space.


Password Property

The Password property determines whether the text of an edit box control or the password character is displayed.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Password property:

Value | Description
False | Text of the control is displayed (the default).
True | The password character is displayed instead of the text.


PenSize Property

The PenSize property is a design-time-only property that specifies the width of the pen used to draw the outline of the geometric shape (ellipse, line, rectangle, or rounded rectangle control) in logical units. The default value is 1.


PenStyle Property

The PenStyle property is a design-time-only property that specifies the style of the pen used to draw the outline of the geometric shape (ellipse, line, rectangle, or rounded rectangle control).

The following table lists the possible values of the PenStyle property:

Value | Description
0 | The pen is solid.
1 | The pen is dashed.
2 | The pen is dotted.
3 | The pen has alternating dashes and dots.
4 | The pen has dashes and double dots.


Play Property

The Play property is a design-time only property that determines when the animation starts or stops playing.

The following table lists the possible values of the Play property:

Value | Description
False | Causes the animation to stop playing (the default).
True | Causes the animation to start playing.


Popup Aligning Toolbar Align Bottoms

The Align Bottoms button on the Aligning and Layout toolbars aligns the bottom edge of each selected control with the bottom edge of the primary selection.


Popup Aligning Toolbar Align Centers

The Align Centers button on the Aligning and Layout toolbars aligns the vertical (up/down) center of each selected control with the vertical center of the primary selection.


Popup Aligning Toolbar Align Lefts

The Align Lefts button on the Aligning and Layout toolbars aligns the left side of each selection with the left side of the primary selection.


Popup Aligning Toolbar Align Middles

The Align Middles button on the Aligning and Layout toolbars aligns the horizontal (left/right) center of each selected control with the horizontal center of the primary selection.


Popup Aligning Toolbar Align Rights

The Align Rights button on the Aligning and Layout toolbars aligns the right side of each selection with the right side of the primary selection.


Popup Aligning Toolbar Align Tops

The Align Tops button on the Aligning and Layout toolbars aligns the top edge of each selected control with the top edge of the primary selection.


Popup Animation Control

An animation control is used to display an AVI clip. An AVI clip is a series of bitmap frames that run like a movie. Only AVI files without sound can be played using the animation control.


Popup Bitmap Control

The bitmap control is used to display bitmapped images. The image can be displayed in several ways, including being tiled or scaled to fit the size of the control. A bitmap defines an image or picture as a pattern of dots (or pixels) and has the file extension .bmp. Even though Windows does not implement or package a bitmap control, it does provide bitmap handling. WOW Extensions adds the bitmap control to provide a convenient way to use bitmaps on a form.


Popup Centering Toolbar Center Horizontally

The Center Horizontally button on the Centering and Layout toolbars aligns the controls horizontally with respect to the center of the form between the left and right borders of the form.


Popup Centering Toolbar Center Vertically

The Center Vertically button on the Centering and Layout toolbars aligns the controls vertically with respect to the center of the form between the top and bottom borders.


Popup Check Box Control

The check box control displays an option that can be turned on or off. The check box control is similar to the command button, in that the primary method of operation is clicking it. The check box control, however, represents data, not a request for action.


Popup Combo Box Control

The combo box control combines the features of an edit box (also known as an edit field) and a list box. This control allows you to combine the list selection capability of a list box with the edit box’s ability to type in a value. Alternatively, to save screen space on a form, you may wish to show only a portion of the list box’s selections. And, there may be instances when you would like to display the currently selected item in a static edit box area when the entire list is not displayed.


Popup Command Button Control

The command button (also known as push button) control causes an action to occur when the user either clicks the button or presses a key.


Popup Date Edit Box Field/Control

The date edit box field/control provides an area on a panel in which a date can be displayed or entered.


Popup Date Time Picker

The date time picker control allows the user to select a date and time, and to display that date-time in the specified format.


Popup Edit Box Control

The edit box control provides an area to input or display text. This control replaces the COBOL ACCEPT statement. The user can enter any type of alphanumeric data in an edit box, including numeric data. Because no formatting is provided, numbers are entered in the same manner as text.


Popup Editing and Find Toolbars Find in Code Fragments

The Find in Code Fragments button on the Editing and Find toolbars displays the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code. Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window. Note that this button is enabled only if a project is opened.


Popup Editing Toolbar Clear Markers

The Clear Markers button on the Editing toolbar removes all markers in the code edit windows.


Popup Editing Toolbar Copy

The Copy button on the Editing toolbar copies a control(s) on a form or between forms. The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged. Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can select multiple controls to be copied from within a single form.


Popup Editing Toolbar Cut

The Cut button on the Editing toolbar cuts a control(s) from a form. The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms. You can select multiple controls to be cut from within a single form. The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form. (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.) You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation.


Popup Editing Toolbar Delete

The Delete button on the Editing toolbar erases a control or controls from a form. Note that you cannot reinsert control(s) removed by using the Delete button since this command does not place the deleted selection in the Clipboard. You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation.


Popup Editing Toolbar Find

The Find button on the Editing toolbar displays a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box. Note that this button is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.


Popup Editing Toolbar Go To Next Marker

The Go To Next Marker button on the Editing toolbar goes to the next marker in the code edit windows.


Popup Editing Toolbar Go To Previous Marker

The Go To Previous Marker button on the Editing toolbar goes to the previous marker in the code edit windows.


Popup Editing Toolbar Paste

The Paste button on the Editing toolbar pastes a control(s) after cutting or copying to the Clipboard. Note that this command is not available if the Clipboard is empty.


Popup Editing Toolbar Redo

The Redo button on the Editing toolbar restores the result of the last editing operation or action, if you decide that you do not want to undo the action.


Popup Editing Toolbar Toggle Marker

The Toggle Marker button on the Editing toolbar shows or hides the display of the markers in the code edit windows. The default is to show markers, which is a setting on the Code Edit Windows Preferences page.


Popup Editing Toolbar Undo

The Undo button on the Editing toolbar reverses the effect of the most recent editing operation. You must choose Undo before performing any other operation or the control is not restored. Note that not all editing operations can be undone. In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms.


Popup Ellipse Shape Control

The ellipse shape is used to draw the geometric shape of an ellipse on the form. A 32-bit Windows-based application uses filled shapes in a variety of ways. Spreadsheet applications, for example, use filled shapes to construct charts and graphs.


Popup File Toolbar New Form

The New Form button on the File toolbar adds a new, blank form to an open project.


Popup File Toolbar Open Form

The Open Form button on the File toolbar retrieves an existing form file from disk while you are in an open project. WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified.


Popup File Toolbar Open Member

The Open Member button on the File toolbar displays a list of all the files (members) in the open, active project from which you can open a member. Note that members can also be added to and deleted from the project at any time with the Properties command.


Popup File Toolbar Print Form

The Print Form button on the File toolbar prints a form. If more than one form is open, the form on top of the stack is printed. Selecting this command opens a standard Windows Print dialog box.


Popup File Toolbar Save All Forms

The Save All Forms button on the File toolbar saves changes made to all open form files. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.


Popup File Toolbar Save Form and Generate Code

The Save Form and Generate Code button on the File toolbar saves changes made to the current form file. When you save a form, WOW Extensions automatically generates COBOL source code. If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.


Popup Group Box Control

The group box control is a specialized box that is used to group other controls, such as check boxes and option buttons.


Popup Help Toolbar About button

The About button on the Help toolbar displays the About WOW Designer dialog box, which provides the version number, copyright notice, the name and company name of the person the copy is licensed to, the serial number, and other information for the installed product.


Popup Help Toolbar What This button

The What's This button on the Help toolbar provides access to context-sensitive Help for control icons, menu commands, toolbar buttons, and other screen elements.


Popup Horizontal Scroll Bar Control

The scroll bar control is used to allow a numeric value to be manipulated as a thumb position on a bar. By specifying the minimum and maximum, the value can be viewed relative to a range of possible values. This value and the scroll bar are often used to scroll the display of other information on a form. A horizontal scroll bar displays a horizontal bar that can be used to scroll information.


Popup Layout Toolbar Bring to Front

The Bring to Front button on the Layout toolbar moves the selected control all the way to the front of the stack of controls. Note that the Bring to Front command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).


Popup Layout Toolbar Send to Back

The Send to Back button on the Layout toolbar moves the selected control behind all other controls in the stack on a form. Note that the Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).


Popup Layout Toolbar Toggle Lock

The Toggle Lock button on the Layout toolbar locks or unlocks the selected control(s), which keeps the control(s) from being moved accidentally.


Popup Line Shape Control

The line shape is used to draw a line on the form.


Popup List Box Control

The list box control allows the selection of one or several items from a list of items. It is a simple, yet versatile control. You load a list box with items at runtime. When enabled, the user can select an item by clicking with the mouse or moving the selection bar with the arrow keys. You send the list box a message to find out which item in the list box is selected.


Popup Month Calendar Picker

The month calendar control displays a monthly calendar. The calendar can display one or more months at a time.


Popup Multi-line Box Field/Control

The multi-line edit box field/control provides an area on a panel in which users may enter several lines of text into a small, fixed space. Because the text box is smaller than the amount of information stored, part of the information is hidden. The user uses scroll bars to display the hidden information. You can design the text box to scroll its contents vertically or horizontally.


Popup Numeric Box Field/Control

The numeric edit box field/control provides an area to input or display numeric data.


Popup Option Button Control

The option button (also known as radio button) control displays an option that can be turned on or off. Option buttons are usually used in groups where turning one button on turns the others off.


Popup Pointer Tool

The Pointer tool, the first item in the Toolbox, provides a way to select the form or a control on the form, and to move and resize forms and controls. The Pointer tool is not a control.


Popup Progress Bar Control

A progress bar control consists of a patterned block that can be used to show the status of a long operation.


Popup Project Toolbar Build Project button

The Build Project button on the Project toolbar generates and compiles a COBOL source program if one does not exist.


Popup Project Toolbar Debug Project button

The Debug Project button on the Project toolbar debugs the project.


Popup Project Toolbar Execute Project button

The Execute Project button on the Project toolbar executes the project by running the COBOL source program after it has been compiled.


Popup Project Toolbar New Project button

The New Project button on the Project toolbar creates a new WOW project using the Project Properties dialog box after you enter and save a name for the project and the directory/folder for the project files. Note that only one project can be opened at one time. If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created. After creating a new project, the Save Project dialog box opens, which establishes the project name and the directory/folder for the project files.


Popup Project Toolbar Open Project button

The Open Project button on the Project toolbar opens an existing project, and includes the forms and custom controls listed in its project (.wpj) file. The Open Project dialog box, which is a standard Windows dialog box, opens. Note that only one project can be opened at one time. If you are already in an open project when you choose the Open command on the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.


Popup Project Toolbar Save Project and Generate Code button

The Save Project and Generate Code button on the Project toolbar saves changes made to an active (open) project. When you save a project, WOW Extensions automatically generates COBOL source code.


Popup Project Toolbar Test Form button

The Test Form button on the Project toolbar runs, from within the WOW Designer, a simplified version of the WOW runtime (wowtestform.exe) without executing COBOL code in order to see how a form will appear at runtime and tests its operation during the design process. This test form program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.


Popup Rectangle Shape Control

The rectangle shape is used to draw the geometric shape of a rectangle on the form. Rectangles are used for the cursor clipping region, the invalid portion of the client area, an area for displaying formatted text, or the scroll area. Your applications can also use rectangles to fill, frame, or invert a portion of the client area with a given brush, and to retrieve the coordinates of a window or a window’s client area.


Popup Rounded Rectangle Shape Control

The rounded rectangle shape is used to draw the geometric shape of a rectangle with rounded corners on the form. Rectangles are used for the cursor clipping region, the invalid portion of the client area, an area for displaying formatted text, or the scroll area. Your applications can also use rectangles to fill, frame, or invert a portion of the client area with a given brush, and to retrieve the coordinates of a window or a window’s client area.


Popup Sizing Toolbar Match Both

The Match Both button on the Sizing and Layout toolbars resizes the controls in both directions (vertical and horizontal) simultaneously.


Popup Sizing Toolbar Match Heights

The Match Heights button on the Sizing and Layout toolbars resizes the selected controls in a vertical direction.


Popup Sizing Toolbar Match Widths

The Match Widths button on the Sizing and Layout toolbars resizes the selected controls in a horizontal direction.


Popup Spacing Toolbar Space Horizontally

The Space Horizontally button on the Spacing and Layout toolbars distributes the selected controls in a horizontal direction such that the spacing between the controls is the same.


Popup Spacing Toolbar Space Vertically

The Space Vertically button on the Spacing and Layout toolbars distributes the controls in the vertical direction, placing equal amounts of space between the selected controls.


Popup Static Text Control

The static text control is used to display text, rectangular outlines, or filled rectangles. These features could reasonably be implemented as several different types of objects, but Windows combines them since they have the same properties. You use the static text control most often to display text the user is not allowed to modify, such as labels for other controls. The static text control is also used to draw rectangles or outlines to highlight parts of a form, group controls, or even create a design.


Popup Status Bar Control

A status bar control display status information in a horizontal window at the bottom of an application window. Status bars are often divided into sections, called panes, and each pane displays different status information.


Popup Tab Control

A tab control is a container control, meaning it allows other controls to be placed inside it. The tab control has several tabs at the top of the control. When a control is added to the tab, it is attached to the tab that is currently selected. When another tab is selected, the controls for the other tabs are hidden and the controls for the selected tab are displayed. This is an excellent way to organize controls by category, rather than placing a large number of controls in a single window.


Popup Time Edit Box Field/Control

The time edit box field/control provides an area on a panel in which the time can be displayed or entered.


Popup Timer Control

The timer control provides a measured time interval that can be tied to events.


Popup Toolbar Control

A toolbar control consists of a series of buttons that can be placed at the top and/or bottom of a form. You can put two toolbars on a form, one at the top and one at the bottom. Event-handling code can be attached to each button in the toolbar. Each button in the toolbar can contain a bitmap and/or text.


Popup Toolbox

The Toolbox contains the icons of the controls that you select, draw, and place on your form. The controls that appear in the Toolbox are the default Windows intrinsic controls. By default, the Toolbox is displayed vertically along the right-hand side of the WOW Designer window. It can, however, be dragged and attached to a different location of your choosing or it can be detached, or floated, in the WOW Designer window


Popup Trackbar Control

A trackbar control displays a window containing a slider and optional tick marks used to select a value or a set of consecutive values in a range. The trackbar control can be oriented either horizontally or vertically. Trackbars are useful when you want the user to select a discrete value or a set of consecutive values in a range.


Popup UpDown Control

An updown control is most often used with a companion control, which is called a buddy window. To the user, an updown control and its buddy window often look like a single control. You can specify that an updown control automatically position itself next to its buddy window and that it automatically set the caption of the buddy window to its current position.


Popup Vertical Scroll Bar Control

The scroll bar control is used to allow a numeric value to be manipulated as a thumb position on a bar. By specifying the minimum and maximum, the value can be viewed relative to a range of possible values. This value and the scroll bar are often used to scroll the display of other information on a form. A vertical scroll bar displays a vertical bar that can be used to scroll information.


Popup View Toolbar Edit Control Code

The Edit Control Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected control.


Popup View Toolbar Edit Form Code

The Edit Form Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the form.


Popup View Toolbar Edit Form Menu Code

The Edit Form Menu Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the specified menu.


Popup View Toolbar Edit Project Code

The Edit Project Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the project.


Popup View Toolbar Show ActiveX Methods

The Show ActiveX Methods button on the View toolbar opens the ActiveX Methods dialog box, which allows you to select method(s) for the control.


Popup View Toolbar Show Menu Editor

The Show Menu Editor button on the View toolbar creates Windows-style pulldown menus for a selected form. The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box. You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance.


Popup View Toolbar Show Properties

The Show Properties button on the View toolbar opens the Properties dialog box for the selected object.


Popup View Toolbar Show Toolbox

The Show Toolbox button on the View toolbar accesses the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form. You must have a mouse to access the controls on the Toolbox.


Preferences Dialog Box See Also

Configuring WOW Extensions

Locating Required Tools

Setting Preferences


Prefix

The Prefix property specifies the prefix to be used when generating .ws and .prc files.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Program

The Program area identifies the COBOL program for which code is being written. The name of the program changes depending upon whether the selected event is for a project, a form, a control, or a menu.


Progress Bar Control Object See Also

Property Manipulation Checklist


Progress Bar Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Project Description Project Properties

The Project Description text box allows you to enter a comment for the project. The description will be displayed in the status bar while the project is selected.


Project Menu Build Command Ref

Build (Project menu)

Use this command to generate and compile a COBOL source program if one does not exist.

Shortcuts

Toolbar: on the Project toolbar

Keys: F7


Project Menu Build Popup

The Build command generates and compiles a COBOL source program if one does not exist.


Project Menu Close Command Ref

Close (Project menu)

Use this command to close a project. If you have made any changes to the file, you are prompted to save the changes.


Project Menu Close Popup

The Close command closes a project. If you have made any changes to the file, you are prompted to save the changes.


Project Menu Commands See Also

Using WOW Projects


Project Menu Debug Command Ref

Debug (Project menu)

Use this command to debug the project. For more information about debugging a WOW project, click here.

Shortcut

Toolbar: on the Project toolbar


Project Menu Debug Popup

The Debug command debugs the project.


Project Menu Edit Code Command Ref

Edit Code (Project menu)

Use this command to open the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the project.

Shortcuts

Toolbar: on the View toolbar

Or, from the Project tree, select the active project name, then right-click to display a pop-up menu. Choose Edit Code on the pop-up menu.


Project Menu Edit Code Popup

The Edit Code command opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the project.


Project Menu New Command Ref

New (Project menu)

Use this command to create a new WOW project. After you enter a name for the project and the directory/folder for the project files (.wpj) in the Save Project dialog box (a standard Windows dialog box), the Project Properties dialog box opens and you can add forms (members) to the project.

Note Only one project can be opened at one time. If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created. After creating a new project, the Save Project dialog box opens, which establishes the project name and the directory/folder for the project files.

Shortcut

Toolbar: on the Project toolbar


Project Menu New Popup

The New command creates a new WOW project. After you enter a name for the project and the directory/folder for the project files (.wpj) in the Save Project dialog box (a standard Windows dialog box), the Project Properties dialog box opens and you can add forms (members) to the project. Note that only one project can be opened at one time. If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created.


Project Menu Open Command Ref

Open (Project menu)

Use this command to open an existing project, and include the forms and custom controls listed in its project file (.wpj). The Open Project dialog box, which is a standard Windows dialog box, opens.

Note Only one project can be opened at one time. If you are already in an open project when you choose the Open command from the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.

Shortcut

Toolbar: on the Project toolbar


Project Menu Open Member Command Ref

Open Member (Project menu)

Use this command to open or access a member of a project. A list box containing all the form files (.wow) in the project is displayed below the toolbar button.

Note Members can be added to and deleted from the project at any time with the Properties command.

Shortcut

Toolbar: on the File toolbar


Project Menu Open Member Popup

The Open Member command opens or accesses a member of a project. A list box containing all the form files (.wow) in the project is displayed below the toolbar button. Note that members can be added to and deleted from the project at any time with the Properties command.


Project Menu Open Popup

The Open command opens an existing project, and includes the forms and custom controls listed in its project file (.wpj). The Open Project dialog box, which is a standard Windows dialog box, opens. Note that only one project can be opened at one time. If you are already in an open project when you choose the Open command from the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.


Project Menu Options Command Ref

Options (Project menu)

Use this command to specify configuration options for the current project using the Project Options dialog box.

Shortcut

From the Project tree, select the active project name, then right-click to display a pop-up menu. Choose Options on the pop-up menu.


Project Menu Options Popup

The Options command specifies configuration options for the current project using the Project Options dialog box.


Project Menu Print Packaging List Command Ref

Print Packaging List (Project menu)

Use this command to print a list of the application components (such as the COBOL program, bitmaps, icons, animation files, ActiveX controls, and so on) that are required for distribution. Selecting this command opens a standard Windows Print dialog box.


Project Menu Print Packaging List Popup

The Print Packaging List command prints a list of the application components (such as the COBOL program, bitmaps, icons, animation files, ActiveX controls, and so on) that are required for distribution. Selecting this command opens a standard Windows Print dialog box.


Project Menu Properties Command Ref

Properties (Project menu)

Use this command to edit the current project by adding or deleting members. The Project Properties dialog box opens. The settings in the Project Properties dialog box affect only the currently open project.

Shortcuts

From the Project tree, select the active project name, then right-click to display a pop-up menu. Choose Properties on the pop-up menu.

From the Project tree, double-click the project name.


Project Menu Properties Popup

The Properties command edits the current project by adding or deleting members. The Project Properties dialog box opens. The settings in the Project Properties dialog box affect only the currently open project.


Project Menu Recent Projects Command Ref

Recent Projects (Project menu)

Use this command to list up to the last four projects most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.


Project Menu Recent Projects Popup

The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.


Project Menu Recent Projects Popup2

The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.


Project Menu Recent Projects Popup3

The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.


Project Menu Recent Projects Popup4

The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer. To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.


Project Menu Regenerate Command Ref

Regenerate (Project menu)

Use this command to regenerate COBOL source code for the active project if changes have been made to a form.


Project Menu Regenerate Popup

The Regenerate command regenerates COBOL source code for the active project if changes have been made to a form.


Project Menu Regenerate wForms Command Ref

Regenerate w/Forms (Project menu)

Use this command to regenerate COBOL source code for the active project if changes have been made to a form.


Project Menu Regenerate wForms Popup

The Regenerate w/Forms command regenerates COBOL source code for the active project if changes have been made to a form.


Project Menu Run Command Ref

Run (Project menu)

Use this command to execute the project by running the COBOL source program after it has been compiled.

Shortcut

Toolbar: on the Project toolbar

Keys: F5


Project Menu Run Popup

The Run command executes the project by running the COBOL source program after it has been compiled.


Project Menu Save As Command Ref

Save As (Project menu)

Use this command to save a copy of the open project with a different name using a standard Windows Save As dialog box.


Project Menu Save As Popup

The Save As command saves a copy of the open project with a different name.


Project Menu Save Command Ref

Save (Project menu)

Use this command to save changes made to an active (open) project. When you save a project, WOW Extensions automatically generates COBOL source code.

Shortcut

Toolbar: on the Project toolbar


Project Menu Save Popup

The Save command saves changes made to an active (open) project. When you save a project, WOW Extensions automatically generates COBOL source code.


Project Properties Dialog Box See Also

Using Global Default Property Settings

Using WOW Projects


Project Toolbar Build Project button

Build Project (Project Toolbar)

Use the Build Project button to generate and compile a COBOL source program if one does not exist.

This button corresponds to the Build command on the Project menu.


Project Toolbar Debug Project button

Debug Project (Project Toolbar)

Use the Debug Project button to debug the project.

This button corresponds to the Debug command on the Project menu.


Project Toolbar Execute Project button

Execute Project (Project Toolbar)

Use the Execute Project button to execute the project by running the COBOL source program after it has been compiled.

This button corresponds to the Run command on the Project menu.


Project Toolbar New Project button

New Project (Project Toolbar)

Use the New Project button to create a new WOW project. After you enter a name for the project and the directory/folder for the project files (.wpj) in the Save Project dialog box (a standard Windows dialog box), the Project Properties dialog box opens and you can add or delete forms (members) to the project.

Note Only one project can be opened at one time. If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created. After creating a new project, the Save Project dialog box opens, which establishes the project name and the directory/folder for the project files.

This button corresponds to the New command on the Project menu.


Project Toolbar Open Project button

Open Project (Project Toolbar)

Use the Open Project button to open an existing project, and include the forms and custom controls listed in its project (.wpj) file. The Open Project dialog box, which is a standard Windows dialog box, opens.

Note Only one project can be opened at one time. If you are already in an open project when you choose the Open command on the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.

This button corresponds to the Open command on the Project menu.


Project Toolbar Save Project and Generate Code button

Save Project and Generate Code (Project Toolbar)

Use the Save Project and Generate Code button to save changes made to an active (open) project. When you save a project, WOW Extensions automatically generates COBOL source code.

This button corresponds to the Save command on the Project menu.


Project Toolbar See Also

Using WOW Projects


Project Toolbar Test Form button

Test Form (Project Toolbar)

Use the Test Form button to execute a simplified version of the WOW runtime (wowtestform.exe) to run from within the WOW Designer without executing COBOL code in order to see how a form will appear at runtime and test its operation during the design process. This test form program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

This button corresponds to the Test command on the Form menu.


Project Tree Popup

When you create or open a project, the Project tree region of the WOW Designer window displays a hierarchical list of forms in the active project. The list can be expanded (to display the member forms and the controls in each form) and contracted, similar to how one might navigate a directory/folder structure of files, an index, or a table of contents.

The Project tree is displayed by default in the WOW Designer window. To toggle the display of the Project tree on and off, choose the Project Tree command on the View menu.


Project Tree See Also

Using WOW Projects


Project Update Check General

WOW Extensions automatically provides information about product updates for the WOW Designer. The option buttons in the Project Update Check group determine which messages are displayed at start up.

· When the None option button is selected, no messages are displayed.

· When the Urgent option button is selected, only those messages that Liant designates as being urgent are displayed.

· When the All option button is selected, all update messages are displayed. This option is enabled by default.


Prompt

The Prompt property indicates whether prompt characters are to be provided for this field/control during input.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


PromptText

The PromptText property specifies the text that is displayed on the panel to prompt the user to enter a correct value.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Prompt When Code Has Been Externally Deleted

The Prompt When Code Has Been Externally Deleted option, enabled by default, provides an additional safety mechanism. It informs you when a section of code has been deleted, regardless of any of the external editing option settings described previously, except for the Do Not Use External Changes option in the At Form/Project Open group. The Prompt When Code Has Been Externally Deleted option displays the External Edit Comparison dialog box prompting you to accept or ignore the external changes. The dialog box displays both the original and deleted code.


Properties and Events for Forms See Also

Adding ActiveX Controls to the WOW Designer

Addressing Issues in Data Entry Programs

Developing Event-Driven Applications

Handling Events for Controls, Forms, and Projects

Looking Behind the Scenes

Manipulating Controls in a Form

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms

Using Global Default Property Settings


Properties and Events for Intrinsic Controls See Also

Common Intrinsic Control Properties

Common Intrinsic Control Events

Manipulating Controls in a Form

Properties and Events for Forms

Properties for RM/Panels Data Fields

Using Global Default Property Settings


Properties (dialog box)

The Properties list box is divided into two columns. The left column of this list box displays all of the properties associated with the selected object (that is, the form or control). The right column displays the current value (or setting) for each property. To view more properties if there are more than can fit in the list box, click the scroll box or arrows to the right of the list box, or use the arrow keys from the keyboard.

Notice that the property names are listed alphabetically for the selected object when the Alphabetic tab is selected, as shown here. You may also view the properties by functional category when you click the Categorized tab. Functional categories always include the Appearance, Behavior, and Position. Other categories, such as Font and Miscellaneous, can be displayed as well, depending on whether a form or a control is the selected object. To see an example of this page of the Properties dialog box, click here.

At design time, there are several ways to edit properties in the settings column of the Properties dialog box. You can directly type in values in the entry boxes. Some values can be changed by clicking the arrow to the right of the entry box; this action will display a drop-down list of pre-existing choices. You can then click an item in the list to select it. With certain properties, double-clicking an ellipsis (...) button in the settings column opens a dialog box that you use to set the property.

Note Certain properties associated with the selected object show a logical value of True or False. Your COBOL code, however, uses integer data types to implement these values.


Properties Dialog Box See Also

General Preferences

Handling Events for Controls, Forms, and Projects

Manipulating Controls in a Form

Properties and Events for Forms

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Properties for RM/Panels Data Fields See Also

Enhancing Existing RM/Panels Panel Libraries

Properties for RM/Panels Panels


Properties for RM/Panels Panels See Also

Enhancing Existing RM/Panels Panel Libraries

Properties for RM/Panels Data Fields


Properties See Also

ActiveX Control Properties

Setting Properties for Controls and Forms

Windows GUI Elements

WOW Extensions Development Process


Property Manipulation Checklist See Also

ActiveX Control Properties

Properties and Events for Intrinsic Controls

Properties and Events for Forms

Properties for RM/Panels Data Fields


Protected

The Protected property, when marked with an X, indicates that while the input cursor moves into this field/control, the value may not be changed by the user.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


PushedAttr

The PushedAttr property indicates the attribute that should be used to display the command button while it is depressed. Valid values are blank (the library default) or A through P (as defined by the attribute code assigned to a block of text within a panel).

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


RaggedRight Property

The RaggedRight property is a design-time-only property that determines whether the width of each tab will be increased so that each row of tabs fills the entire width of the tab control. This parameter is valid only when the MultiLine property is set to True. (Note that this property also can be changed using the Ragged Right check box in the Tab Control Editor dialog box.)

The following table lists the possible values of the RaggedRight property:

Value | Description
False | Rows of tabs will be stretched to fill the entire width of the control (the default).
True | Rows of tabs will not be stretched to fill the entire width of the control.


Range Property

The Range property is a runtime-only property that retrieves the current minimum and maximum allowable system times for a date time picker or month calendar control.

This property can be retrieved, but not set, at runtime.


RButtonDown Event Form

The RButtonDown event occurs when the right mouse button is depressed.


RButtonUp Event Form

The RButtonUp event occurs when the right mouse button is released.


ReadOnly Property

The ReadOnly property determines whether the contents of an edit box control can be modified by the user.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the ReadOnly property:

Value | Description
False | Contents may be modified (the default).
True | Contents may not be modified.


Rectangle Shape Object See Also

Property Manipulation Checklist


Rectangle Shape See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Remove Button (Customize Toolbar)

The Remove command button moves the button selected in the Current toolbar buttons area to the Available toolbar buttons area.


Remove (CustTool)

The Remove command button moves the selected tool in the Current Tools area to the Available Tools area.


Removing One or All Items from the List Box

You may want to clear one or all items from the list box during the use of the form containing the list box. To remove a single item from a list box use the WOWREMOVEITEM function as follows:

CALL WOWREMOVEITEM USING WIN-RETURN CTL-H INDEX.

WIN-RETURN returns 0 if the function is successful. CTL-H is the handle of the list box. INDEX is a numeric data item or literal that specifies the zero-relative index of the item to delete.

To remove all items from a list box, use the WOWCLEAR function as follows:

CALL WOWCLEAR USING WIN-RETURN CTL-H.

WIN-RETURN returns 0 if the function is successful. CTL-H is the handle of the list box.


Required

The Required property determines whether the user must enter data into field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the Required property:

Value | Description
False | The field/control is not required (the default).
True | The field/control is required.


Reset (Customize Toolbar)

The Reset command button removes any changes you made to the selected toolbar and restores the original settings (the default set of buttons) on the toolbar.


Restore Windows at Startup

If the Restore Windows At Startup check box is selected, WOW Extensions loads (or returns) the last opened windows you worked with (that is, the Toolbox, Properties dialog box, Event-Handling Code dialog box, and/or the Menu Editor dialog box) to their same positions in the WOW Designer window when you last quit WOW Extensions. This option is enabled by default.


Retrieving the Selection

You will undoubtedly want to retrieve the text of the selected list box item. This is accomplished by retrieving the value of the list box’s SelText property as follows:

CALL WOWGETPROP USING WIN-RETURN CTL-H "SELTEXT" SEL-TEXT.

SEL-TEXT returns the value of the selected list box item. If no item is selected, space is returned. CTL-H is the handle of the list box.


RightAlignedText Property

The RightAlignedText property is a design-time-only property that determines whether the control has right-aligned properties.

The following table lists the possible values of the RightAlignedText property:

Value | Description
False | The control does not have right-aligned properties (the default).
True | The control has right-aligned properties.


RightAlign Property

The RightAlign property is a design-time-only property that determines whether the drop-down month calendar will be right-aligned or left-aligned with the date time picker control.

The following table lists the possible values of the RightAlign property:

Value | Description
False | The drop-down month calendar will be left-aligned with the control (the default).
True | The drop-down month calendar will be right-aligned with the control.


Right Justify Menus

The Right Justify Menus option causes the MFT_RIGHTJUSTIFY style to be added at runtime to a menu when it is created.


RightJustify Property

The RightJustify property is a design-time-only property that determines whether the width of each tab will be increased so that each row of tabs fills the entire width of the tab control. This parameter is valid only when the MultiLine property is set to True. Note that this property also can be changed using the Right Justify check box in the Tab Control Editor dialog box.

The following table lists the possible values of the RightJustify property:

Value | Description
False | The width of each tab will not be increased (the default).
True | The width of each tab will be increased


Right Property

The Right property is a design-time-only property that determines whether or not tabs appear vertically on the right side of controls that have the Vertical property set to True. (Note that this property also can be changed using the Right check box in the Tab Control Editor dialog box.)

Note If the Vertical property is set to False and the Right property is set to True, the tabs will appear at the bottom of the control.

The following table lists the possible values of the Right property:

Value | Description
False | Tabs will not appear vertically on the right side of controls (the default).
True | Tabs appear vertically on the right side of controls.


RightToLeftReading Property

The RightToLeftReading property is a design-time-only property that determines whether the control's text is displayed using right-to-left reading-order properties.

The following table lists the possible values of the RightToLeftReading property:

Value | Description
False | The control's text is not displayed using right-to-left reading-order properties (the default).
True | The control's text is displayed using right-to-left reading-order properties.


RM/Panels Toolbox Configuration

Toolbox (Configured for RM/Panels)


Rounded Rectangle Shape Object See Also

Property Manipulation Checklist


Rounded Rectangle Shape See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


RoundnessX Property

The RoundnessX property is a design-time-only property that specifies the width of the ellipse used to draw the rounded corners.


RoundnessY Property

The RoundnessY property is a design-time-only property that specifies the height of the ellipse used to draw the rounded corners.


Rows Property

The Rows property is a design-time-only property that indicates how many rows can be used to display the toolbar. This property can be ignored, based on the grouping and separation of buttons.


Run Diff

The Run Diff command button causes the WOW Designer to write the information in the Original Code and Externally Edited Code areas to a file and invokes a file comparison tool to report the results of the comparison. The Microsoft Windows windiff tool is the default, but a different comparison tool can be specified in the File Difference Program area of the Tools Preferences page.


Runtime Command Line Arguments

The Runtime Command Line Arguments option sets the RM/COBOL Runtime Command options for the project.

Note You can also set this configuration option on the Tools Preferences page of the Preferences dialog box.


Runtime Preferences See Also

Setting Preferences

WOW Runtime System


Sample RM/COBOL Configuration File Entry

TERM-INPUT Action=Screen-Terminate CODE=13 CR

TERM-INPUT Action=Screen-Terminate CODE=1 NUL 59

TERM-INPUT Action=Screen-Terminate CODE=2 NUL 60

TERM-INPUT Action=Screen-Terminate CODE=3 NUL 61

TERM-INPUT Action=Screen-Terminate CODE=4 NUL 62

TERM-INPUT Action=Screen-Terminate CODE=5 NUL 63

TERM-INPUT Action=Screen-Terminate CODE=6 NUL 64

TERM-INPUT Action=Screen-Terminate CODE=7 NUL 65

TERM-INPUT Action=Screen-Terminate CODE=8 NUL 66

TERM-INPUT Action=Screen-Terminate CODE=9 NUL 67

TERM-INPUT Action=Screen-Terminate CODE=10 NUL 68

TERM-INPUT ACTION=SCREEN-PREVIOUS-FIELD CODE=52 NUL 72

TERM-INPUT ACTION=LEFT-ARROW CODE=65 NUL 75

TERM-INPUT ACTION=RIGHT-ARROW CODE=66 NUL 77

TERM-INPUT CODE=53 NUL 80


Sample WOW runtime initialization File Entry

Sample WOW Runtime Initialization File (wowrt.ini) Entry

[RMPanelsFunctionKeys]
; Windows key
names
F1=1
F2=2
F3=3
F4=4
F5=5
F6=6
F7=7
F8=8
F9=9
F10=10
ESC=27
LEFT=65
RIGHT=66
UP=52
DOWN=53
ENTER=13
Shift+F1=11
Shift+F2=12
Control+F1=21
Control+F2=22
;
RM/COBOL key
names
WF4=4
WF5=5
WSFT+WF4=14
WSFT+WF5=15
WCNT+WF4=24
WCNT+WF5=25

The wowrt.ini file must be present on a system to run a WOW Extensions-enhanced RM/Panels application so that the function key information can be loaded by the WOW runtime. The wowrt.ini file must be located in the same directory as the RM/COBOL runtime system. To view examples showing corresponding entries between a typical RM/COBOL runtime configuration file and the new [RMPanelsFunctionKeys] section in the wowrt.ini file, click here.


Save Menu Editor

The Save command button displays the Save Menu dialog box, a variation of the standard Windows Save dialog, so that you can save any changes to a menu file. These files are stored as .wmn files. The Menu Editor dialog allows you to save any menu that you design so that you can use it again in another WOW project.


Screen-Position Flags and Values

The screen-position flag can be one of the following values:

Value | Meaning
TPM-CENTERALIGN | Centers the pop-up menu horizontally relative to the coordinate specified by the X parameter.
TPM-LEFTALIGN | Positions the pop-up menu so that its left side is aligned with the coordinate specified by the X parameter.
TPM-RIGHTALIGN | Positions the pop-up menu so that its right side is aligned with the coordinate specified by the X parameter.


Scroll Bar Controls Object See Also

Property Manipulation Checklist


Scroll Bar Controls See Also

Handling Different Types of Data

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


ScrollBar Property

The ScrollBar property is a design-time-only property that determines whether a scroll bar is included on a combo box or list box control.

The following table lists the possible values of the ScrollBar property:

Value | Description
False | No scroll bar is included.
True | A scroll bar is included (the default).


ScrollBars Property

The ScrollBars property is a design-time-only property that determines whether one or more scroll bars are included in an edit box control.

Note Vertical scroll bars should only be used with edit box controls when the MultiLine property is set to True.

The following table lists the possible values of the ScrollBars property:

Value | Description
0 | No scroll bars are added (the default).
1 | A vertical scroll bar is added.
2 | A horizontal scroll bar is added.
3 | Both vertical and horizontal scroll bars are added.


ScrollBars Property Form

The ScrollBars property is a design-time-only property that determines whether one or more scroll bars are attached to a form.

The following table lists the possible values of the ScrollBars property:

Value | Description
0 | No scroll bars are added (the default).
1 | A vertical scroll bar is added.
2 | A horizontal scroll bar is added.
3 | Both vertical and horizontal scroll bars are added.


SectionNoBorders Property

The SectionNoBorders property specifies whether the text in the specified pane of a status bar is drawn without borders. The value of the CurSection property determines which pane is affected.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the SectionNoBorders property:

Value | Description
False | The text in the status bar pane is drawn with borders (the default).
True | The text in the status bar pane is drawn without borders.


SectionPopOut Property

The SectionPopOut property determines whether the text in the specified pane of a status bar is drawn with a border to appear higher than the plane of the status bar. The value of the CurSection property determines which pane is affected.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the SectionPopOut property:

Value | Description
False | The text is not drawn with a border to appear higher than the plane of the status bar (the default).
True | The text is drawn with a border to appear higher than the plane of the status bar.


Sections Property

The Sections property indicates the number of panes into which the status bar is divided. The number of sections cannot be greater than 256.

This property can be manipulated at design time and either retrieved or set at runtime.


SectionStatus Property

The SectionStatus property specifies the text that appears in the specified pane of the status bar. The value of the CurSection property determines which pane is affected.

This property can be manipulated at design time and either retrieved or set at runtime.


SectionWidth Property

The SectionWidth property is a pointer to an integer array. The number of elements is specified in the Sections property. Each element specifies the position, in client coordinates, of the right edge of the corresponding part. If an element is -1, the right edge of the corresponding part extends to the border of the window.

This property can be manipulated at design time and either retrieved or set at runtime.


SelChange Event Tab

The SelChange event notifies a tab control’s parent window that the currently selected tab has changed. This message is sent in the form of a WM-NOTIFY message.


SelChanging Event

The SelChanging event notifies a tab control’s parent window that the currently selected tab is about to change. This message is sent in the form of a WM-NOTIFY message.


Select ActiveX Controls Dialog Box See Also

Adding ActiveX Controls to the WOW Designer

Add and remove ActiveX controls on the Toolbox


SelectAllOnGotFocus Property

The SelectAllOnGotFocus property is a design-time-only property that determines whether the text in an edit box control will be selected when the control has focus.

The following table lists the possible values of the SelectAllOnGotFocus property:

Value | Description
False | Text will not be selected when the control has focus (the default).
True | Text will be selected when the control has focus.


SelectedAttr

The SelectedAttr property determines whether the field/control has input focus. Valid values are blank (the library default) or A through P (as defined by the attribute code assigned to a block of text within a panel).

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Selecting an Item

Occasionally, you will want to set the selection from inside your programs. This is accomplished by setting the value of the list box’s CurSel property as follows:

CALL WOWSETPROP USING WIN-RETURN CTL-H "CURSEL" SEL-VALUE.

SEL-VALUE is the 0 relative index of the item to select. CTL-H is the handle of the list box. SEL-VALUE must not be greater than the number of items in the list box -1 (since the value is zero relative). The number of items in the list box can be determined by checking the value of the list box’s Count property.


Select the desired ActiveX controls

The Select the desired ActiveX controls list box lists the ActiveX controls that are installed on your system and that appear to be compatible with WOW Extensions. From this list, select the control(s) that you wish to add to the Toolbox and click the OK command button.

To select controls that are contiguous in this list, press the Shift key and move the cursor until all of the controls between the anchor (the first selected control) and the destination (the last selected control) are highlighted. Or, press Ctrl and move the cursor to highlight and add a non-continuous single control to a selected group.


SelEnd Property

The SelEnd property sets the ending position of the selection range when the EnableSelRange property is set to True.

This property can be manipulated at design time and either retrieved or set at runtime. At runtime, the property name is SelectionEnd.


SelRange MC Property

The SelRange property is a runtime-only property that retrieves the currently selected date for a month calendar control. If the specified date is not in view, the control updates the display to bring it into view. The specific date information can be determined by examining the values in the MONTHCAL-SYSTEMTIMES GLOBAL statement in windows.cpy.


SelStart Property

The SelStart property sets the beginning position of the selection range when the EnableSelRange property is set to True.

This property can be manipulated at design time and either retrieved or set at runtime. At runtime, the property name is SelectionStart.


SelText Property

The SelText property is a runtime-only property that lets you retrieve the text of the currently selected list box item. If no item is selected, the value returned is space.

This property can be retrieved, but not set, at runtime.


SelText Property Lbox

The SelText property is a runtime-only property that lets you retrieve the text of the currently selected list box item. If no item is selected, the value returned is space.

Note This property can only be retrieved, not set, at runtime.


Separator

The Separator check box allows you to insert a horizontal line, known as a separator bar, between the menu items. You can use separator bars to indicate groupings within the menu item list, or simply to provide a visual break in a list.


SETFOCUS

Window Windows API Function

The SETFOCUS function sets the input focus to the given window. All subsequent keyboard input is directed to this window. The window, if any, which previously had the input focus loses it.

The SETFOCUS function sends a WM-KILLFOCUS message to the window that loses the input focus and a WM-SETFOCUS message to the window that receives the input focus. It also activates either the window that receives the focus or the parent of the window that receives the focus.

If a window is active but does not have the focus (that is, no window has the focus), any key pressed will produce the WM-SYSCHAR, WM-SYSKEYDOWN, or WM-SYSKEYUP message. If the VK-MENU key is also pressed, the LPARAM parameter of the message will have bit 30 set. Otherwise, the messages that are produced do not have this bit set.

Calling Sequence

CALL SETFOCUS USING PREV-H WND-H.

Parameter | Declaration | Description
PREV-H | PIC 9(10) BINARY(8) | The return value is the handle of the window that previously had the input focus, if the function is successful. It is zero if there is no such window or if the specified handle is invalid.
WND-H | PIC 9(10) BINARY(8) | The handle of the window to receive the keyboard input. If the value of this parameter is zero, keystrokes are ignored.


Setting Properties for Controls and Forms See Also

Adding ActiveX Controls to the WOW Designer

Handling Events for Controls, Forms, and Projects

Manipulating Controls in a Form

Properties and Events for Forms

Properties and Events for Intrinsic Controls

Properties for RM/Panels Data Fields


SETWINDOWTEXT

Window Windows API Function

The SETWINDOWTEXT function sets the given window’s title to the specified text.

This function causes a WM-SETTEXT message to be sent to the given window or control.

If the window specified by the WND-H parameter is a control, the text within the control is set. If the specified window is a list box control created with the WS-CAPTION style of the WIN-STYLE parameter, however, SETWINDOWTEXT will set the caption for the control, not for the list box entries.

For more information, see the Functions and Messages online Help file.

Calling Sequence

CALL SETWINDOWTEXT USING WND-H TEXT.

Parameter | Declaration | Description
WND-H | PIC 9(10) BINARY(8) | The handle of the window or control whose text is to be set.
TEXT | alphanumeric | A string to be used as the new title or control text.


ShortDateCenturyFormat Property

The ShortDateCenturyFormat property is a design-time-only property that, when set to a value of True, causes the date to display in the MM/DD/YYYY format. For example: “4/19/2002”.

The following table lists the possible values of the ShortDateCenturyFormat property:

Value | Description
False | The date is displayed in short date format, for example, “4/19/02” (the default).
True | The date is displayed in short date century format, for example, “4/19/2002”.


Show Event Form

The Show event occurs when the form is hidden or displayed.


Show Line Number

When selected, the Show Line Number option indicates the edit position in the source code.


Show Markers

Markers are set on specified lines in the source code and are contained in the selection margin. Markers help you find a certain line of code quickly. By default, the Show Markers option is selected and all markers are displayed.


ShowNone Property

The ShowNone property is a design-time-only property that determines whether the control displays a check box.

The following table lists the possible values of the ShowNone property:

Value | Description
False | No check box is displayed (the default).
True | A check box is displayed.


ShowSections with Code Only

When selected, the Show Sections with Code Only check box causes only those code sections that are not empty to be displayed.


Show State Project Properties

The Show State command button indicates the forms that will be displayed at project startup (open), which is determined by the options configured for the project in the Project Options dialog box.


ShowState Property Form

The ShowState property determines the manner in which a form is displayed.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the ShowState property:

Value | Description
0 | Form is displayed normally (the default).
1 | Form is displayed as maximized, that is, it fills the entire desktop area.
2 | Form is displayed as an icon.


Show Tool Tips on Controls

The Show Tool Tips on Controls check box, which is enabled by default, causes a tool tip identifying the type of control to display when the mouse hovers over the control. If you deselect the check box, the change is not effective until the form is reopened.


Signed

The Signed property specifies whether the field/control includes a plus (+) or minus (-) sign.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the Signed property:

Value | Description
False | The field/control is not signed.
True | The field/control is signed (the default).


SimpleNoBorders Property

The SimpleNoBorders property specifies whether the text in the status bar is drawn without borders when the status bar is in simple mode, that is, when only one pane is visible.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the SimpleNoBorders property:

Value | Description
False | The text in the status bar pane is drawn with borders (the default).
True | The text in the status bar pane is drawn without borders.


SimplePopOut Property

The SimplePopOut property determines whether the text in the status bar is drawn with a border to appear higher than the plane of the status bar when the status bar is in simple mode, that is, when only one pane is visible.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the SimplePopOut property:

Value | Description
False | The text is not drawn with a border to appear higher than the plane of the status bar (the default).
True | The text is drawn with a border to appear higher than the plane of the status bar.


SimpleStatus Property

The SimpleStatus property specifies the text that appears in the status bar when it is in simple mode.

This property can be manipulated at design time and either retrieved or set at runtime.


Size

The Size property specifies the size of the scroll bar in characters.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Size Event Form

The Size event occurs after a form's size has changed.


SizeType

The SizeType property specifies the size of the button displayed for the command button.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the SizeType property:

Value | Description
Auto | The button is just wide enough to hold the title.
Small | Refers to the default set for the panel library.
Medium | Refers to the default set for the panel library.
Large | Refers to the default set for the panel library.
Explicit | You can enter a number that specifies the size of the button in characters.


SizeValue

The SizeValue property specifies the width of the button in character positions. This value is valid only if the SizeType property value is set to explicit.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Sizing Toolbar Match Both

Match Both (Sizing and Layout toolbars)

Use the Match Both button to resize the controls in both directions simultaneously.

This button corresponds to the Match Both option from the Size command submenu on the Control menu.


Sizing Toolbar Match Heights

Match Heights (Sizing and Layout toolbars)

Use the Match Heights button to resize the selected controls in a vertical direction.

This button corresponds to the Match Height option from the Size command submenu on the Control menu.


Sizing Toolbar Match Widths

Match Widths (Sizing and Layout toolbars)

Use the Match Widths button to resize the selected controls in a horizontal direction.

This button corresponds to the Match Width option from the Size command submenu on the Control menu.


Sort Property

The Sort property is a design-time-only property that determines whether the entries in a combo box control are automatically sorted.

The following table lists the possible values of the Sort property:

Value | Description
False | Entries are not sorted.
True | Entries are sorted (the default).


Sort Property Lbox

The Sort property is a design-time-only property that determines whether the entries in a list box control are automatically sorted.

The following table lists the possible values of the Sort property:

Value | Description
False | Entries are not sorted.
True | Entries are sorted (the default).


Spacing

This pair of option buttons modifies the behavior of the Space command on the Control menu.

· Selecting the Space Centers option button distributes the selected controls on a form such that the spacing between the centers of the controls is equal.

· Selecting the Space Controls option button distributes the selected controls such that the spacing between the edges of the controls is equal. This option is enabled by default.


Spacing Toolbar Space Horizontally

Space Horizontally (Spacing and Layout toolbars)

Use the Space Horizontally button to distribute the selected controls in a horizontal direction such that the spacing between the controls is the same.

This button corresponds to the Horizontal option from the Space command submenu on the Control menu.


Spacing Toolbar Space Vertically

Space Vertically (Spacing and Layout toolbars)

Use the Space Vertically button to distribute the controls in the vertical direction, placing equal amounts of space between the selected controls.

This button corresponds to the Vertical option from the Space command submenu on the Control menu.


Standard Property

The Standard property is a design-time-only property that, when turned on, causes a list box control to be sorted alphabetically, the Click event to occur every time the selection changes, and the list box to contain horizontal and vertical scroll bars. The Standard property is a combination of the Windows styles LBS_NOTIFY, LBS_SORT, WS_VSCROLL, and WS_BORDER.

The following table lists the possible values of the Standard property:

Value | Description
False | No sorting or Click event.
True | Entries sorted and Click event on selection (the default).


Start Event

The Start event notifies an animation control’s parent window that the associated AVI clip has started playing. This notification message is sent in the form of a WM-COMMAND message.


Starting and Exiting WOW Extensions See Also

Setting Preferences


StartOfGroup

The StartOfGroup property, when marked with an X, indicates that this field/control is the start of a number of fields/controls (for example, a group of option buttons) that is to be treated as a group. A group includes all fields/controls having contiguous entry order numbers until the next StartOfGroup property is encountered.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


StaticChoices

The StaticChoices property determines whether the choices in a list box or the list box portion of a combo box field/control are specified on the panel or are supplied by the application program.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the StaticChoices property:

Value | Description
False | Choices in a list box are supplied by the application program (the default).
True | Choices in a list box are specified on the panel.


StaticEdge Property

The StaticEdge property is a design-time-only property that determines whether the control is created with a three-dimensional border style intended to be used for items that do not accept user input.

The following table lists the possible values of the StaticEdge property:

Value | Description
False | The control does not have the three-dimensional border style (the default).
True | The control has the three-dimensional border style.


Static Text Control Object See Also

Property Manipulation Checklist


Static Text Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Status Bar Control Object See Also

Property Manipulation Checklist


Status Bar Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


StepSize

The StepSize property specifies the change in value to be associated with clicking on the scroll bar end-arrows.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Stop Event

The Stop event notifies an animation control’s parent window that the associated AVI clip has stopped playing. This notification message is sent in the form of a WM-COMMAND message.


StorageFormat Date

The StorageFormat property specifies the format to be used when storing this field/control, based on years, months, and days, which are represented as follows:

· YYYY is a four-digit numeric representation of the year (for example, 2001)

· YY is a two-digit numeric representation of the year (for example, 01)

· MM is a two-digit numeric representation of the month (for example, 12)

· DD is a two-digit numeric representation of the day (for example, 30)

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the StorageFormat property:

Value | Description
1 | Date is displayed as YYYYMMDD.
2 | Date is displayed as YYMMDD.
3 | Date is displayed as MMDDYYYY.
4 | Date is displayed as MMDDYY.


StorageFormat Time

The StorageFormat property specifies the format to be used for the storage of this field/control, based on hours, minutes, and seconds, which are represented by HH, MM, and SS, respectively.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the StorageFormat property:

Value | Description
1 | Time is displayed as HHMMSS.
2 | Time is displayed as HHMM.
3 | Time is displayed as HH.


StoreByName

The StoreByName property determines whether fields/controls on the panel/form are stored by name or by sequence number in the generated .ws file.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the StoreByName property:

Value | Description
False | Fields/controls are stored by sequence number in the generated .ws file.
True | Fields/controls are stored by name in the generated .ws file (the default).


Store Project Profile Settings in Project.ini file

The Store Project Profile Settings in Project.ini file option causes the project-specific profile settings to be stored in a special initialization file rather than in the WOW Designer cblwow.ini file. By default, WOW Extensions creates a separate section in cblwow.ini for each project, which can cause the size of cblwow.ini to grow quite large in some applications. Enabling this option overrides the default behavior and helps reduce the size of cblwow.ini. The project-specific initialization file is stored in the same directory as the project file (.wpj).


Stream

The Stream property indicates that insert and delete operations should affect the entire field/control.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the Stream property:

Value | Description
False | Insert and delete operations should not affect the entire field/control (the default).
True | Insert and delete operations should affect the entire field/control.


Style Property

The Style property is a design-time-only property that determines what type of combo box is created. The three types of combo boxes are specified with the Style property. The possible values for this property include simple (standard) combo box, drop-down combo box, and drop-down list box.

A standard combo box always displays an edit box and list box. A drop-down combo box always displays an edit box, but only displays the list box when the drop-down arrow displayed beside the edit box is clicked. A drop-down list box always displays a static edit box control containing the current selection, but, like the drop-down combo box, only displays the list box when the drop-down arrow beside the static text control is clicked.

You might question why the drop-down list box is a style for combo boxes but is not a style for list boxes. This is the way Windows built this control; it should not cause you any problems. Windows simply implements these three styles as one control because they all combine two types of controls into one.

You work with the list box portion of a combo box in exactly the same way you work with a list box. You use messages with a CB- prefix and supply the combo box handle. Windows knows what part of the combo box to change.

For the edit box portion, work with the combo box properties, events, and messages as you would an edit box remembering to use the CB-prefix.

The following table lists the possible values of the Style property:

Value | Description
0 | Simple (standard combo box). The edit box (edit field) and list box portions are always displayed.
1 | Drop-down combo box. The edit box portion is always displayed but the list box area is only displayed when the drop-down arrow is clicked.
2 | Drop-down list box. The edit box portion is always displayed, however, it only displays the value of the selection. The edit box portion will not accept user input. The list box portion is only displayed when the drop-down arrow is clicked.


Style Property Form

The Style property is a design-time-only property that is used to determine the type of a form.

The following table lists the possible values of the Style property:

Value | Description
0 | Specifies the form as a child, which means that the form has a parent. The parent-child relationship determines where a window can be drawn on the screen. A child window can be drawn only within its parent's client area, and is destroyed along with its parent.
1 | Specifies the form as a pop-up, which means that the form is a pop-up window. A pop-up window does not have a parent by default (although a parent can be set for it); a pop-up window can be drawn anywhere on the screen. The main difference between a pop-up window and an overlapped window is that a pop-up window can be displayed outside the border of its parent window.
2 | Specifies the form as overlapped, which means that the form is a top-level window that has a title bar, border, and client area. It is meant to serve as an application's main window. It can also have a menu, minimize and maximize buttons, and scroll bars. Overlapped windows may own other top-level windows or be owned by other top-level windows or both. (This is the default value.)


Styles (Tab Editor)

The Styles area allows you to change the following properties for the tab control:

· Buttons. When selected, the Buttons check box causes tabs to appear as buttons. Note that this value also can be changed using the Buttons property in the Properties dialog box.

· Fixed Width. When selected, the Fixed Width check box causes all tabs to be the same width. Note that this value also can be changed using the FixedWidth property in the Properties dialog box.

· Force Label Left. When selected, the Force Label Left check box forces tab texts to the left. If the Force Label Left check box is selected, the Fixed Width check box must also be selected. Note that this value also can be changed using the ForceLabelLeft property in the Properties dialog box.

· Vertical. When selected, the Vertical check box forces tabs to appear at the left side of the control, with tab text displayed vertically. If the Vertical check box is selected, the Multi-Line check box must also be selected. Note that this value also can be changed using the Vertical property in the Properties dialog box.

· Multi-Line. When selected, the Multi-Line check box causes the tabs to occupy multiple lines if the tab control is too narrow for all the tabs to be displayed on a single line. Note that this value also can be changed using the MultiLine property in the Properties dialog box.

· Right. When selected, the Right check box causes tabs to appear vertically on the right side of any control that has the Vertical property set to True. Note that this value also can be changed using the Right property in the Properties dialog box.

· Ragged Right. When selected, the Ragged Right check box causes the width of each tab to be increased so that each row of tabs fills the entire width of the tab control. Note that this value also can be changed using the RaggedRight property in the Properties dialog box.


Syntax Coloring

Use the options in the Syntax Coloring area to highlight syntax, which provides a helpful visual clue to your various code components. You are able to customize the default foreground and background colors for keywords, comment lines, bad braces, brace highlights, and operators in the source code file.

The RGB (Red, Green, Blue) values for the current color selections are displayed in the text entry boxes, and samples of the colors are shown in the sample display boxes for each of these options.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default foreground and background colors for each of these options.


SysKeyMode Property Form

The SysKeyMode property is a design-time-only property that specifies the way in which a WOW application processes WM-SYSKEY messages (controlled on a form-by-form basis). The Windows operating system makes a distinction between system keystrokes and non-system keystrokes. System keystrokes produce system keystroke messages, such as WM-SYSKEYDOWN and WM-SYSKEYUP. Non-system keystrokes produce non-system keystroke messages, such as WM-KEYDOWN and WM-KEYUP. Windows generates a WM-KEYDOWN or a WM-SYSKEYDOWN message when the user presses a key. When the user releases a key, the system generates a WM-KEYUP or a WM-SYSKEYUP message.

The following table lists the possible values of the SysKeyMode property:

Value | Description
0 | WantSysKey. The application receives WM-SYSKEY system messages (the default).
1 | WantKey. The application receives WM-KEY messages that have been translated from WM-SYSKEY messages.
2 | WantKeyandSysKey. The application receives both WM-SYSKEY and WM-KEY messages.
3 | None. The application receives neither WM-SYSKEY nor WM-KEY messages.


SystemMenu Property Form

The SystemMenu property is a design-time-only property that determines whether a form contains a Control menu (also know as the System menu) that features Maximize, Minimize, and Close buttons.

The following table lists the possible values of the SystemMenu property:

Value | Description
False | Form does not contain a Control menu (the default).
True | Form contains a Control menu.


Tab Accelerator (Tab Editor)

The Tab Accelerator list box allows you to specify what key, if any, should simulate the pressing of the tab. This property cannot be modified or retrieved at runtime.

Note Wow Extensions automatically creates an Accelerator property if you use an ampersand (&) in a caption for the tab control. The accelerator will be “Alt + ” the character following the ‘&’. You may override this automatic accelerator. If you remove the ‘&’ character, the accelerator will not be deleted.

Note that this value also can be changed using the Accelerator property in the Properties dialog box.

The following table lists the possible values of the tab accelerator:

Value | Description
Alt + alphabetic character | The accelerator is the Alternate key plus the first letter of the Caption property value (the default).
Ctrl + alphabetic character | The accelerator is the Control key plus any character of the alphabet.
F1 - F12 | The accelerator is a function key.
Ctrl + F1 - F12 | The accelerator is the Control key plus a function key.
Shift + F1 - F12 | The accelerator is the Shift key plus a function key.
Ctrl + Shift + F1 - F12 | The accelerator is the Control key plus the Shift key plus a function key.
Ctrl + Ins | The accelerator is the Control key plus the Insert key.
Shift + Ins | The accelerator is the Shift key plus the Insert key.
Shift + Del | The accelerator is the Shift key plus the Delete key.
Alt + Bksp | The accelerator is the Alternate key plus the Backspace key.
Del | The accelerator is the Delete key.
Escape | The accelerator is the Escape key.


Tab Accelerator Values (Table)

The following table lists the possible values of the tab accelerator:

Value | Description
Alt + alphabetic character | The accelerator is the Alternate key plus the first letter of the Caption property value (the default).
Ctrl + alphabetic character | The accelerator is the Control key plus any character of the alphabet.
F1 - F12 | The accelerator is a function key.
Ctrl + F1 - F12 | The accelerator is the Control key plus a function key.
Shift + F1 - F12 | The accelerator is the Shift key plus a function key.
Ctrl + Shift + F1 - F12 | The accelerator is the Control key plus the Shift key plus a function key.
Ctrl + Ins | The accelerator is the Control key plus the Insert key.
Shift + Ins | The accelerator is the Shift key plus the Insert key.
Shift + Del | The accelerator is the Shift key plus the Delete key.
Alt + Bksp | The accelerator is the Alternate key plus the Backspace key.
Del | The accelerator is the Delete key.
Escape | The accelerator is the Escape key.


Tab Control Name (Tab Editor)

The Tab Control Name is a static text box that indicates the name of the tab control currently having focus. This is the value that appears in the Name property for that tab.


Tab Control Object See Also

Property Manipulation Checklist


Tab Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms

Tab Control Editor Dialog Box


TabEnabled Property

The TabEnabled property controls whether an individual tab on the tab control can be selected at runtime. WOW Extensions provides runtime support for the TabEnabled property using the WOWGETPROP and WOWSETPROP functions, which allow the enabled state of the tab to be set or retrieved at runtime. Before getting or setting the TabEnabled property value, the CurTab property must be set to the zero-based index of the desired tab. Note that this property also can be changed using the Tab Enabled check box in the Tab Control Editor dialog box.

The following table lists the possible values of the TabEnabled property:

Value | Description
False | The tab cannot be selected at runtime.
True | The tab can be selected at runtime (the default).


Tab Enabled (Tab Editor)

The Tab Enabled check box controls whether the tab identified in the Current Tab text box can be selected at runtime. Note that the Tab Enabled value also can be changed using the TabEnabled property n the Properties dialog box.


TabIndex Property

The TabIndex property is a design-time-only property that determines the tab order, that is the order in which Tab and Shift+Tab key presses will move input focus between controls. Controls that have the same TabIndex property value will have undefined tab sequencing.

Set the TabIndex property to a value of 1 or greater.


TabIndex Property ActiveX

The TabIndex property determines the tab order, that is, the order in which Tab and Shift+Tab key presses will move input focus between controls. Controls that have the same TabIndex property value will have undefined tab sequencing.

Note The TabIndex property cannot be changed or retrieved at runtime (with the WOWGETPROP and WOWSETPROP functions) and can only be set in the WOW Designer.

Set the TabIndex property to a value of 1 or greater.


Tabs Property

The Tabs property is a design-time-only property that determines how many tabs are displayed on the control.


TabStop Property

The TabStop property determines whether a user can use the Tab key to set the focus to a control in a form.

Note This property can be manipulated at design time and either retrieved or set at runtime; however, at runtime, the control must be a child control having the Windows style, WS-CHILD.

The following table lists the possible values of the TabStop property:

Value | Description
False | Control is not a tab stop.
True | Control is a tab stop (the default).


TabStop Property ActiveX

The TabStop property determines whether a user can use the Tab key to set the focus to a control in a form.

Note This property is implemented only if the control can be visible at runtime.

The following table lists the possible values of the TabStop property:

Value | Description
False | Control is not a tab stop.
True | Control is a tab stop (the default).


Tab Stops

The Tab Stops option specifies the column numbers in the COBOL source code at which tab stops will be placed. By default, the initial tab stop is defined as 8, with subsequent tab stops set at intervals of 4. Tab stops can be set to any column, must be separated by commas, and must be in increasing order.


TabStops Property Edit

The TabStops property is a design-time-only property that determines where to position tab stops, listed in integers separated by ",", ";", "-", or " ", when displaying the text specified by the Text property. The integers represent the number of dialog template units. The tab stops must be sorted in ascending order; backward tabs are not allowed. The default is every 32-dialog template units. The MultiLine property must be set to True for the tab stops to have any effect. If one tab stop is listed, then tab stops are set every nth position, where n is the tab stop position given. If the property is blank, then the default value for the control will be used.


TabStops Property Lbox

The TabStops property is a design-time-only property that determines where to position tab stops, listed in integers separated by ",", ";", "-", or " ", when displaying the data item specified by the Data property. The integers represent the number of quarters of the average character width for the font that is selected into the list box. For example, a tab stop of 4 is placed at 1.0 character units, and a tab stop of 6 is placed at 1.5 average character units. The tab stops must be sorted in ascending order; backward tabs are not allowed. The default is every 2-dialog template units. The UseTabStops property must be set to True for the tab stops to have any effect. If one tab stop is listed, then tab stops are set every nth position, where n is the tab stop position given. If the property is blank, then the default value for the control will be used.


TabText Property

The TabText property controls the text of each tab. The value of the CurTab property determines which tab is affected. Note that this property also can be changed using the Tab Text edit box in the Tab Control Editor dialog box.

This property can be manipulated at design time and either retrieved or set at runtime.


Tab Text (Tab Editor)

The Tab Text edit box indicates the text that appears in the currently selected tab (in this example, the tab text "File" is shown for illustrative purposes only). This is the value that appears in the tab control's TabText property for the currently selected tab. Note that this value also can be changed using the TabText property in the Properties dialog box.


Tag Property

The Tag property specifies a user-definable property associated with a control. The Tag property can be used to store application-related information in the control. This property is not used by WOW Extensions for any specific purpose except to allow it to be set at design time, and set and retrieved at runtime.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the value of the Tag property with any COBOL data item.


Tag Property ActiveX

The Tag property specifies a user-definable property associated with an ActiveX control. The Tag property can be used to store application-related information in the control. This property is not used by WOW Extensions for any specific purpose except to allow it to be set at design time, and set and retrieved at runtime.

Set the value of the Tag property with any COBOL data item.


Tag Property Form

The Tag property specifies a user-definable property associated with a form. The Tag property can be used to store application-related information in the form. This property is not used by WOW Extensions for any specific purpose except to allow it to be set at design time, and set and retrieved at runtime.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the value of the Tag property with any COBOL data item.


Text Property Date Time Picker

The Text property is a runtime-only property that retrieves the text in a date time picker control.

This property can be retrieved, but not set, at runtime.


Text Property Edit Box

The Text property specifies the text associated with an edit box control. If the MultiLine property is set to False, Edit Box is displayed in the edit box control, but those words can be replaced with a single line of text.

If the MultiLine property is set to True, more than a single line of text can be entered for the edit box.

If the text specified by the Text property contains a \t in the string, and the MultiLine property is set to True, a tab character will be inserted in the string before it is loaded into the control.

This property can be manipulated at design time and either retrieved or set at runtime.


ThreeState Property

The ThreeState property determines whether a check box control can be cycled through two or three states.

When you create the check box, you assign it a caption that describes the option for which the user is selecting the state (for example, Tax Exempt or Drop Ship). Initially, a check box control has two states, checked and unchecked. These are intuitively On/Off, Yes/No, or True/False selections of whatever the caption describes. The user toggles the check box to the desired state. When the user presses OK, you simply check the state of the button to see what condition to store as data.

You can determine whether you want your check box to have two states or three with the ThreeState property. The third state (grayed) is considered to be no choice made or undefined.

This property can be set and retrieved either at design time or at runtime.

The following table lists the possible values of the ThreeState property:

Value | Description
False | Check box has two states, checked or unchecked (the default).
True | Check box has three states, checked, unchecked and grayed.


ThumbAttr

The ThumbAttr property specifies the attribute code associated with the thumb object of the scroll bar. Valid values are blank (the library default) or A through P (as defined by the attribute code assigned to a block of text within a panel).

Note T This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


ThumbPos Event Scroll bar

A ThumbPos event occurs when the mouse is released after being clicked on the scroll bar thumb.


ThumbPos Event Trackbar

The ThumbPos event occurs when the user drags the slider and releases the mouse.


ThumbPos Event Updown

The ThumbPos event occurs when the user drags the slider and releases the mouse.


ThumbTrk Event Scroll bar

A ThumbTrk event occurs when the mouse is pressed on the scroll bar thumb.


ThumbTrk Event Trackbar

The ThumbTrk event occurs when the user drags the slider.


TickFreq Property

The TickFreq property determines the number of tick marks to display on the control in a range of 1 through 100. The default is 10.

This property can be manipulated at design time and either retrieved or set at runtime.


Time Edit Box Control Object See Also

Property Manipulation Checklist


TimeFormat Property

The TimeFormat property is a design-time-only property that determines whether the time will display instead of the date. When set to a value of True, the TimeFormat property causes the time to display in HH/MM/SS AM or PM format. For example: “5:31:42 PM”.

The following table lists the possible values of the TimeFormat property:

Value | Description
False | The time is not displayed (the default).
True | The time is displayed in HH/MM/SS AM or PM format. For example, “5:31:42 PM”.


TimeOut

The TimeOut property determines whether this field/control should wait a maximum time for input, when input is needed.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the TimeOut property:

Value | Description
Default | The default set for the panel library applies to the field/control.
Yes | The field/control should wait for input, overriding any default set for the panel library.
No | The field/control should not wait for input, overriding any default set for the panel library.


TimeOutValue

The TimeOutValue property specifies the amount of time to wait for input when the TimeOut property is set to Yes or if the default for the panel library is set to Yes.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Time Property

The Time property is a runtime-only property that retrieves the currently selected time from a date time picker control.

This property can be retrieved or set at runtime.


Timer Control Object See Also

Property Manipulation Checklist


Timer Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Timer Event

The Timer event enables or disables one event per timer tick (interval).


Title

As you type in the Title text box, WOW Extensions automatically assigns the Name property of the menu control to a default value. Under the default configuration for WOW Extensions, the naming convention used for menu controls includes the prefix M- followed by the text entered in the Title box. For example, if you type File in the Title box, the default name entered in the Name box is M-FILE. (You can configure the way in which the menu names are generated by changing the options in the Code Preferences page of the Preferences dialog box.) This name is displayed in the Events/Sections list of the menus Event-Handling Code dialog box, and it is the name that WOW Extensions uses to reference the menu control in the generated code.

Note To specify a mnemonic character for quick keyboard access in a menu control, add an ampersand (&) in front of the appropriate letter in the Title property value. The letter following the ampersand appears underlined in the menu control. For example, to add a File menu command with the letter F as a mnemonic, type &File. The user will then be able to type Alt and the letter F to quickly access the menu. Be careful to keep track of the mnemonic key values that you enter since WOW Extensions does not check for duplicates.

It is also possible to place a tab character in a pulldown menu item. This is useful for aligning text used to describe accelerator key sequences. In the Title property, a tab character can be added by placing the sequence \t in the menu item followed by the accelerator key sequence selected in the Accelerator list box (for example, type Open\tAlt+o). This should be done only for pulldown menu items, not for top-level titles. Only one tab character should be added to a menu item.


Title Common Panels Data Fields

The Title property specifies the text that appears with the field/control. Note that for the check box field/control, the Title property specifies the text that appears to the right of the check box.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Title Panel

The Title property specifies the title to be associated with the panel/form if the Windowed property is set to True.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Title Property Form

The Title property determines whether a form contains a title in the title bar.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Title property with any alphanumeric characters, including spaces.

The title will be displayed only if the value of the Caption property is set to True.


Today MC Property

The Today property is a runtime-only property that retrieves the date information for the date specified as today for a month calendar control. The specific date information can be determined by examining the values in the MONTHCAL-SYSTEMTIMES GLOBAL statement in windows.cpy.


Toolbar Buttons Area Project Properties

This area contains several toolbar buttons that allow you to perform the following tasks:

· Up One Level Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· View Desktop Click to see the contents of the Desktop hierarchy in the Look in list box.

· Create New Folder Click to create a new folder within the folder you are currently viewing.

· List Click to view the contents of a folder in a simple list format (only the names of the files are shown in the List area). This is the default view.

· Details Click to display details of the files in the List area: filename, size, file type, and date modified. You can click any of these column headings to sort the list by that category. Click the List button to view only the filenames.


Toolbar Control Object See Also

Property Manipulation Checklist


Toolbar Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


Tools Preferences See Also

Locating Required Tools

Panel Menu Commands

Setting Preferences


ToolTipEnabled Property

The ToolTipEnabled property determines whether a tool tip will be displayed when the mouse hovers over the control. The text of the tool tip is specified by the ToolTipText property.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the ToolTipEnabled property:

Value | Description
False | Disable tool tip for this control (the default).
True | Enable tool tip for this control.


ToolTipText Property

The ToolTipText property contains the tool tip text that is displayed if the ToolTipEnabled property is set to True.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the value of the ToolTipText property with any COBOL data item.


ToolWindow Property Form

The ToolWindow property is a design-time-only property that determines whether a form appears in the Windows Task Bar and whether it has a shorter title bar.

The following table lists the possible values of the ToolWindow property:

Value | Description
False | Form does appear in the Windows Task Bar (the default).
True | Form does not appear in the Windows Task Bar, and the title has a shorter title bar.


Top Event

The Top event occurs when the user interacts with trackbar control the using the Home key.


Top Property

The Top property determines, in pixels, the location of the top of the control. This value is relative to the client area of the form containing the control.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Top property with any value from 0 to the value specified in the Height property of the form.


Top Property ActiveX

The Top property determines, in pixels, the location of the top of the ActiveX control. This value is relative to the client area of the form containing the control.

Set the Top property with any value from 0 to the value specified in the Height property of the form.


Top Property Form

The Top property determines, in pixels, the location of the top of a form. This value is relative to the entire desktop area.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Top property with any value from 0 to the height of the screen display.


TopTicks Property

The TopTicks property is a design-time-only property that determines whether tick marks are displayed above the control.

The following table lists the possible values of the TopTicks property:

Value | Description
False | The trackbar control does not display tick marks above the control.
True | The trackbar control displays tick marks above the control (the default).


Trackbar Control Object See Also

Property Manipulation Checklist


Trackbar Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


TRACKPOPUPMENU

Menu Windows API Function

The TRACKPOPUPMENU function displays the given floating pop-up menu at the specified location and tracks the selection of items on the pop-up menu. A floating pop-up menu can appear anywhere on the screen.

Calling Sequence

CALL TRACKPOPUPMENU USING WIN-RETURN MENU-H MENU-FLAGS
X Y RESERVED WND-H RECT.

Note By first initializing the MENU-FLAGS parameter with the statement MOVE ALL 'N' TO MENU-FLAGS, all existing values are unset so that new values can be specified. For example:

MOVE ALL 'N' TO MENU-FLAGS.
SET TPM-CENTERALIGN TO TRUE.
CALL TRACKPOPUPMENU USING WIN-RETURN MENU-H MENU-FLAGS
X Y RESERVED WND-H RECT.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is nonzero if the function is successful. Otherwise, it is zero.
MENU-H | PIC 9(10) BINARY(8) | The handle of the pop-up menu to be displayed. The application retrieves this handle by calling the CREATEPOPUPMENU function to create a new pop-up menu or by calling the GETSUBMENU function to retrieve the handle of a pop-up menu associated with an existing menu item.
MENU-FLAGS | windows.cpy | Specifies the screen-position and mouse-button flags.
X | numeric | Specifies the horizontal position, in screen coordinates, of the pop-up menu. Depending on the value of the MENU-FLAGS parameter, the menu can be left-aligned, right-aligned, or centered relative to this position.
Y | numeric | Specifies the vertical position, in screen coordinates, of the top of the menu on the screen.
RESERVED | numeric | Reserved; must be zero.
WND-H | PIC 9(10) BINARY(8) | The handle of the window that owns the pop-up menu. This window receives all messages from the menu. The window will not receive WM-COMMAND messages until TRACKPOPUPMENU returns.
RECT | windows.cpy | A RECT structure that contains the screen coordinates of a rectangle in which the user can click without dismissing the pop-up menu. If this parameter is zero, the pop-up menu is dismissed if the user clicks outside the pop-up menu.


Transparent Animation Property

The Transparent property is a design-time only property that determines whether the animation will be drawn with a transparent background. Currently, this property does not work properly for all animations.

The following table lists the possible values of the Transparent property:

Value | Description
False | Causes the animation to be drawn with an opaque background (the default).
True | Causes the animation to be drawn with a transparent background.


Transparent Property

The Transparent property is a design-time-only property that determines whether the background of the form, or the underlying control, will show through.

The following table lists the possible values of the Transparent property:

Value | Description
False | Causes the background of the form or the underlying control not to show through (the default).
True | Causes the background of the form or the underlying control to show through.


Understanding WOW Thin Client See Also

Benefits of WOW Thin Client

Code Templates Tree

Running the Application with WOW Thin Client

WOW Extensions Components


Up and Down

The Up and Down command buttons move the selected menu control among the existing menu controls. When you click these buttons, the selected object moves to the new position either above or below the selected line.


Update

The Update property indicates whether the current value of this field/control should be updated or completely replaced by new input.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the Update property:

Value | Description
Default | The default set for the panel library applies to the field/control.
Yes | The field/control should wait for input, overriding any default set for the panel library.
No | The field/control should not wait for input, overriding any default set for the panel library.


Updown Control Object See Also

Property Manipulation Checklist


Updown Control See Also

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Properties for Controls and Forms


UpDown Property

The UpDown property is a design-time-only property that determines whether the control displays an arrow button. If the user clicks the arrow button, an embedded month calendar control drops down. The user can select a specific date by clicking an area of the calendar.

The following table lists the possible values of the UpDown property:

Value | Description
False | An arrow button is displayed (the default).
True | An arrow button is not displayed.


Use Global Default Properties Project Properties

The Use Global Default Properties check box, when selected, causes any property settings defined in the WOW Designer initialization file (cblwow.ini) to be used for the project (except as noted below).

The global default property settings defined in the cblwow.ini file allow you to provide a consistent look and behavior throughout your application. Each form or control that you create includes a set of initial properties and values. During design time, you can change and customize the property settings. Once you have modified the properties for a form or a control, you may want to save them and reuse them in other projects. This is done using the Save Properties | For Global Use command on the Form menu, Control menu, or Options menu. Such predefined form and control properties can provide a starting point that enables you to design an overall user interface that presents your application to its best advantage.

Note When applying initial property values in a new project, WOW Extensions first checks the project definition file (.wpj) to see whether any properties have been established as defaults for a project. If there are no project defaults, WOW Extensions then checks the cblwow.ini file to see if any global defaults have been defined. If global defaults have been defined, and if the Use Global Default Properties check box has been selected, those global defaults will be applied to the new project. If there are no project defaults and no global defaults, WOW Extensions applies the initial built-in defaults.


Use OEM Conversion

The Use OEM Conversion option causes COBOL data to be converted from OEM to ANSI (and vice versa) when the WOWGETPROP and WOWSETPROP functions are used at runtime. This option is useful if you need to support extended characters in your WOW application. Extended characters are those having an ASCII value greater than 128, such as 'Ü' and '¢'.


UseTabStops Property

The UseTabStops property is a design-time-only property that determines whether tab characters are interpreted as a spacing technique by a list box control.

The following table lists the possible values of the UseTabStops property:

Value | Description
False | Tabs are not expanded (the default).
True | Tabs are expanded.


Use VB Like Create, Move and Size

The Use VB Like Create, Move and Size option causes WOW Extensions to behave in the same manner as Visual Basic when creating, moving, and sizing controls on a form. When this option is enabled, the control appears as a rectangle on the form until you release the mouse.


Using Function Keys for Special Options See Also

Addressing Issues in Data Entry Programs


Using Global Default Property Settings See Also

Enhancing Existing RM/Panels Panel Libraries

Modifying an Existing RM/Panels Panel Library


Using WOW Extensions Help See Also

Help Button Bar

Help Toolbar


Using WOW Projects See Also

Addressing Issues in Data Entry Programs

Developing Event-Driven Applications

Looking Behind the Scenes

Using Global Default Property Settings

Working with Menus

WOW Extensions Components

WOW Extensions Development Process


Validation

The Validation property specifies the type of validation to be applied upon input to a field/control. The following types of validation are possible:

· List of values. A list of values, separated with commas, for example: 1,4,47. If a space is included as a valid value, it cannot be the last entry on the list.

· Range of values. A range of values, specified by separating the lowest value and the highest value with two periods, for example: 5..30. Ranges are inclusive by default. Ranges can be made exclusive by inserting greater than and less than symbols before the beginning and ending values, for example: >A..<Z.

· Conditions. The following operators can be used to specify conditions:

Equal =

Not equal !=

Less than <

Not less than !<

Greater than >

Not greater than !>

Greater than or equal to >=

Less than or equal to <=

You can combine a list of values, a range of values, and a condition in a single validation by separating them with commas.

When validating date edit box fields/controls, the following special names can be used to validate the field/control against the system date:

· DATE (the system date)

· YEAR (the system year)

· MONTH (the system month)

· DAY (the system day)

DATE is the only name that contains all components of the system date. The following validation allows only the entry of a date greater than the system date: >DATE. The other three names can be used to validate a numeric edit box field/control against a single component of the system date. The following validation forces entry of a year that is smaller than the system year: <YEAR.

When validating time edit box fields/controls, a special name, TIME, can be used to validate the field/control against the system time.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.


Valid Numeric Characters

The Valid Numeric Characters option causes the WOWGETNUM function to return a value of 1 at runtime if an invalid numeric character is contained in the field. By default, valid characters are considered to be the digits 0 through 9, the dollar sign ($), the plus (+) and minus (-) characters, and the edit (comma) and decimal (period) characters. You can change this default to a character set of your choosing. All characters listed will be considered valid numeric characters. A limit of 80 characters is supported.


Value Property

The Value property determines the state of a check box control.

This property can be set and retrieved either at design time or at runtime.

The following table lists the possible values of the Value property:

Value | Description
0 | Check box is not checked (the default).
1 | Check box is checked.
2 | Check box is grayed (displays only if ThreeState property is set to True).


Value Property Option

The Value property determines the state of an option button control.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Value property:

Value | Description
False | Option button is not pushed (the default).
True | Option button is pushed.


Value Property Progress

The Value property specifies the value of the progress bar and should be in the range specified by the settings of the Minimum and Maximum properties.

This property can be manipulated at design time and either retrieved or set at runtime.


Value Property Scroll bar

The Value property, a numeric value, determines the position of the scroll bar thumb. This value will never be lower than the value of the Minimum property, or greater than the value of Maximum property. If the thumb is positioned at the top or left of the scroll bar, the Value property is equal to the Minimum property. If the thumb is positioned at the bottom or right of the scroll bar, the Value property is equal to the Maximum property. If the thumb is positioned somewhere between the ends of the scroll bar, the value is proportional to the position of the thumb, within the numeric range established by the Minimum and Maximum properties.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Value property with any value from that of the Minimum property to the value of the Maximum property.


Value Property Trackbar

The Value property specifies the value of the trackbar and should be in the range specified by the settings of the Minimum and Maximum properties.

This property can be manipulated at design time and either retrieved or set at runtime.


Value Property Updown

The Value property specifies the value of the updown control and should be in the range specified by the settings of the Minimum and Maximum properties.

This property can be manipulated at design time and either retrieved or set at runtime.


Version Property Form

The Version property is a runtime-only property that, when retrieved, represents the numeric value of the internal version number of the form. As new features are added to the form, this number increments automatically.

This property can be retrieved, but not set, at runtime.


Vertical Alignment Submenu

The vertical alignment submenu determines the vertical alignment to be applied to the selected controls. The submenu presents three options:

· Lefts. Aligns the left side of each selected control with the left side of the first (primary) control selected.

· Centers. Aligns the vertical (up/down) center of each selected control with the vertical center of the first (primary) control selected.

· Rights. Aligns the right side of each selected control with the right side of the first (primary) control selected.

Note If the Snap to Grid command is enabled, you can align controls to the grid. When you align controls to the grid, the bounds (or edges) of the controls are lined up as specified, snapping to the nearest grid point. See the Snap to Grid command for more information.


Vertical Line Color

The Vertical Line Color option specifies the color of the vertical lines defined in the Vertical Lines option.

The RGB (Red, Green, Blue) values for the current color selection are displayed in the text entry box, and a sample of the color is shown in the sample display box.

Use the ellipsis button (…), located next to the color sample box, to open the standard Windows Color dialog box to change the default color for this option.


Vertical Lines

The Vertical Lines option defines the column position of the thin vertical lines that serve as alignment guides when placing COBOL code in the proper areas. You also can specify the color of these lines by using the Vertical Line Color option.


Vertical Property

The Vertical property is a design-time-only property that specifies the orientation of the trackbar.

The following table lists the possible values of the Vertical property:

Value | Description
False | The trackbar control is not oriented vertically (the default).
True | The trackbar control is oriented vertically.


Vertical Property Tab

The Vertical property a design-time-only property that determines whether or not tabs appear at the left side of the control, with tab text displayed vertically. This parameter is valid only when the MultiLine property is set to True. To make tabs appear on the right side of the control, you must also use the Right property. (Note that this property also can be changed using the Vertical check box in the Tab Control Editor dialog box.)

The following table lists the possible values of the Vertical property:

Value | Description
False | Tabs will not appear at the left side of the control, with tab text displayed vertically (the default).
True | Tabs appear at the left side of the control, with tab text displayed vertically.


Vertical Scroll Bar (Control Specific Page)

The edit boxes and option buttons in the Vertical Scroll Bar group allow you to determine the width of a vertical scroll bar field/control when a panel library is converted to WOW.

· The value in the Width edit box, when set to any number other than zero, overrides the default setting of either the Column Width edit box or the Static Text font width when the Use Static Text Font Size for Line/Column Spacing check box is selected on the General tab in determining the width of a vertical scroll bar.

· The value in the Width Factor edit box, which is preset to 1, specifies a value by which to multiply either the value of the Width edit box or the default setting of either the Column Width edit box or the Static Text font width when the Use Static Text Font Size for Line/Column Spacing check box is selected on the General tab. This multiplier is applied depending on the settings of the following option buttons:

-  The Use width factor always option button, when selected, causes WOW to always use the value specified in the Width Factor edit box to determine the width of the vertical scroll bar on a panel/form.

-  The Use width factor only when border was present in panel definition option button, selected by default, causes WOW to always use the value specified in the Width Factor edit box to determine the width of the vertical scroll bar only if a border was present in the panel definition.


View Menu ActiveX Methods Command Ref

ActiveX Methods (View menu)

Use this command to open the ActiveX Methods dialog box, which allows you to select method(s) for the control.

Note If a form is not open in the project, this command is unavailable.

Shortcuts

Toolbar: on the View toolbar

Keys: Shift+F2


View Menu ActiveX Methods Popup

The ActiveX Methods command opens the ActiveX Methods dialog box, which allows you to select method(s) for the control. Note that if a form is not open in the project, this command is unavailable.


View Menu Aligning Toolbar Command Ref

Aligning Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Aligning Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Aligning Toolbar Popup

The Aligning Toolbar command toggles the display of the Aligning Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu All Toolbars Command Ref

All Toolbars (View menu | Toolbars)

Use this command to display all toolbars if any have been hidden (toggled off).


View Menu All Toolbars Popup

The All Toolbars command displays all toolbars if any have been hidden (toggled off).


View Menu Centering Toolbar Command Ref

Centering Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Centering Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Centering Toolbar Popup

The Centering Toolbar command toggles the display of the Centering Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Code Templates Command Ref

Code Templates (View menu)

Use this command to access the Code Templates tree, which displays a list of available templates, also called shortcuts, for a function call or a message and provides different ways of viewing this information.


View Menu Code Templates Popup

The Code Templates command accesses the Code Templates tree, which displays a list of available templates, also called shortcuts, for a function call or a message and provides different ways of viewing this information.


View Menu Custom Toolbar 1 Command Ref

Custom Toolbar 1 (View menu | Toolbars)

Use this command to display a Custom Toolbar. You can customize the toolbars in the WOW Designer to fit your work preferences by using the Customize Toolbar dialog box. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Custom Toolbar 1 Popup

The Custom Toolbar 1 command toggles the display of a Custom Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Custom Toolbar 2 Command Ref

Custom Toolbar 2 (View menu | Toolbars)

Use this command to display a Custom Toolbar. You can customize the toolbars in the WOW Designer to fit your work preferences by using the Customize Toolbar dialog box. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Custom Toolbar 2 Popup

The Custom Toolbar 2 command toggles the display of a Custom Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Editing Toolbar Command Ref

Editing Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Editing Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Editing Toolbar Popup

The Editing Toolbar command toggles the display of the Editing Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu File Toolbar Command Ref

File Toolbar (View menu | Toolbars)

Use this command to toggle the display of the File toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu File Toolbar Popup

The File Toolbar command toggles the display of the File Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Find Toolbar Command Ref

Find Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Find Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Find Toolbar Popup

The Find Toolbar command toggles the display of the Find Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Help Toolbar Command Ref

Help Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Help Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Help Toolbar Popup

The Help Toolbar command toggles the display of the Help Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Layout Toolbar Command Ref

Layout Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Layout Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Layout Toolbar Popup

The Layout Toolbar command toggles the display of the Layout Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Lock Icons Command Ref

Lock Icons (View menu)

Use this command to toggle the visual display of the lock icon placed on control(s) when the control(s) are locked by any of the following methods:

· Selecting the Toggle Lock command.

· Pressing the Toggle Lock button.

· Setting the Locked property.

· Using the Ctrl+L shortcut.

Note If no form is open in the project, this command is not available.


View Menu Lock Icons Popup

The Lock Icons command toggles the visual display of the lock icon placed on control(s) when the control(s) are locked. Note that if no form is open in the project, this command is not available.


View Menu Menu Command Ref

Menu Editor (View menu)

Use this command to create Windows-style pulldown menus for a selected form. The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box. You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance.

Note If no form is open in the project, this command is not available.

Shortcuts

Toolbar: on the View toolbar

Keys: Shift+Return


View Menu Menu Popup

The Menu Editor command creates Windows-style pulldown menus for a selected form. The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box. You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance. Note that if no form is open in the project, this command is not available.


View Menu Project Output Command Ref

Project Output (View menu)

Use this command to toggle the display the Project Output dialog bar, a dockable window that shows the results of an application code search or a compilation.


View Menu Project Output Popup

The Project Output command displays the Project Output dialog bar, a dockable window that shows the results of an application code search or a compilation.


View Menu Project Toolbar Command Ref

Project Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Project Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Project Toolbar Popup

The Project Toolbar command toggles the display of the Project Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Project Tree Command Ref

Project Tree (View menu)

Use this command to access the Project tree, a window that shows the current project and lists all its forms.


View Menu Project Tree Popup

The Project Tree command accesses the Project tree, a window that shows the current project and lists all its forms.


View Menu Properties Command Ref

Properties (View menu)

Use this command to open the Properties dialog box for the selected object.

Note If no form is open in the project, this command is not available.

Shortcuts

Toolbar: on the View toolbar

Keys: Alt+Return

Single-click the right mouse button in the selected form or control.


View Menu Properties Popup

The Properties command opens the Properties dialog box for the selected object. Note that if no form is open in the project, this command is not available.


View Menu Sizing Toolbar Command Ref

Sizing Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Sizing Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Sizing Toolbar Popup

The Sizing Toolbar command toggles the display of the Sizing Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Spacing Toolbar Command Ref

Spacing Toolbar (View menu | Toolbars)

Use this command to toggle the display of the Spacing Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Spacing Toolbar Popup

Spacing Toolbar (View menu | Toolbars)

The Spacing Toolbar command toggles the display of the Spacing Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu Status Bar Command Ref

Status Bar (View menu)

Use this command to toggle the display of the status bar on and off. When a check mark appears next to this command on the menu, it indicates that the status bar is visible. If the command is no longer active, the check mark is removed and the status bar is hidden.


View Menu Status Bar Popup

The Status Bar command toggles the display of the status bar on and off. When a check mark appears next to this command on the menu, it indicates that the status bar is visible. If the command is no longer active, the check mark is removed and the status bar is hidden.


View Menu Toolbox Command Ref

Toolbox (View menu)

Use this command to access the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form, using the Toolbox window. You must have a mouse to access the tools on the Toolbox.

Shortcut

Toolbar: on the View toolbar


View Menu Toolbox Popup

The Toolbox command accesses the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form, using the Toolbox window. You must have a mouse to access the tools on the Toolbox.


View Menu View Toolbar Command Ref

View Toolbar (View menu | Toolbars)

Use this command to toggle the display of the View Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Menu View Toolbar Popup

The View Toolbar command toggles the display of the View Toolbar on and off. When a check mark appears next to this command on the menu, it indicates that the toolbar is visible. If the command is not active, the check mark is removed and the toolbar is hidden.


View Toolbar Edit Control Code

Edit Control Code (View Toolbar)

Use the Edit Control Code button to open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the selected control.

This button corresponds to the Edit Code command on the Control menu.


View Toolbar Edit Form Code

Edit Form Code (View Toolbar)

Use the Edit Form Code button to open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the form.

This button corresponds to the Edit Code command on the Form menu.


View Toolbar Edit Form Menu Code

Edit Form Menu Code (View Toolbar)

Use the Edit Form Menu Code button to open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the specified menu.

This button corresponds to the Edit Code command on the Form menu.


View Toolbar Edit Project Code

Edit Project Code (View Toolbar)

Use the Edit Project Code button to open the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the project.

This button corresponds to the Edit Code command on the Project menu.


View Toolbar Show ActiveX Methods

Show ActiveX Methods (View Toolbar)

Use the Show ActiveX Methods button to open the ActiveX Methods dialog box, which allows you to select method(s) for the control.

This button corresponds to the ActiveX Methods command on the View menu.


View Toolbar Show Menu Editor

Show Menu Editor (View Toolbar)

Use the Show Menu Editor button to create Windows-style pulldown menus for a selected form. The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box. You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance.

This button corresponds to the Menu Editor command on the View menu.


View Toolbar Show Properties

Show Properties (View Toolbar)

Use the Show Properties button to open the Properties dialog box for the selected object.

This button corresponds to the Properties command on the View menu.


View Toolbar Show Toolbox

Show Toolbox (View Toolbar)

Use the Show Toolbox button to access the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form. You must have a mouse to access the controls on the Toolbox.

This button corresponds to the Toolbox command on the View menu.


Visible Property

The Visible property determines whether the control is visible or hidden at runtime.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Visible property:

Value | Description
False | Control is hidden.
True | Control is visible (the default).


Visible Property ActiveX

The Visible property determines whether the ActiveX control is visible or hidden at runtime.

Note This property is implemented only if the control can be visible at runtime.

The following table lists the possible values of the Visible property:

Value | Description
False | Control is hidden.
True | Control is visible (the default).


Visible Property Form

The Visible property determines whether a form is hidden or visible at runtime.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the Visible property:

Value | Description
False | Form is hidden.
True | Form is visible (the default).


VScroll Event

The VScroll event occurs when the user clicks the vertical scroll bar for the edit box control.


WantKeyboard Property

The WantKeyboard property is a design-time-only property that determines whether keystroke events are reported to the form containing a list box control.

The following table lists the possible values of the WantKeyboard property:

Value | Description
False | Keystroke events are not reported to the form (the default).
True | Keystrokes are reported to the form.


WantPopUpMenu Property

The WantPopUpMenu is a design-time-only property that determines whether a standard Windows popup menu will display when the user right-clicks while in an edit box.

The following table lists the possible values of the WantReturn property:

Value | Description
False | No standard Windows popup menu will display when the user right-clicks while in an edit box.
True | A standard Windows popup menu will display when the user right-clicks while in an edit box (the default).


WantReturn Property

The WantReturn property, used in combination with the MultiLine property, specifies that a carriage return be inserted when the user presses the Enter (or Return) key while entering text into a multi-line edit box control in a dialog box. When the user presses Enter in a multi-line edit box control that omits this property, the dialog box’s default command button is pressed.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the WantReturn property:

Value | Description
False | A carriage return is not inserted when the user presses the Enter key during text entry (the default).
True | A carriage return is inserted when the user presses the Enter key during text entry.


WeekNumbers MC Property

The WeekNumbers property is a design-time-only property that displays week numbers (1-52) to the left of each row of days. Week 1 is defined as the first week that contains at least four days.

The following table lists the possible values of the WeekNumbers property:

Value | Description
False | Week numbers are not displayed to the left of each row of days (the default).
True | Week numbers are displayed to the left of each row of days.


Whats New in WOW Extensions See Also

WOW Extensions Components

WOW Extensions Development Process


.topic 1073865088
The date edit box field/control provides an area on a panel in which a date can be displayed or entered.

.topic 1073865090
The multi-line edit box field/control provides an area on a panel in which users may enter several lines of text into a small, fixed space.  Because the text box is smaller than the amount of information stored, part of the information is hidden.  The user uses scroll bars to display the hidden information.  You can design the text box to scroll its contents vertically or horizontally.

.topic 1073865087
The numeric edit box field/control provides an area to input or display numeric data.

.topic 1073865089
The time edit box field/control provides an area on a panel in which the time can be displayed or entered.

.topic 1074069787
The Toolbox contains the icons of the controls that you select, draw, and place on your form.  The controls that appear in the Toolbox are the default Windows intrinsic controls.  By default, the Toolbox is displayed vertically along the right-hand side of the WOW Designer window.  It can, however, be dragged and attached to a different location of your choosing or it can be detached, or floated, in the WOW Designer window

.topic 1073865072
An animation control is used to display an AVI clip.  An AVI clip is a series of bitmap frames that run like a movie.  Only AVI files without sound can be played using the animation control.

.topic 1073865071
The bitmap control is used to display bitmapped images.  The image can be displayed in several ways, including being tiled or scaled to fit the size of the control.  A bitmap defines an image or picture as a pattern of dots (or pixels) and has the file extension .bmp.  Even though Windows does not implement or package a bitmap control, it does provide bitmap handling.  WOW Extensions adds the bitmap control to provide a convenient way to use bitmaps on a form.

.topic 1073865062
The check box control displays an option that can be turned on or off.  The check box control is similar to the command button, in that the primary method of operation is clicking it.  The check box control, however, represents data, not a request for action.

.topic 1073865066
The combo box control combines the features of an edit box (also known as an edit field) and a list box.  This control allows you to combine the list selection capability of a list box with the edit box’s ability to type in a value.  Alternatively, to save screen space on a form, you may wish to show only a portion of the list box’s selections.  And, there may be instances when you would like to display the currently selected item in a static edit box area when the entire list is not displayed.

.topic 1073865061
The command button (also known as push button) control causes an action to occur when the user either clicks the button or presses a key.

.topic 1073865080
The date time picker control allows the user to select a date and time, and to display that date-time in the specified format.

.topic 1073865069
The edit box control provides an area to input or display text.  This control replaces the COBOL ACCEPT statement.  The user can enter any type of alphanumeric data in an edit box, including numeric data.  Because no formatting is provided, numbers are entered in the same manner as text.

.topic 1073865085
The ellipse shape is used to draw the geometric shape of an ellipse on the form.  A 32-bit Windows-based application uses filled shapes in a variety of ways.  Spreadsheet applications, for example, use filled shapes to construct charts and graphs.

.topic 1073865070
The group box control is a specialized box that is used to group other controls, such as check boxes and option buttons.

.topic 1073865082
The line shape is used to draw a line on the form.

.topic 1073865065
The list box control allows the selection of one or several items from a list of items.  It is a simple, yet versatile control.  You load a list box with items at runtime.  When enabled, the user can select an item by clicking with the mouse or moving the selection bar with the arrow keys.  You send the list box a message to find out which item in the list box is selected.

.topic 1073865081
The month calendar control displays a monthly calendar.  The calendar can display one or more months at a time.

.topic 1073865063
The option button (also known as radio button) control displays an option that can be turned on or off.  Option buttons are usually used in groups where turning one button on turns the others off.

.topic 1073865073
A progress bar control consists of a patterned block that can be used to show the status of a long operation.

.topic 1073865083
The rectangle shape is used to draw the geometric shape of a rectangle on the form.  Rectangles are used for the cursor clipping region, the invalid portion of the client area, an area for displaying formatted text, or the scroll area.  Your applications can also use rectangles to fill, frame, or invert a portion of the client area with a given brush, and to retrieve the coordinates of a window or a window’s client area.

.topic 1073865084
The rounded rectangle shape is used to draw the geometric shape of a rectangle with rounded corners on the form.  Rectangles are used for the cursor clipping region, the invalid portion of the client area, an area for displaying formatted text, or the scroll area.  Your applications can also use rectangles to fill, frame, or invert a portion of the client area with a given brush, and to retrieve the coordinates of a window or a window’s client area.

.topic 1073865067
The scroll bar control is used to allow a numeric value to be manipulated as a thumb position on a bar.  By specifying the minimum and maximum, the value can be viewed relative to a range of possible values.  This value and the scroll bar are often used to scroll the display of other information on a form.  A vertical scroll bar displays a vertical bar that can be used to scroll information.

.topic 1073865068
The scroll bar control is used to allow a numeric value to be manipulated as a thumb position on a bar.  By specifying the minimum and maximum, the value can be viewed relative to a range of possible values.  This value and the scroll bar are often used to scroll the display of other information on a form.  A horizontal scroll bar displays a horizontal bar that can be used to scroll information.

.topic 1073865064
The static text control is used to display text, rectangular outlines, or filled rectangles.  These features could reasonably be implemented as several different types of objects, but Windows combines them since they have the same properties.  You use the static text control most often to display text the user is not allowed to modify, such as labels for other controls.  The static text control is also used to draw rectangles or outlines to highlight parts of a form, group controls, or even create a design.

.topic 1073865075
A status bar control display status information in a horizontal window at the bottom of an application window.  Status bars are often divided into sections, called panes, and each pane displays different status information.

.topic 1073865077
A tab control is a container control, meaning it allows other controls to be placed inside it.  The tab control has several tabs at the top of the control.  When a control is added to the tab, it is attached to the tab that is currently selected.  When another tab is selected, the controls for the other tabs are hidden and the controls for the selected tab are displayed.  This is an excellent way to organize controls by category, rather than placing a large number of controls in a single window.

.topic 1073865079
The timer control provides a measured time interval that can be tied to events.

.topic 1073865078
A toolbar control consists of a series of buttons that can be placed at the top and/or bottom of a form.  You can put two toolbars on a form, one at the top and one at the bottom.  Event-handling code can be attached to each button in the toolbar.  Each button in the toolbar can contain a bitmap and/or text.

.topic 1073865074
A trackbar control displays a window containing a slider and optional tick marks used to select a value or a set of consecutive values in a range.  The trackbar control can be oriented either horizontally or vertically.  Trackbars are useful when you want the user to select a discrete value or a set of consecutive values in a range.

.topic 1073865076
An updown control is most often used with a companion control, which is called a buddy window.  To the user, an updown control and its buddy window often look like a single control.  You can specify that an updown control automatically position itself next to its buddy window and that it automatically set the caption of the buddy window to its current position.

.topic 1073872899
Forms are the containers within which you group controls.  In traditional programming, you place fields on the screen or in a pop-up window.  With WOW Extensions, you place fields (that is, controls) in a form.  The form has only default properties associated with it.

.topic 1073840368
The New Form and New commands add a new, blank form to an open project.  If a project is open but no forms are open in that project, this command is shown as New on the menu.  If a project is not open, this command is unavailable.

.topic 1073840370
The Open Form and Open commands retrieve an existing form file from disk while you are in an open project.  WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified.  If a project is open but no forms are open in that project, this command is shown as Open on the menu.  If a project is not open, this command is unavailable.

.topic 1073840371
The Close Form and Close commands close a form file without leaving WOW Extensions.  If you have not made changes to the form since you last opened or saved it, WOW Extensions will immediately close the form.  If you have made changes to the form, however, WOW Extensions will display a message box asking whether you want to save the changes to the form.  If you choose Yes and the current form has previously been saved, WOW Extensions will save the form under its current name and then close it.  If you choose Yes and the form has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it, as described under the Save Form As command.  If you choose No, WOW Extensions will close the form without saving the changes.  If you choose Cancel, WOW Extensions will return you to the form without saving it or closing it.  If a project is open but no forms are open in that project, or if no project is open, this command is not available.

.topic 1073840372
The Save Form and Save commands save changes made to the current form file.  When you save a form, WOW Extensions automatically generates COBOL source code.  If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.  If a project is open but no forms are open in that project, or if no project is open, this command is not available.

.topic 1073840373
The Save Form As and Save As commands save a form file under a new name or in a different directory/folder or drive.  The standard Windows Save As dialog box opens so that you can specify a filename.  If a project is open but no forms are open in that project, or if no project is open, this command is not available.

.topic 1073840560
The Open All Forms and Open All commands open all form files of the project that is currently open for this session.  If a project is open but no forms are open in that project, this command is shown as Open All on the menu.  If a project is not open, this command is unavailable.

.topic 1073840233
The Save All Forms and Save All commands save all open forms if you are working on more than one form at a time.  If any open forms have not been saved before, WOW Extensions displays a standard Windows Save As dialog box so that you can specify a filename.  If a project is open but no forms are open in that project, or if no project is open, this command is not available.

.topic 1073840223
The Close All Forms and Close All commands close all open forms.  If a form has changes that have not been saved, WOW Extensions prompts you to save the changes in each form before closing.  If a project is open but no forms are open in that project, or if no project is open, this command is not available.

.topic 1073864976
The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.

.topic 1073864977
The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.

.topic 1073864978
The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.

.topic 1073864979
The Recent Projects and Recent Forms commands list up to the last four projects and/or forms most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects or switch focus and navigate to any of the listed forms, click the name of the project or form, or type the number that appears to the left of the name.

.topic 1073865025
Exit (File menu)
The Exit command closes form and/or project files and exit WOW Extensions.  If you have not made any changes since the last time you saved the open files, WOW Extensions will terminate.  If you have made changes, you will see a message box asking whether you want to save your changes.  You can save or discard your changes by choosing Yes or No for each item.  You can also cancel the Exit command any time by choosing Cancel.  You will return to the file without saving it or closing it.

.topic 1073865003
The Undo command reverses the effect of the most recent editing operation.  You must choose Undo before performing any other operation or the control is not restored.  Not all editing operations can be undone.  In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms.  Shortcut:  Ctrl+Z.

.topic 1073865004
The Redo command restores the result of the last editing operation or action, if you decide that you do not want to undo the action.  Note that not all editing operations can be restored.  Shortcut:  Ctrl+Shift+Z.

.topic 1073864995
The Cut command removes a control(s) from a form.  The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms.  You can select multiple controls to be cut from within a single form.  The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form.  (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.)  You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation.  Shortcut:  Ctrl+X.

.topic 1073864994
The Copy command copies a control(s) on a form or between forms.  The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged.  Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form.  (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.)  You can select multiple controls to be copied from within a single form.  Shortcut:  Ctrl+C.

.topic 1073864997
The Paste command pastes a control(s) after cutting or copying to the Clipboard.  This command is not available if the Clipboard is empty.  Shortcut:  Ctrl+V.

.topic 1073840247
The Duplicate command creates a copy of a control or controls.  The copy will be offset slightly to the lower right and placed on top of the original control.  The new duplicate copy is automatically selected.  When you use this method of copying, WOW Extensions does not use the Clipboard to transfer the control(s).  This command is not available if the Clipboard is empty.  Shortcut:  Ctrl+D.

.topic 1073864992
The Delete command erases a control or controls from a form.  You cannot reinsert control(s) removed by using the Delete command since this command does not place the deleted selection in the Clipboard.  You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation.  Shortcut:  Del

.topic 1073865002
The Select All command selects all the controls on the current form.  To quickly deselect all controls on a form, click the left mouse button anywhere in the form that is not a control.  Once you have selected multiple controls, you can manipulate them as though they were a single control.  For example, you can cut, copy, delete, or duplicate them as one unit.  Shortcut:  Ctrl+A.

.topic 1073864996
The Find command displays a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box.  Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.  Shortcut:  Ctrl+F.

.topic 1073840412
The Find Next command finds the next instance of the text string specified with the Find command.  Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.  Shortcut:  Ctrl+N.

.topic 1073840594
The Find Previous command finds the previous instance of the text string specified with the Find command.  Shortcut:  Shift+F3.

.topic 1073865001
The Find & Replace command displays a variation of the standard Windows Find and Replace dialog box in order to enter a text string that you want to locate and modify in the Code Entry area of the Event-Handling Code dialog box.  Note that this command is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.  Shortcut:  Ctrl+H.

.topic 1073840497
The Find in Code command displays the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code.  Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window.  Shortcut:  Ctrl+Shift+F.

.topic 1073840586
The Edit Bookmarks command opens the Edit Bookmarks dialog box in order to add a bookmark, which identifies a location or selection of text that you name and identify for future reference; for example, to a frequently-used position of the COBOL source code that you may wish to revise in the code edit windows.  Shortcut:  Alt+F2.

.topic 1073840587
The Go To Bookmark command opens the Go To Bookmark dialog box in order to jump quickly to a certain line in the COBOL source code that has been identified by a bookmark name.  When you select a bookmark from the dropdown list, the editor scrolls to the location of the bookmark in the code edit windows.  Shortcut:  Ctrl+G.

.topic 1073840590
The Toggle Marker command shows or hides the display of the markers in the code edit windows.  The default is to show markers, which is a setting on the Code Edit Windows Preferences page.  Shortcut:  Ctrl+F2.

.topic 1073840591
The Go To First Marker command goes to the first marker in the code edit windows.

.topic 1073840588
The Go To Next Marker command goes to the next marker in the code edit windows.  Shortcut:  F2.

.topic 1073840589
The Go To Previous Marker command goes to the previous marker in the code edit windows.  Shortcut:  Shift+F2.

.topic 1073840592
The Go To Last Marker command goes to the last marker in the code edit windows.

.topic 1073840593
The Clear All Markers command clears all markers in the code edit windows.

.topic 1073840135
The Foreground command changes the foreground color (that is, the line or text color) of one or more selected controls.  A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the foreground color of the control(s).  You cannot set the foreground color for a command button, or for the horizontal or vertical scroll bars.
Note  You can also set the foreground color of a control from the selected control’s Properties dialog box.  On the Properties dialog box, this property is called ForeColor.

.topic 1073840136
The Background command changes the background (fill) color of one or more selected controls.  A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of the control(s).  You cannot set the background color for a command button, or for the horizontal or vertical scroll bars.
Note  You can also set the background color of a control from the selected control’s Properties dialog box.  On the Properties dialog box, this property is called BackColor.

.topic 1073840162
The Font command changes the font, style (such as bold and italic), size, underline, color, and font effects (such as strikeout and underline) for text displayed in one or more selected controls.  This command also allows you to set new defaults.  The standard Windows Font dialog box opens.  You cannot set font settings for a form, or for the horizontal and vertical scroll bars.
Note  You can also set the font characteristics of a control from the selected control’s associated Properties dialog box.  On the Properties dialog box, these properties are called FontBold, FontItalic, FontName, FontSize, FontStrikethru, and FontUnderline.

.topic 1073840456
The Tab Order command determines the current tab order for your program.  You can change the tab order for selected controls by double-clicking the control you want to be first in the tab order, and then single-clicking on the rest of the controls in the order in which you want them to be selected in the form.  Note that for complicated forms having many controls, the preferred method of changing the tab order is with the Tab Order Editor dialog box.

.topic 1073840514
The Z-Order command determines the control stacking order, that is, the order in which controls are created.  You can change the z-order for selected controls by clicking the control you want to appear first in the stacking order, and then single-clicking on the rest of the controls until they are in the desired order.  Note that for complicated forms having many controls, the preferred method of changing the z-order is with the Z-Order Editor dialog box.

.topic 1073840348
The Edit Code command opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the selected control.

.topic 1073840431
The Align Lefts command aligns the left side of each selected control with the left side of the first (primary) control selected.

.topic 1073840432
The Align Centers command aligns the vertical (up/down) center of each selected control with the vertical center of the first (primary) control selected.

.topic 1073840433
The Align Rights command aligns the right side of each selected control with the right side of the first (primary) control selected.

.topic 1073840434
The Align Tops command aligns the top edge of each selected control with the top edge of the first (primary) control selected.

.topic 1073840435
The Align Middles command aligns the horizontal (left/right) center of each selected control with the horizontal center of the first (primary) control selected.

.topic 1073840436
The Align Bottoms command aligns the bottom edge of each selected control with the bottom edge of the first (primary) control selected.

.topic 1073840437
The Center Vertical command aligns the selected controls vertically with respect to the center of the form between the top and bottom borders.

.topic 1073840438
The Center Horizontal command aligns the selected controls horizontally with respect to the center of the form between the left and right borders of the form.

.topic 1073840442
The Space Vertical command distributes the selected controls in the vertical direction, placing equal amounts of space between the selected controls.  The default setting for the spacing of the controls is determined by the exact centers of the controls.

.topic 1073840443
The Space Horizontal command distributes the selected controls in a horizontal direction such that the spacing between the controls is the same.  The default setting for the spacing of the controls is determined by the exact centers of the controls.

.topic 1073840440
The Size Match height command resizes the selected controls in a vertical direction.

.topic 1073840439
The Size Match Width command resizes the selected controls in a horizontal direction.

.topic 1073840441
The Size Match Both command resizes the selected controls in both directions simultaneously.

.topic 1073840256
The Save Properties | For Project Use command saves the selected controls’ properties to the project definition file (.wpj).  These property settings become the new default settings for the controls when they are used in that particular project.

.topic 1073840252
The Saves Properties | For Global Use saves the selected controls’ properties to the cblwow.ini initialization file so that the modified controls may be used in a different project.

.topic 1073840261
The Restore Properties | From Project Defaults command resets the selected controls’ properties from the project definition file (.wpj).

.topic 1073840262
The Restore Properties | From Global Defaults command resets the selected controls’ properties from the cblwow.ini initialization file.

.topic 1073840239
The Bring to Front command moves the selected control all the way to the front of the stack of controls.  The Bring to Front command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

.topic 1073840240
The Send to Back command moves the selected control behind all other controls in the stack on a form.  The Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

.topic 1073840455
The Toggle Lock command locks or unlocks the selected control(s), which keeps the control(s) from being moved accidentally.

.topic 1073840550
The Tab Editor command opens the Tab Control Editor dialog box, which allows modifications to the tab control and certain tab properties that require special consideration with the tab control.  Note that this command is available only if you have selected a tab control on a form.

.topic 1073840579
The Tab Order Editor command opens the Tab Editor Control Editor dialog box, which displays a list of controls on the active form and enables you to easily change their tab order.  Note that for simple forms having few controls, the Tab Order command can be used to change the tab order.

.topic 1073840580
The Z-Order Editor command opens the Z-Order Editor Control Editor dialog box, which allows you to specify the control stacking order (or z-order).  Note that for simple forms having few controls, the Z-Order command can be used to change the control stacking order.

.topic 1073840551
The Drop Down combo Box command displays the drop-down portion of the combo box control, which allows all of the pre-defined data entries to be visible in the drop-down list box during the design process and provides the capability to select one of the entries for display in the edit box portion of the combo box control.

.topic 1073840444
The All Toolbars command displays all toolbars if any have been hidden (toggled off).

.topic 1073840380
The File Toolbar command  toggles the display of the File Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840381
The Editing Toolbar command toggles the display of the Editing Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840382
The Find Toolbar command toggles the display of the Find Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840383
The Layout Toolbar command toggles the display of the Layout Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840384
The Aligning Toolbar command toggles the display of the Aligning Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840386
The Sizing Toolbar command toggles the display of the Sizing Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840385
The Centering Toolbar command toggles the display of the Centering Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840387
Spacing Toolbar (View menu | Toolbars)
The Spacing Toolbar command toggles the display of the Spacing Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840388
The View Toolbar command toggles the display of the View Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840389
The Project Toolbar command toggles the display of the Project Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840390
The Help Toolbar command toggles the display of the Help Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840391
The Custom Toolbar 1 command toggles the display of a Custom Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073840392
The Custom Toolbar 2 command toggles the display of a Custom Toolbar on and off.  When a check mark appears next to this command on the menu, it indicates that the toolbar is visible.  If the command is not active, the check mark is removed and the toolbar is hidden.

.topic 1073866753
The Status Bar command toggles the display of the status bar on and off.  When a check mark appears next to this command on the menu, it indicates that the status bar is visible.  If the command is no longer active, the check mark is removed and the status bar is hidden.

.topic 1073840304
The Toolbox command accesses the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form, using the Toolbox window.  You must have a mouse to access the tools on the Toolbox.

.topic 1073840349
The Project Tree command accesses the Project tree, a window that shows the current project and lists all its forms.

.topic 1073840545
The Project Output command displays the Project Output dialog bar, a dockable window that shows the results of an application code search or a compilation.

.topic 1073840546
The Code Templates command accesses the Code Templates tree, which displays a list of available templates, also called shortcuts, for a function call or a message and provides different ways of viewing this information.

.topic 1073840582
The Lock Icons command toggles the visual display of the lock icon placed on control(s) when the control(s) are locked.  Note that if no form is open in the project, this command is not available.

.topic 1073840163
The Properties command opens the Properties dialog box for the selected object.  Note that if no form is open in the project, this command is not available.

.topic 1073840168
The Menu Editor command creates Windows-style pulldown menus for a selected form.  The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box.  You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance.  Note that if no form is open in the project, this command is not available.

.topic 1073840554
The ActiveX Methods command opens the ActiveX Methods dialog box, which allows you to select method(s) for the control.  Note that if a form is not open in the project, this command is unavailable.

.topic 1073840210
The New command creates a new WOW project.  After you enter a name for the project and the directory/folder for the project files (.wpj) in the Save Project dialog box (a standard Windows dialog box), the Project Properties dialog box opens and you can add forms (members) to the project.  Note that only one project can be opened at one time.  If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created.

.topic 1073840211
The Open command opens an existing project, and includes the forms and custom controls listed in its project file (.wpj).  The Open Project dialog box, which is a standard Windows dialog box, opens.  Note that only one project can be opened at one time.  If you are already in an open project when you choose the Open command from the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.

.topic 1073840268
The Save command saves changes made to an active (open) project.  When you save a project, WOW Extensions automatically generates COBOL source code.

.topic 1073840496
The Save As command saves a copy of the open project with a different name.

.topic 1073840214
The Close command closes a project.  If you have made any changes to the file, you are prompted to save the changes.

.topic 1073840269
The Regenerate command regenerates COBOL source code for the active project if changes have been made to a form.

.topic 1073840578
The Regenerate w/Forms command regenerates COBOL source code for the active project if changes have been made to a form.

.topic 1073840226
The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.

.topic 1073840227
The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.

.topic 1073840228
The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.

.topic 1073842229
The Recent Projects command lists up to the last four projects most recently opened in the WOW Designer.  To close the current project and reopen one of the listed projects, click the name of the project or type the number that appears to the left of the name.

.topic 1073840218
The Properties command edits the current project by adding or deleting members.  The Project Properties dialog box opens.  The settings in the Project Properties dialog box affect only the currently open project.

.topic 1073840221
The Options command specifies configuration options for the current project using the Project Options dialog box.

.topic 1073840231
The Open Member command opens or accesses a member of a project.  A list box containing all the form files (.wow) in the project is displayed below the toolbar button.  Note that members can be added to and deleted from the project at any time with the Properties command.

.topic 1073840347
The Edit Code command opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the project.

.topic 1073840219
The Build command generates and compiles a COBOL source program if one does not exist.

.topic 1073840220
The Run command executes the project by running the COBOL source program after it has been compiled.

.topic 1073840209
The Debug command debugs the project.

.topic 1073840508
The Print Packaging List command prints a list of the application components (such as the COBOL program, bitmaps, icons, animation files, ActiveX controls, and so on) that are required for distribution.  Selecting this command opens a standard Windows Print dialog box.

.topic 1073864967
The Print command prints a form.  If more than one form is open, the form on top of the stack is printed.  Selecting this command opens a standard Windows Print dialog box.

.topic 1073840243
The Show Grid command toggles the display of the grid, an evenly spaced pattern of pixels (screen dots) that appear in a form, on and off.  The grid helps you to draw, position, align, and size controls exactly where you want them in a form.  The grid is displayed by default.  When a check mark appears next to this command on the menu, it indicates that the grid is visible.  If the command is no longer active, the check mark is removed and the grid is hidden.
The default spacing of the grid points is 10 x 10 pixels.  To modify the vertical and horizontal spacing of the grid marks (the X and Y coordinates), see the Show Grid option on the General Preferences page of the Preferences dialog box.  Although you see the grid marks on the form in the WOW Designer, they are not displayed at runtime.

.topic 1073840241
The Snap to Grid command toggles the snap-to-grid option, which forces controls into perfect horizontal and/or vertical alignment to the nearest grid point, on and off.  The Snap to Grid option is enabled by default (see the initial Snap to Grid option on the General Preferences page of the Preferences dialog box for more information).
When a check mark appears next to this command on the menu, it indicates that the snap-to-grid option is enabled.  If the command is no longer active, the check mark is removed and the snap-to-grid option is no longer in effect.  When you align or move a control with Snap to Grid enabled, the handles on the selected control are forced to the nearest grid point.  You determine which of the eight handles snaps to the grid by controlling the direction in which you move the control.

.topic 1073840141
The Background Color command changes the background (fill) color of a form.  A variation of the standard Windows Color dialog box opens so that you can define the basic colors, custom colors, and system colors for the background color of a form.
Note  You can also set the background color of a form from the form’s Properties dialog box.  On the Properties dialog box, this property is called BackColor.

.topic 1073865010
The Cascade command arranges multiple open forms in an overlapped pattern so that the title bar of each form is visible in the WOW Designer window.  You can access the form you want by clicking on the title bar to bring it to the front of the stack.

.topic 1073865011
The Tile Horizontally command arranges multiple open forms in rows with no overlap so that all forms are visible within the workspace.  To access the form you want, click the title bar.

.topic 1073865012
The Tile Vertically command arranges multiple open forms in columns (side by side) with no overlap so that all forms are visible within the workspace.  To access the form you want, click the title bar.

.topic 1073865009
The Arrange Icons command distributes forms that have been reduced (using the Minimize button) to icons evenly along the lower edge of the WOW Designer window.

.topic 1073840344
The Edit Code | Form Events command opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected item.

.topic 1073840346
The Edit Code | Menus Events command opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected item.

.topic 1073840581
The Test command runs, from within the WOW Designer, a simplified version of the WOW runtime (wowtestform.exe) without executing COBOL code in order to see how a form will appear at runtime and tests its operation during the design process.  This test program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

.topic 1073840270
The Regenerate command generates an existing COBOL source program if modifications have been made to a form.  This command regenerates COBOL source code for the active form.

.topic 1073840577
The Regenerates All command regenerates COBOL source programs for all forms in the project, not just the active form.

.topic 1073840254
The Save Properties | For Project Use command saves the form’s properties to the project definition file (.wpj).  These property settings become the new default settings for the controls when they are used in that particular project.

.topic 1073840255
The Save Properties | For Global Use command saves the form’s properties to the cblwow.ini initialization file so that you may reuse the modified form in a different project.

.topic 1073840259
The Restore Properties | From Project Defaults command resets the form's properties from the project definition file (.wpj).

.topic 1073840258
The Restore Properties | From Global Defaults command resets the form's properties from the cblwow.ini initialization file.

.topic 1073868575
The Recent Forms command lists the forms that are open in the current project of the WOW Designer.  To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.

.topic 1073868576
The Recent Forms command lists the forms that are open in the current project of the WOW Designer.  To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.

.topic 1073868577
The Recent Forms command lists the forms that are open in the current project of the WOW Designer.  To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.

.topic 1073868578
The Recent Forms command lists the forms that are open in the current project of the WOW Designer.  To switch focus and navigate to any of the listed forms, click the name of the form or type the number that appears to the left of the name.

.topic 1073840273
The Open command opens an RM/Panels panel in the WOW Designer.  WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified.  WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls).  Once a library has been selected, a subsequent dialog box is displayed so that a specific panel may be selected.

.topic 1073840473
The Save command saves an existing RM/Panels panel modified with WOW Extensions and writes the description of the panel back into the standard panel library.  No WOW-specific files are created.

.topic 1073840474
The Close command closes a panel without leaving WOW Extensions.  If you have not made changes to the panel since you last opened or saved it, WOW Extensions will immediately close the panel.  If you have made changes to the panel, however, WOW Extensions will display a message box asking whether you want to save the changes to the panel.  If you choose Yes and the current panel has previously been saved, WOW Extensions will save the panel under its current name and then close it.

.topic 1073840571
The Open All command opens all RM/Panels panels in a panel library in the WOW Designer.  WOW Extensions displays the Select Panel Library dialog box so that a panel library can be specified.  WOW Extensions must interface to the RM/Panels COBOL programs via TCP/IP using RPC (Remote Procedure Calls).  Once a library has been selected, a subsequent dialog box is displayed so that a specific panel may be selected.

.topic 1073840572
The Save All command saves all existing RM/Panels panels in a panels library that were modified with WOW Extensions and write their descriptions back into that standard panel library.  (No WOW-specific files are created).  WOW Extensions will display a message box with a Yes/No To All command button.  If you choose Yes To All and the current panel has previously been saved, WOW Extensions will save the panel under its current name and then close it.  If you choose Yes To All and the current panel has never been saved, WOW Extensions will display a standard Windows File Save As dialog box allowing you to save it.  This process will be repeated for all open panels.  If you choose No To All, WOW Extensions will close all the panels without saving any changes.

.topic 1073840573
The Close All command closes all open panels without leaving WOW Extensions.  WOW Extensions will display a message box with Yes To All and No To All command buttons.  If you click Yes To All, and if you have not made changes to any of the panels since you last opened or saved them, WOW Extensions will immediately close all the panels.  If you have made changes to any panel in the library, however, WOW Extensions will display a message box asking whether you want to save those changes.  If you click No To All, none of the panels will be closed.

.topic 1073840488
The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer.  To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.

.topic 1073840489
The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer.  To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.

.topic 1073840490
The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer.  To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.

.topic 1073840491
The Recent Panel Library command lists up to the last four panel libraries most recently opened in the WOW Designer.  To close the panel library and reopen one of the listed panel libraries, click the name of the panel library or type the number that appears to the left of the name.

.topic 1073840274
The Export command saves a single panel created with RM/Panels as a WOW form, providing the ability to create a new WOW program using an existing panel.

.topic 1073840574
The Export All command saves all panels in a panel library created with RM/Panels as WOW forms, providing the ability to create a new WOW program using an existing panel.

.topic 1073840271
The Recreate GUI command restores an RM/Panels panel to its original state after it has been opened in WOW Extensions.  Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted.

.topic 1073840576
The Recreate GUI All command restores all panels in an RM/Panels library to their original states after the panels have been opened in WOW Extensions.  Any fields that have been added will not be deleted; however, any "cosmetic" modifications that have been made to the panel (such as control location, fonts, colors, and so on) are deleted.

.topic 1073840272
The Test command runs, from within the WOW Designer, a generic COBOL program to see how an RM/Panels panel will appear at runtime.

.topic 1073840575
The Import Preferences command displays the Panel Import Preferences dialog box in order to specify certain graphical characteristics that will determine the way that character-based panels in an RM/Panels library will appear when the library is opened in the WOW Designer.

.topic 1073840173
The Preferences command changes the default settings and customizes the WOW Designer development environment to your specifications using the Preferences dialog box.

.topic 991
The Customize Toolbars command adds or removes buttons from most existing toolbars (the Find and Layout toolbars require special handling and are, therefore, excluded) or create up to two new toolbars.

.topic 1073840527
The Customize Toolbars | File Toolbar command adds or removes buttons from the File toolbar.

.topic 1073840528
The Customize Toolbars | Editing Toolbar command adds or removes buttons from the Editing toolbar.

.topic 1073840531
The Customize Toolbars | Aligning Toolbar command adds or removes buttons from the Aligning toolbar.

.topic 1073840533
The Customize Toolbars | Sizing Toolbar command adds or removes buttons from the Sizing toolbar.

.topic 1073840532
The Customize Toolbars | Centering Toolbar command adds or removes buttons from the Centering toolbar.

.topic 1073840534
The Customize Toolbars | Spacing Toolbar command adds or removes buttons from the Spacing toolbar.

.topic 1073840535
The Customize Toolbars | View Toolbar command adds or removes buttons from the View toolbar.

.topic 1073840536
The Customize Toolbars | Project Toolbar command adds or removes buttons from the Project toolbar.

.topic 1073840537
The Customize Toolbars | Help Toolbar command adds or removes buttons from the Help toolbar.

.topic 1073840538
The Customize Toolbars | Custom 1 Toolbar command adds or removes buttons from the Custom 1 toolbar.

.topic 1073840539
The Customize Toolbars | Custom 2 Toolbar command adds or removes buttons from the Custom 2 toolbar.

.topic 1073840337
The Customize Toolbox command adds or removes controls to or from the Toolbox using the Customize Toolbox dialog box.

.topic 1073840336
The Select ActiveX Controls command chooses from a list of ActiveX controls that are installed on your Windows machine using the Select ActiveX Controls dialog box.

.topic 1073840478
The Save Properties | For Project Use command saves the selected object's properties to the project definition file (.wpj).  These property settings become the new default settings for the selected object (control or form) when they are used in that particular project.

.topic 1073840481
The Save Properties | For Global Use command saves the selected object's properties to the cblwow.ini initialization file in order to reuse the modified form or control in a different project.

.topic 1073840485
The Restore Properties | From Project Defaults command resets the selected object's properties from the project definition file (.wpj).

.topic 1073840486
The Restore Properties | From Global Defaults command resets the selected object's properties from the cblwow.ini initialization file.

.topic 1073840464
The Designer command opens the WOW Designer online Help file.

.topic 1073840469
The Functions and Messages command opens the Functions and Messages (for WOW Extensions) online Help file.

.topic 1073865024
The About command displays the version number, copyright notice, the name and company name of the person the copy is licensed to, the serial number, and other information about the WOW Designer product that is currently running.

.topic 1610711143
The Open Member button on the File toolbar displays a list of all the files (members) in the open, active project from which you can open a member.  Note that members can also be added to and deleted from the project at any time with the Properties command.

.topic 1610711280
The New Form button on the File toolbar adds a new, blank form to an open project.

.topic 1610711282
The Open Form button on the File toolbar retrieves an existing form file from disk while you are in an open project.  WOW Extensions displays a standard Windows File Open dialog box so that the filename can be specified.

.topic 1610711284
The Save Form and Generate Code button on the File toolbar saves changes made to the current form file.  When you save a form, WOW Extensions automatically generates COBOL source code.  If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

.topic 1610711145
The Save All Forms button on the File toolbar saves changes made to all open form files.  When you save a form, WOW Extensions automatically generates COBOL source code.  If you have not previously saved the form, WOW Extensions displays a standard Windows File Save As dialog box so that you can specify a filename.

.topic 1610735879
The Print Form button on the File toolbar prints a form.  If more than one form is open, the form on top of the stack is printed.  Selecting this command opens a standard Windows Print dialog box.

.topic 1610735907
The Cut button on the Editing toolbar cuts a control(s) from a form.  The Cut command removes the selected object from the form and places it on the Clipboard, a temporary storage area used to transfer objects between forms.  You can select multiple controls to be cut from within a single form.  The Cut command differs from the Delete command in that once the selected control or controls are placed on the Clipboard, you can retrieve the control(s) with the Paste command and insert the control(s) on to a form.  (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.)  You can also retrieve the control(s) by immediately choosing the Undo command on the Edit menu before performing any other operation.

.topic 1610735906
The Copy button on the Editing toolbar copies a control(s) on a form or between forms.  The Copy command places the object on the Clipboard and leaves the current control(s) on the form unchanged.  Once the object is on the Clipboard, choose Paste on the Edit menu to place a copy of the object onto the active form.  (The original object remains on the Clipboard until you cut or copy another object, or end the current WOW session.)  You can select multiple controls to be copied from within a single form.

.topic 1610735909
The Paste button on the Editing toolbar pastes a control(s) after cutting or copying to the Clipboard.  Note that this command is not available if the Clipboard is empty.

.topic 1610735904
The Delete button on the Editing toolbar erases a control or controls from a form.  Note that you cannot reinsert control(s) removed by using the Delete button since this command does not place the deleted selection in the Clipboard.  You can, however, retrieve the material by immediately choosing the Undo command on the Edit menu before performing any other operation.

.topic 1610735915
The Undo button on the Editing toolbar reverses the effect of the most recent editing operation.  You must choose Undo before performing any other operation or the control is not restored.  Note that not all editing operations can be undone.  In this release, the only operations that can be reversed are the cutting and deleting of controls from or between forms.

.topic 1610735916
The Redo button on the Editing toolbar restores the result of the last editing operation or action, if you decide that you do not want to undo the action.

.topic 1610735908
The Find button on the Editing toolbar displays a variation of the standard Windows Find dialog box in order to enter a text string that you want to locate in the Code Entry area of the Event-Handling Code dialog box.  Note that this button is enabled only if the Event-Handling Code dialog box has been opened for a form or control in the project.

.topic 1610711409
The Find in Code Fragments button on the Editing and Find toolbars displays the Find in Code dialog box (a variation of the standard Windows Find dialog box) in order to enter a text string that you want to locate in your application code.  Results are displayed on the Find in Code tab in the Project Output dialog bar, an area located below the Project tree and Code Templates tree of the WOW Designer window.  Note that this button is enabled only if a project is opened.

.topic 1610711502
The Toggle Marker button on the Editing toolbar shows or hides the display of the markers in the code edit windows.  The default is to show markers, which is a setting on the Code Edit Windows Preferences page.

.topic 1610711500
The Go To Next Marker button on the Editing toolbar goes to the next marker in the code edit windows.

.topic 1610711501
The Go To Previous Marker button on the Editing toolbar goes to the previous marker in the code edit windows.

.topic 1610711505
The Clear Markers button on the Editing toolbar removes all markers in the code edit windows.

.topic 1610711151
The Bring to Front button on the Layout toolbar moves the selected control all the way to the front of the stack of controls.  Note that the Bring to Front command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

.topic 1610711152
The Send to Back button on the Layout toolbar moves the selected control behind all other controls in the stack on a form.  Note that the Send to Back command will affect the Z-Order property setting for the selected control(s) since this command changes the z-order of the selected control(s).

.topic 1610711367
The Toggle Lock button on the Layout toolbar locks or unlocks the selected control(s), which keeps the control(s) from being moved accidentally.

.topic 1610711343
The Align Lefts button on the Aligning and Layout toolbars aligns the left side of each selection with the left side of the primary selection.

.topic 1610711344
The Align Centers button on the Aligning and Layout toolbars aligns the vertical (up/down) center of each selected control with the vertical center of the primary selection.

.topic 1610711345
The Align Rights button on the Aligning and Layout toolbars aligns the right side of each selection with the right side of the primary selection.

.topic 1610711346
The Align Tops button on the Aligning and Layout toolbars aligns the top edge of each selected control with the top edge of the primary selection.

.topic 1610711347
The Align Middles button on the Aligning and Layout toolbars aligns the horizontal (left/right) center of each selected control with the horizontal center of the primary selection.

.topic 1610711348
The Align Bottoms button on the Aligning and Layout toolbars aligns the bottom edge of each selected control with the bottom edge of the primary selection.

.topic 1610711351
The Match Widths button on the Sizing and Layout toolbars resizes the selected controls in a horizontal direction.

.topic 1610711352
The Match Heights button on the Sizing and Layout toolbars resizes the selected controls in a vertical direction.

.topic 1610711353
The Match Both button on the Sizing and Layout toolbars resizes the controls in both directions (vertical and horizontal) simultaneously.

.topic 1610711349
The Center Vertically button on the Centering and Layout toolbars aligns the controls vertically with respect to the center of the form between the top and bottom borders.

.topic 1610711350
The Center Horizontally button on the Centering and Layout toolbars aligns the controls horizontally with respect to the center of the form between the left and right borders of the form.

.topic 1610711355
The Space Horizontally button on the Spacing and Layout toolbars distributes the selected controls in a horizontal direction such that the spacing between the controls is the same.

.topic 1610711354
The Space Vertically button on the Spacing and Layout toolbars distributes the controls in the vertical direction, placing equal amounts of space between the selected controls.

.topic 1610711216
The Show Toolbox button on the View toolbar accesses the Toolbox, a window that contains the icons of the controls that you select, draw, and place on your form.  You must have a mouse to access the controls on the Toolbox.

.topic 1610711075
The Show Properties button on the View toolbar opens the Properties dialog box for the selected object.

.topic 1610711080
The Show Menu Editor button on the View toolbar creates Windows-style pulldown menus for a selected form.  The Menu Editor dialog box opens with the first (blank) position highlighted in the Menu Control list box.  You add menu items to a menu at design time by creating menu controls and setting the properties to define their appearance.

.topic 1610711466
The Show ActiveX Methods button on the View toolbar opens the ActiveX Methods dialog box, which allows you to select method(s) for the control.

.topic 1610711259
The Edit Project Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the project.

.topic 1610711256
The Edit Form Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the form.

.topic 1610711260
The Edit Control Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, edit, or maintain the event-driven code associated with the selected control.

.topic 1610711258
The Edit Form Menu Code button on the View toolbar opens the Event-Handling Code dialog box in order to write, add, or maintain the event-driven code associated with the specified menu.

.topic 1610711122
The New Project button on the Project toolbar creates a new WOW project using the Project Properties dialog box after you enter and save a name for the project and the directory/folder for the project files.  Note that only one project can be opened at one time.  If a project is open when you choose this command, you are prompted to close the active project and to save any changes before a new project is created.  After creating a new project, the Save Project dialog box opens, which establishes the project name and the directory/folder for the project files.

.topic 1610711123
The Open Project button on the Project toolbar opens an existing project, and includes the forms and custom controls listed in its project (.wpj) file.  The Open Project dialog box, which is a standard Windows dialog box, opens.  Note that only one project can be opened at one time.  If you are already in an open project when you choose the Open command on the Project menu, the currently opened project closes and you are prompted to save any changes made to the file.

.topic 1610711180
The Save Project and Generate Code button on the Project toolbar saves changes made to an active (open) project.  When you save a project, WOW Extensions automatically generates COBOL source code.

.topic 1610711131
The Build Project button on the Project toolbar generates and compiles a COBOL source program if one does not exist.

.topic 1610711132
The Execute Project button on the Project toolbar executes the project by running the COBOL source program after it has been compiled.

.topic 1610711493
The Test Form button on the Project toolbar runs, from within the WOW Designer, a simplified version of the WOW runtime (wowtestform.exe) without executing COBOL code in order to see how a form will appear at runtime and tests its operation during the design process.  This test form program is executed with the formname as a command line option, and adds a .wfd or .wws extension to the formname, depending on the value of the WSDefinition property of the form.

.topic 1610711121
The Debug Project button on the Project toolbar debugs the project.

.topic 1610735936
The About button on the Help toolbar displays the About WOW Designer dialog box, which provides the version number, copyright notice, the name and company name of the person the copy is licensed to, the serial number, and other information for the installed product.

.topic 1610735941
The What's This button on the Help toolbar provides access to context-sensitive Help for control icons, menu commands, toolbar buttons, and other screen elements.

.topic 1117
The Pointer tool, the first item in the Toolbox, provides a way to select the form or a control on the form, and to move and resize forms and controls.  The Pointer tool is not a control.

.topic 1073807638
When you create or open a project, the Project tree region of the WOW Designer window displays a hierarchical list of forms in the active project.  The list can be expanded (to display the member forms and the controls in each form) and contracted, similar to how one might navigate a directory/folder structure of files, an index, or a table of contents.
The Project tree is displayed by default in the WOW Designer window.  To toggle the display of the Project tree on and off, choose the Project Tree command on the View menu.

.topic 1073874449
The Code Templates tree lists all the available templates, also called shortcuts, for a function call or a message and provides different ways of viewing this information.  WOW Extensions provides shortcuts for frequently-used messages so that it is easier to understand what the parameters are for a particular function or message.  Each shortcut contains a brief description of the function or message, the calling sequence, and the parameter values.
The Code Templates tree is displayed by default in the WOW Designer window.  To toggle the display of the Code Templates tree, click Code Templates on the View menu.

.topic 1610736054
Horizontal and Vertical Align Submenu

.topic 1610736055

.topic 1610736056

.topic 1610736057


What's This popups for menu commands, toolbar buttons, and other GUI elements of the DSN from wowdesigner document

The following popups moved to this document from the wowdesigner.doc. What’s This popups are what is shown when the user clicks the What’s This button on one of these objects. It is not what pops up when a user presses F1.


What's This popups for toolbox and toolbox controls in propnew document

The following popups moved to this document from the propnew.doc. What’s This popups are what is shown when the user clicks the What’s This button on one of these objects. It is not what pops up when a user presses F1.


What's This popups for toolbox controls in panels document

The following popups moved to this document from the panels.doc. What’s This popups are what is shown when the user clicks the What’s This button on one of these objects. It is not what pops up when a user presses F1.


Width Property

The Width property determines, in pixels, the width of the control.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Width property with any value from 0 to the value specified in the Width property of the form less the value specified in the Left property of the control.


Width Property ActiveX

The Width property determines, in pixels, the width of the ActiveX control.

Set the Width property with any value from 0 to the value specified in the Width property of the form less the value specified in the Left property of the control.


Width Property Form

The Width property determines, in pixels, the width of a form.

This property can be manipulated at design time and either retrieved or set at runtime.

Set the Width property with any value from 0 to the width of the screen display less the value specified in the Left property.


Windowed

The Windowed property determines whether the panel/form should be displayed and removed as a window. The following properties pertain to windowed panels only: BorderAttr, BorderType, DropShadow, and Title.

The following table lists the possible values of the Windowed property:

Value | Description
False | The panel is not displayed and removed as a window.
True | The panel is displayed and removed as a window (the default).


Window Options General

The check boxes in the Window Options group determine the way in which various windows are displayed in the WOW Designer. Each of these options is enabled by default.

· Checking the Properties Window Always On Top option displays the Properties dialog box on top of the form during design time when you choose the Properties command on the View menu or click Show Properties [image] on the View toolbar.

· Checking the ActiveX Methods Window Always on Top option displays the ActiveX Methods dialog box on top of the form during design time when you choose the ActiveX Methods command on the View menu or click Show ActiveX Methods [image] on the View toolbar.

· Checking the Menu Editor Window Always On Top option displays the Menu Editor dialog box on top of the form during design time when you choose the Menu Editor command on the View menu or click Show Menu Editor [image] on the View toolbar.


Windows GUI Elements See Also

WOW Extensions Components

WOW Extensions Development Process


WM-SETTEXT

Object Manipulation Message: Send

An application sends a WM-SETTEXT message to set the text of a window.

For an edit box, the text to be set is the contents of the edit box. For a combo box, the text is the contents of the edit box (or static text box) portions of the combo box. For a button, the text is the button name. For other windows, the text is the window title.

This message does not change the current selection in the list box portion of a combo box. An application should use the CB-SELECTSTRING message to select the item in the list box that matches the text in the edit box.

For more information, see the Functions and Messages online Help file.

Calling Sequence

CALL SENDMESSAGE USING WIN-RETURN WND-H WM-SETTEXT 0 NEW-TEXT.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is LB-ERRSPACE (for a list box) or CB-ERRSPACE (for a combo box) if insufficient space is available to set the text in the edit box. It is CB-ERR if this message is sent to a combo box without an edit box.
WND-H | PIC 9(10) BINARY(8) | The handle of the window to which the message will be sent.
WM-SETTEXT | Possible values are declared as 78-level descriptions in windows.cpy. | The ID of the message to be sent.
0 | Not used. | Must be zero.
NEW-TEXT | alphanumeric | A string that is the window text.


WordWrap Property

The WordWrap property is a design-time-only property that determines whether text is wrapped to multiple lines on a static text control.

The following table lists the possible values of the WordWrap property:

Value | Description
False | Text is wrapped (the default).
True | Text is not wrapped.


Working Storage

The Working Storage area, which is available for forms, controls, and menus but not projects, allows you to make entries in the Working-Storage Section associated with the selected event. The <<Common>> special section will appear in the Working-Storage section of the main (nested) program for a control or form. Review the generated code for a nested program in a WOW project to become more familiar with the naming and structure of WOW-generated nested programs. This ability facilitates the generation of nested programs, which allows for a more structured approach to COBOL programming.

Note This area can be resized as necessary using a track bar located on the right-hand side of the form. Alternatively, a default size for this area, based on percentage, can be set using the Working Storage Edit Window Percentage option on the Code Preferences page.


Working Storage Edit Window Percentage

The Working Storage Edit Window Percentage option allows for the initial size of the Working-Storage area of the Event-Handling Code dialog box to be preset. The size can range from a value of 0 to 100 percent. Once this percentage has been set, it then becomes the default size for the Working-Storage area. This option is useful when more space is desired for the Code Entry area, as it allows the size of the Working-Storage area to be reduced.


Working with Menus See Also

Addressing Issues in Data Entry Programs

Developing Event-Driven Applications

Looking Behind the Scenes

Using Function Keys for Special Options

Using WOW Projects

WOW Extensions Development Process


WOWADDITEM

The WOWADDITEM function adds a new item to a list box or combo box.

WOWADDITEM places NEWITEM in the list box or combo box. If you supply a valid value for the optional INDEX, NEWITEM is placed at that position within the control. If INDEX is omitted, NEWITEM is added at the proper sorted position (if Sorted property is True), or the end of the list (if Sorted is False).

Calling Sequence

CALL WOWADDITEM USING WIN-RETURN WND-H NEWITEM INDEX.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is zero if the function is successful.
WND-H | PIC 9(10) BINARY(8) | The handle that identifies the list box or combo box control.
NEWITEM | alphanumeric | Data to add to the control.
INDEX | numeric | Optional, zero-based integer representing the position within the control where the new item is placed.


WOWCLEAR

The WOWCLEAR function clears the contents of a list box or combo box.

Calling Sequence

CALL WOWCLEAR USING WIN-RETURN WND-H.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is zero if the function is successful.
WND-H | PIC 9(10) BINARY(8) | The handle that identifies the list box or combo box control.


WOW Designer See Also

Looking Behind the Scenes

WOW Extensions Development Process

WOW Runtime System

WOW Thin Client


WOW Designer Window See Also

Adding ActiveX Controls to the WOW Designer

Developing Event-Driven Applications

General Preferences

Handling Events for Controls, Forms, and Projects

Properties and Events for Intrinsic Controls

Setting Preferences

Setting Properties for Controls and Forms

Starting and Exiting WOW Extensions

WOW Designer


WOW Ext Components See Also

Locating Required Tools

Looking Behind the Scenes

Using WOW Projects

Windows GUI Elements

WOW Extensions Development Process


WOW Ext Development Process See Also

Initial Creation of a WOW Program

Looking Behind the Scenes

Windows GUI Elements

WOW Extensions Components


WOWGETMESSAGE

WOW Function

The WOWGETMESSAGE function retrieves a message from the Windows message queue maintained by the WOW runtime system. The WOWGETMESSAGE function is central to every WOW Extensions application. The messages returned by this function drive the application processing. This function will be automatically generated in the template program created by the WOW Designer. The call to this function will be automatically generated in the WOW program created by the WOW Designer. (For further information, see the Functions and Messages online Help file.)

WIN-MSG-WS is declared in windows.cpy as follows:

01 WIN-MSG-WS GLOBAL.
03 WIN-MSG-HANDLE PIC 9(10) BINARY(8).
03 WIN-MSG-HANDLE-A REDEFINES WIN-MSG-HANDLE PIC X(8).
03 WIN-WPARAM-H PIC S9(10) BINARY(8).
03 WIN-WPARAM-L PIC S9(10) BINARY(8).
03 WOW-KEY-VALUE REDEFINES WIN-WPARAM-L PIC 9(10) BINARY(8).
03 WIN-LPARAM PIC S9(10) BINARY(8).
03 WIN-LPARAM-A REDEFINES WIN-LPARAM PIC X(8).
03 WIN-LPARAM-HL REDEFINES WIN-LPARAM.
05 FILLER PIC 9 BINARY(4).
05 WIN-LPARAM-H PIC 9(5) BINARY(2).
05 WIN-LPARAM-L PIC 9(5) BINARY(2).
03 WIN-MSG-ID PIC 9(10) BINARY(8).
03 WIN-MSG-ID-RED REDEFINES WIN-MSG-ID.
05 FILLER PIC X(6).
05 WIN-MSG-ID-A PIC XX.

The information returned in each of these fields is described as follows:

Field | Description
WIN-MSG-HANDLE | The handle of the window with which the message is associated.
WIN-LPARAM | The meaning of the value varies depending on message.
WIN-WPARAM-H | The meaning of the value varies depending on message.
WIN-WPARAM-L | The meaning of the value varies depending on message.
WOW-KEY-VALUE | Used in key press events (KeyUp, KeyPress, KeyUp) to retrieve the value of the pressed key.
WIN-MSG-ID | The unique identifier of the message.

Calling Sequence

CALL WOWGETMESSAGE USING WIN-RETURN WIN-MSG-WS WM-NOTIFY-WS.

Parameter | Declaration | Description
WIN-RETURN | numeric | If the function successfully retrieves a message, the return value is nonzero. If an error occurs and no message is returned, the return value is zero. This should occur only if the number or size of parameters passed to the function is incorrect.
WIN-MSG-WS | windows.cpy | Contain the message information.
WM-NOTIFY-WS | windows.cpy | Returns 32-bit common control event information.


WOWGETPROP

WOW Function

The WOWGETPROP function can be used to retrieve one or more property values from a form, or an intrinsic or ActiveX control at runtime.

The ability to retrieve multiple property values makes WOWGETPROP the preferred method for retrieving property values.

Calling Sequence

CALL WOWGETPROP USING WIN-RETURN WNDORACTIVEX-H
PROPERTY-NAME… PROPERTY-VALUE….

Parameter

Declaration

Description

WIN-RETURN

windows.cpy

The return value is always zero.

WNDORACTIVEX-H

PIC 9(10) BINARY(8)
or PIC X(8)

The handle that identifies the form, or an intrinsic or ActiveX control that retrieves property value(s).

PROPERTY-NAME…

alphanumeric

Name of property for which the value is to be retrieved. The PROPERTY-NAME parameter can be repeated.

PROPERTY-VALUE…

alphanumeric or
numeric

Data item in which to store the property value. The PROPERTY-VALUE parameter can be repeated.


WOWREMOVEITEM

The WOWREMOVEITEM function removes an item from a list box or combo box at run time.

Calling Sequence

CALL WOWREMOVEITEM USING WIN-RETURN WND-H INDEX.

Parameter | Declaration | Description
WIN-RETURN | numeric | The return value is zero if the function is successful.
WND-H | PIC 9(10) BINARY(8) | The handle that identifies the list box or combo box control.
INDEX | numeric | Represents the position within the control of the item to remove. For the first item in a list box or combo box, INDEX = 0.


[WOWRT Section] See Also

Debugging with CodeWatch

Debugging with WOW Extensions

WOW Runtime System


WOW Runtime

Use the WOW Runtime area to specify the location of the WOW Extensions runtime system, wowrt.dll.

The Directory text box allows you to specify the runtime system’s installation directory, which must exist or be accessible when running the WOW application or testing a WOW panel from the WOW Designer. Version 9 and later of the WOW Designer uses the WOW runtime for testing panels.


WOW Runtime System See Also

Configuring Function Keys

Functions and Messages

Looking Behind the Scenes

WOW Designer

WOW Extensions Development Process

WOW Thin Client


WOWSETPROP

WOW Function

The WOWSETPROP function can be used to set one or more property values for a form, or an intrinsic or ActiveX control at runtime.

The ability to set multiple property values makes WOWSETPROP the preferred method for setting property values.

Note Using WOWSETPROP to set the width or height of a form affects the client area of that form, but not the overall size of the form. Contrast this behavior with that of MOVEWINDOW, which, when used to move or resize a form, will set the absolute size of that form, including borders and title bar. Providing identical values to WOWSETPROP and MOVEWINDOW for width and height will result in forms of different sizes.

Calling Sequence

CALL WOWSETPROP USING WIN-RETURN WNDORACTIVEX-H
PROPERTY-NAME… PROPERTY-VALUE….

Parameter

Declaration

Description

WIN-RETURN

windows.cpy

The return value is always zero.

WNDORACTIVEX-H

PIC 9(10) BINARY(8)
or PIC X(8)

The handle that identifies the form, or the intrinsic or ActiveX control for which to set property value(s).

PROPERTY-NAME…

alphanumeric

Name of property for which to set the value. The PROPERTY-NAME parameter can be repeated.

PROPERTY-VALUE…

alphanumeric or
numeric

New value for the property. The PROPERTY-VALUE parameter can be repeated.


WOW Thin Client See Also

Benefits of WOW Thin Client

Understanding WOW Thin Client

WOW Designer

WOW Runtime System


Wrap

The Wrap property indicates that words automatically wrap to the succeeding line when they are typed, inserted, or deleted.

Note This property has no effect when running a program with a WOW runtime that uses a WOW DLL (wowrt.dll). It is possible, however, to edit this property in the WOW Designer in order to tailor the appearance of the application for situations when the panel is not used with a WOW runtime.

The following table lists the possible values of the Wrap property:

Value | Description
False | Words do not automatically wrap to the succeeding line (the default).
True | Words automatically wrap to the succeeding line.


Wrapable Property Toolbar

The Wrapable property is a design-time-only property that indicates that a toolbar may be wrapped to subsequent lines if it is too long.


Wrapable Property Updown

The Wrapable property is a design-time-only property that causes the position of the updown control to wrap if it is incremented or decremented beyond the ending or beginning of the range. By default, the current position does not change if the user attempts to increment it or decrement it beyond the Maximum property or Minimum property values. You can change this behavior by using the Wrapable property, so the position wraps to the opposite extreme. For example, incrementing past the upper limit wraps the position back to the lower limit.

The following table lists the possible values of the Wrapable property:

Value | Description
False | The current position of the updown control does not change if the user attempts to increment it or decrement it beyond the maximum or minimum value (the default).
True | The current position of the updown control changes if the user attempts to increment it or decrement it beyond the maximum or minimum value.


WSDefinition Property Form

The WSDefinition property determines whether form definition data will be written to the formname.wws copy file, which is the default, or to a file having a .wfd extension (WOW form definition). If the form definition is written to a .wfd file, that file must be distributed with the application.

This property can be manipulated at design time and either retrieved or set at runtime.

The following table lists the possible values of the WSDefinition property:

Value | Description
False | Form definition data will be written to a file having a .wfd extension.
True | Form definition data will be written to the formname.wws copy file (the default).


Xoffset Property

The Xoffset property determines how far, in pixels, from the left edge of the control the bitmap is displayed. This value is reset to zero whenever the BitmapMode property settings change.

This property can be set and retrieved either at design time or at runtime.

The Xoffset value must be in the range of 0 to the width of the control.


Yoffset Property

The Yoffset property determines how far, in pixels, from the top of the control the bitmap is displayed. This value is reset to zero whenever the BitmapMode property settings change.

This property can be set and retrieved either at design time or at runtime.

The Yoffset value must be in the range of 0 to the height of the control.


Z-Order Property

The Z-Order property is a design-time-only property that determines and changes the control stacking order (also known as “z-order”), that is, the order in which controls are created. The controls with the smaller numbers are stacked “behind” the controls with the larger numbers. The controls with the larger numbers are “on top” of all the other controls. The Z-Order property can be manipulated using the Bring To Front and Send To Back commands on the Control menu.

The value is a one-based index to the z-order of the controls, where 1 indicates the first control, 2 indicates the second control, and so on. WOW Extensions initially sets the z-order for each control to correspond to the order in which they were added to the form. You can also change the z-order by choosing the Z-Order command on the Control menu.


Z-Order Property ActiveX

The Z-Order property determines and changes the control stacking order (also known as “z-order”), that is, the order in which controls are created. The controls with the smaller numbers are stacked “behind” the controls with the larger numbers. The controls with the larger numbers are “on top” of all the other controls. The Z-Order property can be manipulated using the Bring To Front and Send To Back commands on the Control menu.

The value is a one-based index to the z-order of the controls, where 1 indicates the first control, 2 indicates the second control, and so on. WOW Extensions initially sets the z-order for each control to correspond to the order in which they were added to the form. You can also change the z-order by choosing the Z-Order command on the Control menu.

Note The Z-Order property cannot be changed or retrieved at runtime (with the WOWGETPROP and WOWSETPROP functions). It can only be set in the WOW Designer.